// Automatically generated

package zonedb

func init() {
	initZones() // Separate function to report allocs in initialization
}

func initZones() {
	z = y
}

// Type s is an alias for []string to generate smaller source code
type s []string

// Constants to generate smaller source code
const (
	t = true
	f = false
	e = ""
)

// Nil variables to generate smaller source code
var (
	n []string // == nil
	x []Zone   // nil (no subdomains)
	r *Zone    // nil (root zone for TLDs)
)

// Tags are stored in a single integer as a bit field.
type Tags uint32

// Tag values corresponding to bit shifts (1 << iota)
const (
	TagAdult          = 1
	TagBrand          = 2
	TagCity           = 4
	TagClosed         = 8
	TagCommunity      = 16
	TagCountry        = 32
	TagGeneric        = 64
	TagGeo            = 128
	TagInfrastructure = 256
	TagPrivate        = 512
	TagRegion         = 1024
	TagRetired        = 2048
	TagSponsored      = 4096
	TagWithdrawn      = 8192
	numTags           = 14
)

// TagStrings maps integer tag values to strings.
var TagStrings = map[Tags]string{
	TagAdult:          "adult",
	TagBrand:          "brand",
	TagCity:           "city",
	TagClosed:         "closed",
	TagCommunity:      "community",
	TagCountry:        "country",
	TagGeneric:        "generic",
	TagGeo:            "geo",
	TagInfrastructure: "infrastructure",
	TagPrivate:        "private",
	TagRegion:         "region",
	TagRetired:        "retired",
	TagSponsored:      "sponsored",
	TagWithdrawn:      "withdrawn",
}

// TagValues maps tag names to integer values.
var TagValues = map[string]Tags{
	"adult":          TagAdult,
	"brand":          TagBrand,
	"city":           TagCity,
	"closed":         TagClosed,
	"community":      TagCommunity,
	"country":        TagCountry,
	"generic":        TagGeneric,
	"geo":            TagGeo,
	"infrastructure": TagInfrastructure,
	"private":        TagPrivate,
	"region":         TagRegion,
	"retired":        TagRetired,
	"sponsored":      TagSponsored,
	"withdrawn":      TagWithdrawn,
}

// Zones is a slice of all Zones in the database.
var Zones = z[:]

// TLDs is a slice of all top-level domain Zones.
var TLDs = z[:1753]

// z is a static array of Zones.
// Other global variables have pointers into this array.
var z [5171]Zone

// y and z are separated to fix circular references.
var y = [5171]Zone{
	{"aaa", r, x, s{"ns1.dns.nic.aaa", "ns2.dns.nic.aaa", "ns3.dns.nic.aaa", "ns4.dns.nic.aaa", "ns5.dns.nic.aaa", "ns6.dns.nic.aaa"}, n, n, "whois.nic.aaa", e, "https://newgtlds.icann.org/", 0x42, f},
	{"aarp", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.aarp", e, "https://newgtlds.icann.org/", 0x42, t},
	{"abarth", r, x, s{"a0.nic.abarth", "a2.nic.abarth", "b0.nic.abarth", "c0.nic.abarth"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"abb", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"abbott", r, x, s{"a0.nic.abbott", "a2.nic.abbott", "b0.nic.abbott", "c0.nic.abbott"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"abbvie", r, x, s{"a0.nic.abbvie", "a2.nic.abbvie", "b0.nic.abbvie", "c0.nic.abbvie"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"abc", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.abc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"able", r, x, s{"ns1.dns.nic.able", "ns2.dns.nic.able", "ns3.dns.nic.able", "ns4.dns.nic.able", "ns5.dns.nic.able", "ns6.dns.nic.able"}, n, n, "whois.nic.able", e, "https://newgtlds.icann.org/", 0x42, f},
	{"abogado", r, x, s{"dns1.nic.abogado", "dns2.nic.abogado", "dns3.nic.abogado", "dns4.nic.abogado", "dnsa.nic.abogado", "dnsb.nic.abogado", "dnsc.nic.abogado", "dnsd.nic.abogado"}, n, n, "whois.nic.abogado", e, "http://nic.abogado/", 0x40, t},
	{"abudhabi", r, x, s{"gtld.alpha.aridns.net.au", "gtld.beta.aridns.net.au", "gtld.delta.aridns.net.au", "gtld.gamma.aridns.net.au"}, n, s{"Abu Dhabi", "AE-AZ"}, "whois.nic.abudhabi", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"ac", r, z[1753:1758], s{"a0.nic.ac", "a2.nic.ac", "b0.nic.ac", "c0.nic.ac"}, n, n, "whois.nic.ac", e, "http://nic.ac", 0xa0, t},
	{"academy", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.academy", e, e, 0x40, t},
	{"accenture", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"accountant", r, x, s{"ns1.dns.nic.accountant", "ns2.dns.nic.accountant", "ns3.dns.nic.accountant", "ns4.dns.nic.accountant", "ns5.dns.nic.accountant", "ns6.dns.nic.accountant"}, n, n, "whois.nic.accountant", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"accountants", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.accountants", e, e, 0x40, t},
	{"acer", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"aco", r, x, s{"a0.nic.aco", "a2.nic.aco", "b0.nic.aco", "c0.nic.aco"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"active", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"actor", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.actor", e, e, 0x40, t},
	{"ad", r, z[1758:1759], s{"ad.cctld.authdns.ripe.net", "ad.ns.nic.es", "dnsc.ad", "dnsm.ad", "ns3.nic.fr"}, n, n, e, e, "http://www.nic.ad/", 0xe0, t},
	{"adac", r, x, s{"a.nic.adac", "b.nic.adac", "c.nic.adac", "d.nic.adac"}, n, n, "whois.nic.adac", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ads", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"adult", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns5.uniregistry.net", "ns6.uniregistry.info"}, n, n, "whois.registrar.adult", e, "https://newgtlds.icann.org/", 0x41, t},
	{"ae", r, z[1759:1768], s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, "whois.aeda.net.ae", e, "http://www.nic.ae/", 0xa0, t},
	{"aeg", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.aeg", e, "https://newgtlds.icann.org/", 0x42, t},
	{"aero", r, z[1768:1771], s{"a0.aero.afilias-nst.info", "a2.aero.afilias-nst.info", "b0.aero.afilias-nst.org", "b2.aero.afilias-nst.org", "c0.aero.afilias-nst.info", "d0.aero.afilias-nst.org"}, n, n, "whois.aero", e, "http://nic.aero/", 0x1040, f},
	{"aetna", r, x, s{"ns1.dns.nic.aetna", "ns2.dns.nic.aetna", "ns3.dns.nic.aetna", "ns4.dns.nic.aetna", "ns5.dns.nic.aetna", "ns6.dns.nic.aetna"}, n, n, "whois.nic.aetna", e, "https://newgtlds.icann.org/", 0x42, f},
	{"af", r, z[1771:1781], s{"ns.anycast.nic.af", "ns.cocca.fr"}, n, n, "whois.nic.af", e, "http://www.nic.af/", 0xa0, f},
	{"afamilycompany", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.afamilycompany", e, "https://newgtlds.icann.org/", 0x42, f},
	{"afl", r, x, s{"a.nic.afl", "b.nic.afl", "c.nic.afl", "d.nic.afl"}, n, n, "whois.nic.afl", e, "https://newgtlds.icann.org/", 0x42, f},
	{"africa", r, x, s{"coza1.dnsnode.net", "ns.coza.net.za", "ns2us.dns.business"}, n, s{"Africa"}, "africa-whois.registry.net.za", e, "https://newgtlds.icann.org/", 0xc0, f},
	{"africamagic", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"ag", r, z[1781:1787], s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, "whois.nic.ag", e, "http://www.nic.ag/", 0xa0, f},
	{"agakhan", r, x, s{"a0.nic.agakhan", "a2.nic.agakhan", "b0.nic.agakhan", "c0.nic.agakhan"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"agency", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.agency", e, e, 0x40, t},
	{"ai", r, z[1787:1791], s{"ns.cocca.fr", "pch.whois.ai"}, n, n, "whois.nic.ai", e, "http://nic.com.ai", 0xa0, f},
	{"aig", r, x, s{"ns1.dns.nic.aig", "ns2.dns.nic.aig", "ns3.dns.nic.aig", "ns4.dns.nic.aig", "ns5.dns.nic.aig", "ns6.dns.nic.aig"}, n, n, "whois.nic.aig", e, "https://newgtlds.icann.org/", 0x42, f},
	{"aigo", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"airbus", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.airbus", e, "https://newgtlds.icann.org/", 0x42, t},
	{"airforce", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.airforce", e, e, 0x40, t},
	{"airtel", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.airtel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"akdn", r, x, s{"a0.nic.akdn", "a2.nic.akdn", "b0.nic.akdn", "c0.nic.akdn"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"al", r, z[1791:1801], s{"munnari.oz.au", "ns1.nic.al", "nsx.nic.al", "rip.psg.com"}, n, n, e, "http://www.akep.al/sq/kerkoni-domain", "http://www.ert.gov.al/ert_eng/domain.html", 0xa0, f},
	{"alcon", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"alfaromeo", r, x, s{"a0.nic.alfaromeo", "a2.nic.alfaromeo", "b0.nic.alfaromeo", "c0.nic.alfaromeo"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"alibaba", r, x, s{"a0.nic.alibaba", "a2.nic.alibaba", "b0.nic.alibaba", "c0.nic.alibaba"}, n, n, "whois.nic.alibaba", e, "https://newgtlds.icann.org/", 0x42, f},
	{"alipay", r, x, s{"a0.nic.alipay", "a2.nic.alipay", "b0.nic.alipay", "c0.nic.alipay"}, n, n, "whois.nic.alipay", e, "https://newgtlds.icann.org/", 0x42, f},
	{"allfinanz", r, x, s{"a.nic.allfinanz", "b.nic.allfinanz", "c.nic.allfinanz", "d.nic.allfinanz"}, n, n, "whois.nic.allfinanz", e, "https://newgtlds.icann.org/", 0x42, f},
	{"allfinanzberater", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"allfinanzberatung", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"allstate", r, x, s{"a0.nic.allstate", "a2.nic.allstate", "b0.nic.allstate", "c0.nic.allstate"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ally", r, x, s{"a0.nic.ally", "a2.nic.ally", "b0.nic.ally", "c0.nic.ally"}, n, n, "whois.nic.ally", e, "https://newgtlds.icann.org/", 0x42, f},
	{"alsace", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, s{"FR-A"}, "whois-alsace.nic.fr", e, "https://newgtlds.icann.org/", 0x4c0, f},
	{"alstom", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.alstom", e, "https://newgtlds.icann.org/", 0x42, f},
	{"am", r, z[1801:1808], s{"fork.sth.dnsnode.net", "ns-cdn.amnic.net", "ns-pch.amnic.net", "ns-pri.nic.am"}, n, n, "whois.amnic.net", e, "https://www.amnic.net/", 0xa0, t},
	{"amazon", r, x, s{"dns1.nic.amazon", "dns2.nic.amazon", "dns3.nic.amazon", "dns4.nic.amazon", "dnsa.nic.amazon", "dnsb.nic.amazon", "dnsc.nic.amazon", "dnsd.nic.amazon"}, n, n, "whois.nic.amazon", e, "https://newgtlds.icann.org/", 0x2042, f},
	{"americanexpress", r, x, s{"ns1.dns.nic.americanexpress", "ns2.dns.nic.americanexpress", "ns3.dns.nic.americanexpress", "ns4.dns.nic.americanexpress", "ns5.dns.nic.americanexpress", "ns6.dns.nic.americanexpress"}, n, n, "whois.nic.americanexpress", e, "https://newgtlds.icann.org/", 0x42, f},
	{"americanfamily", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.americanfamily", e, "https://newgtlds.icann.org/", 0x42, t},
	{"amex", r, x, s{"ns1.dns.nic.amex", "ns2.dns.nic.amex", "ns3.dns.nic.amex", "ns4.dns.nic.amex", "ns5.dns.nic.amex", "ns6.dns.nic.amex"}, n, n, "whois.nic.amex", e, "https://newgtlds.icann.org/", 0x42, f},
	{"amfam", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.amfam", e, "https://newgtlds.icann.org/", 0x42, t},
	{"amica", r, x, s{"ns1.dns.nic.amica", "ns2.dns.nic.amica", "ns3.dns.nic.amica", "ns4.dns.nic.amica", "ns5.dns.nic.amica", "ns6.dns.nic.amica"}, n, n, "whois.nic.amica", e, "https://newgtlds.icann.org/", 0x42, f},
	{"amp", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"amsterdam", r, x, s{"ns1.nic.amsterdam", "ns2.nic.amsterdam", "ns3.nic.amsterdam"}, n, s{"Amsterdam", "NL-NH"}, "whois.nic.amsterdam", e, "http://nic.amsterdam/", 0xc4, f},
	{"an", r, z[1808:1812], n, n, n, e, e, "http://www.una.an/an_domreg/", 0x8a8, f},
	{"analytics", r, x, s{"ns1.dns.nic.analytics", "ns2.dns.nic.analytics", "ns3.dns.nic.analytics", "ns4.dns.nic.analytics", "ns5.dns.nic.analytics", "ns6.dns.nic.analytics"}, n, n, "whois.nic.analytics", e, "https://newgtlds.icann.org/", 0x40, f},
	{"android", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"anquan", r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.teleinfo.cn", e, "https://newgtlds.icann.org/", 0x40, f},
	{"ansons", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"anthem", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"antivirus", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"anz", r, x, s{"a.nic.anz", "b.nic.anz", "c.nic.anz", "d.nic.anz"}, n, n, "whois.nic.anz", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ao", r, z[1812:1818], s{"ao01.dns.pt", "ao03.dns.pt", "h.dns.pt"}, n, n, e, e, "http://www.dns.ao/", 0xa0, f},
	{"aol", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.aol", e, "https://newgtlds.icann.org/", 0x42, f},
	{"apartments", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.apartments", e, "https://newgtlds.icann.org/", 0x40, t},
	{"app", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"apple", r, x, s{"a0.nic.apple", "a2.nic.apple", "b0.nic.apple", "c0.nic.apple"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"aq", r, z[1818:1819], s{"fork.sth.dnsnode.net", "ns1.anycast.dns.aq", "ns99.dns.net.nz"}, n, n, e, e, "http://www.gobin.info/domainname/aq.txt", 0xa0, f},
	{"aquarelle", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.aquarelle", e, "https://newgtlds.icann.org/", 0x42, t},
	{"aquitaine", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"ar", r, z[1819:1828], s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "d.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, "whois.nic.ar", "http://www.nic.ar/", "http://www.nic.ar/", 0xa0, t},
	{"arab", r, x, s{"gtld.alpha.aridns.net.au", "gtld.beta.aridns.net.au", "gtld.delta.aridns.net.au", "gtld.gamma.aridns.net.au"}, n, n, "whois.nic.arab", e, "https://newgtlds.icann.org/", 0x40, f},
	{"aramco", r, x, s{"ns1.dns.nic.aramco", "ns2.dns.nic.aramco", "ns3.dns.nic.aramco", "ns4.dns.nic.aramco", "ns5.dns.nic.aramco", "ns6.dns.nic.aramco"}, n, n, "whois.nic.aramco", e, "https://newgtlds.icann.org/", 0x42, f},
	{"archi", r, x, s{"a0.nic.archi", "a2.nic.archi", "b0.nic.archi", "c0.nic.archi"}, n, n, "whois.afilias.net", e, "http://nic.archi/", 0x40, f},
	{"architect", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"army", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.army", e, e, 0x40, t},
	{"arpa", r, z[1828:1834], s{"a.root-servers.net", "b.root-servers.net", "c.root-servers.net", "d.root-servers.net", "e.root-servers.net", "f.root-servers.net", "g.root-servers.net", "h.root-servers.net", "i.root-servers.net", "k.root-servers.net", "l.root-servers.net", "m.root-servers.net"}, n, n, "whois.iana.org", e, "https://www.iana.org/domains/arpa", 0x148, f},
	{"art", r, x, s{"a.nic.art", "b.nic.art", "c.nic.art", "d.nic.art"}, n, n, "whois.nic.art", e, "https://newgtlds.icann.org/", 0x40, t},
	{"arte", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.arte", e, "https://newgtlds.icann.org/", 0x42, t},
	{"as", r, x, s{"ns1.asnic.biz", "ns2.asnic.info", "ns3.asnic.org", "ns4.asnic.uk", "ns5.asnic.us", "ns99.dns.net.nz", "pch.nic.as"}, n, n, "whois.nic.as", e, "http://nic.as/", 0xe0, t},
	{"asda", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.asda", e, "https://newgtlds.icann.org/", 0x42, f},
	{"asia", r, x, s{"a0.asia.afilias-nst.info", "a2.asia.afilias-nst.info", "b0.asia.afilias-nst.asia", "b2.asia.afilias-nst.org", "c0.asia.afilias-nst.info", "d0.asia.afilias-nst.asia"}, n, n, "whois.nic.asia", e, "http://www.dotasia.org/", 0x1040, t},
	{"associates", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.associates", e, e, 0x40, t},
	{"astrium", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"at", r, z[1834:1839], s{"d.ns.at", "j.ns.at", "n.ns.at", "ns1.univie.ac.at", "ns2.univie.ac.at", "ns9.univie.ac.at", "r.ns.at", "u.ns.at"}, n, n, "whois.nic.at", e, "http://www.nic.at/", 0xa0, t},
	{"athleta", r, x, s{"ns1.dns.nic.athleta", "ns2.dns.nic.athleta", "ns3.dns.nic.athleta", "ns4.dns.nic.athleta", "ns5.dns.nic.athleta", "ns6.dns.nic.athleta"}, n, n, "whois.nic.athleta", e, "https://newgtlds.icann.org/", 0x42, f},
	{"attorney", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.attorney", e, e, 0x40, t},
	{"au", r, z[1839:1859], s{"a.au", "c.au", "d.au", "m.au", "n.au", "q.au", "r.au", "s.au", "t.au"}, n, n, "whois.auda.org.au", e, "http://www.auda.org.au/", 0xa8, f},
	{"auction", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.auction", e, "https://newgtlds.icann.org/", 0x40, t},
	{"audi", r, x, s{"a0.nic.audi", "a2.nic.audi", "b0.nic.audi", "c0.nic.audi"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"audible", r, x, s{"dns1.nic.audible", "dns2.nic.audible", "dns3.nic.audible", "dns4.nic.audible", "dnsa.nic.audible", "dnsb.nic.audible", "dnsc.nic.audible", "dnsd.nic.audible"}, n, n, "whois.nic.audible", e, "https://newgtlds.icann.org/", 0x42, t},
	{"audio", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.audio/", 0x40, t},
	{"auspost", r, x, s{"a.nic.auspost", "b.nic.auspost", "c.nic.auspost", "d.nic.auspost"}, n, n, "whois.nic.auspost", e, "https://newgtlds.icann.org/", 0x42, f},
	{"author", r, x, s{"dns1.nic.author", "dns2.nic.author", "dns3.nic.author", "dns4.nic.author", "dnsa.nic.author", "dnsb.nic.author", "dnsc.nic.author", "dnsd.nic.author"}, n, n, "whois.nic.author", e, "https://newgtlds.icann.org/", 0x40, t},
	{"auto", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.auto/", 0x40, t},
	{"autoinsurance", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"autos", r, x, s{"a0.nic.autos", "a2.nic.autos", "b0.nic.autos", "c0.nic.autos"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x40, f},
	{"avery", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"avianca", r, x, s{"a0.nic.avianca", "a2.nic.avianca", "b0.nic.avianca", "c0.nic.avianca"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"aw", r, z[1859:1860], s{"aw01.setarnet.aw", "aw02.setarnet.aw", "ns1.dns.aw", "ns2.dns.aw", "ns3.dns.aw"}, n, n, "whois.nic.aw", e, "http://www.setarnet.aw/", 0xa0, f},
	{"aws", r, x, s{"dns1.nic.aws", "dns2.nic.aws", "dns3.nic.aws", "dns4.nic.aws", "dnsa.nic.aws", "dnsb.nic.aws", "dnsc.nic.aws", "dnsd.nic.aws"}, n, n, "whois.nic.aws", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ax", r, x, s{"ns1.aland.net", "ns2.aland.net", "ns3.alcom.fi", "ns4.alcom.fi"}, n, n, "whois.ax", e, "http://www.regeringen.ax/axreg/", 0xa0, f},
	{"axa", r, x, s{"ns1.dns.nic.axa", "ns2.dns.nic.axa", "ns3.dns.nic.axa", "ns4.dns.nic.axa", "ns5.dns.nic.axa", "ns6.dns.nic.axa"}, n, n, "whois.nic.axa", e, "https://newgtlds.icann.org/", 0x42, t},
	{"axis", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"az", r, z[1860:1881], s{"az.hostmaster.ua", "rip.psg.com"}, n, n, e, "http://www.nic.az/", "http://www.nic.az/", 0xa0, f},
	{"azure", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"ba", r, z[1881:1894], s{"ns.ba", "sava.utic.net.ba", "una.utic.net.ba"}, n, n, e, "http://nic.ba/lat/menu/view/13", "http://www.nic.ba/", 0xa0, f},
	{"baby", r, x, s{"a.nic.baby", "b.nic.baby", "c.nic.baby", "d.nic.baby"}, n, n, "whois.nic.baby", e, "https://newgtlds.icann.org/", 0x40, f},
	{"baidu", r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, "https://newgtlds.icann.org/", 0x42, t},
	{"banamex", r, x, s{"ns1.dns.nic.banamex", "ns2.dns.nic.banamex", "ns3.dns.nic.banamex", "ns4.dns.nic.banamex", "ns5.dns.nic.banamex", "ns6.dns.nic.banamex"}, n, n, "whois.nic.banamex", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bananarepublic", r, x, s{"ns1.dns.nic.bananarepublic", "ns2.dns.nic.bananarepublic", "ns3.dns.nic.bananarepublic", "ns4.dns.nic.bananarepublic", "ns5.dns.nic.bananarepublic", "ns6.dns.nic.bananarepublic"}, n, n, "whois.nic.bananarepublic", e, "https://newgtlds.icann.org/", 0x42, f},
	{"band", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.band", e, "https://newgtlds.icann.org/", 0x40, t},
	{"bank", r, x, s{"a.nic.bank", "b.nic.bank", "c.nic.bank", "d.nic.bank", "e.nic.bank", "f.nic.bank"}, n, n, "whois.nic.bank", e, "https://newgtlds.icann.org/", 0x40, f},
	{"banque", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"bar", r, x, s{"a.nic.bar", "b.nic.bar", "c.nic.bar", "d.nic.bar"}, n, n, "whois.nic.bar", e, e, 0x40, t},
	{"barcelona", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.barcelona", e, "https://newgtlds.icann.org/", 0x40, f},
	{"barclaycard", r, x, s{"a.nic.barclaycard", "b.nic.barclaycard", "c.nic.barclaycard", "d.nic.barclaycard"}, n, n, "whois.nic.barclaycard", e, "https://newgtlds.icann.org/", 0x42, f},
	{"barclays", r, x, s{"a.nic.barclays", "b.nic.barclays", "c.nic.barclays", "d.nic.barclays"}, n, n, "whois.nic.barclays", e, "https://newgtlds.icann.org/", 0x42, f},
	{"barefoot", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.barefoot", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bargains", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.bargains", e, e, 0x40, t},
	{"baseball", r, x, s{"ns1.dns.nic.baseball", "ns2.dns.nic.baseball", "ns3.dns.nic.baseball", "ns4.dns.nic.baseball", "ns5.dns.nic.baseball", "ns6.dns.nic.baseball"}, n, n, "whois.nic.baseball", e, "https://newgtlds.icann.org/", 0x40, f},
	{"basketball", r, x, s{"a.nic.basketball", "b.nic.basketball", "c.nic.basketball", "d.nic.basketball"}, n, n, "whois.nic.basketball", e, "https://newgtlds.icann.org/", 0x40, f},
	{"bauhaus", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.bauhaus", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bayern", r, x, s{"dns1.nic.bayern", "dns2.nic.bayern", "dns3.nic.bayern", "dns4.nic.bayern", "dnsa.nic.bayern", "dnsb.nic.bayern", "dnsc.nic.bayern", "dnsd.nic.bayern"}, n, s{"DE-BY"}, "whois.nic.bayern", e, "http://nic.bayern/", 0x4c0, t},
	{"bb", r, z[1894:1903], s{"ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, "http://whois.telecoms.gov.bb/search_domain.php", "http://www.barbadosdomains.net/", 0xa0, f},
	{"bbb", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"bbc", r, x, s{"dns1.nic.bbc", "dns2.nic.bbc", "dns3.nic.bbc", "dns4.nic.bbc", "dnsa.nic.bbc", "dnsb.nic.bbc", "dnsc.nic.bbc", "dnsd.nic.bbc"}, n, n, "whois.nic.bbc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bbt", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.bbt", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bbva", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.bbva", e, "https://newgtlds.icann.org/", 0x42, t},
	{"bcg", r, x, s{"a0.nic.bcg", "a2.nic.bcg", "b0.nic.bcg", "c0.nic.bcg"}, n, n, "whois.nic.bcg", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bcn", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.bcn", e, "https://newgtlds.icann.org/", 0x40, f},
	{"bd", r, z[1903:1910], s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, "http://whois.btcl.net.bd/", "http://www.bttb.net.bd/", 0xa8, t},
	{"be", r, x, s{"a.ns.dns.be", "b.ns.dns.be", "c.ns.dns.be", "d.ns.dns.be", "y.ns.dns.be", "z.nsset.be"}, n, n, "whois.dns.be", e, e, 0xa0, t},
	{"beats", r, x, s{"a0.nic.beats", "a2.nic.beats", "b0.nic.beats", "c0.nic.beats"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"beauty", r, x, s{"a.nic.beauty", "b.nic.beauty", "c.nic.beauty", "d.nic.beauty"}, n, n, "whois.nic.beauty", e, "https://newgtlds.icann.org/", 0x40, t},
	{"beer", r, x, s{"dns1.nic.beer", "dns2.nic.beer", "dns3.nic.beer", "dns4.nic.beer", "dnsa.nic.beer", "dnsb.nic.beer", "dnsc.nic.beer", "dnsd.nic.beer"}, n, n, "whois.nic.beer", e, "http://nic.beer/", 0x40, t},
	{"beknown", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"bentley", r, x, s{"dns1.nic.bentley", "dns2.nic.bentley", "dns3.nic.bentley", "dns4.nic.bentley", "dnsa.nic.bentley", "dnsb.nic.bentley", "dnsc.nic.bentley", "dnsd.nic.bentley"}, n, n, "whois.nic.bentley", e, "https://newgtlds.icann.org/", 0x42, f},
	{"berlin", r, x, s{"a.dns.nic.berlin", "m.dns.nic.berlin", "n.dns.nic.berlin"}, n, s{"Berlin", "DE-BE"}, "whois.nic.berlin", e, e, 0xc4, t},
	{"best", r, x, s{"a.nic.best", "b.nic.best", "c.nic.best", "d.nic.best"}, n, n, "whois.nic.best", e, "http://nic.best/", 0x40, t},
	{"bestbuy", r, x, s{"a0.nic.bestbuy", "a2.nic.bestbuy", "b0.nic.bestbuy", "c0.nic.bestbuy"}, n, n, "whois.nic.bestbuy", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bet", r, x, s{"a0.nic.bet", "a2.nic.bet", "b0.nic.bet", "c0.nic.bet"}, n, n, "whois.afilias.net", e, "http://nic.bet/", 0x40, f},
	{"bf", r, z[1910:1911], s{"a.registre.bf", "censvrns0001.ird.fr", "nahouri.onatel.bf"}, n, n, e, e, e, 0xa0, t},
	{"bg", r, z[1911:1947], s{"a.nic.bg", "b.nic.bg", "c.nic.bg", "d.nic.bg", "e.nic.bg", "p.nic.bg"}, n, n, "whois.register.bg", e, "https://www.register.bg/user/", 0xa0, t},
	{"bh", r, z[1947:1955], s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0xa0, f},
	{"bharti", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"bi", r, z[1955:1965], s{"anyns.nic.bi", "bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, "whois1.nic.bi", e, e, 0xa0, f},
	{"bible", r, x, s{"ns1.dns.nic.bible", "ns2.dns.nic.bible", "ns3.dns.nic.bible", "ns4.dns.nic.bible", "ns5.dns.nic.bible", "ns6.dns.nic.bible"}, n, n, "whois.nic.bible", e, "https://newgtlds.icann.org/", 0x40, f},
	{"bid", r, x, s{"ns1.dns.nic.bid", "ns2.dns.nic.bid", "ns3.dns.nic.bid", "ns4.dns.nic.bid", "ns5.dns.nic.bid", "ns6.dns.nic.bid"}, n, n, "whois.nic.bid", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"bike", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.bike", e, e, 0x40, t},
	{"bing", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"bingo", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.bingo", e, "https://newgtlds.icann.org/", 0x40, t},
	{"bio", r, x, s{"a0.nic.bio", "a2.nic.bio", "b0.nic.bio", "c0.nic.bio"}, n, n, "whois.afilias.net", e, "http://nic.bio/", 0x40, t},
	{"biz", r, z[1965:1967], s{"a.gtld.biz", "b.gtld.biz", "c.gtld.biz", "e.gtld.biz", "f.gtld.biz", "k.gtld.biz"}, n, n, "whois.nic.biz", e, e, 0x40, t},
	{"bj", r, z[1967:1974], s{"ns.cocca.fr", "ns1.nic.bj", "ns2.nic.bj", "pch.nic.bj"}, n, n, "whois.nic.bj", e, e, 0xa0, f},
	{"black", r, x, s{"a0.nic.black", "a2.nic.black", "b0.nic.black", "c0.nic.black"}, n, n, "whois.afilias.net", e, "http://nic.black/", 0x40, f},
	{"blackfriday", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.blackfriday/", 0x40, t},
	{"blanco", r, x, n, n, n, "whois.nic.blanco", e, "https://newgtlds.icann.org/", 0x40, t},
	{"blockbuster", r, x, s{"a0.nic.blockbuster", "a2.nic.blockbuster", "b0.nic.blockbuster", "c0.nic.blockbuster"}, n, n, "whois.nic.blockbuster", e, "https://newgtlds.icann.org/", 0x42, f},
	{"blog", r, z[1974:2000], s{"a.nic.blog", "b.nic.blog", "c.nic.blog", "d.nic.blog"}, n, n, "whois.nic.blog", e, "http://nic.blog/", 0x40, f},
	{"bloomberg", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"bloomingdales", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"blue", r, x, s{"a0.nic.blue", "a2.nic.blue", "b0.nic.blue", "b2.nic.blue", "c0.nic.blue"}, n, n, "whois.afilias.net", e, "http://nic.blue/", 0x40, f},
	{"bm", r, z[2000:2005], s{"a0.bm.afilias-nst.info", "a2.bm.afilias-nst.info", "b0.bm.afilias-nst.org", "b2.bm.afilias-nst.org", "c0.bm.afilias-nst.info", "d0.bm.afilias-nst.org"}, n, n, e, "http://www.bermudanic.bm/cgi-bin/lansaweb?procfun+BMWHO+BMWHO2+WHO", e, 0xa0, f},
	{"bms", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.bms", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bmw", r, x, s{"a.nic.bmw", "b.nic.bmw", "c.nic.bmw", "d.nic.bmw"}, n, n, "whois.nic.bmw", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bn", r, z[2005:2010], s{"bn-ns.anycast.pch.net", "ns1.bnnic.bn", "ns2.bnnic.bn", "ns4.apnic.net"}, n, n, "whois.bnnic.bn", e, "http://www.brunet.bn/products_webrelated_domain_main.htm", 0xa0, f},
	{"bnl", r, x, n, n, n, "whois.nic.bnl", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bnpparibas", r, x, s{"a0.nic.bnpparibas", "a2.nic.bnpparibas", "b0.nic.bnpparibas", "c0.nic.bnpparibas"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bo", r, z[2010:2019], s{"anycast.ns.nic.bo", "ns.dns.br", "ns.nic.bo", "ns2.nic.fr"}, n, n, "whois.nic.bo", e, e, 0xa0, t},
	{"boats", r, x, s{"a0.nic.boats", "a2.nic.boats", "b0.nic.boats", "c0.nic.boats"}, n, n, "whois.afilias-srs.net", e, "http://nic.boats/", 0x40, f},
	{"boehringer", r, x, s{"a0.nic.boehringer", "a2.nic.boehringer", "b0.nic.boehringer", "c0.nic.boehringer"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bofa", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.bofa", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bom", r, x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, "whois.gtlds.nic.br", e, "https://newgtlds.icann.org/", 0x42, t},
	{"bond", r, x, s{"a.nic.bond", "b.nic.bond", "c.nic.bond", "d.nic.bond"}, n, n, "whois.nic.bond", e, "https://newgtlds.icann.org/", 0x42, f},
	{"boo", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"book", r, x, s{"dns1.nic.book", "dns2.nic.book", "dns3.nic.book", "dns4.nic.book", "dnsa.nic.book", "dnsb.nic.book", "dnsc.nic.book", "dnsd.nic.book"}, n, n, "whois.nic.book", e, "https://newgtlds.icann.org/", 0x40, t},
	{"booking", r, x, s{"ns1.dns.nic.booking", "ns2.dns.nic.booking", "ns3.dns.nic.booking", "ns4.dns.nic.booking", "ns5.dns.nic.booking", "ns6.dns.nic.booking"}, n, n, "whois.nic.booking", e, "https://newgtlds.icann.org/", 0x48, f},
	{"boots", r, x, n, n, n, "whois.nic.boots", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bosch", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.bosch", e, "https://newgtlds.icann.org/", 0x42, f},
	{"bostik", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.bostik", e, "https://newgtlds.icann.org/", 0x42, t},
	{"boston", r, x, s{"dns1.nic.boston", "dns2.nic.boston", "dns3.nic.boston", "dns4.nic.boston", "dnsa.nic.boston", "dnsb.nic.boston", "dnsc.nic.boston", "dnsd.nic.boston"}, n, s{"Boston"}, "whois.nic.boston", e, "http://nic.boston/", 0xc4, f},
	{"bot", r, x, s{"dns1.nic.bot", "dns2.nic.bot", "dns3.nic.bot", "dns4.nic.bot", "dnsa.nic.bot", "dnsb.nic.bot", "dnsc.nic.bot", "dnsd.nic.bot"}, n, n, "whois.nic.bot", e, "https://newgtlds.icann.org/", 0x40, t},
	{"boutique", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.boutique", e, e, 0x40, t},
	{"box", r, x, s{"a.nic.box", "b.nic.box", "c.nic.box", "d.nic.box"}, n, n, "whois.nic.box", e, "https://newgtlds.icann.org/", 0x40, f},
	{"br", r, z[2019:2114], s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, "whois.registro.br", e, "http://nic.br/", 0xa0, t},
	{"bradesco", r, x, s{"dns1.nic.bradesco", "dns2.nic.bradesco", "dns3.nic.bradesco", "dns4.nic.bradesco", "dnsa.nic.bradesco", "dnsb.nic.bradesco", "dnsc.nic.bradesco", "dnsd.nic.bradesco"}, n, n, "whois.nic.bradesco", e, "http://nic.bradesco/", 0x42, f},
	{"bridgestone", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.bridgestone", e, "https://newgtlds.icann.org/", 0x42, f},
	{"broadway", r, x, s{"dns1.nic.broadway", "dns2.nic.broadway", "dns3.nic.broadway", "dns4.nic.broadway", "dnsa.nic.broadway", "dnsb.nic.broadway", "dnsc.nic.broadway", "dnsd.nic.broadway"}, n, n, "whois.nic.broadway", e, "http://nic.broadway/", 0x40, f},
	{"broker", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.broker", e, "https://bostonivy.co/", 0x40, f},
	{"brother", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.brother", e, "https://newgtlds.icann.org/", 0x42, f},
	{"brussels", r, x, s{"a.nic.brussels", "b.nic.brussels", "c.ns.dns.be", "d.ns.dns.be", "y.ns.dns.be", "z.nsset.brussels"}, n, s{"Brussels", "BE-BRU"}, "whois.nic.brussels", e, "https://newgtlds.icann.org/", 0xc4, t},
	{"bs", r, z[2114:2120], s{"anyns.dns.bs", "anyns.pch.net", "ns36.cdns.net"}, n, n, e, "http://www.nic.bs/cgi-bin/search.pl", e, 0xa0, t},
	{"bt", r, z[2120:2125], s{"auth00.ns.uu.net", "auth61.ns.uu.net", "ns.itu.ch", "ns1.druknet.bt", "ns2.druknet.bt", "ns3.druknet.bt", "phloem.uoregon.edu"}, n, n, e, "http://www.nic.bt/", e, 0xa0, f},
	{"budapest", r, x, s{"dns1.nic.budapest", "dns2.nic.budapest", "dns3.nic.budapest", "dns4.nic.budapest", "dnsa.nic.budapest", "dnsb.nic.budapest", "dnsc.nic.budapest", "dnsd.nic.budapest"}, n, s{"Budapest", "HU-BU"}, "whois.nic.budapest", e, "http://nic.budapest/", 0xc4, t},
	{"bugatti", r, x, s{"a0.nic.bugatti", "a2.nic.bugatti", "b0.nic.bugatti", "c0.nic.bugatti"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"buick", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"build", r, x, s{"a.nic.build", "b.nic.build", "c.nic.build", "d.nic.build"}, n, n, "whois.nic.build", e, "http://nic.build/", 0x40, f},
	{"builders", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.builders", e, e, 0x40, t},
	{"business", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.business", e, "https://newgtlds.icann.org/", 0x40, t},
	{"buy", r, x, s{"dns1.nic.buy", "dns2.nic.buy", "dns3.nic.buy", "dns4.nic.buy", "dnsa.nic.buy", "dnsb.nic.buy", "dnsc.nic.buy", "dnsd.nic.buy"}, n, n, "whois.nic.buy", e, "https://newgtlds.icann.org/", 0x40, t},
	{"buzz", r, x, s{"ns1.dns.nic.buzz", "ns2.dns.nic.buzz", "ns3.dns.nic.buzz", "ns4.dns.nic.buzz", "ns5.dns.nic.buzz", "ns6.dns.nic.buzz"}, n, n, "whois.nic.buzz", e, e, 0x40, t},
	{"bv", r, x, s{"nac.no", "nn.uninett.no", "server.nordu.net"}, n, n, "whois.norid.no", e, e, 0xa8, f},
	{"bw", r, z[2125:2129], s{"dns1.nic.net.bw", "dns2.nic.net.bw", "master.btc.net.bw", "ns-bw.afrinic.net", "pch.nic.net.bw"}, n, n, "whois.nic.net.bw", e, e, 0xa0, f},
	{"bway", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"by", r, z[2129:2134], s{"dns1.tld.tutby.com", "dns2.tld.tutby.com", "dns3.tld.tutby.com", "dns4.tld.tutby.com", "dns5.tld.tutby.com"}, n, n, "whois.cctld.by", e, "http://tld.by/", 0xa0, f},
	{"bz", r, z[2134:2141], s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, "whois.afilias-grs.info", e, "http://www.belizenic.bz/", 0xe0, f},
	{"bzh", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, s{"FR-E"}, "whois.nic.bzh", e, "https://newgtlds.icann.org/", 0x4c0, t},
	{"ca", r, z[2141:2157], s{"any.ca-servers.ca", "c.ca-servers.ca", "j.ca-servers.ca", "x.ca-servers.ca"}, n, n, "whois.cira.ca", e, e, 0xa0, t},
	{"cab", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cab", e, e, 0x40, t},
	{"cadillac", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"cafe", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cafe", e, "https://newgtlds.icann.org/", 0x40, t},
	{"cal", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"call", r, x, s{"dns1.nic.call", "dns2.nic.call", "dns3.nic.call", "dns4.nic.call", "dnsa.nic.call", "dnsb.nic.call", "dnsc.nic.call", "dnsd.nic.call"}, n, n, "whois.nic.call", e, "https://newgtlds.icann.org/", 0x40, t},
	{"calvinklein", r, x, s{"ns1.dns.nic.calvinklein", "ns2.dns.nic.calvinklein", "ns3.dns.nic.calvinklein", "ns4.dns.nic.calvinklein", "ns5.dns.nic.calvinklein", "ns6.dns.nic.calvinklein"}, n, n, "whois.nic.calvinklein", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cam", r, x, s{"a.nic.cam", "b.nic.cam", "c.nic.cam", "d.nic.cam"}, n, n, "whois.nic.cam", e, "https://newgtlds.icann.org/", 0x40, t},
	{"camera", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.camera", e, e, 0x40, t},
	{"camp", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.camp", e, e, 0x40, t},
	{"canalplus", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"cancerresearch", r, x, s{"a.nic.cancerresearch", "b.nic.cancerresearch", "c.nic.cancerresearch", "d.nic.cancerresearch"}, n, n, "whois.nic.cancerresearch", e, "https://newgtlds.icann.org/", 0x40, f},
	{"canon", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.canon", e, "https://newgtlds.icann.org/", 0x42, t},
	{"capetown", r, x, s{"coza1.dnsnode.net", "ns.coza.net.za", "ns2us.dns.business"}, n, s{"Cape Town"}, "capetown-whois.registry.net.za", e, e, 0xc4, t},
	{"capital", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.capital", e, e, 0x40, t},
	{"capitalone", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.capitalone", e, "https://newgtlds.icann.org/", 0x42, f},
	{"car", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.car/", 0x40, t},
	{"caravan", r, x, s{"ns1.dns.nic.caravan", "ns2.dns.nic.caravan", "ns3.dns.nic.caravan", "ns4.dns.nic.caravan", "ns5.dns.nic.caravan", "ns6.dns.nic.caravan"}, n, n, "whois.nic.caravan", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cards", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cards", e, e, 0x40, t},
	{"care", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.care", e, e, 0x40, t},
	{"career", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.career", e, e, 0x40, t},
	{"careers", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.careers", e, e, 0x40, t},
	{"carinsurance", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"cars", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.cars/", 0x40, t},
	{"cartier", r, x, n, n, n, "whois.nic.cartier", e, "https://newgtlds.icann.org/", 0x42, t},
	{"casa", r, x, s{"dns1.nic.casa", "dns2.nic.casa", "dns3.nic.casa", "dns4.nic.casa", "dnsa.nic.casa", "dnsb.nic.casa", "dnsc.nic.casa", "dnsd.nic.casa"}, n, n, "whois.nic.casa", e, "http://nic.casa/", 0x40, t},
	{"case", r, x, s{"a0.nic.case", "a2.nic.case", "b0.nic.case", "c0.nic.case"}, n, n, "whois.nic.case", e, "https://newgtlds.icann.org/", 0x40, f},
	{"caseih", r, x, s{"a0.nic.caseih", "a2.nic.caseih", "b0.nic.caseih", "c0.nic.caseih"}, n, n, "whois.nic.caseih", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cash", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cash", e, e, 0x40, t},
	{"cashbackbonus", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x48, f},
	{"casino", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.casino", e, "https://newgtlds.icann.org/", 0x40, t},
	{"cat", r, x, s{"anyc1.irondns.net", "cat.pch.net", "ns.nic.cat", "ns1.nic.es", "nsc.nic.de", "switch.nic.cat"}, n, s{"ES-CT"}, "whois.nic.cat", e, "http://www.domini.cat/", 0x1440, t},
	{"catalonia", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"catering", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.catering", e, e, 0x40, t},
	{"catholic", r, x, s{"a.nic.catholic", "b.nic.catholic", "c.nic.catholic", "d.nic.catholic"}, n, n, "whois.nic.catholic", e, "https://newgtlds.icann.org/", 0x40, f},
	{"cba", r, x, s{"a.nic.cba", "b.nic.cba", "c.nic.cba", "d.nic.cba"}, n, n, "whois.nic.cba", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cbn", r, x, s{"ns1.dns.nic.cbn", "ns2.dns.nic.cbn", "ns3.dns.nic.cbn", "ns4.dns.nic.cbn", "ns5.dns.nic.cbn", "ns6.dns.nic.cbn"}, n, n, "whois.nic.cbn", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cbre", r, x, s{"ns1.dns.nic.cbre", "ns2.dns.nic.cbre", "ns3.dns.nic.cbre", "ns4.dns.nic.cbre", "ns5.dns.nic.cbre", "ns6.dns.nic.cbre"}, n, n, "whois.nic.cbre", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cbs", r, x, s{"a0.nic.cbs", "a2.nic.cbs", "b0.nic.cbs", "c0.nic.cbs"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cc", r, z[2157:2161], s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "ccwhois.verisign-grs.com", e, e, 0xe0, t},
	{"cd", r, z[2161:2167], s{"igubu.saix.net", "ns-root-1.scpt-network.com", "ns-root-2.scpt-network.com", "ns-root-5.scpt-network.com", "sabela.saix.net", "sangoma.saix.net"}, n, n, "whois.cd", e, "http://www.nic.cd/", 0xe0, f},
	{"ceb", r, x, s{"a0.nic.ceb", "a2.nic.ceb", "b0.nic.ceb", "c0.nic.ceb"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"center", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.center", e, e, 0x40, t},
	{"ceo", r, x, s{"a.nic.ceo", "b.nic.ceo", "c.nic.ceo", "d.nic.ceo"}, n, n, "whois.nic.ceo", e, e, 0x40, t},
	{"cern", r, x, s{"a0.nic.cern", "a2.nic.cern", "b0.nic.cern", "c0.nic.cern"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cf", r, x, s{"a.ns.cf", "b.ns.cf", "c.ns.cf", "d.ns.cf"}, n, n, "whois.dot.cf", e, e, 0xa0, t},
	{"cfa", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.cfa", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cfd", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.cfd", e, "https://bostonivy.co/", 0x40, f},
	{"cg", r, x, s{"dns-fr.dnsafrica.net", "dns-za.dnsafrica.net", "sunic.sunet.se"}, n, n, e, "http://www.nic.cg/cgi-bin/whois.pl", e, 0xa0, f},
	{"ch", r, x, s{"a.nic.ch", "b.nic.ch", "c.nic.ch", "e.nic.ch", "f.nic.ch", "g.nic.ch", "h.nic.ch"}, n, n, "whois.nic.ch", e, e, 0xa0, t},
	{"chanel", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.chanel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"changiairport", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"channel", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"charity", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.charity", e, "https://newgtlds.icann.org/", 0x40, t},
	{"chartis", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"chase", r, x, s{"ns1.dns.nic.chase", "ns2.dns.nic.chase", "ns3.dns.nic.chase", "ns4.dns.nic.chase", "ns5.dns.nic.chase", "ns6.dns.nic.chase"}, n, n, "whois.nic.chase", e, "https://newgtlds.icann.org/", 0x42, f},
	{"chat", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.chat", e, "https://newgtlds.icann.org/", 0x40, t},
	{"cheap", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cheap", e, e, 0x40, t},
	{"chesapeake", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"chevrolet", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"chevy", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"chintai", r, x, s{"ns1.dns.nic.chintai", "ns2.dns.nic.chintai", "ns3.dns.nic.chintai", "ns4.dns.nic.chintai", "ns5.dns.nic.chintai", "ns6.dns.nic.chintai"}, n, n, "whois.nic.chintai", e, "https://newgtlds.icann.org/", 0x42, f},
	{"chk", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"chloe", r, x, n, n, n, "whois.nic.chloe", e, "https://newgtlds.icann.org/", 0x2042, f},
	{"christmas", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.christmas/", 0x40, t},
	{"chrome", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"chrysler", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"church", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.church", e, e, 0x40, t},
	{"ci", r, z[2167:2184], s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, "whois.nic.ci", e, e, 0xa0, f},
	{"cimb", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"cipriani", r, x, s{"a0.nic.cipriani", "a2.nic.cipriani", "b0.nic.cipriani", "c0.nic.cipriani"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"circle", r, x, s{"dns1.nic.circle", "dns2.nic.circle", "dns3.nic.circle", "dns4.nic.circle", "dnsa.nic.circle", "dnsb.nic.circle", "dnsc.nic.circle", "dnsd.nic.circle"}, n, n, "whois.nic.circle", e, "https://newgtlds.icann.org/", 0x40, t},
	{"cisco", r, x, s{"ns1.dns.nic.cisco", "ns2.dns.nic.cisco", "ns3.dns.nic.cisco", "ns4.dns.nic.cisco", "ns5.dns.nic.cisco", "ns6.dns.nic.cisco"}, n, n, "whois.nic.cisco", e, "https://newgtlds.icann.org/", 0x42, f},
	{"citadel", r, x, s{"ns1.dns.nic.citadel", "ns2.dns.nic.citadel", "ns3.dns.nic.citadel", "ns4.dns.nic.citadel", "ns5.dns.nic.citadel", "ns6.dns.nic.citadel"}, n, n, "whois.nic.citadel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"citi", r, x, s{"ns1.dns.nic.citi", "ns2.dns.nic.citi", "ns3.dns.nic.citi", "ns4.dns.nic.citi", "ns5.dns.nic.citi", "ns6.dns.nic.citi"}, n, n, "whois.nic.citi", e, "https://newgtlds.icann.org/", 0x42, f},
	{"citic", r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.citic", e, "https://newgtlds.icann.org/", 0x42, t},
	{"city", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.city", e, e, 0x40, t},
	{"cityeats", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.cityeats", e, "https://newgtlds.icann.org/", 0x48, f},
	{"ck", r, z[2184:2192], s{"circa.mcs.vuw.ac.nz", "downstage.mcs.vuw.ac.nz", "parau.oyster.net.ck", "poiparau.oyster.net.ck"}, n, n, "whois.ck-nic.org.ck", e, "http://www.oyster.net.ck/about/index.php?about=domain", 0xa8, f},
	{"cl", r, x, s{"a.nic.cl", "b.nic.cl", "c.nic.cl", "cl-ns.anycast.pch.net", "cl1-tld.d-zone.ca", "cl1.dnsnode.net", "cl2-tld.d-zone.ca"}, n, n, "whois.nic.cl", e, e, 0xa0, t},
	{"claims", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.claims", e, e, 0x40, t},
	{"cleaning", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cleaning", e, e, 0x40, t},
	{"click", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.click/", 0x40, t},
	{"clinic", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.clinic", e, e, 0x40, t},
	{"clinique", r, x, s{"a0.nic.clinique", "a2.nic.clinique", "b0.nic.clinique", "c0.nic.clinique"}, n, n, "whois.nic.clinique", e, "https://newgtlds.icann.org/", 0x42, f},
	{"clothing", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.clothing", e, e, 0x40, t},
	{"cloud", r, x, s{"a.nic.cloud", "b.nic.cloud", "c.nic.cloud", "d.nic.cloud"}, n, n, "whois.nic.cloud", e, "https://newgtlds.icann.org/", 0x40, f},
	{"club", r, x, s{"ns1.dns.nic.club", "ns2.dns.nic.club", "ns3.dns.nic.club", "ns4.dns.nic.club", "ns5.dns.nic.club", "ns6.dns.nic.club"}, n, n, "whois.nic.club", e, e, 0x40, t},
	{"clubmed", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.clubmed", e, "https://newgtlds.icann.org/", 0x42, t},
	{"cm", r, z[2192:2196], s{"auth02.ns.uu.net", "kim.camnet.cm", "lom.camnet.cm", "ns.itu.ch", "sanaga.camnet.cm"}, n, n, "whois.netcom.cm", "http://antic.cm", e, 0xa0, f},
	{"cn", r, z[2196:2238], s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn", "ns.cernet.net"}, n, n, "whois.cnnic.cn", e, e, 0xa0, t},
	{"co", r, z[2238:2245], s{"ns1.cctld.co", "ns2.cctld.co", "ns3.cctld.co", "ns4.cctld.co", "ns5.cctld.co", "ns6.cctld.co"}, n, n, "whois.nic.co", e, "http://www.go.co/", 0xe0, t},
	{"coach", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.coach", e, "https://newgtlds.icann.org/", 0x40, t},
	{"codes", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.codes", e, e, 0x40, t},
	{"coffee", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.coffee", e, e, 0x40, t},
	{"college", r, x, s{"a.nic.college", "b.nic.college", "c.nic.college", "d.nic.college"}, n, n, "whois.nic.college", e, "https://newgtlds.icann.org/", 0x40, t},
	{"cologne", r, x, s{"dns.ryce-rsp.com", "ns1.dns.business", "ns1.ryce-rsp.com"}, n, s{"Cologne", "Koeln"}, "whois.ryce-rsp.com", e, e, 0xc4, t},
	{"com", r, z[2245:2275], s{"a.gtld-servers.net", "b.gtld-servers.net", "c.gtld-servers.net", "d.gtld-servers.net", "e.gtld-servers.net", "f.gtld-servers.net", "g.gtld-servers.net", "h.gtld-servers.net", "i.gtld-servers.net", "j.gtld-servers.net", "k.gtld-servers.net", "l.gtld-servers.net", "m.gtld-servers.net"}, n, n, "whois.verisign-grs.com", e, "http://www.verisigninc.com/en_US/products-and-services/domain-name-services/registry-services/index.xhtml", 0x40, t},
	{"comcast", r, x, s{"dns1.nic.comcast", "dns2.nic.comcast", "dns3.nic.comcast", "dns4.nic.comcast", "dnsa.nic.comcast", "dnsb.nic.comcast", "dnsc.nic.comcast", "dnsd.nic.comcast"}, n, n, "whois.nic.comcast", e, "https://newgtlds.icann.org/", 0x42, f},
	{"commbank", r, x, s{"a.nic.commbank", "b.nic.commbank", "c.nic.commbank", "d.nic.commbank"}, n, n, "whois.nic.commbank", e, "https://newgtlds.icann.org/", 0x42, f},
	{"community", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.community", e, e, 0x40, t},
	{"company", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.company", e, e, 0x40, t},
	{"compare", r, x, s{"a.nic.compare", "b.nic.compare", "c.nic.compare", "d.nic.compare"}, n, n, "whois.nic.compare", e, "http://nic.compare", 0x40, f},
	{"computer", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.computer", e, e, 0x40, t},
	{"comsec", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.comsec", e, "https://newgtlds.icann.org/", 0x42, t},
	{"condos", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.condos", e, e, 0x40, t},
	{"connectors", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"construction", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.construction", e, e, 0x40, t},
	{"consulting", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.consulting", e, e, 0x40, t},
	{"contact", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.contact", e, "https://newgtlds.icann.org/", 0x40, t},
	{"contractors", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.contractors", e, e, 0x40, t},
	{"cooking", r, x, s{"dns1.nic.cooking", "dns2.nic.cooking", "dns3.nic.cooking", "dns4.nic.cooking", "dnsa.nic.cooking", "dnsb.nic.cooking", "dnsc.nic.cooking", "dnsd.nic.cooking"}, n, n, "whois.nic.cooking", e, "http://nic.cooking/", 0x40, t},
	{"cookingchannel", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.cookingchannel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cool", r, z[2275:2276], s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cool", e, e, 0x40, t},
	{"coop", r, x, s{"a.nic.coop", "b.nic.coop", "c.nic.coop", "d.nic.coop"}, n, n, "whois.nic.coop", e, "http://www.nic.coop/", 0x1040, f},
	{"corp", r, x, n, n, n, e, e, "https://features.icann.org/addressing-new-gtld-program-applications-corp-home-and-mail", 0x2140, t},
	{"corsica", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, s{"FR-H"}, "whois-corsica.nic.fr", e, "https://newgtlds.icann.org/", 0x4c0, t},
	{"country", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.country/", 0x40, t},
	{"coupon", r, x, s{"ns1.dns.nic.coupon", "ns2.dns.nic.coupon", "ns3.dns.nic.coupon", "ns4.dns.nic.coupon", "ns5.dns.nic.coupon", "ns6.dns.nic.coupon"}, n, n, "whois.nic.coupon", e, "https://newgtlds.icann.org/", 0x40, t},
	{"coupons", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.coupons", e, "https://newgtlds.icann.org/", 0x40, t},
	{"courses", r, x, s{"a.nic.courses", "b.nic.courses", "c.nic.courses", "d.nic.courses"}, n, n, "whois.nic.courses", e, "https://newgtlds.icann.org/", 0x40, f},
	{"cpa", r, x, s{"a.nic.cpa", "b.nic.cpa", "c.nic.cpa", "d.nic.cpa"}, n, n, "whois.nic.cpa", e, "https://newgtlds.icann.org/", 0x40, f},
	{"cr", r, z[2276:2284], s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, "whois.nic.cr", "http://www.nic.cr/niccr_publico/showRegistroDominiosScreen.do", e, 0xa0, f},
	{"credit", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.credit", e, e, 0x40, t},
	{"creditcard", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.creditcard", e, e, 0x40, t},
	{"creditunion", r, x, s{"a0.nic.creditunion", "a2.nic.creditunion", "b0.nic.creditunion", "c0.nic.creditunion"}, n, n, "whois.afilias-srs.net", e, "http://nic.creditunion/", 0x40, t},
	{"cricket", r, x, s{"ns1.dns.nic.cricket", "ns2.dns.nic.cricket", "ns3.dns.nic.cricket", "ns4.dns.nic.cricket", "ns5.dns.nic.cricket", "ns6.dns.nic.cricket"}, n, n, "whois.nic.cricket", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"crown", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"crs", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.crs", e, "http://nic.crs/", 0x42, f},
	{"cruise", r, x, s{"a0.nic.cruise", "a2.nic.cruise", "b0.nic.cruise", "c0.nic.cruise"}, n, n, "whois.nic.cruise", e, "https://newgtlds.icann.org/", 0x40, f},
	{"cruises", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.cruises", e, e, 0x40, t},
	{"csc", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.csc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cu", r, z[2284:2295], s{"cu.cctld.authdns.ripe.net", "ns.ceniai.net.cu", "ns.dns.br", "ns2.ceniai.net.cu", "ns2.gip.net", "rip.psg.com"}, n, n, e, "http://www.nic.cu/", e, 0xa0, f},
	{"cuisinella", r, x, s{"a.nic.cuisinella", "b.nic.cuisinella", "c.nic.cuisinella", "d.nic.cuisinella"}, n, n, "whois.nic.cuisinella", e, "https://newgtlds.icann.org/", 0x42, f},
	{"cv", r, z[2295:2303], s{"c.dns.pt", "cv01.dns.pt", "ns-ext.isc.org", "ns.dns.cv"}, n, n, e, "http://www.dns.cv/", e, 0xa0, f},
	{"cw", r, z[2303:2305], s{"cw.cctld.authdns.ripe.net", "kadushi.curinfo.cw", "ns0.ja.net", "ns01-server.curinfo.cw", "ns1.uoc.cw", "ns2.uoc.cw", "ns3.uoc.cw"}, n, n, e, e, "http://en.wikipedia.org/wiki/.cw", 0xa0, f},
	{"cx", r, z[2305:2310], s{"ns.anycast.nic.cx", "ns.cocca.fr"}, n, n, "whois.nic.cx", e, e, 0xa0, f},
	{"cy", r, z[2310:2323], s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, "http://www.nic.cy/nslookup/online_database.php", e, 0xa8, f},
	{"cymru", r, x, s{"dns1.nic.cymru", "dns2.nic.cymru", "dns3.nic.cymru", "dns4.nic.cymru", "dnsa.nic.cymru", "dnsb.nic.cymru", "dnsc.nic.cymru", "dnsd.nic.cymru"}, n, s{"GB-WLS"}, "whois.nic.cymru", e, "http://nic.cymru/", 0x440, t},
	{"cyou", r, x, s{"a.nic.cyou", "b.nic.cyou", "c.nic.cyou", "d.nic.cyou"}, n, n, "whois.nic.cyou", e, "https://newgtlds.icann.org/", 0x40, f},
	{"cz", r, z[2323:2324], s{"a.ns.nic.cz", "b.ns.nic.cz", "c.ns.nic.cz", "d.ns.nic.cz"}, n, n, "whois.nic.cz", e, "https://www.nic.cz/", 0xa0, t},
	{"dabur", r, x, s{"a0.nic.dabur", "a2.nic.dabur", "b0.nic.dabur", "c0.nic.dabur"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x40, f},
	{"dad", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"dance", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.dance", e, e, 0x40, t},
	{"data", r, x, s{"a0.nic.data", "a2.nic.data", "b0.nic.data", "c0.nic.data"}, n, n, "whois.nic.data", e, "https://newgtlds.icann.org/", 0x40, f},
	{"date", r, x, s{"ns1.dns.nic.date", "ns2.dns.nic.date", "ns3.dns.nic.date", "ns4.dns.nic.date", "ns5.dns.nic.date", "ns6.dns.nic.date"}, n, n, "whois.nic.date", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"dating", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.dating", e, e, 0x40, t},
	{"datsun", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"day", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"dclk", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"dds", r, x, s{"dns1.nic.dds", "dns2.nic.dds", "dns3.nic.dds", "dns4.nic.dds", "dnsa.nic.dds", "dnsb.nic.dds", "dnsc.nic.dds", "dnsd.nic.dds"}, n, n, "whois.nic.dds", e, "http://nic.dds/", 0x40, t},
	{"de", r, z[2324:2327], s{"a.nic.de", "f.nic.de", "l.de.net", "n.de.net", "s.de.net", "z.nic.de"}, n, n, "whois.denic.de", e, "https://www.denic.de/", 0xa0, t},
	{"deal", r, x, s{"dns1.nic.deal", "dns2.nic.deal", "dns3.nic.deal", "dns4.nic.deal", "dnsa.nic.deal", "dnsb.nic.deal", "dnsc.nic.deal", "dnsd.nic.deal"}, n, n, "whois.nic.deal", e, "https://newgtlds.icann.org/", 0x40, t},
	{"dealer", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.nic.dealer", e, "https://newgtlds.icann.org/", 0x40, t},
	{"deals", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.deals", e, e, 0x40, t},
	{"degree", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.degree", e, "https://newgtlds.icann.org/", 0x40, t},
	{"delivery", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.delivery", e, "https://newgtlds.icann.org/", 0x40, t},
	{"dell", r, x, s{"ns1.dns.nic.dell", "ns2.dns.nic.dell", "ns3.dns.nic.dell", "ns4.dns.nic.dell", "ns5.dns.nic.dell", "ns6.dns.nic.dell"}, n, n, "whois.nic.dell", e, "https://newgtlds.icann.org/", 0x42, f},
	{"delmonte", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"deloitte", r, x, s{"a.nic.deloitte", "b.nic.deloitte", "c.nic.deloitte", "d.nic.deloitte"}, n, n, "whois.nic.deloitte", e, "https://newgtlds.icann.org/", 0x42, t},
	{"delta", r, x, s{"a0.nic.delta", "a2.nic.delta", "b0.nic.delta", "c0.nic.delta"}, n, n, "whois.nic.delta", e, "https://newgtlds.icann.org/", 0x42, f},
	{"democrat", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.democrat", e, e, 0x40, t},
	{"dental", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.dental", e, e, 0x40, t},
	{"dentist", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.dentist", e, "https://newgtlds.icann.org/", 0x40, t},
	{"desi", r, x, s{"a.nic.desi", "b.nic.desi", "c.nic.desi", "d.nic.desi"}, n, n, "whois.nic.desi", e, e, 0x40, t},
	{"design", r, x, s{"a.nic.design", "b.nic.design", "c.nic.design", "d.nic.design"}, n, n, "whois.nic.design", e, "https://newgtlds.icann.org/", 0x40, t},
	{"deutschepost", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"dev", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"dhl", r, x, s{"a.nic.dhl", "b.nic.dhl", "c.nic.dhl", "d.nic.dhl"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"diamonds", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.diamonds", e, e, 0x40, t},
	{"diet", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.diet/", 0x40, t},
	{"digikey", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"digital", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.digital", e, e, 0x40, t},
	{"direct", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.direct", e, e, 0x40, t},
	{"directory", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.directory", e, e, 0x40, t},
	{"discount", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.discount", e, e, 0x40, t},
	{"discover", r, x, s{"ns1.dns.nic.discover", "ns2.dns.nic.discover", "ns3.dns.nic.discover", "ns4.dns.nic.discover", "ns5.dns.nic.discover", "ns6.dns.nic.discover"}, n, n, "whois.nic.discover", e, "https://newgtlds.icann.org/", 0x42, f},
	{"dish", r, x, s{"a0.nic.dish", "a2.nic.dish", "b0.nic.dish", "c0.nic.dish"}, n, n, "whois.nic.dish", e, "https://newgtlds.icann.org/", 0x42, f},
	{"diy", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.diy", e, "https://newgtlds.icann.org/", 0x40, f},
	{"dj", r, x, s{"bow1.intnet.dj", "bow5.intnet.dj", "vps443605.ovh.net"}, n, n, e, "http://www.nic.dj/whois.php", e, 0xe0, f},
	{"dk", r, z[2327:2329], s{"a.nic.dk", "b.nic.dk", "c.nic.dk", "d.nic.dk", "l.nic.dk", "p.nic.dk", "s.nic.dk"}, n, n, "whois.dk-hostmaster.dk", e, "https://www.dk-hostmaster.dk/", 0xa0, t},
	{"dm", r, z[2329:2335], s{"ns.blacknightsolutions.com", "ns2.blacknightsolutions.com", "ns2.nic.dm", "ns34.cdns.net"}, n, n, "whois.nic.dm", e, e, 0xa0, t},
	{"dnb", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"dnp", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.dnp", e, "https://newgtlds.icann.org/", 0x42, t},
	{"do", r, z[2335:2346], s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, "whois.nic.do", "http://www.nic.do/whois-h.php3", "http://www.nic.do/", 0xa0, f},
	{"docomo", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"docs", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"doctor", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.doctor", e, "https://newgtlds.icann.org/", 0x40, t},
	{"dodge", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"dog", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.dog", e, "https://newgtlds.icann.org/", 0x40, t},
	{"doha", r, x, n, n, s{"Doha", "QA-DA"}, "whois.nic.doha", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"domains", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.domains", e, e, 0x40, t},
	{"doosan", r, x, n, n, n, "whois.nic.xn--cg4bki", e, "https://newgtlds.icann.org/", 0x2042, f},
	{"dot", r, x, s{"a0.nic.dot", "a2.nic.dot", "b0.nic.dot", "c0.nic.dot"}, n, n, "whois.nic.dot", e, "https://newgtlds.icann.org/", 0x40, f},
	{"dotafrica", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"download", r, x, s{"ns1.dns.nic.download", "ns2.dns.nic.download", "ns3.dns.nic.download", "ns4.dns.nic.download", "ns5.dns.nic.download", "ns6.dns.nic.download"}, n, n, "whois.nic.download", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"drive", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"dstv", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"dtv", r, x, s{"a0.nic.dtv", "a2.nic.dtv", "b0.nic.dtv", "c0.nic.dtv"}, n, n, "whois.nic.dtv", e, "https://newgtlds.icann.org/", 0x42, f},
	{"dubai", r, x, s{"gtld.alpha.aridns.net.au", "gtld.beta.aridns.net.au", "gtld.delta.aridns.net.au", "gtld.gamma.aridns.net.au"}, n, s{"AE-DU", "Dubai"}, "whois.nic.dubai", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"duck", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.duck", e, "https://newgtlds.icann.org/", 0x40, f},
	{"dunlop", r, x, s{"a0.nic.dunlop", "a2.nic.dunlop", "b0.nic.dunlop", "c0.nic.dunlop"}, n, n, "whois.nic.dunlop", e, "https://newgtlds.icann.org/", 0x42, f},
	{"duns", r, x, n, n, n, "whois.nic.duns", e, "https://newgtlds.icann.org/", 0x42, f},
	{"dupont", r, x, s{"ns1.dns.nic.dupont", "ns2.dns.nic.dupont", "ns3.dns.nic.dupont", "ns4.dns.nic.dupont", "ns5.dns.nic.dupont", "ns6.dns.nic.dupont"}, n, n, "whois.nic.dupont", e, "https://newgtlds.icann.org/", 0x42, f},
	{"durban", r, x, s{"coza1.dnsnode.net", "ns.coza.net.za", "ns2us.dns.business"}, n, s{"Durban"}, "durban-whois.registry.net.za", e, e, 0xc4, t},
	{"dvag", r, x, s{"a.nic.dvag", "b.nic.dvag", "c.nic.dvag", "d.nic.dvag"}, n, n, "whois.nic.dvag", e, "https://newgtlds.icann.org/", 0x42, f},
	{"dvr", r, x, s{"a0.nic.dvr", "a2.nic.dvr", "b0.nic.dvr", "c0.nic.dvr"}, n, n, "whois.nic.dvr", e, "https://newgtlds.icann.org/", 0x42, f},
	{"dwg", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"dz", r, z[2346:2354], s{"ns-dz.afrinic.net", "ns1.nic.dz", "ns2.nic.dz", "ns3.nic.fr", "ns4.nic.dz", "ns5.nic.dz"}, n, n, "whois.nic.dz", e, e, 0xa0, f},
	{"earth", r, x, s{"ns1.dns.nic.earth", "ns2.dns.nic.earth", "ns3.dns.nic.earth", "ns4.dns.nic.earth", "ns5.dns.nic.earth", "ns6.dns.nic.earth"}, n, n, "whois.nic.earth", e, "https://newgtlds.icann.org/", 0x40, f},
	{"eat", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"ec", r, z[2354:2365], s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, "whois.nic.ec", e, e, 0xa0, f},
	{"eco", r, x, s{"a0.nic.eco", "a2.nic.eco", "b0.nic.eco", "c0.nic.eco"}, n, n, "whois.nic.eco", e, "http://nic.eco/", 0x40, f},
	{"ecom", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"edeka", r, x, s{"a0.nic.edeka", "a2.nic.edeka", "b0.nic.edeka", "c0.nic.edeka"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"edu", r, x, s{"a.edu-servers.net", "b.edu-servers.net", "c.edu-servers.net", "d.edu-servers.net", "e.edu-servers.net", "f.edu-servers.net", "g.edu-servers.net", "h.edu-servers.net", "i.edu-servers.net", "j.edu-servers.net", "k.edu-servers.net", "l.edu-servers.net", "m.edu-servers.net"}, n, n, "whois.educause.edu", e, e, 0x1040, f},
	{"education", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.education", e, e, 0x40, t},
	{"ee", r, z[2365:2379], s{"b.tld.ee", "e.tld.ee", "ee.aso.ee", "ee.eenet.ee", "ns.tld.ee"}, n, n, "whois.tld.ee", e, e, 0xa0, f},
	{"eg", r, z[2379:2391], s{"frcu.eun.eg", "ns5.univie.ac.at", "rip.psg.com"}, n, n, e, "http://lookup.egregistry.eg/english.aspx", e, 0xa0, f},
	{"email", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.email", e, e, 0x40, t},
	{"emerck", r, x, s{"a0.nic.emerck", "a2.nic.emerck", "b0.nic.emerck", "c0.nic.emerck"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"emerson", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"energy", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.energy", e, "https://newgtlds.icann.org/", 0x40, t},
	{"engineer", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.engineer", e, e, 0x40, t},
	{"engineering", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.engineering", e, e, 0x40, t},
	{"enterprises", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.enterprises", e, "https://newgtlds.icann.org/", 0x40, t},
	{"epost", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"epson", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.epson", e, "https://newgtlds.icann.org/", 0x42, f},
	{"equipment", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.equipment", e, e, 0x40, t},
	{"er", r, z[2391:2398], s{"er.cctld.authdns.ripe.net", "sawanew.noc.net.er", "zaranew.noc.net.er"}, n, n, e, e, e, 0xa8, f},
	{"ericsson", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.ericsson", e, "https://newgtlds.icann.org/", 0x42, f},
	{"erni", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.erni", e, "https://newgtlds.icann.org/", 0x42, f},
	{"es", r, z[2398:2403], s{"a.nic.es", "f.nic.es", "g.nic.es", "h.nic.es", "ns-es.nic.fr", "ns1.cesca.es", "ssdns-tld.nic.cl"}, n, n, "whois.nic.es", e, e, 0xa0, t},
	{"esq", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"estate", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.estate", e, e, 0x40, t},
	{"esurance", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"et", r, z[2403:2411], s{"a.nic.et", "b.nic.et"}, n, n, e, e, "http://www.ethionet.et/?q=ipservicedomainname", 0xa0, f},
	{"etisalat", r, x, s{"a.nic.etisalat", "b.nic.etisalat", "c.nic.etisalat", "d.nic.etisalat"}, n, n, "whois.centralnic.com", e, "https://newgtlds.icann.org/", 0x42, f},
	{"eu", r, z[2411:2414], s{"nl.dns.eu", "si.dns.eu", "w.dns.eu", "x.dns.eu", "y.dns.eu"}, n, n, "whois.eu", e, e, 0xa0, t},
	{"eurovision", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.eurovision", e, "https://newgtlds.icann.org/", 0x42, f},
	{"eus", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.eus", e, e, 0x440, t},
	{"events", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.events", e, e, 0x40, t},
	{"everbank", r, x, n, n, n, "whois.nic.everbank", e, "https://newgtlds.icann.org/", 0x42, f},
	{"exchange", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.exchange", e, e, 0x40, t},
	{"expert", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.expert", e, e, 0x40, t},
	{"exposed", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.exposed", e, e, 0x40, t},
	{"express", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.express", e, "https://newgtlds.icann.org/", 0x40, t},
	{"extraspace", r, x, s{"a0.nic.extraspace", "a2.nic.extraspace", "b0.nic.extraspace", "c0.nic.extraspace"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fage", r, x, s{"a0.nic.fage", "a2.nic.fage", "b0.nic.fage", "c0.nic.fage"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fail", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.fail", e, e, 0x40, t},
	{"fairwinds", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.fairwinds", e, "https://newgtlds.icann.org/", 0x42, t},
	{"faith", r, x, s{"ns1.dns.nic.faith", "ns2.dns.nic.faith", "ns3.dns.nic.faith", "ns4.dns.nic.faith", "ns5.dns.nic.faith", "ns6.dns.nic.faith"}, n, n, "whois.nic.faith", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"family", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.family", e, "https://newgtlds.icann.org/", 0x40, t},
	{"fan", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.fan", e, "https://newgtlds.icann.org/", 0x40, t},
	{"fans", r, x, s{"a.nic.fans", "b.nic.fans", "c.nic.fans", "d.nic.fans"}, n, n, "whois.nic.fans", e, "https://newgtlds.icann.org/", 0x40, f},
	{"farm", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.farm", e, e, 0x40, t},
	{"farmers", r, x, s{"ns1.dns.nic.farmers", "ns2.dns.nic.farmers", "ns3.dns.nic.farmers", "ns4.dns.nic.farmers", "ns5.dns.nic.farmers", "ns6.dns.nic.farmers"}, n, n, "whois.nic.farmers", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fashion", r, x, s{"dns1.nic.fashion", "dns2.nic.fashion", "dns3.nic.fashion", "dns4.nic.fashion", "dnsa.nic.fashion", "dnsb.nic.fashion", "dnsc.nic.fashion", "dnsd.nic.fashion"}, n, n, "whois.nic.fashion", e, "http://nic.fashion/", 0x40, t},
	{"fast", r, x, s{"dns1.nic.fast", "dns2.nic.fast", "dns3.nic.fast", "dns4.nic.fast", "dnsa.nic.fast", "dnsb.nic.fast", "dnsc.nic.fast", "dnsd.nic.fast"}, n, n, "whois.nic.fast", e, "https://newgtlds.icann.org/", 0x42, t},
	{"fedex", r, x, s{"a0.nic.fedex", "a2.nic.fedex", "b0.nic.fedex", "c0.nic.fedex"}, n, n, "whois.nic.fedex", e, "https://newgtlds.icann.org/", 0x42, f},
	{"feedback", r, x, s{"a.nic.feedback", "b.nic.feedback", "c.nic.feedback", "d.nic.feedback"}, n, n, "whois.nic.feedback", e, "https://newgtlds.icann.org/", 0x40, t},
	{"ferrari", r, x, s{"a0.nic.ferrari", "a2.nic.ferrari", "b0.nic.ferrari", "c0.nic.ferrari"}, n, n, "whois.nic.ferrari", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ferrero", r, x, s{"ns1.dns.nic.ferrero", "ns2.dns.nic.ferrero", "ns3.dns.nic.ferrero", "ns4.dns.nic.ferrero", "ns5.dns.nic.ferrero", "ns6.dns.nic.ferrero"}, n, n, "whois.nic.ferrero", e, "https://newgtlds.icann.org/", 0x42, t},
	{"fi", r, x, s{"a.fi", "b.fi", "c.fi", "d.fi", "e.fi", "f.fi", "g.fi", "h.fi", "i.fi"}, n, n, "whois.fi", e, e, 0xa0, t},
	{"fiat", r, x, s{"a0.nic.fiat", "a2.nic.fiat", "b0.nic.fiat", "c0.nic.fiat"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fidelity", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.fidelity", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fido", r, x, s{"a0.nic.fido", "a2.nic.fido", "b0.nic.fido", "c0.nic.fido"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"film", r, x, s{"a.nic.film", "b.nic.film", "c.nic.film", "d.nic.film"}, n, n, "whois.nic.film", e, "https://newgtlds.icann.org/", 0x40, f},
	{"final", r, x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, "whois.gtlds.nic.br", e, "https://newgtlds.icann.org/", 0x40, t},
	{"finance", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.finance", e, e, 0x40, t},
	{"financial", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.financial", e, e, 0x40, t},
	{"financialaid", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"finish", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"fire", r, x, s{"dns1.nic.fire", "dns2.nic.fire", "dns3.nic.fire", "dns4.nic.fire", "dnsa.nic.fire", "dnsb.nic.fire", "dnsc.nic.fire", "dnsd.nic.fire"}, n, n, "whois.nic.fire", e, "https://newgtlds.icann.org/", 0x42, t},
	{"firestone", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.firestone", e, "https://newgtlds.icann.org/", 0x42, f},
	{"firmdale", r, x, s{"ns1.nic.firmdale", "ns2.nic.firmdale"}, n, n, "whois.nic.firmdale", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fish", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.fish", e, e, 0x40, t},
	{"fishing", r, x, s{"dns1.nic.fishing", "dns2.nic.fishing", "dns3.nic.fishing", "dns4.nic.fishing", "dnsa.nic.fishing", "dnsb.nic.fishing", "dnsc.nic.fishing", "dnsd.nic.fishing"}, n, n, "whois.nic.fishing", e, "http://nic.fishing/", 0x40, t},
	{"fit", r, x, s{"dns1.nic.fit", "dns2.nic.fit", "dns3.nic.fit", "dns4.nic.fit", "dnsa.nic.fit", "dnsb.nic.fit", "dnsc.nic.fit", "dnsd.nic.fit"}, n, n, "whois.nic.fit", e, "http://nic.fit/", 0x40, t},
	{"fitness", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.fitness", e, e, 0x40, t},
	{"fj", r, z[2414:2425], s{"adns1.berkeley.edu", "adns2.berkeley.edu", "auth00.ns.uu.net", "manu.usp.ac.fj", "rip.psg.com", "teri.usp.ac.fj"}, n, n, "whois.usp.ac.fj", "http://domains.fj", e, 0xa0, f},
	{"fk", r, z[2425:2431], s{"ns1.horizon.net.fk", "ns2.horizon.net.fk", "ns3.horizon.net.fk"}, n, n, e, "http://whois.marcaria.com", e, 0xa8, f},
	{"flickr", r, x, s{"ns1.dns.nic.flickr", "ns2.dns.nic.flickr", "ns3.dns.nic.flickr", "ns4.dns.nic.flickr", "ns5.dns.nic.flickr", "ns6.dns.nic.flickr"}, n, n, "whois.nic.flickr", e, "https://newgtlds.icann.org/", 0x42, t},
	{"flights", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.flights", e, e, 0x40, t},
	{"flir", r, x, s{"ns1.dns.nic.flir", "ns2.dns.nic.flir", "ns3.dns.nic.flir", "ns4.dns.nic.flir", "ns5.dns.nic.flir", "ns6.dns.nic.flir"}, n, n, "whois.nic.flir", e, "https://newgtlds.icann.org/", 0x42, f},
	{"florist", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.florist", e, e, 0x40, t},
	{"flowers", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.flowers/", 0x40, t},
	{"fls", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"flsmidth", r, x, n, n, n, "whois.ksregistry.net", e, "https://newgtlds.icann.org/", 0x2042, f},
	{"fly", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"fm", r, z[2431:2437], s{"tld1.ultradns.net", "tld2.ultradns.net", "tld3.ultradns.org", "tld4.ultradns.org", "tld5.ultradns.info", "tld6.ultradns.co.uk"}, s{"198.74.54.240"}, n, "whois.nic.fm", "http://dot.fm/whois.html", e, 0xe0, t},
	{"fo", r, z[2437:2459], s{"a.nic.fo", "b.nic.fo", "c.nic.fo", "d.nic.fo"}, n, n, "whois.nic.fo", e, e, 0xa0, f},
	{"foo", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"food", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.food", e, "https://newgtlds.icann.org/", 0x40, f},
	{"foodnetwork", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.foodnetwork", e, "https://newgtlds.icann.org/", 0x42, f},
	{"football", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.football", e, "https://newgtlds.icann.org/", 0x40, t},
	{"ford", r, x, s{"ns1.dns.nic.ford", "ns2.dns.nic.ford", "ns3.dns.nic.ford", "ns4.dns.nic.ford", "ns5.dns.nic.ford", "ns6.dns.nic.ford"}, n, n, "whois.nic.ford", e, "https://newgtlds.icann.org/", 0x42, f},
	{"forex", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.forex", e, "https://bostonivy.co/", 0x40, f},
	{"forsale", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.forsale", e, "https://newgtlds.icann.org/", 0x40, t},
	{"forum", r, x, s{"a.nic.forum", "b.nic.forum", "c.nic.forum", "d.nic.forum"}, n, n, "whois.nic.forum", e, "https://newgtlds.icann.org/", 0x40, t},
	{"foundation", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.foundation", e, e, 0x40, t},
	{"fox", r, x, s{"ns1.dns.nic.fox", "ns2.dns.nic.fox", "ns3.dns.nic.fox", "ns4.dns.nic.fox", "ns5.dns.nic.fox", "ns6.dns.nic.fox"}, n, n, "whois.nic.fox", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fr", r, z[2459:2477], s{"d.nic.fr", "e.ext.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.fr", e, e, 0xa0, t},
	{"free", r, x, s{"dns1.nic.free", "dns2.nic.free", "dns3.nic.free", "dns4.nic.free", "dnsa.nic.free", "dnsb.nic.free", "dnsc.nic.free", "dnsd.nic.free"}, n, n, "whois.nic.free", e, "https://newgtlds.icann.org/", 0x40, t},
	{"fresenius", r, x, s{"a.nic.fresenius", "b.nic.fresenius", "c.nic.fresenius", "d.nic.fresenius"}, n, n, "whois.nic.fresenius", e, "https://newgtlds.icann.org/", 0x42, f},
	{"frl", r, x, s{"a.nic.frl", "b.nic.frl", "c.nic.frl", "d.nic.frl"}, n, s{"NL-FY"}, "whois.nic.frl", e, "https://newgtlds.icann.org/", 0x440, t},
	{"frogans", r, x, s{"a0.nic.frogans", "a2.nic.frogans", "b0.nic.frogans", "c0.nic.frogans"}, n, n, "whois.nic.frogans", e, "https://newgtlds.icann.org/", 0x42, t},
	{"frontdoor", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.frontdoor", e, "https://newgtlds.icann.org/", 0x40, f},
	{"frontier", r, x, s{"ns1.dns.nic.frontier", "ns2.dns.nic.frontier", "ns3.dns.nic.frontier", "ns4.dns.nic.frontier", "ns5.dns.nic.frontier", "ns6.dns.nic.frontier"}, n, n, "whois.nic.frontier", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ftr", r, x, s{"ns1.dns.nic.ftr", "ns2.dns.nic.ftr", "ns3.dns.nic.ftr", "ns4.dns.nic.ftr", "ns5.dns.nic.ftr", "ns6.dns.nic.ftr"}, n, n, "whois.nic.ftr", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fujitsu", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"fujixerox", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.fujixerox", e, "https://newgtlds.icann.org/", 0x42, t},
	{"fun", r, x, s{"a.nic.fun", "b.nic.fun", "e.nic.fun", "f.nic.fun"}, n, n, "whois.nic.fun", e, "https://newgtlds.icann.org/", 0x40, t},
	{"fund", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.fund", e, e, 0x40, t},
	{"furniture", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.furniture", e, e, 0x40, t},
	{"futbol", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.futbol", e, e, 0x40, t},
	{"fyi", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.fyi", e, "https://newgtlds.icann.org/", 0x40, t},
	{"ga", r, z[2477:2490], s{"a.ns.ga", "b.ns.ga", "c.ns.ga", "d.ns.ga"}, n, n, "whois.dot.ga", e, e, 0xa0, t},
	{"gal", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, s{"ES-GA"}, "whois.nic.gal", e, e, 0x4c0, t},
	{"gallery", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.gallery", e, e, 0x40, t},
	{"gallo", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.gallo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"gallup", r, x, s{"a0.nic.gallup", "a2.nic.gallup", "b0.nic.gallup", "c0.nic.gallup"}, n, n, "whois.nic.gallup", e, "https://newgtlds.icann.org/", 0x42, f},
	{"game", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.game/", 0x40, t},
	{"games", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.games", e, "https://newgtlds.icann.org/", 0x40, t},
	{"gap", r, x, s{"ns1.dns.nic.gap", "ns2.dns.nic.gap", "ns3.dns.nic.gap", "ns4.dns.nic.gap", "ns5.dns.nic.gap", "ns6.dns.nic.gap"}, n, n, "whois.nic.gap", e, "https://newgtlds.icann.org/", 0x42, f},
	{"garden", r, x, s{"dns1.nic.garden", "dns2.nic.garden", "dns3.nic.garden", "dns4.nic.garden", "dnsa.nic.garden", "dnsb.nic.garden", "dnsc.nic.garden", "dnsd.nic.garden"}, n, n, "whois.nic.garden", e, "http://nic.garden/", 0x40, t},
	{"garnier", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"gay", r, x, s{"a.nic.gay", "b.nic.gay", "c.nic.gay", "d.nic.gay"}, n, n, "whois.nic.gay", e, "https://newgtlds.icann.org/", 0x40, f},
	{"gb", r, z[2490:2491], s{"ns.uu.net", "ns0.ja.net", "ns4.ja.net"}, n, n, e, e, e, 0xa8, f},
	{"gbiz", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"gcc", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"gd", r, z[2491:2498], s{"a.nic.gd", "b.nic.gd", "c.nic.gd", "d.nic.gd"}, n, n, "whois.nic.gd", e, e, 0xa0, f},
	{"gdn", r, x, s{"ns1.nic.gdn", "ns3.nic.gdn", "ns4.nic.gdn"}, n, n, "whois.nic.gdn", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ge", r, z[2498:2506], s{"ge.hostmaster.ua", "ns.nic.ge", "ns.uu.net", "ns2.nic.fr", "ns2.nic.ge"}, n, n, "whois.nic.ge", "http://www.registration.ge/", "http://www.nic.net.ge/", 0xa0, f},
	{"gea", r, x, s{"a0.nic.gea", "a2.nic.gea", "b0.nic.gea", "c0.nic.gea"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"gecompany", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"ged", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"gent", r, x, s{"a.nic.gent", "b.nic.gent", "c.nic.gent", "d.nic.gent"}, n, s{"Gent", "Ghent"}, "whois.nic.gent", e, e, 0xc4, t},
	{"genting", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.genting", e, "https://newgtlds.icann.org/", 0x40, t},
	{"george", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.george", e, "https://newgtlds.icann.org/", 0x42, f},
	{"gf", r, x, s{"ns1-gp.mediaserv.net", "ns1-mq.mediaserv.net"}, n, n, "whois.mediaserv.net", "https://www.dom-enic.com/whois.html", e, 0xa0, f},
	{"gg", r, z[2506:2517], s{"c.ci-servers.org", "dns1.nominetdns.uk", "e.ci-servers.gg", "f.ci-servers.je", "ns0.ja.net", "ns99.dns.net.nz"}, n, n, "whois.gg", e, e, 0xa0, f},
	{"ggee", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.ggee", e, "https://newgtlds.icann.org/", 0x42, t},
	{"gh", r, z[2517:2523], s{"ns.dns.br", "ns1.nic.gh", "ns2.nic.gh"}, n, n, e, "http://www.nic.gh/customer/search_c.htm", e, 0xa8, f},
	{"gi", r, z[2523:2529], s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, "whois2.afilias-grs.net", e, e, 0xa0, f},
	{"gift", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.gift/", 0x40, t},
	{"gifts", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.gifts", e, e, 0x40, t},
	{"gives", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.gives", e, "https://newgtlds.icann.org/", 0x40, t},
	{"giving", r, x, s{"a.nic.giving", "b.nic.giving", "c.nic.giving", "d.nic.giving"}, n, n, "whois.nic.giving", e, "https://newgtlds.icann.org/", 0x40, f},
	{"gl", r, z[2529:2534], s{"a.nuuk.nic.gl", "d.nic.gl", "ns.cocca.fr"}, n, n, "whois.nic.gl", e, e, 0xa0, t},
	{"glade", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.glade", e, "https://newgtlds.icann.org/", 0x42, f},
	{"glass", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.glass", e, e, 0x40, t},
	{"gle", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"global", r, x, s{"a0.nic.global", "a2.nic.global", "b0.nic.global", "c0.nic.global"}, n, n, "whois.nic.global", e, e, 0x40, t},
	{"globalx", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"globo", r, x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, "whois.gtlds.nic.br", e, "https://newgtlds.icann.org/", 0x42, t},
	{"gm", r, x, s{"ns-gm.afrinic.net", "ns1.nic.gm", "ns2.nic.gm"}, n, n, e, "http://www.nic.gm/htmlpages/whois.htm", e, 0xa0, f},
	{"gmail", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"gmbh", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.gmbh", e, "https://newgtlds.icann.org/", 0x40, t},
	{"gmc", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"gmo", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"gmx", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.gmx", e, "https://newgtlds.icann.org/", 0x42, t},
	{"gn", r, z[2534:2540], s{"fork.sth.dnsnode.net", "ns-gn.afrinic.net", "rip.psg.com"}, n, n, e, e, e, 0xa8, f},
	{"godaddy", r, x, s{"a0.nic.godaddy", "a2.nic.godaddy", "b0.nic.godaddy", "c0.nic.godaddy"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"gold", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.gold", e, "https://newgtlds.icann.org/", 0x40, t},
	{"goldpoint", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.goldpoint", e, "https://newgtlds.icann.org/", 0x42, t},
	{"golf", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.golf", e, "https://newgtlds.icann.org/", 0x40, t},
	{"goo", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"goodhands", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"goodyear", r, x, s{"a0.nic.goodyear", "a2.nic.goodyear", "b0.nic.goodyear", "c0.nic.goodyear"}, n, n, "whois.nic.goodyear", e, "https://newgtlds.icann.org/", 0x42, f},
	{"goog", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"google", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"gop", r, x, s{"dns1.nic.gop", "dns2.nic.gop", "dns3.nic.gop", "dns4.nic.gop", "dnsa.nic.gop", "dnsb.nic.gop", "dnsc.nic.gop", "dnsd.nic.gop"}, n, n, "whois.nic.gop", e, "http://nic.gop/", 0x40, f},
	{"got", r, x, s{"dns1.nic.got", "dns2.nic.got", "dns3.nic.got", "dns4.nic.got", "dnsa.nic.got", "dnsb.nic.got", "dnsc.nic.got", "dnsd.nic.got"}, n, n, "whois.nic.got", e, "https://newgtlds.icann.org/", 0x42, t},
	{"gotv", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"gov", r, x, s{"a.gov-servers.net", "b.gov-servers.net", "c.gov-servers.net", "d.gov-servers.net"}, n, n, "whois.dotgov.gov", e, e, 0x1040, f},
	{"gp", r, z[2540:2551], s{"a.lactld.org", "gp.cctld.authdns.ripe.net", "ns-gp.nic.fr", "ns1.nic.gp", "ns2.nic.gp"}, n, n, "whois.nic.gp", "https://www.dom-enic.com/whois.html", e, 0xa0, f},
	{"gq", r, x, s{"a.ns.gq", "b.ns.gq", "c.ns.gq", "d.ns.gq"}, n, n, "whois.dominio.gq", e, e, 0xa0, t},
	{"gr", r, z[2551:2556], s{"estia.ics.forth.gr", "gr-at.ics.forth.gr", "gr-c.ics.forth.gr", "gr-d.ics.forth.gr", "gr-m.ics.forth.gr", "grdns.ics.forth.gr"}, n, n, e, "https://grweb.ics.forth.gr/Whois?lang=en", e, 0xa0, t},
	{"grainger", r, x, s{"ns1.dns.nic.grainger", "ns2.dns.nic.grainger", "ns3.dns.nic.grainger", "ns4.dns.nic.grainger", "ns5.dns.nic.grainger", "ns6.dns.nic.grainger"}, n, n, "whois.nic.grainger", e, "https://newgtlds.icann.org/", 0x42, f},
	{"graphics", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.graphics", e, e, 0x40, t},
	{"gratis", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.gratis", e, e, 0x40, t},
	{"gree", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"green", r, x, s{"a0.nic.green", "a2.nic.green", "b0.nic.green", "c0.nic.green"}, n, n, "whois.afilias.net", e, "http://nic.green/", 0x40, f},
	{"gripe", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.gripe", e, e, 0x40, t},
	{"grocery", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"group", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.group", e, "https://newgtlds.icann.org/", 0x40, t},
	{"gs", r, x, s{"ns.anycast.nic.gs", "ns.cocca.fr"}, n, n, "whois.nic.gs", e, e, 0xa0, f},
	{"gt", r, z[2556:2563], s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, "http://www.gt/", e, 0xa0, f},
	{"gu", r, z[2563:2570], s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, "http://gadao.gov.gu/domainsearch.htm", "http://gadao.gov.gu", 0xa0, f},
	{"guardian", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"guardianlife", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"guardianmedia", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"gucci", r, x, s{"ns1.dns.nic.gucci", "ns2.dns.nic.gucci", "ns3.dns.nic.gucci", "ns4.dns.nic.gucci", "ns5.dns.nic.gucci", "ns6.dns.nic.gucci"}, n, n, "whois.nic.gucci", e, "https://newgtlds.icann.org/", 0x42, t},
	{"guge", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"guide", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.guide", e, e, 0x40, t},
	{"guitars", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.guitars/", 0x40, t},
	{"guru", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.guru", e, e, 0x40, t},
	{"gw", r, x, s{"gw01.dns.pt", "gw03.dns.pt", "h.dns.pt"}, n, n, e, "http://nic.gw/en/whois/", e, 0xa0, f},
	{"gy", r, z[2570:2574], s{"a.lactld.org", "gy-ns.anycast.pch.net", "ns.cocca.fr"}, n, n, "whois.registry.gy", e, e, 0xa0, f},
	{"hair", r, x, s{"a.nic.hair", "b.nic.hair", "c.nic.hair", "d.nic.hair"}, n, n, "whois.nic.hair", e, "https://newgtlds.icann.org/", 0x40, t},
	{"halal", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"hamburg", r, x, s{"a.dns.nic.hamburg", "m.dns.nic.hamburg", "n.dns.nic.hamburg"}, n, s{"Hamburg", "DE-HH"}, "whois.nic.hamburg", e, e, 0xc4, t},
	{"hangout", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"haus", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.haus", e, e, 0x40, t},
	{"hbo", r, x, s{"ns1.dns.nic.hbo", "ns2.dns.nic.hbo", "ns3.dns.nic.hbo", "ns4.dns.nic.hbo", "ns5.dns.nic.hbo", "ns6.dns.nic.hbo"}, n, n, "whois.nic.hbo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hdfc", r, x, s{"a0.nic.hdfc", "a2.nic.hdfc", "b0.nic.hdfc", "c0.nic.hdfc"}, n, n, "whois.nic.hdfc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hdfcbank", r, x, s{"a0.nic.hdfcbank", "a2.nic.hdfcbank", "b0.nic.hdfcbank", "c0.nic.hdfcbank"}, n, n, "whois.nic.hdfcbank", e, "https://newgtlds.icann.org/", 0x42, f},
	{"health", r, x, s{"ns1.dns.nic.health", "ns2.dns.nic.health", "ns3.dns.nic.health", "ns4.dns.nic.health", "ns5.dns.nic.health", "ns6.dns.nic.health"}, n, n, "whois.nic.health", e, "https://newgtlds.icann.org/", 0x40, f},
	{"healthcare", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.healthcare", e, e, 0x40, t},
	{"heart", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"heinz", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"help", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.help/", 0x40, t},
	{"helsinki", r, x, s{"a0.nic.helsinki", "a2.nic.helsinki", "b0.nic.helsinki", "c0.nic.helsinki"}, n, n, "whois.nic.helsinki", e, "https://newgtlds.icann.org/", 0x40, f},
	{"here", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"hermes", r, x, s{"a0.nic.hermes", "a2.nic.hermes", "b0.nic.hermes", "c0.nic.hermes"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hgtv", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.hgtv", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hilton", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"hiphop", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.hiphop", 0x40, t},
	{"hisamitsu", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hitachi", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"hiv", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.hiv/", 0x40, t},
	{"hk", r, z[2574:2583], s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, "whois.hkirc.hk", e, e, 0xa0, t},
	{"hkt", r, x, s{"a0.nic.hkt", "a2.nic.hkt", "b0.nic.hkt", "c0.nic.hkt"}, n, n, "whois.nic.hkt", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hm", r, x, s{"ns1.registry.hm", "ns2.registry.hm", "ns3.registry.hm"}, n, n, "whois.registry.hm", e, "http://www.registry.hm/", 0xa0, f},
	{"hn", r, z[2583:2589], s{"a.lactld.org", "nicmx-anycast.rds.org.hn", "pch-anycast.rds.org.hn"}, n, n, "whois.nic.hn", e, e, 0xa0, f},
	{"hockey", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.hockey", e, "https://newgtlds.icann.org/", 0x40, t},
	{"holdings", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.holdings", e, e, 0x40, t},
	{"holiday", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.holiday", e, e, 0x40, t},
	{"home", r, x, n, n, n, e, e, "https://features.icann.org/addressing-new-gtld-program-applications-corp-home-and-mail", 0x2140, t},
	{"homedepot", r, x, s{"a0.nic.homedepot", "a2.nic.homedepot", "b0.nic.homedepot", "c0.nic.homedepot"}, n, n, "whois.nic.homedepot", e, "https://newgtlds.icann.org/", 0x42, f},
	{"homegoods", r, x, s{"ns1.dns.nic.homegoods", "ns2.dns.nic.homegoods", "ns3.dns.nic.homegoods", "ns4.dns.nic.homegoods", "ns5.dns.nic.homegoods", "ns6.dns.nic.homegoods"}, n, n, "whois.nic.homegoods", e, "https://newgtlds.icann.org/", 0x42, f},
	{"homes", r, x, s{"a0.nic.homes", "a2.nic.homes", "b0.nic.homes", "c0.nic.homes"}, n, n, "whois.afilias-srs.net", e, "http://nic.homes/", 0x40, f},
	{"homesense", r, x, s{"ns1.dns.nic.homesense", "ns2.dns.nic.homesense", "ns3.dns.nic.homesense", "ns4.dns.nic.homesense", "ns5.dns.nic.homesense", "ns6.dns.nic.homesense"}, n, n, "whois.nic.homesense", e, "https://newgtlds.icann.org/", 0x42, f},
	{"honda", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.honda", e, "https://newgtlds.icann.org/", 0x42, f},
	{"honeywell", r, x, n, n, n, "whois.nic.honeywell", e, "https://newgtlds.icann.org/", 0x42, f},
	{"horse", r, x, s{"dns1.nic.horse", "dns2.nic.horse", "dns3.nic.horse", "dns4.nic.horse", "dnsa.nic.horse", "dnsb.nic.horse", "dnsc.nic.horse", "dnsd.nic.horse"}, n, n, "whois.nic.horse", e, "http://nic.horse/", 0x40, t},
	{"hospital", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.hospital", e, "https://newgtlds.icann.org/", 0x40, t},
	{"host", r, x, s{"a.nic.host", "b.nic.host", "e.nic.host", "f.nic.host"}, n, n, "whois.nic.host", e, e, 0x40, t},
	{"hosting", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.hosting/", 0x40, t},
	{"hot", r, x, s{"dns1.nic.hot", "dns2.nic.hot", "dns3.nic.hot", "dns4.nic.hot", "dnsa.nic.hot", "dnsb.nic.hot", "dnsc.nic.hot", "dnsd.nic.hot"}, n, n, "whois.nic.hot", e, "https://newgtlds.icann.org/", 0x40, t},
	{"hoteis", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"hotel", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"hoteles", r, x, s{"ns1.dns.nic.hoteles", "ns2.dns.nic.hoteles", "ns3.dns.nic.hoteles", "ns4.dns.nic.hoteles", "ns5.dns.nic.hoteles", "ns6.dns.nic.hoteles"}, n, n, "whois.nic.hoteles", e, "https://newgtlds.icann.org/", 0x40, f},
	{"hotels", r, x, s{"ns1.dns.nic.hotels", "ns2.dns.nic.hotels", "ns3.dns.nic.hotels", "ns4.dns.nic.hotels", "ns5.dns.nic.hotels", "ns6.dns.nic.hotels"}, n, n, "whois.nic.hotels", e, "https://newgtlds.icann.org/", 0x40, f},
	{"hotmail", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"house", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.house", e, e, 0x40, t},
	{"how", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"hr", r, z[2589:2593], s{"hr-ns-1.carnet.hr", "n.dns.hr", "pch.carnet.hr"}, n, n, "whois.dns.hr", e, e, 0xa0, f},
	{"hsbc", r, x, s{"ns1.dns.nic.hsbc", "ns2.dns.nic.hsbc", "ns3.dns.nic.hsbc", "ns4.dns.nic.hsbc", "ns5.dns.nic.hsbc", "ns6.dns.nic.hsbc"}, n, n, "whois.nic.hsbc", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ht", r, z[2593:2610], s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, "whois.nic.ht", e, e, 0xa0, f},
	{"htc", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2842, f},
	{"hu", r, z[2610:2644], s{"a.hu", "b.hu", "c.hu", "d.hu", "e.hu", "ns-com.nic.hu", "ns2.nic.fr"}, n, n, "whois.nic.hu", e, e, 0xa0, t},
	{"hughes", r, x, s{"a0.nic.hughes", "a2.nic.hughes", "b0.nic.hughes", "c0.nic.hughes"}, n, n, "whois.nic.hughes", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hyatt", r, x, s{"ns1.dns.nic.hyatt", "ns2.dns.nic.hyatt", "ns3.dns.nic.hyatt", "ns4.dns.nic.hyatt", "ns5.dns.nic.hyatt", "ns6.dns.nic.hyatt"}, n, n, "whois.nic.hyatt", e, "https://newgtlds.icann.org/", 0x42, f},
	{"hyundai", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.hyundai", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ibm", r, x, s{"a.nic.ibm", "b.nic.ibm", "c.nic.ibm", "d.nic.ibm"}, n, n, "whois.nic.ibm", e, "https://newgtlds.icann.org/", 0x42, f},
	{"icbc", r, x, s{"a0.nic.icbc", "a2.nic.icbc", "b0.nic.icbc", "c0.nic.icbc"}, n, n, "whois.nic.icbc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ice", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.ice", e, "https://newgtlds.icann.org/", 0x42, f},
	{"icu", r, x, s{"a.nic.icu", "b.nic.icu", "c.nic.icu", "d.nic.icu"}, n, n, "whois.nic.icu", e, "https://newgtlds.icann.org/", 0x42, t},
	{"id", r, z[2644:2656], s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id", "ns4.apnic.net"}, n, n, "whois.id", e, "https://pandi.id/", 0xa0, t},
	{"idn", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"ie", r, z[2656:2661], s{"b.ns.ie", "c.ns.ie", "d.ns.ie", "g.ns.ie", "h.ns.ie", "i.ns.ie"}, n, n, "whois.iedr.ie", e, "https://www.iedr.ie/", 0xa0, t},
	{"ieee", r, x, s{"ns1.dns.nic.ieee", "ns2.dns.nic.ieee", "ns3.dns.nic.ieee", "ns4.dns.nic.ieee", "ns5.dns.nic.ieee", "ns6.dns.nic.ieee"}, n, n, "whois.nic.ieee", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ifm", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.ifm", e, "https://newgtlds.icann.org/", 0x42, t},
	{"iinet", r, x, n, n, n, "whois.aridnrs.net.au", e, "https://newgtlds.icann.org/", 0x2042, f},
	{"ikano", r, x, s{"a.dns.nic.ikano", "m.dns.nic.ikano", "n.dns.nic.ikano"}, n, n, "whois.nic.ikano", e, "https://newgtlds.icann.org/", 0x42, t},
	{"il", r, z[2661:2669], s{"ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, "whois.isoc.org.il", e, "http://www.isoc.org.il/domains/", 0xa8, t},
	{"im", r, z[2669:2675], s{"barney.advsys.co.uk", "hoppy.iom.com", "ns4.ja.net", "pebbles.iom.com"}, n, n, "whois.nic.im", e, e, 0xa0, f},
	{"imamat", r, x, s{"a0.nic.imamat", "a2.nic.imamat", "b0.nic.imamat", "c0.nic.imamat"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"imdb", r, x, s{"dns1.nic.imdb", "dns2.nic.imdb", "dns3.nic.imdb", "dns4.nic.imdb", "dnsa.nic.imdb", "dnsb.nic.imdb", "dnsc.nic.imdb", "dnsd.nic.imdb"}, n, n, "whois.nic.imdb", e, "https://newgtlds.icann.org/", 0x42, t},
	{"immo", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.immo", e, "https://newgtlds.icann.org/", 0x40, t},
	{"immobilien", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.immobilien", e, e, 0x40, t},
	{"in", r, z[2675:2687], s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0xa0, f},
	{"inc", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.nic.inc", e, "https://newgtlds.icann.org/", 0x40, t},
	{"indians", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"industries", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.industries", e, e, 0x40, t},
	{"infiniti", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"info", r, z[2687:2688], s{"a0.info.afilias-nst.info", "a2.info.afilias-nst.info", "b0.info.afilias-nst.org", "b2.info.afilias-nst.org", "c0.info.afilias-nst.info", "d0.info.afilias-nst.org"}, n, n, "whois.afilias.net", e, "http://info.info/", 0x40, t},
	{"infosys", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"infy", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"ing", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"ink", r, x, s{"a.nic.ink", "b.nic.ink", "c.nic.ink", "d.nic.ink"}, n, n, "whois.nic.ink", e, e, 0x40, t},
	{"institute", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.institute", e, e, 0x40, t},
	{"insurance", r, x, s{"a.nic.insurance", "b.nic.insurance", "c.nic.insurance", "d.nic.insurance", "e.nic.insurance", "f.nic.insurance"}, n, n, "whois.nic.insurance", e, "https://newgtlds.icann.org/", 0x40, f},
	{"insure", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.insure", e, e, 0x40, t},
	{"int", r, z[2688:2689], s{"ns.uu.net", "ns0.ja.net", "sec2.authdns.ripe.net", "x.iana-servers.net", "y.iana-servers.net", "z.iana-servers.net"}, n, n, "whois.iana.org", e, e, 0x1040, f},
	{"intel", r, x, n, n, n, "whois.nic.intel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"international", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.international", e, e, 0x40, t},
	{"intuit", r, x, s{"ns1.dns.nic.intuit", "ns2.dns.nic.intuit", "ns3.dns.nic.intuit", "ns4.dns.nic.intuit", "ns5.dns.nic.intuit", "ns6.dns.nic.intuit"}, n, n, "whois.nic.intuit", e, "https://newgtlds.icann.org/", 0x42, f},
	{"investments", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.investments", e, e, 0x40, t},
	{"io", r, z[2689:2691], s{"a0.nic.io", "a2.nic.io", "b0.nic.io", "c0.nic.io"}, n, n, "whois.nic.io", e, "http://nic.io/", 0xe0, t},
	{"ipiranga", r, x, s{"ns1.dns.nic.ipiranga", "ns2.dns.nic.ipiranga", "ns3.dns.nic.ipiranga", "ns4.dns.nic.ipiranga", "ns5.dns.nic.ipiranga", "ns6.dns.nic.ipiranga"}, n, n, "whois.nic.ipiranga", e, "https://newgtlds.icann.org/", 0x42, f},
	{"iq", r, z[2691:2701], s{"iq.cctld.authdns.ripe.net", "ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq"}, n, n, "whois.cmc.iq", e, e, 0xa0, f},
	{"ir", r, z[2701:2708], s{"a.nic.ir", "b.nic.ir", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, "whois.nic.ir", e, e, 0xa0, t},
	{"ira", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"irish", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.irish", e, "https://newgtlds.icann.org/", 0x40, t},
	{"is", r, x, s{"bes.isnic.is", "durinn.rhnet.is", "isgate.is", "sab.isnic.is", "sunic.sunet.se"}, n, n, "whois.isnic.is", e, e, 0xa0, t},
	{"iselect", r, x, n, n, n, "whois.nic.iselect", e, "https://newgtlds.icann.org/", 0x42, f},
	{"islam", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"ismaili", r, x, s{"a0.nic.ismaili", "a2.nic.ismaili", "b0.nic.ismaili", "c0.nic.ismaili"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ist", r, x, s{"a0.nic.ist", "a2.nic.ist", "b0.nic.ist", "c0.nic.ist"}, n, s{"Istanbul", "TR-34"}, "whois.afilias-srs.net", e, "http://nic.ist/", 0xc4, f},
	{"istanbul", r, x, s{"a0.nic.istanbul", "a2.nic.istanbul", "b0.nic.istanbul", "c0.nic.istanbul"}, n, s{"Istanbul", "TR-34"}, "whois.afilias-srs.net", e, "http://nic.istanbul/", 0xc4, f},
	{"it", r, z[2708:3069], s{"a.dns.it", "dns.nic.it", "m.dns.it", "nameserver.cnr.it", "r.dns.it", "s.dns.it"}, n, n, "whois.nic.it", e, "http://www.nic.it/", 0xa0, t},
	{"itau", r, x, s{"ns1.dns.nic.itau", "ns2.dns.nic.itau", "ns3.dns.nic.itau", "ns4.dns.nic.itau", "ns5.dns.nic.itau", "ns6.dns.nic.itau"}, n, n, "whois.nic.itau", e, "https://newgtlds.icann.org/", 0x42, f},
	{"itv", r, x, s{"a0.nic.itv", "a2.nic.itv", "b0.nic.itv", "c0.nic.itv"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"iveco", r, x, s{"a0.nic.iveco", "a2.nic.iveco", "b0.nic.iveco", "c0.nic.iveco"}, n, n, "whois.nic.iveco", e, "https://newgtlds.icann.org/", 0x42, f},
	{"iwc", r, x, n, n, n, "whois.nic.iwc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jaguar", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.jaguar", e, "https://newgtlds.icann.org/", 0x42, f},
	{"java", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.java", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jcb", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"jcp", r, x, s{"a0.nic.jcp", "a2.nic.jcp", "b0.nic.jcp", "c0.nic.jcp"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"je", r, z[3069:3075], s{"c.ci-servers.org", "dns1.nominetdns.uk", "e.ci-servers.gg", "f.ci-servers.je", "ns0.ja.net", "ns99.dns.net.nz"}, n, n, "whois.je", e, e, 0xa0, f},
	{"jeep", r, x, s{"a0.nic.jeep", "a2.nic.jeep", "b0.nic.jeep", "c0.nic.jeep"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jetzt", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.jetzt", e, e, 0x40, t},
	{"jewelry", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.jewelry", e, "https://newgtlds.icann.org/", 0x40, t},
	{"jio", r, x, s{"a0.nic.jio", "a2.nic.jio", "b0.nic.jio", "c0.nic.jio"}, n, n, "whois.nic.jio", e, "https://newgtlds.icann.org/", 0x40, f},
	{"jlc", r, x, n, n, n, "whois.nic.jlc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jll", r, x, s{"a0.nic.jll", "a2.nic.jll", "b0.nic.jll", "c0.nic.jll"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jm", r, z[3075:3081], s{"jm.cctld.authdns.ripe.net", "ns.jm", "ns.utechjamaica.edu.jm", "ns3-jm.fsl.org.jm", "phloem.uoregon.edu"}, n, n, e, e, e, 0xa8, f},
	{"jmp", r, x, s{"ns1.dns.nic.jmp", "ns2.dns.nic.jmp", "ns3.dns.nic.jmp", "ns4.dns.nic.jmp", "ns5.dns.nic.jmp", "ns6.dns.nic.jmp"}, n, n, "whois.nic.jmp", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jnj", r, x, s{"ns1.dns.nic.jnj", "ns2.dns.nic.jnj", "ns3.dns.nic.jnj", "ns4.dns.nic.jnj", "ns5.dns.nic.jnj", "ns6.dns.nic.jnj"}, n, n, "whois.nic.jnj", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jo", r, z[3081:3089], s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, "http://www.dns.jo/Whois.aspx", e, 0xa0, f},
	{"jobs", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.jobs", e, e, 0x1040, f},
	{"joburg", r, x, s{"coza1.dnsnode.net", "ns.coza.net.za", "ns2us.dns.business"}, n, s{"Johannesburg"}, "joburg-whois.registry.net.za", e, e, 0xc4, t},
	{"jot", r, x, s{"dns1.nic.jot", "dns2.nic.jot", "dns3.nic.jot", "dns4.nic.jot", "dnsa.nic.jot", "dnsb.nic.jot", "dnsc.nic.jot", "dnsd.nic.jot"}, n, n, "whois.nic.jot", e, "https://newgtlds.icann.org/", 0x40, t},
	{"joy", r, x, s{"dns1.nic.joy", "dns2.nic.joy", "dns3.nic.joy", "dns4.nic.joy", "dnsa.nic.joy", "dnsb.nic.joy", "dnsc.nic.joy", "dnsd.nic.joy"}, n, n, "whois.nic.joy", e, "https://newgtlds.icann.org/", 0x40, t},
	{"jp", r, z[3089:3192], s{"a.dns.jp", "b.dns.jp", "c.dns.jp", "d.dns.jp", "e.dns.jp", "f.dns.jp", "g.dns.jp", "h.dns.jp"}, n, n, "whois.jprs.jp", e, e, 0xa0, t},
	{"jpmorgan", r, x, s{"ns1.dns.nic.jpmorgan", "ns2.dns.nic.jpmorgan", "ns3.dns.nic.jpmorgan", "ns4.dns.nic.jpmorgan", "ns5.dns.nic.jpmorgan", "ns6.dns.nic.jpmorgan"}, n, n, "whois.nic.jpmorgan", e, "https://newgtlds.icann.org/", 0x42, f},
	{"jpmorganchase", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"jprs", r, x, s{"tld1.nic.jprs", "tld2.nic.jprs", "tld3.nic.jprs", "tld4.nic.jprs", "tld5.nic.jprs"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"juegos", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.juegos/", 0x40, t},
	{"juniper", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.juniper", e, "https://newgtlds.icann.org/", 0x42, f},
	{"justforu", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"kaufen", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.kaufen", e, e, 0x40, t},
	{"kddi", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.kddi", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ke", r, z[3192:3201], s{"kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, "whois.kenic.or.ke", e, "http://www.kenic.or.ke/", 0xa8, f},
	{"kerastase", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"kerryhotels", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.kerryhotels", e, "https://newgtlds.icann.org/", 0x42, f},
	{"kerrylogisitics", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"kerrylogistics", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.kerrylogistics", e, e, 0x0, t},
	{"kerryproperties", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.kerryproperties", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ketchup", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"kfh", r, x, s{"a.nic.kfh", "b.nic.kfh", "c.nic.kfh", "d.nic.kfh"}, n, n, "whois.nic.kfh", e, "https://newgtlds.icann.org/", 0x42, f},
	{"kg", r, z[3201:3207], s{"kg.cctld.authdns.ripe.net", "ns.kg"}, n, n, "whois.kg", e, e, 0xa0, f},
	{"kh", r, z[3207:3214], s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0xa0, f},
	{"ki", r, z[3214:3226], s{"ns.cocca.fr", "pch.nic.ki"}, n, n, "whois.nic.ki", e, e, 0xa0, f},
	{"kia", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.kia", e, "https://newgtlds.icann.org/", 0x42, f},
	{"kid", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"kids", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"kiehls", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"kim", r, x, s{"a0.nic.kim", "a2.nic.kim", "b0.nic.kim", "c0.nic.kim"}, n, n, "whois.afilias.net", e, "http://nic.kim/", 0x40, f},
	{"kinder", r, x, s{"ns1.dns.nic.kinder", "ns2.dns.nic.kinder", "ns3.dns.nic.kinder", "ns4.dns.nic.kinder", "ns5.dns.nic.kinder", "ns6.dns.nic.kinder"}, n, n, "whois.nic.kinder", e, "https://newgtlds.icann.org/", 0x40, t},
	{"kindle", r, x, s{"dns1.nic.kindle", "dns2.nic.kindle", "dns3.nic.kindle", "dns4.nic.kindle", "dnsa.nic.kindle", "dnsb.nic.kindle", "dnsc.nic.kindle", "dnsd.nic.kindle"}, n, n, "whois.nic.kindle", e, "https://newgtlds.icann.org/", 0x42, t},
	{"kitchen", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.kitchen", e, e, 0x40, t},
	{"kiwi", r, x, s{"a.ns.nic.kiwi", "b.ns.nic.kiwi"}, n, n, "whois.nic.kiwi", e, e, 0x40, t},
	{"km", r, z[3226:3240], s{"dns1.nic.km", "dns2.nic.km", "ns-km.afrinic.net"}, n, n, e, e, e, 0xa0, f},
	{"kn", r, z[3240:3246], s{"ns.cocca.fr", "ns.coccaregistry.org", "pch.nic.kn"}, n, n, "whois.nic.kn", "http://www.nic.kn/", e, 0xa0, f},
	{"koeln", r, x, s{"dns.ryce-rsp.com", "ns1.dns.business", "ns1.ryce-rsp.com"}, n, s{"Cologne", "Koeln"}, "whois.ryce-rsp.com", e, e, 0xc4, t},
	{"komatsu", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.komatsu", e, "https://newgtlds.icann.org/", 0x42, f},
	{"konami", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"kone", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"kosher", r, x, s{"a0.nic.kosher", "a2.nic.kosher", "b0.nic.kosher", "c0.nic.kosher"}, n, n, "whois.nic.kosher", e, "https://newgtlds.icann.org/", 0x40, f},
	{"kp", r, z[3246:3250], s{"ns1.kptc.kp", "ns2.kptc.kp"}, n, n, e, e, e, 0xa0, f},
	{"kpmg", r, x, s{"ns1.dns.nic.kpmg", "ns2.dns.nic.kpmg", "ns3.dns.nic.kpmg", "ns4.dns.nic.kpmg", "ns5.dns.nic.kpmg", "ns6.dns.nic.kpmg"}, n, n, "whois.nic.kpmg", e, "https://newgtlds.icann.org/", 0x42, t},
	{"kpn", r, x, s{"a.nic.kpn", "b.nic.kpn", "c.nic.kpn", "d.nic.kpn"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"kr", r, z[3250:3279], s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, "whois.kr", e, e, 0xa0, t},
	{"krd", r, x, s{"a.nic.krd", "b.nic.krd", "c.nic.krd", "d.nic.krd"}, n, n, "whois.nic.krd", e, "https://newgtlds.icann.org/", 0x440, f},
	{"kred", r, x, s{"a.nic.kred", "b.nic.kred", "c.nic.kred", "d.nic.kred"}, n, n, "whois.nic.kred", e, "https://newgtlds.icann.org/", 0x50, t},
	{"kuokgroup", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.kuokgroup", e, "https://newgtlds.icann.org/", 0x42, f},
	{"kw", r, z[3279:3284], s{"a.nic.kw", "b.nic.kw", "c.nic.kw", "d.nic.kw", "e.nic.kw", "pch.nic.kw"}, n, n, e, "http://www.kw/", e, 0xa0, f},
	{"ky", r, z[3284:3289], s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.kyregistry.ky", "http://kynseweb.messagesecure.com/kywebadmin/", e, 0xa0, f},
	{"kyknet", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"kyoto", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, s{"Kyoto", "JP-26"}, "whois.nic.kyoto", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"kz", r, z[3289:3295], s{"ns.nic.kz", "ns1.nic.kz"}, n, n, "whois.nic.kz", e, e, 0xa0, f},
	{"la", r, x, s{"ns1.nic.la", "ns2.nic.la", "ns3.nic.la", "ns4.nic.la"}, n, s{"Los Angeles"}, "whois.nic.la", e, e, 0xa4, t},
	{"lacaixa", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.lacaixa", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ladbrokes", r, x, n, n, n, "whois.nic.ladbrokes", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lamborghini", r, x, s{"a0.nic.lamborghini", "a2.nic.lamborghini", "b0.nic.lamborghini", "c0.nic.lamborghini"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lamer", r, x, s{"a0.nic.lamer", "a2.nic.lamer", "b0.nic.lamer", "c0.nic.lamer"}, n, n, "whois.nic.lamer", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lancaster", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.lancaster", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lancia", r, x, s{"a0.nic.lancia", "a2.nic.lancia", "b0.nic.lancia", "c0.nic.lancia"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lancome", r, x, n, n, n, "whois.nic.lancome", e, "https://newgtlds.icann.org/", 0x42, f},
	{"land", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.land", e, e, 0x40, t},
	{"landrover", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.landrover", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lanxess", r, x, s{"ns1.dns.nic.lanxess", "ns2.dns.nic.lanxess", "ns3.dns.nic.lanxess", "ns4.dns.nic.lanxess", "ns5.dns.nic.lanxess", "ns6.dns.nic.lanxess"}, n, n, "whois.nic.lanxess", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lasalle", r, x, s{"a0.nic.lasalle", "a2.nic.lasalle", "b0.nic.lasalle", "c0.nic.lasalle"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lat", r, x, s{"c.mx-ns.mx", "e.mx-ns.mx", "i.mx-ns.mx", "m.mx-ns.mx", "o.mx-ns.mx", "x.mx-ns.mx"}, n, n, "whois.nic.lat", e, "http://nic.lat/", 0x40, t},
	{"latino", r, x, s{"a0.nic.latino", "a2.nic.latino", "b0.nic.latino", "c0.nic.latino"}, n, n, "whois.nic.latino", e, "https://newgtlds.icann.org/", 0x40, f},
	{"latrobe", r, x, s{"a.nic.latrobe", "b.nic.latrobe", "c.nic.latrobe", "d.nic.latrobe"}, n, n, "whois.nic.latrobe", e, "https://newgtlds.icann.org/", 0x42, f},
	{"law", r, x, s{"dns1.nic.law", "dns2.nic.law", "dns3.nic.law", "dns4.nic.law", "dnsa.nic.law", "dnsb.nic.law", "dnsc.nic.law", "dnsd.nic.law"}, n, n, "whois.nic.law", e, "http://nic.law/", 0x40, t},
	{"lawyer", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.lawyer", e, e, 0x40, t},
	{"lb", r, z[3295:3300], s{"fork.sth.dnsnode.net", "rip.psg.com", "zeina.aub.edu.lb"}, n, n, e, "http://www.aub.edu.lb/lbdr/", e, 0xa8, f},
	{"lc", r, z[3300:3309], s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, "whois.afilias-grs.info", "http://www.nic.lc", e, 0xa0, f},
	{"lds", r, x, s{"a0.nic.lds", "a2.nic.lds", "b0.nic.lds", "c0.nic.lds"}, n, n, "whois.nic.lds", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lease", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.lease", e, e, 0x40, t},
	{"leclerc", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois-leclerc.nic.fr", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lefrak", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.lefrak", e, "https://newgtlds.icann.org/", 0x42, f},
	{"legal", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.legal", e, "https://newgtlds.icann.org/", 0x40, t},
	{"lego", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.lego", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lexus", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.lexus", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lgbt", r, x, s{"a0.nic.lgbt", "a2.nic.lgbt", "b0.nic.lgbt", "c0.nic.lgbt"}, n, n, "whois.afilias.net", e, "http://nic.lgbt/", 0x40, f},
	{"li", r, x, s{"a.nic.li", "b.nic.li", "c.nic.li", "e.nic.li", "f.nic.li", "g.nic.li", "h.nic.li"}, n, n, "whois.nic.li", e, e, 0xa0, t},
	{"liaison", r, x, n, n, n, "whois.nic.liaison", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lidl", r, x, s{"a.nic.lidl", "b.nic.lidl", "c.nic.lidl", "d.nic.lidl"}, n, n, "whois.nic.lidl", e, "https://newgtlds.icann.org/", 0x42, t},
	{"life", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.life", e, e, 0x40, t},
	{"lifeinsurance", r, x, s{"ns1.dns.nic.lifeinsurance", "ns2.dns.nic.lifeinsurance", "ns3.dns.nic.lifeinsurance", "ns4.dns.nic.lifeinsurance", "ns5.dns.nic.lifeinsurance", "ns6.dns.nic.lifeinsurance"}, n, n, "whois.nic.lifeinsurance", e, "https://newgtlds.icann.org/", 0x40, f},
	{"lifestyle", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.lifestyle", e, "https://newgtlds.icann.org/", 0x40, f},
	{"lighting", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.lighting", e, e, 0x40, t},
	{"like", r, x, s{"dns1.nic.like", "dns2.nic.like", "dns3.nic.like", "dns4.nic.like", "dnsa.nic.like", "dnsb.nic.like", "dnsc.nic.like", "dnsd.nic.like"}, n, n, "whois.nic.like", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lilly", r, x, s{"ns1.dns.nic.lilly", "ns2.dns.nic.lilly", "ns3.dns.nic.lilly", "ns4.dns.nic.lilly", "ns5.dns.nic.lilly", "ns6.dns.nic.lilly"}, n, n, "whois.nic.lilly", e, "https://newgtlds.icann.org/", 0x42, f},
	{"limited", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.limited", e, e, 0x40, t},
	{"limo", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.limo", e, e, 0x40, t},
	{"lincoln", r, x, s{"ns1.dns.nic.lincoln", "ns2.dns.nic.lincoln", "ns3.dns.nic.lincoln", "ns4.dns.nic.lincoln", "ns5.dns.nic.lincoln", "ns6.dns.nic.lincoln"}, n, n, "whois.nic.lincoln", e, "https://newgtlds.icann.org/", 0x42, f},
	{"linde", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.linde", e, "https://newgtlds.icann.org/", 0x42, t},
	{"link", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.link/", 0x40, t},
	{"lipsy", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.lipsy", e, "https://newgtlds.icann.org/", 0x42, f},
	{"live", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.live", e, "https://newgtlds.icann.org/", 0x40, t},
	{"livestrong", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"living", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"lixil", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.lixil", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lk", r, z[3309:3323], s{"c.nic.lk", "d.nic.lk", "l.nic.lk", "m.nic.lk", "ns1.ac.lk", "p.nic.lk", "pendragon.cs.purdue.edu", "t.nic.lk"}, n, n, "whois.nic.lk", e, e, 0xa0, f},
	{"llc", r, x, s{"a0.nic.llc", "a2.nic.llc", "b0.nic.llc", "c0.nic.llc"}, n, n, "whois.afilias.net", e, "https://newgtlds.icann.org/", 0x40, f},
	{"llp", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "https://newgtlds.icann.org/", 0x40, f},
	{"loan", r, x, s{"ns1.dns.nic.loan", "ns2.dns.nic.loan", "ns3.dns.nic.loan", "ns4.dns.nic.loan", "ns5.dns.nic.loan", "ns6.dns.nic.loan"}, n, n, "whois.nic.loan", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"loans", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.loans", e, e, 0x40, t},
	{"locker", r, x, s{"a0.nic.locker", "a2.nic.locker", "b0.nic.locker", "c0.nic.locker"}, n, n, "whois.nic.locker", e, "https://newgtlds.icann.org/", 0x42, f},
	{"locus", r, x, s{"dns1.nic.locus", "dns2.nic.locus", "dns3.nic.locus", "dns4.nic.locus", "dnsa.nic.locus", "dnsb.nic.locus", "dnsc.nic.locus", "dnsd.nic.locus"}, n, n, "whois.nic.locus", e, "https://newgtlds.icann.org/", 0x42, f},
	{"loft", r, x, s{"ns1.dns.nic.loft", "ns2.dns.nic.loft", "ns3.dns.nic.loft", "ns4.dns.nic.loft", "ns5.dns.nic.loft", "ns6.dns.nic.loft"}, n, n, "whois.nic.loft", e, "https://newgtlds.icann.org/", 0x40, f},
	{"lol", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.lol/", 0x40, t},
	{"london", r, x, s{"dns1.nic.london", "dns2.nic.london", "dns3.nic.london", "dns4.nic.london", "dnsa.nic.london", "dnsb.nic.london", "dnsc.nic.london", "dnsd.nic.london"}, n, s{"London", "GB-LND", "GB-BDG", "GB-BNE", "GB-BEX", "GB-BEN", "GB-BRY", "GB-CMD", "GB-CRY", "GB-EAL", "GB-ENF", "GB-GRE", "GB-HCK", "GB-HMF", "GB-HRY", "GB-HRW", "GB-HAV", "GB-HIL", "GB-HNS", "GB-ISL", "GB-KEC", "GB-KTT", "GB-LBH", "GB-LEW", "GB-MRT", "GB-NWM", "GB-RDB", "GB-RIC", "GB-SWK", "GB-STN", "GB-TWH", "GB-WFT", "GB-WND", "GB-WSM"}, "whois.nic.london", e, "http://nic.london/", 0xc4, t},
	{"loreal", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"lotte", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.lotte", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lotto", r, x, s{"a0.nic.lotto", "a2.nic.lotto", "b0.nic.lotto", "c0.nic.lotto"}, n, n, "whois.afilias.net", e, "https://nic.lotto/", 0x40, f},
	{"love", r, x, s{"a.nic.love", "b.nic.love", "c.nic.love", "d.nic.love"}, n, n, "whois.nic.love", e, "https://newgtlds.icann.org/", 0x40, t},
	{"lpl", r, x, s{"a.nic.lpl", "b.nic.lpl", "c.nic.lpl", "d.nic.lpl"}, n, n, "whois.nic.lpl", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lplfinancial", r, x, s{"a.nic.lplfinancial", "b.nic.lplfinancial", "c.nic.lplfinancial", "d.nic.lplfinancial"}, n, n, "whois.nic.lplfinancial", e, "https://newgtlds.icann.org/", 0x42, t},
	{"lr", r, z[3323:3329], s{"fork.sth.dnsnode.net", "ns-lr.afrinic.net", "rip.psg.com"}, n, n, e, e, e, 0xa8, f},
	{"ls", r, z[3329:3335], s{"ls-ns.anycast.pch.net", "ns-ls.afrinic.net", "ns1.nic.ls", "ns2.nic.ls"}, n, n, "whois.nic.ls", "http://www.co.ls/co.asp", "http://www.co.ls/", 0xa8, f},
	{"lt", r, z[3335:3336], s{"a.tld.lt", "b.tld.lt", "c.tld.lt", "d.tld.lt", "e.tld.lt", "f.tld.lt"}, n, n, "whois.domreg.lt", e, e, 0xa0, t},
	{"ltd", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.ltd", e, "https://newgtlds.icann.org/", 0x40, t},
	{"ltda", r, x, s{"a0.nic.ltda", "a2.nic.ltda", "b0.nic.ltda", "c0.nic.ltda"}, n, n, "whois.afilias-srs.net", e, "https://nic.ltda/", 0x40, f},
	{"lu", r, x, s{"g.dns.lu", "i.dns.lu", "j.dns.lu", "k.dns.lu", "ns1.dns.lu", "p.dns.lu"}, n, n, "whois.dns.lu", e, e, 0xa0, t},
	{"lundbeck", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.lundbeck", e, "https://newgtlds.icann.org/", 0x42, f},
	{"lupin", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"luxe", r, x, s{"dns1.nic.luxe", "dns2.nic.luxe", "dns3.nic.luxe", "dns4.nic.luxe", "dnsa.nic.luxe", "dnsb.nic.luxe", "dnsc.nic.luxe", "dnsd.nic.luxe"}, n, n, "whois.nic.luxe", e, "http://nix.luxe/", 0x40, t},
	{"luxury", r, x, s{"a.nic.luxury", "b.nic.luxury", "c.nic.luxury", "d.nic.luxury"}, n, n, "whois.nic.luxury", e, "http://nic.luxury/", 0x40, f},
	{"lv", r, z[3336:3345], s{"a.nic.lv", "b.nic.lv", "c.nic.lv", "d.nic.lv", "sunic.sunet.se"}, n, n, "whois.nic.lv", e, e, 0xa0, t},
	{"ly", r, z[3345:3354], s{"dns.lttnet.net", "dns1.lttnet.net", "ns-ly.afrinic.net", "pch.ltt.ly", "phloem.uoregon.edu"}, n, n, "whois.nic.ly", e, "http://nic.ly/", 0xa0, f},
	{"ma", r, z[3354:3360], s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "dns.inria.fr", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, "whois.registre.ma", e, e, 0xa0, f},
	{"macys", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.macys", e, "https://newgtlds.icann.org/", 0x42, f},
	{"madrid", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, s{"Madrid", "ES-MD"}, "whois.nic.madrid", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"maif", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"mail", r, x, n, n, n, e, e, "https://features.icann.org/addressing-new-gtld-program-applications-corp-home-and-mail", 0x2140, t},
	{"maison", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.maison", e, e, 0x40, t},
	{"makeup", r, x, s{"a.nic.makeup", "b.nic.makeup", "c.nic.makeup", "d.nic.makeup"}, n, n, "whois.nic.makeup", e, "https://newgtlds.icann.org/", 0x42, f},
	{"man", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.man", e, "https://newgtlds.icann.org/", 0x42, t},
	{"management", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.management", e, e, 0x40, t},
	{"mango", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.mango", e, "https://newgtlds.icann.org/", 0x42, t},
	{"map", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"market", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.market", e, e, 0x40, t},
	{"marketing", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.marketing", e, e, 0x40, t},
	{"markets", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.markets", e, "https://bostonivy.co/", 0x40, f},
	{"marriott", r, x, s{"a0.nic.marriott", "a2.nic.marriott", "b0.nic.marriott", "c0.nic.marriott"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"marshalls", r, x, s{"ns1.dns.nic.marshalls", "ns2.dns.nic.marshalls", "ns3.dns.nic.marshalls", "ns4.dns.nic.marshalls", "ns5.dns.nic.marshalls", "ns6.dns.nic.marshalls"}, n, n, "whois.nic.marshalls", e, "https://newgtlds.icann.org/", 0x42, f},
	{"maserati", r, x, s{"a0.nic.maserati", "a2.nic.maserati", "b0.nic.maserati", "c0.nic.maserati"}, n, n, "whois.nic.maserati", e, "https://newgtlds.icann.org/", 0x42, f},
	{"matrix", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"mattel", r, x, s{"ns1.dns.nic.mattel", "ns2.dns.nic.mattel", "ns3.dns.nic.mattel", "ns4.dns.nic.mattel", "ns5.dns.nic.mattel", "ns6.dns.nic.mattel"}, n, n, "whois.nic.mattel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"maybelline", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"mba", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.mba", e, "https://newgtlds.icann.org/", 0x40, t},
	{"mc", r, z[3360:3362], s{"mc.cctld.authdns.ripe.net", "ns1.nic.mc", "ns2.nic.mc"}, n, n, e, e, "http://www.nic.mc/", 0xa0, f},
	{"mcd", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"mcdonalds", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"mckinsey", r, x, s{"a0.nic.mckinsey", "a2.nic.mckinsey", "b0.nic.mckinsey", "c0.nic.mckinsey"}, n, n, "whois.nic.mckinsey", e, "https://newgtlds.icann.org/", 0x42, f},
	{"md", r, x, s{"nsa.tld.md", "nsb.tld.md", "nsc.dns.md", "nsf.dns.md", "nsr.dns.md"}, n, n, "whois.nic.md", e, e, 0xa0, f},
	{"me", r, z[3362:3370], s{"a0.nic.me", "a2.nic.me", "b0.nic.me", "b2.nic.me", "c0.nic.me"}, n, n, "whois.nic.me", e, "http://domain.me/", 0xe0, f},
	{"med", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.med", e, "https://newgtlds.icann.org/", 0x40, f},
	{"media", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.media", e, e, 0x40, t},
	{"medical", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"meet", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"melbourne", r, x, s{"a.nic.melbourne", "b.nic.melbourne", "c.nic.melbourne", "d.nic.melbourne"}, n, s{"Melbourne"}, "whois.nic.melbourne", e, "http://nic.melbourne/", 0xc4, f},
	{"meme", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"memorial", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.memorial", e, "https://newgtlds.icann.org/", 0x40, t},
	{"men", r, x, s{"a.nic.men", "b.nic.men", "c.nic.men", "d.nic.men"}, n, n, "whois.nic.men", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"menu", r, x, s{"a.nic.menu", "b.nic.menu", "c.nic.menu", "d.nic.menu"}, n, n, "whois.nic.menu", e, e, 0x40, f},
	{"meo", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"merck", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"merckmsd", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"metlife", r, x, n, n, n, "whois.nic.metlife", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mf", r, x, n, n, n, e, e, "http://en.wikipedia.org/wiki/.mf", 0x8a0, f},
	{"mg", r, z[3370:3381], s{"censvrns0001.ird.fr", "ns-mg.malagasy.com", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, "whois.nic.mg", e, e, 0xa0, f},
	{"mh", r, x, s{"ns.amarshallinc.com", "ns.ntamar.net"}, n, n, e, e, e, 0xa8, f},
	{"miami", r, x, s{"dns1.nic.miami", "dns2.nic.miami", "dns3.nic.miami", "dns4.nic.miami", "dnsa.nic.miami", "dnsb.nic.miami", "dnsc.nic.miami", "dnsd.nic.miami"}, n, s{"Miami"}, "whois.nic.miami", e, "http://nic.miami/", 0xc4, t},
	{"microsoft", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"mih", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"mii", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"mil", r, x, s{"con1.nipr.mil", "con2.nipr.mil", "eur1.nipr.mil", "eur2.nipr.mil", "pac1.nipr.mil", "pac2.nipr.mil"}, n, n, "is-1.nic.mil", e, e, 0x1040, f},
	{"mini", r, x, s{"a.nic.mini", "b.nic.mini", "c.nic.mini", "d.nic.mini"}, n, n, "whois.nic.mini", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mint", r, x, s{"ns1.dns.nic.mint", "ns2.dns.nic.mint", "ns3.dns.nic.mint", "ns4.dns.nic.mint", "ns5.dns.nic.mint", "ns6.dns.nic.mint"}, n, n, "whois.nic.mint", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mit", r, x, s{"a0.nic.mit", "a2.nic.mit", "b0.nic.mit", "c0.nic.mit"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mitek", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"mitsubishi", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mk", r, z[3381:3389], s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, "whois.marnet.mk", e, e, 0xa0, f},
	{"ml", r, z[3389:3395], s{"a.ns.ml", "b.ns.ml", "c.ns.ml", "d.ns.ml"}, n, n, "whois.dot.ml", e, e, 0xa0, t},
	{"mlb", r, x, s{"ns1.dns.nic.mlb", "ns2.dns.nic.mlb", "ns3.dns.nic.mlb", "ns4.dns.nic.mlb", "ns5.dns.nic.mlb", "ns6.dns.nic.mlb"}, n, n, "whois.nic.mlb", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mls", r, x, s{"a.ns.nic.mls", "b.ns.nic.mls"}, n, n, "whois.nic.mls", e, "https://newgtlds.icann.org/", 0x40, t},
	{"mm", r, z[3395:3403], s{"a.nic.net.mm", "b.nic.net.mm", "c.nic.net.mm", "d.nic.net.mm"}, n, n, "whois.registry.gov.mm", e, e, 0xa8, f},
	{"mma", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.mma", e, "https://newgtlds.icann.org/", 0x42, t},
	{"mn", r, z[3403:3406], s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "ns1.magic.mn", "ns2.magic.mn", "ns3.magic.mn", "ns4.magic.mn"}, n, n, "whois.nic.mn", e, e, 0xa0, f},
	{"mnet", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"mo", r, z[3406:3412], s{"a.monic.mo", "b.monic.mo", "c.monic.mo", "d.monic.mo", "e.monic.mo", "ns17.cdns.net", "ns2.cuhk.edu.hk"}, n, n, "whois.monic.mo", e, e, 0xa0, f},
	{"mobi", r, x, s{"a0.mobi.afilias-nst.info", "a2.mobi.afilias-nst.info", "b0.mobi.afilias-nst.org", "b2.mobi.afilias-nst.org", "c0.mobi.afilias-nst.info", "d0.mobi.afilias-nst.org"}, n, n, "whois.nic.mobi", e, "https://dotmobi.mobi/", 0x1040, t},
	{"mobile", r, x, s{"a0.nic.mobile", "a2.nic.mobile", "b0.nic.mobile", "c0.nic.mobile"}, n, n, "whois.nic.mobile", e, "https://newgtlds.icann.org/", 0x40, f},
	{"mobily", r, x, n, n, n, "whois.nic.mobily", e, "https://newgtlds.icann.org/", 0x40, f},
	{"moda", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.moda", e, e, 0x40, t},
	{"moe", r, x, s{"ns1.dns.nic.moe", "ns2.dns.nic.moe", "ns3.dns.nic.moe", "ns4.dns.nic.moe", "ns5.dns.nic.moe", "ns6.dns.nic.moe"}, n, n, "whois.nic.moe", e, e, 0x40, t},
	{"moi", r, x, s{"dns1.nic.moi", "dns2.nic.moi", "dns3.nic.moi", "dns4.nic.moi", "dnsa.nic.moi", "dnsb.nic.moi", "dnsc.nic.moi", "dnsd.nic.moi"}, n, n, "whois.nic.moi", e, "https://newgtlds.icann.org/", 0x42, t},
	{"mom", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.mom/", 0x40, t},
	{"monash", r, x, s{"a.nic.monash", "b.nic.monash", "c.nic.monash", "d.nic.monash"}, n, n, "whois.nic.monash", e, "https://newgtlds.icann.org/", 0x42, f},
	{"money", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.money", e, "https://newgtlds.icann.org/", 0x40, t},
	{"monster", r, x, s{"a.nic.monster", "b.nic.monster", "c.nic.monster", "d.nic.monster"}, n, n, "whois.nic.monster", e, "https://newgtlds.icann.org/", 0x42, f},
	{"montblanc", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"mopar", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mormon", r, x, s{"a0.nic.mormon", "a2.nic.mormon", "b0.nic.mormon", "c0.nic.mormon"}, n, n, "whois.nic.mormon", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mortgage", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.mortgage", e, e, 0x40, t},
	{"moscow", r, x, s{"a.dns.flexireg.ru", "b.dns.flexireg.net", "c.dns.flexireg.org", "d.dns.flexireg.domains"}, n, s{"Moscow", "RU-MOW"}, "whois.nic.moscow", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"moto", r, x, s{"ns1.dns.nic.moto", "ns2.dns.nic.moto", "ns3.dns.nic.moto", "ns4.dns.nic.moto", "ns5.dns.nic.moto", "ns6.dns.nic.moto"}, n, n, "whois.nic.moto", e, "https://newgtlds.icann.org/", 0x40, f},
	{"motorcycles", r, x, s{"a0.nic.motorcycles", "a2.nic.motorcycles", "b0.nic.motorcycles", "c0.nic.motorcycles"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x40, f},
	{"mov", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"movie", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.movie", e, "https://newgtlds.icann.org/", 0x40, t},
	{"movistar", r, x, n, n, n, "whois-fe.movistar.tango.knipp.de", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mozaic", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"mp", r, z[3412:3416], s{"ns1.nic.mp", "ns2.nic.mp", "ns3.nic.mp", "ns4.nic.mp"}, n, n, "whois.nic.mp", e, "http://chi.mp/", 0xa0, f},
	{"mq", r, x, s{"ns1-fr.mediaserv.net", "ns1-gp.mediaserv.net", "ns1-mq.mediaserv.net"}, n, n, "whois.mediaserv.net", "https://www.dom-enic.com/whois.html", e, 0xa0, f},
	{"mr", r, z[3416:3420], s{"ns-mr.afrinic.net", "ns-mr.nic.fr", "ns-mr.nic.tn", "ns1.nic.mr", "ns2.nic.mr", "ns3.nic.mr"}, n, n, "whois.nic.mr", e, e, 0xa0, f},
	{"mrmuscle", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"mrporter", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"ms", r, z[3420:3424], s{"ms-ns.anycast.pch.net", "ns.cocca.fr"}, n, n, "whois.nic.ms", e, e, 0xe0, f},
	{"msd", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"mt", r, z[3424:3429], s{"a.ns.mt", "b.ns.mt", "f.ns.mt", "p.ns.mt"}, n, n, e, "https://www.nic.org.mt/dotmt/", e, 0xa0, f},
	{"mtn", r, x, s{"a.nic.mtn", "b.nic.mtn", "c.nic.mtn", "d.nic.mtn"}, n, n, "whois.nic.mtn", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mtpc", r, x, n, n, n, "whois.nic.mtpc", e, "https://newgtlds.icann.org/", 0x2042, f},
	{"mtr", r, x, s{"ns1.nic.mtr", "ns2.nic.mtr", "ns3.nic.mtr", "ns4.nic.mtr"}, n, n, "whois.nic.mtr", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mu", r, z[3429:3438], s{"anycast1.irondns.net", "fork.sth.dnsnode.net", "udns1.tld.mu", "udns2.tld.mu"}, n, n, "whois.nic.mu", e, e, 0xa0, f},
	{"multichoice", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"museum", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.museum", e, "http://about.museum/", 0x1040, t},
	{"music", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"mutual", r, x, s{"ns1.dns.nic.mutual", "ns2.dns.nic.mutual", "ns3.dns.nic.mutual", "ns4.dns.nic.mutual", "ns5.dns.nic.mutual", "ns6.dns.nic.mutual"}, n, n, "whois.nic.mutual", e, "https://newgtlds.icann.org/", 0x42, f},
	{"mutualfunds", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"mutuelle", r, x, n, n, n, "whois-mutuelle.nic.fr", e, "https://newgtlds.icann.org/", 0x840, f},
	{"mv", r, z[3438:3452], s{"mv-ns.anycast.pch.net", "ns.dhivehinet.net.mv", "ns2.dhivehinet.net.mv"}, n, n, e, e, e, 0xa0, f},
	{"mw", r, z[3452:3462], s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "mw.cctld.authdns.ripe.net", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, "whois.nic.mw", "http://www.registrar.mw/", e, 0xa0, f},
	{"mx", r, z[3462:3467], s{"c.mx-ns.mx", "e.mx-ns.mx", "i.mx-ns.mx", "m.mx-ns.mx", "o.mx-ns.mx", "x.mx-ns.mx"}, n, n, "whois.mx", e, e, 0xa0, f},
	{"my", r, z[3467:3475], s{"a.mynic.centralnic-dns.com", "a.nic.my", "a1.nic.my", "b.mynic.centralnic-dns.com", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, "whois.mynic.my", e, e, 0xa0, t},
	{"mz", r, z[3475:3482], s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, "whois.nic.mz", "http://www.domains.co.mz", e, 0xa8, f},
	{"mzansimagic", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"na", r, z[3482:3500], s{"anyc2.irondns.net", "etld-1.anycast.net", "na-ns.anycast.pch.net", "na.anycastdns.cz"}, n, n, "whois.na-nic.com.na", e, e, 0xa0, f},
	{"nab", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.nab", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nadex", r, x, n, n, n, "whois.nic.nadex", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nagoya", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, s{"Nagoya-shi"}, "whois.nic.nagoya", e, e, 0xc4, t},
	{"name", r, z[3500:3503], s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.name", e, e, 0x40, t},
	{"naspers", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"nationwide", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.nationwide", e, "https://newgtlds.icann.org/", 0x42, f},
	{"natura", r, x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, "whois.gtlds.nic.br", e, "https://newgtlds.icann.org/", 0x42, t},
	{"navy", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.navy", e, e, 0x40, t},
	{"nba", r, x, s{"ns1.dns.nic.nba", "ns2.dns.nic.nba", "ns3.dns.nic.nba", "ns4.dns.nic.nba", "ns5.dns.nic.nba", "ns6.dns.nic.nba"}, n, n, "whois.nic.nba", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nc", r, z[3503:3506], s{"any-ns1.nc", "nc.cctld.authdns.ripe.net", "ns1.nc", "ns2.nc"}, n, n, "whois.nc", e, e, 0xa0, f},
	{"ne", r, z[3506:3511], s{"bow.rain.fr", "ne.cctld.authdns.ripe.net", "ns-ne.afrinic.net", "ns.intnet.ne"}, n, n, e, e, e, 0xa0, f},
	{"nec", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.nec", e, "https://newgtlds.icann.org/", 0x42, f},
	{"net", r, z[3511:3521], s{"a.gtld-servers.net", "b.gtld-servers.net", "c.gtld-servers.net", "d.gtld-servers.net", "e.gtld-servers.net", "f.gtld-servers.net", "g.gtld-servers.net", "h.gtld-servers.net", "i.gtld-servers.net", "j.gtld-servers.net", "k.gtld-servers.net", "l.gtld-servers.net", "m.gtld-servers.net"}, n, n, "whois.verisign-grs.com", e, "http://www.verisigninc.com/en_US/products-and-services/domain-name-services/registry-services/index.xhtml", 0x40, t},
	{"netaporter", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"netbank", r, x, s{"a.nic.netbank", "b.nic.netbank", "c.nic.netbank", "d.nic.netbank"}, n, n, "whois.nic.netbank", e, "https://newgtlds.icann.org/", 0x42, f},
	{"netflix", r, x, s{"ns1.dns.nic.netflix", "ns2.dns.nic.netflix", "ns3.dns.nic.netflix", "ns4.dns.nic.netflix", "ns5.dns.nic.netflix", "ns6.dns.nic.netflix"}, n, n, "whois.nic.netflix", e, "https://newgtlds.icann.org/", 0x42, f},
	{"network", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.network", e, "https://newgtlds.icann.org/", 0x40, t},
	{"neustar", r, x, s{"ns1.dns.nic.neustar", "ns2.dns.nic.neustar", "ns3.dns.nic.neustar", "ns4.dns.nic.neustar", "ns5.dns.nic.neustar", "ns6.dns.nic.neustar"}, n, n, "whois.nic.neustar", e, "https://newgtlds.icann.org/", 0x42, t},
	{"new", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"newholland", r, x, s{"a0.nic.newholland", "a2.nic.newholland", "b0.nic.newholland", "c0.nic.newholland"}, n, n, "whois.nic.newholland", e, "https://newgtlds.icann.org/", 0x42, f},
	{"news", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.news", e, "https://newgtlds.icann.org/", 0x40, t},
	{"next", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.next", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nextdirect", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.nextdirect", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nexus", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"nf", r, z[3521:3533], s{"ns.anycast.nic.nf", "ns.cocca.fr"}, n, n, "whois.nic.nf", e, e, 0xa0, f},
	{"nfl", r, x, s{"ns1.dns.nic.nfl", "ns2.dns.nic.nfl", "ns3.dns.nic.nfl", "ns4.dns.nic.nfl", "ns5.dns.nic.nfl", "ns6.dns.nic.nfl"}, n, n, "whois.nic.nfl", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ng", r, z[3533:3543], s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, "whois.nic.net.ng", e, "www.web4africa.com.ng", 0xa0, f},
	{"ngo", r, x, s{"a0.nic.ngo", "a2.nic.ngo", "b0.nic.ngo", "b2.nic.ngo", "c0.nic.ngo", "d0.nic.ngo"}, n, n, "whois.publicinterestregistry.net", e, "https://pir.org/products/ngo-ong-domain/", 0x40, t},
	{"nhk", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.nhk", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ni", r, z[3543:3558], s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, "http://www.nic.ni/", "http://www.nic.ni/", 0xa8, f},
	{"nico", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.nico", e, "https://newgtlds.icann.org/", 0x42, t},
	{"nike", r, x, s{"ns1.dns.nic.nike", "ns2.dns.nic.nike", "ns3.dns.nic.nike", "ns4.dns.nic.nike", "ns5.dns.nic.nike", "ns6.dns.nic.nike"}, n, n, "whois.nic.nike", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nikon", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.nikon", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ninja", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.ninja", e, e, 0x40, t},
	{"nissan", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"nissay", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.nissay", e, "https://newgtlds.icann.org/", 0x42, t},
	{"nl", r, z[3558:3564], s{"ns1.dns.nl", "ns2.dns.nl", "ns3.dns.nl"}, n, n, "whois.domain-registry.nl", e, e, 0xa0, f},
	{"no", r, z[3564:3574], s{"i.nic.no", "njet.norid.no", "not.norid.no", "x.nic.no", "y.nic.no", "z.nic.no"}, n, n, "whois.norid.no", e, e, 0xa0, t},
	{"nokia", r, x, s{"a0.nic.nokia", "a2.nic.nokia", "b0.nic.nokia", "c0.nic.nokia"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"northlandinsurance", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"northwesternmutual", r, x, s{"ns1.dns.nic.northwesternmutual", "ns2.dns.nic.northwesternmutual", "ns3.dns.nic.northwesternmutual", "ns4.dns.nic.northwesternmutual", "ns5.dns.nic.northwesternmutual", "ns6.dns.nic.northwesternmutual"}, n, n, "whois.nic.northwesternmutual", e, "https://newgtlds.icann.org/", 0x42, f},
	{"norton", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.norton", e, "https://newgtlds.icann.org/", 0x42, t},
	{"now", r, x, s{"dns1.nic.now", "dns2.nic.now", "dns3.nic.now", "dns4.nic.now", "dnsa.nic.now", "dnsb.nic.now", "dnsc.nic.now", "dnsd.nic.now"}, n, n, "whois.nic.now", e, "https://newgtlds.icann.org/", 0x40, t},
	{"nowruz", r, x, s{"a.ns.nic.nowruz", "b.ns.nic.nowruz", "ns.cocca.fr"}, n, s{"Iran"}, "whois.nic.nowruz", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nowtv", r, x, s{"a0.nic.nowtv", "a2.nic.nowtv", "b0.nic.nowtv", "c0.nic.nowtv"}, n, n, "whois.nic.nowtv", e, "https://newgtlds.icann.org/", 0x42, f},
	{"np", r, z[3574:3720], s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, "http://register.mos.com.np/np-whois-lookup", e, 0xa8, f},
	{"nr", r, z[3720:3727], s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "ns2.cenpac.net.nr", "phloem.uoregon.edu"}, n, n, e, "http://www.cenpac.net.nr/dns/whois.html", e, 0xa0, f},
	{"nra", r, x, s{"a0.nic.nra", "a2.nic.nra", "b0.nic.nra", "c0.nic.nra"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"nrw", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, s{"DE-NW"}, "whois.nic.nrw", e, "https://newgtlds.icann.org/", 0x440, t},
	{"ntt", r, x, s{"tld1.nic.ntt", "tld2.nic.ntt", "tld3.nic.ntt", "tld5.nic.ntt"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"nu", r, z[3727:3732], s{"a.ns.nu", "c.ns.nu", "d.ns.nu", "m.ns.nu", "y.ns.nu", "z.ns.nu"}, n, n, "whois.iis.nu", e, "http://www.nic.nu/", 0xe0, t},
	{"nyc", r, x, s{"ns1.dns.nic.nyc", "ns2.dns.nic.nyc", "ns3.dns.nic.nyc", "ns4.dns.nic.nyc", "ns5.dns.nic.nyc", "ns6.dns.nic.nyc"}, n, s{"New York City"}, "whois.nic.nyc", e, e, 0xc4, t},
	{"nz", r, z[3732:3747], s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, "whois.srs.net.nz", e, e, 0xa0, t},
	{"obi", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.obi", e, "https://newgtlds.icann.org/", 0x42, f},
	{"observer", r, x, s{"a.nic.observer", "b.nic.observer", "c.nic.observer", "d.nic.observer"}, n, n, "whois.nic.observer", e, "https://newgtlds.icann.org/", 0x42, f},
	{"off", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.off", e, "https://newgtlds.icann.org/", 0x42, f},
	{"office", r, x, s{"ns1.dns.nic.office", "ns2.dns.nic.office", "ns3.dns.nic.office", "ns4.dns.nic.office", "ns5.dns.nic.office", "ns6.dns.nic.office"}, n, n, "whois.nic.office", e, "https://newgtlds.icann.org/", 0x42, f},
	{"okinawa", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, s{"Okinawa", "JP-47"}, "whois.nic.okinawa", e, e, 0xc4, t},
	{"olayan", r, x, s{"a.nic.olayan", "b.nic.olayan", "c.nic.olayan", "d.nic.olayan"}, n, n, "whois.nic.olayan", e, "https://newgtlds.icann.org/", 0x42, f},
	{"olayangroup", r, x, s{"a.nic.olayangroup", "b.nic.olayangroup", "c.nic.olayangroup", "d.nic.olayangroup"}, n, n, "whois.nic.olayangroup", e, "https://newgtlds.icann.org/", 0x42, f},
	{"oldnavy", r, x, s{"ns1.dns.nic.oldnavy", "ns2.dns.nic.oldnavy", "ns3.dns.nic.oldnavy", "ns4.dns.nic.oldnavy", "ns5.dns.nic.oldnavy", "ns6.dns.nic.oldnavy"}, n, n, "whois.nic.oldnavy", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ollo", r, x, s{"a0.nic.ollo", "a2.nic.ollo", "b0.nic.ollo", "c0.nic.ollo"}, n, n, "whois.nic.ollo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"olympus", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"om", r, z[3747:3760], s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, "whois.registry.om", e, "http://www.registry.om", 0xa0, f},
	{"omega", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.omega", e, "https://newgtlds.icann.org/", 0x42, t},
	{"one", r, x, s{"a.nic.one", "b.nic.one", "c.nic.one", "d.nic.one"}, n, n, "whois.nic.one", e, "https://newgtlds.icann.org/", 0x40, f},
	{"ong", r, x, s{"a0.nic.ong", "a2.nic.ong", "b0.nic.ong", "b2.nic.ong", "c0.nic.ong", "d0.nic.ong"}, n, n, "whois.publicinterestregistry.net", e, "https://pir.org/products/ngo-ong-domain/", 0x40, f},
	{"onl", r, x, s{"a0.nic.onl", "a2.nic.onl", "b0.nic.onl", "c0.nic.onl"}, n, n, "whois.afilias-srs.net", e, "http://nic.onl/", 0x40, f},
	{"online", r, x, s{"a.nic.online", "b.nic.online", "e.nic.online", "f.nic.online"}, n, n, "whois.nic.online", e, "https://newgtlds.icann.org/", 0x40, t},
	{"onyourside", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.onyourside", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ooo", r, x, s{"a.nic.ooo", "b.nic.ooo", "c.nic.ooo", "d.nic.ooo"}, n, n, "whois.nic.ooo", e, e, 0x40, t},
	{"open", r, x, s{"ns1.dns.nic.open", "ns2.dns.nic.open", "ns3.dns.nic.open", "ns4.dns.nic.open", "ns5.dns.nic.open", "ns6.dns.nic.open"}, n, n, "whois.nic.open", e, "https://newgtlds.icann.org/", 0x42, f},
	{"oracle", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.oracle", e, "https://newgtlds.icann.org/", 0x42, f},
	{"orange", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.orange", e, "https://newgtlds.icann.org/", 0x42, t},
	{"org", r, z[3760:3766], s{"a0.org.afilias-nst.info", "a2.org.afilias-nst.info", "b0.org.afilias-nst.org", "b2.org.afilias-nst.org", "c0.org.afilias-nst.info", "d0.org.afilias-nst.org"}, n, n, "whois.pir.org", e, "https://pir.org/products/org-domain/", 0x40, t},
	{"organic", r, x, s{"a0.nic.organic", "a2.nic.organic", "b0.nic.organic", "c0.nic.organic"}, n, n, "whois.afilias.net", e, "http://nic.organic/", 0x40, f},
	{"orientexpress", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x2042, f},
	{"origin", r, x, n, n, n, "whois.afilias-srs.net", e, e, 0x0, t},
	{"origins", r, x, s{"a0.nic.origins", "a2.nic.origins", "b0.nic.origins", "c0.nic.origins"}, n, n, "whois.nic.origins", e, "https://newgtlds.icann.org/", 0x42, f},
	{"osaka", r, x, s{"ns1.dns.nic.osaka", "ns2.dns.nic.osaka", "ns3.dns.nic.osaka", "ns4.dns.nic.osaka", "ns5.dns.nic.osaka", "ns6.dns.nic.osaka"}, n, s{"Osaka", "JP-27"}, "whois.nic.osaka", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"otsuka", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.otsuka", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ott", r, x, s{"a0.nic.ott", "a2.nic.ott", "b0.nic.ott", "c0.nic.ott"}, n, n, "whois.nic.ott", e, "https://newgtlds.icann.org/", 0x48, f},
	{"overheidnl", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"ovh", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois-ovh.nic.fr", e, e, 0x40, t},
	{"pa", r, z[3766:3777], s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, "http://www.nic.pa/", "http://www.nic.pa/", 0xa0, f},
	{"page", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"pamperedchef", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"panasonic", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"panerai", r, x, n, n, n, "whois.nic.panerai", e, "https://newgtlds.icann.org/", 0x42, f},
	{"paris", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr", "h.ext.nic.fr"}, n, s{"Paris", "FR-J"}, "whois-paris.nic.fr", e, e, 0xc4, t},
	{"pars", r, x, s{"a.ns.nic.pars", "b.ns.nic.pars", "ns.cocca.fr"}, n, s{"Iran"}, "whois.nic.pars", e, "https://newgtlds.icann.org/", 0x40, f},
	{"partners", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.partners", e, e, 0x40, t},
	{"parts", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.parts", e, e, 0x40, t},
	{"party", r, x, s{"ns1.dns.nic.party", "ns2.dns.nic.party", "ns3.dns.nic.party", "ns4.dns.nic.party", "ns5.dns.nic.party", "ns6.dns.nic.party"}, n, n, "whois.nic.party", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"passagens", r, x, s{"ns1.dns.nic.passagens", "ns2.dns.nic.passagens", "ns3.dns.nic.passagens", "ns4.dns.nic.passagens", "ns5.dns.nic.passagens", "ns6.dns.nic.passagens"}, n, n, "whois.nic.passagens", e, "https://newgtlds.icann.org/", 0x42, f},
	{"patagonia", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"patch", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"pay", r, x, s{"dns1.nic.pay", "dns2.nic.pay", "dns3.nic.pay", "dns4.nic.pay", "dnsa.nic.pay", "dnsb.nic.pay", "dnsc.nic.pay", "dnsd.nic.pay"}, n, n, "whois.nic.pay", e, "https://newgtlds.icann.org/", 0x40, t},
	{"payu", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"pccw", r, x, s{"a0.nic.pccw", "a2.nic.pccw", "b0.nic.pccw", "c0.nic.pccw"}, n, n, "whois.nic.pccw", e, "https://newgtlds.icann.org/", 0x42, f},
	{"pe", r, z[3777:3786], s{"pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, "kero.yachay.pe", e, "http://www.nic.pe/", 0xa0, t},
	{"persiangulf", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0xc0, f},
	{"pet", r, x, s{"a0.nic.pet", "a2.nic.pet", "b0.nic.pet", "c0.nic.pet"}, n, n, "whois.afilias.net", e, "http://nic.pet/", 0x40, f},
	{"pets", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"pf", r, z[3786:3791], s{"ns1.mana.pf", "ns2.mana.pf"}, n, n, "whois.registry.pf", e, e, 0xa0, f},
	{"pfizer", r, x, s{"ns1.dns.nic.pfizer", "ns2.dns.nic.pfizer", "ns3.dns.nic.pfizer", "ns4.dns.nic.pfizer", "ns5.dns.nic.pfizer", "ns6.dns.nic.pfizer"}, n, n, "whois.nic.pfizer", e, "https://newgtlds.icann.org/", 0x42, f},
	{"pg", r, z[3791:3797], s{"munnari.oz.au", "ns.uu.net", "ns1.tiare.net.pg", "ns1.unitech.ac.pg", "ns2.tiare.net.pg"}, n, n, e, e, e, 0xa0, f},
	{"ph", r, z[3797:3806], s{"1.ns.ph", "ns2.cuhk.edu.hk", "ns4.apnic.net", "ph.communitydns.net"}, s{"45.79.222.138"}, n, e, "http://www.dot.ph/whois", e, 0xa0, f},
	{"pharmacy", r, x, s{"ns1.dns.nic.pharmacy", "ns2.dns.nic.pharmacy", "ns3.dns.nic.pharmacy", "ns4.dns.nic.pharmacy", "ns5.dns.nic.pharmacy", "ns6.dns.nic.pharmacy"}, n, n, "whois.nic.pharmacy", e, "https://newgtlds.icann.org/", 0x40, f},
	{"phd", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"philips", r, x, s{"a.nic.philips", "b.nic.philips", "c.nic.philips", "d.nic.philips"}, n, n, "whois.nic.philips", e, "https://newgtlds.icann.org/", 0x42, f},
	{"phone", r, x, s{"a0.nic.phone", "a2.nic.phone", "b0.nic.phone", "c0.nic.phone"}, n, n, "whois.nic.phone", e, "https://newgtlds.icann.org/", 0x40, f},
	{"photo", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.photo/", 0x40, t},
	{"photography", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.photography", e, e, 0x40, t},
	{"photos", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.photos", e, e, 0x40, t},
	{"physio", r, x, s{"a.nic.physio", "b.nic.physio", "c.nic.physio", "d.nic.physio"}, n, n, "whois.nic.physio", e, "https://newgtlds.icann.org/", 0x40, f},
	{"piaget", r, x, n, n, n, "whois.nic.piaget", e, "https://newgtlds.icann.org/", 0x42, f},
	{"pics", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.pics/", 0x40, t},
	{"pictet", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"pictures", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.pictures", e, e, 0x40, t},
	{"pid", r, x, s{"a.nic.pid", "b.nic.pid", "c.nic.pid", "d.nic.pid"}, n, n, "whois.nic.pid", e, "https://newgtlds.icann.org/", 0x40, t},
	{"pin", r, x, s{"dns1.nic.pin", "dns2.nic.pin", "dns3.nic.pin", "dns4.nic.pin", "dnsa.nic.pin", "dnsb.nic.pin", "dnsc.nic.pin", "dnsd.nic.pin"}, n, n, "whois.nic.pin", e, "https://newgtlds.icann.org/", 0x48, t},
	{"ping", r, x, s{"ns1.dns.nic.ping", "ns2.dns.nic.ping", "ns3.dns.nic.ping", "ns4.dns.nic.ping", "ns5.dns.nic.ping", "ns6.dns.nic.ping"}, n, n, "whois.nic.ping", e, "https://newgtlds.icann.org/", 0x42, f},
	{"pink", r, x, s{"a0.nic.pink", "a2.nic.pink", "b0.nic.pink", "b2.nic.pink", "c0.nic.pink"}, n, n, "whois.afilias.net", e, "http://nic.pink/", 0x40, f},
	{"pioneer", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"piperlime", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"pitney", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"pizza", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.pizza", e, "https://newgtlds.icann.org/", 0x40, t},
	{"pk", r, z[3806:3821], s{"root-c1.pknic.pk", "root-c2.pknic.pk", "root-e.pknic.pk", "root-s.pknic.pk"}, n, n, e, "http://www.pknic.net.pk/", e, 0xa0, f},
	{"pl", r, z[3821:3989], s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, "whois.dns.pl", e, e, 0xa0, t},
	{"place", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.place", e, e, 0x40, t},
	{"play", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"playstation", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.playstation", e, "https://newgtlds.icann.org/", 0x42, f},
	{"plumbing", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.plumbing", e, e, 0x40, t},
	{"plus", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.plus", e, "https://newgtlds.icann.org/", 0x40, t},
	{"pm", r, x, s{"d.nic.fr", "e.ext.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.pm", e, e, 0xa0, t},
	{"pn", r, z[3989:4008], s{"dns1.nominetdns.uk", "dns4.nominetdns.uk", "fork.sth.dnsnode.net", "ns0.pitcairn.net.pn", "ns1.pitcairn.net.pn"}, n, n, e, "http://www.pitcairn.pn/PnRegistry/", "http://www.nic.pn/", 0xa0, f},
	{"pnc", r, x, s{"a0.nic.pnc", "a2.nic.pnc", "b0.nic.pnc", "c0.nic.pnc"}, n, n, "whois.nic.pnc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"pohl", r, x, s{"a.nic.pohl", "b.nic.pohl", "c.nic.pohl", "d.nic.pohl"}, n, n, "whois.nic.pohl", e, "https://newgtlds.icann.org/", 0x42, f},
	{"poker", r, x, s{"a0.nic.poker", "a2.nic.poker", "b0.nic.poker", "c0.nic.poker"}, n, n, "whois.afilias.net", e, "http://nic.poker/", 0x40, f},
	{"politie", r, x, s{"ns1.nic.politie", "ns2.nic.politie", "ns3.nic.politie"}, n, n, "whois.nic.politie", e, "https://newgtlds.icann.org/", 0x42, f},
	{"polo", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"porn", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns5.uniregistry.net", "ns6.uniregistry.info"}, n, n, "whois.registrar.adult", e, "http://nic.porn/", 0x41, t},
	{"post", r, x, s{"a0.post.afilias-nst.info", "a2.post.afilias-nst.info", "b0.post.afilias-nst.org", "b2.post.afilias-nst.org", "c0.post.afilias-nst.info", "d0.post.afilias-nst.org"}, n, n, "whois.dotpostregistry.net", e, "http://en.wikipedia.org/wiki/.post", 0x1040, f},
	{"pr", r, z[4008:4060], s{"a.lactld.org", "a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org", "pr-dns.denic.de"}, n, n, "whois.afilias-srs.net", e, "http://www.nic.pr/", 0xa0, t},
	{"pramerica", r, x, s{"ns1.dns.nic.pramerica", "ns2.dns.nic.pramerica", "ns3.dns.nic.pramerica", "ns4.dns.nic.pramerica", "ns5.dns.nic.pramerica", "ns6.dns.nic.pramerica"}, n, n, "whois.nic.pramerica", e, "https://newgtlds.icann.org/", 0x42, f},
	{"praxi", r, x, s{"ns1.dns.nic.praxi", "ns2.dns.nic.praxi", "ns3.dns.nic.praxi", "ns4.dns.nic.praxi", "ns5.dns.nic.praxi", "ns6.dns.nic.praxi"}, n, n, "whois.nic.praxi", e, "https://newgtlds.icann.org/", 0x42, f},
	{"press", r, x, s{"a.nic.press", "b.nic.press", "e.nic.press", "f.nic.press"}, n, n, "whois.nic.press", e, e, 0x40, t},
	{"prime", r, x, s{"dns1.nic.prime", "dns2.nic.prime", "dns3.nic.prime", "dns4.nic.prime", "dnsa.nic.prime", "dnsb.nic.prime", "dnsc.nic.prime", "dnsd.nic.prime"}, n, n, "whois.nic.prime", e, "https://newgtlds.icann.org/", 0x42, t},
	{"pro", r, z[4060:4096], s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, "whois.afilias.net", e, "https://registry.pro/", 0x40, f},
	{"prod", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"productions", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.productions", e, e, 0x40, t},
	{"prof", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"progressive", r, x, s{"a0.nic.progressive", "a2.nic.progressive", "b0.nic.progressive", "c0.nic.progressive"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"promo", r, x, s{"a0.nic.promo", "a2.nic.promo", "b0.nic.promo", "c0.nic.promo"}, n, n, "whois.afilias.net", e, "http://nic.promo/", 0x40, f},
	{"properties", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.properties", e, e, 0x40, t},
	{"property", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.property/", 0x40, t},
	{"protection", r, x, s{"a.nic.protection", "b.nic.protection", "e.nic.protection", "f.nic.protection"}, n, n, "whois.nic.protection", e, "https://newgtlds.icann.org/", 0x40, t},
	{"pru", r, x, s{"ns1.dns.nic.pru", "ns2.dns.nic.pru", "ns3.dns.nic.pru", "ns4.dns.nic.pru", "ns5.dns.nic.pru", "ns6.dns.nic.pru"}, n, n, "whois.nic.pru", e, "https://newgtlds.icann.org/", 0x42, f},
	{"prudential", r, x, s{"ns1.dns.nic.prudential", "ns2.dns.nic.prudential", "ns3.dns.nic.prudential", "ns4.dns.nic.prudential", "ns5.dns.nic.prudential", "ns6.dns.nic.prudential"}, n, n, "whois.nic.prudential", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ps", r, z[4096:4105], s{"dns1.gov.ps", "fork.sth.dnsnode.net", "ns1.pnina.ps", "ps-ns.anycast.pch.net", "ps.cctld.authdns.ripe.net", "rip.psg.com"}, n, n, "whois.pnina.ps", e, e, 0xa0, f},
	{"pt", r, z[4105:4114], s{"a.dns.pt", "b.dns.pt", "c.dns.pt", "d.dns.pt", "e.dns.pt", "f.dns.pt", "g.dns.pt", "h.dns.pt", "ns.dns.br", "ns2.nic.fr"}, n, n, "whois.dns.pt", e, e, 0xa0, t},
	{"pub", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.pub", e, e, 0x40, t},
	{"pw", r, z[4114:4125], s{"ns1.nic.pw", "ns2.nic.pw", "ns5.nic.pw", "ns6.nic.pw"}, n, n, "whois.nic.pw", e, e, 0xa0, t},
	{"pwc", r, x, s{"a0.nic.pwc", "a2.nic.pwc", "b0.nic.pwc", "c0.nic.pwc"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"py", r, z[4125:4133], s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, "http://www.nic.py/consulta-datos.php", e, 0xa8, f},
	{"qa", r, z[4133:4141], s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, "whois.registry.qa", e, e, 0xa0, f},
	{"qpon", r, x, s{"ns1.dns.nic.qpon", "ns2.dns.nic.qpon", "ns3.dns.nic.qpon", "ns4.dns.nic.qpon", "ns5.dns.nic.qpon", "ns6.dns.nic.qpon"}, n, n, "whois.nic.qpon", e, e, 0x40, t},
	{"qtel", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"quebec", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, s{"Quebec", "CA-QC"}, "whois.nic.quebec", e, e, 0xc4, t},
	{"quest", r, x, s{"a-cnic.nic.quest", "b-cnic.nic.quest", "c-cnic.nic.quest", "d-cnic.nic.quest"}, n, n, "whois.nic.quest", e, "https://newgtlds.icann.org/", 0x42, f},
	{"qvc", r, x, s{"ns1.dns.nic.qvc", "ns2.dns.nic.qvc", "ns3.dns.nic.qvc", "ns4.dns.nic.qvc", "ns5.dns.nic.qvc", "ns6.dns.nic.qvc"}, n, n, "whois.nic.qvc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"racing", r, x, s{"ns1.dns.nic.racing", "ns2.dns.nic.racing", "ns3.dns.nic.racing", "ns4.dns.nic.racing", "ns5.dns.nic.racing", "ns6.dns.nic.racing"}, n, n, "whois.nic.racing", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"radio", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.radio", e, "http://nic.radio/", 0x40, f},
	{"raid", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.raid", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ram", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"re", r, z[4141:4144], s{"d.nic.fr", "e.ext.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.re", e, e, 0xa0, t},
	{"read", r, x, s{"dns1.nic.read", "dns2.nic.read", "dns3.nic.read", "dns4.nic.read", "dnsa.nic.read", "dnsb.nic.read", "dnsc.nic.read", "dnsd.nic.read"}, n, n, "whois.nic.read", e, "https://newgtlds.icann.org/", 0x42, t},
	{"realestate", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.realestate", e, "https://newgtlds.icann.org/", 0x40, t},
	{"realtor", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://www.claim.realtor/", 0x40, f},
	{"realty", r, x, s{"a.nic.realty", "b.nic.realty", "c.nic.realty", "d.nic.realty"}, n, n, "whois.nic.realty", e, "https://newgtlds.icann.org/", 0x40, t},
	{"recipes", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.recipes", e, e, 0x40, t},
	{"red", r, x, s{"a0.nic.red", "a2.nic.red", "b0.nic.red", "c0.nic.red"}, n, n, "whois.afilias.net", e, "http://nic.red/", 0x40, f},
	{"redken", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"redstone", r, x, s{"a0.nic.redstone", "a2.nic.redstone", "b0.nic.redstone", "c0.nic.redstone"}, n, n, "whois.nic.redstone", e, "https://newgtlds.icann.org/", 0x42, f},
	{"redumbrella", r, x, s{"a0.nic.redumbrella", "a2.nic.redumbrella", "b0.nic.redumbrella", "c0.nic.redumbrella"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"rehab", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.rehab", e, "https://newgtlds.icann.org/", 0x40, t},
	{"reise", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.reise", e, "https://newgtlds.icann.org/", 0x40, t},
	{"reisen", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.reisen", e, e, 0x40, t},
	{"reit", r, x, s{"a.nic.reit", "b.nic.reit", "c.nic.reit", "d.nic.reit"}, n, n, "whois.nic.reit", e, "https://newgtlds.icann.org/", 0x50, f},
	{"reliance", r, x, s{"a0.nic.reliance", "a2.nic.reliance", "b0.nic.reliance", "c0.nic.reliance"}, n, n, "whois.nic.reliance", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ren", r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.ren", e, "https://newgtlds.icann.org/", 0x42, f},
	{"rent", r, x, s{"a.nic.rent", "b.nic.rent", "c.nic.rent", "d.nic.rent"}, n, n, "whois.nic.rent", e, "https://newgtlds.icann.org/", 0x40, t},
	{"rentals", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.rentals", e, e, 0x40, t},
	{"repair", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.repair", e, e, 0x40, t},
	{"report", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.report", e, e, 0x40, t},
	{"republican", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.republican", e, e, 0x40, t},
	{"rest", r, x, s{"a.nic.rest", "b.nic.rest", "c.nic.rest", "d.nic.rest"}, n, n, "whois.nic.rest", e, e, 0x40, t},
	{"restaurant", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.restaurant", e, e, 0x40, t},
	{"retirement", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"review", r, x, s{"ns1.dns.nic.review", "ns2.dns.nic.review", "ns3.dns.nic.review", "ns4.dns.nic.review", "ns5.dns.nic.review", "ns6.dns.nic.review"}, n, n, "whois.nic.review", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"reviews", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.reviews", e, e, 0x40, t},
	{"rexroth", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.rexroth", e, "https://newgtlds.icann.org/", 0x42, f},
	{"rich", r, x, s{"a0.nic.rich", "a2.nic.rich", "b0.nic.rich", "c0.nic.rich"}, n, n, "whois.afilias-srs.net", e, "http://nic.rich/", 0x40, f},
	{"richardli", r, x, s{"a0.nic.richardli", "a2.nic.richardli", "b0.nic.richardli", "c0.nic.richardli"}, n, n, "whois.nic.richardli", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ricoh", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.ricoh", e, "https://newgtlds.icann.org/", 0x42, f},
	{"rightathome", r, x, n, n, n, "whois.nic.rightathome", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ril", r, x, s{"a0.nic.ril", "a2.nic.ril", "b0.nic.ril", "c0.nic.ril"}, n, n, "whois.nic.ril", e, "https://newgtlds.icann.org/", 0x42, f},
	{"rio", r, x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, s{"Rio de Janeiro", "BR-RJ"}, "whois.gtlds.nic.br", e, "https://newgtlds.icann.org/", 0xc4, t},
	{"rip", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.rip", e, "https://newgtlds.icann.org/", 0x40, t},
	{"rmit", r, x, s{"a.nic.rmit", "b.nic.rmit", "c.nic.rmit", "d.nic.rmit"}, n, n, "whois.nic.rmit", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ro", r, z[4144:4161], s{"dns-at.rotld.ro", "dns-c.rotld.ro", "dns-ro.denic.de", "primary.rotld.ro", "sec-dns-a.rotld.ro", "sec-dns-b.rotld.ro"}, n, n, "whois.rotld.ro", e, e, 0xa0, f},
	{"rocher", r, x, s{"ns1.dns.nic.rocher", "ns2.dns.nic.rocher", "ns3.dns.nic.rocher", "ns4.dns.nic.rocher", "ns5.dns.nic.rocher", "ns6.dns.nic.rocher"}, n, n, "whois.nic.rocher", e, "https://newgtlds.icann.org/", 0x42, t},
	{"rocks", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.rocks", e, e, 0x40, t},
	{"rockwool", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"rodeo", r, x, s{"dns1.nic.rodeo", "dns2.nic.rodeo", "dns3.nic.rodeo", "dns4.nic.rodeo", "dnsa.nic.rodeo", "dnsb.nic.rodeo", "dnsc.nic.rodeo", "dnsd.nic.rodeo"}, n, n, "whois.nic.rodeo", e, "http://nic.rodeo/", 0x40, t},
	{"rogers", r, x, s{"a0.nic.rogers", "a2.nic.rogers", "b0.nic.rogers", "c0.nic.rogers"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"roma", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"room", r, x, s{"dns1.nic.room", "dns2.nic.room", "dns3.nic.room", "dns4.nic.room", "dnsa.nic.room", "dnsb.nic.room", "dnsc.nic.room", "dnsd.nic.room"}, n, n, "whois.nic.room", e, "https://newgtlds.icann.org/", 0x40, t},
	{"root", r, x, n, n, n, e, e, e, 0x40, f},
	{"rs", r, z[4161:4167], s{"a.nic.rs", "b.nic.rs", "f.nic.rs", "g.nic.rs", "h.nic.rs", "l.nic.rs"}, n, n, "whois.rnids.rs", e, e, 0xa0, t},
	{"rsvp", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"ru", r, z[4167:4195], s{"a.dns.ripn.net", "b.dns.ripn.net", "d.dns.ripn.net", "e.dns.ripn.net", "f.dns.ripn.net"}, n, n, "whois.tcinet.ru", e, e, 0xa0, t},
	{"rugby", r, x, s{"a.nic.rugby", "b.nic.rugby", "c.nic.rugby", "d.nic.rugby"}, n, n, "whois.nic.rugby", e, "https://newgtlds.icann.org/", 0x40, f},
	{"ruhr", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, s{"DE-NW"}, "whois.nic.ruhr", e, e, 0x440, t},
	{"run", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.run", e, "https://newgtlds.icann.org/", 0x40, t},
	{"rw", r, z[4195:4205], s{"fork.sth.dnsnode.net", "ns-rw.afrinic.net", "ns1.ricta.org.rw", "ns3.ricta.org.rw", "pch.ricta.org.rw"}, n, n, "whois.ricta.org.rw", "http://whois.ricta.org.rw", e, 0xa0, f},
	{"rwe", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.rwe", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ryukyu", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, s{"JP-46", "JP-47"}, "whois.nic.ryukyu", e, "https://newgtlds.icann.org/", 0x440, t},
	{"sa", r, z[4205:4213], s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, "whois.nic.net.sa", e, e, 0xa0, f},
	{"saarland", r, x, s{"a.nic.saarland", "b.nic.saarland", "c.nic.saarland", "d.nic.saarland"}, n, s{"DE-SL"}, "whois.nic.saarland", e, e, 0x4c0, t},
	{"safe", r, x, s{"dns1.nic.safe", "dns2.nic.safe", "dns3.nic.safe", "dns4.nic.safe", "dnsa.nic.safe", "dnsb.nic.safe", "dnsc.nic.safe", "dnsd.nic.safe"}, n, n, "whois.nic.safe", e, "https://newgtlds.icann.org/", 0x48, t},
	{"safety", r, x, s{"ns1.dns.nic.safety", "ns2.dns.nic.safety", "ns3.dns.nic.safety", "ns4.dns.nic.safety", "ns5.dns.nic.safety", "ns6.dns.nic.safety"}, n, n, "whois.nic.safety", e, "https://newgtlds.icann.org/", 0x40, f},
	{"safeway", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"sakura", r, x, s{"tld1.nic.sakura", "tld2.nic.sakura", "tld3.nic.sakura", "tld5.nic.sakura"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"sale", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.sale", e, "https://newgtlds.icann.org/", 0x40, t},
	{"salon", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.salon", e, "https://newgtlds.icann.org/", 0x40, t},
	{"samsclub", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.samsclub", e, "https://newgtlds.icann.org/", 0x42, f},
	{"samsung", r, x, s{"ns1.samsung.centralnic-dns.com", "ns2.samsung.centralnic-dns.com", "ns3.samsung.centralnic-dns.com", "ns4.samsung.centralnic-dns.com"}, n, n, "whois.nic.samsung", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sandvik", r, x, s{"a.nic.sandvik", "b.nic.sandvik", "c.nic.sandvik", "d.nic.sandvik"}, n, n, "whois.nic.sandvik", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sandvikcoromant", r, x, s{"a.nic.sandvikcoromant", "b.nic.sandvikcoromant", "c.nic.sandvikcoromant", "d.nic.sandvikcoromant"}, n, n, "whois.nic.sandvikcoromant", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sanofi", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.sanofi", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sap", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.sap", e, "https://newgtlds.icann.org/", 0x42, t},
	{"sapo", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"sapphire", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"sarl", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.sarl", e, e, 0x40, t},
	{"sas", r, x, s{"ns1.dns.nic.sas", "ns2.dns.nic.sas", "ns3.dns.nic.sas", "ns4.dns.nic.sas", "ns5.dns.nic.sas", "ns6.dns.nic.sas"}, n, n, "whois.nic.sas", e, "https://newgtlds.icann.org/", 0x42, f},
	{"save", r, x, s{"dns1.nic.save", "dns2.nic.save", "dns3.nic.save", "dns4.nic.save", "dnsa.nic.save", "dnsb.nic.save", "dnsc.nic.save", "dnsd.nic.save"}, n, n, "whois.nic.save", e, "https://newgtlds.icann.org/", 0x40, t},
	{"saxo", r, x, s{"a.nic.saxo", "b.nic.saxo", "c.nic.saxo", "d.nic.saxo"}, n, n, "whois.nic.saxo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sb", r, z[4213:4218], s{"ns.cocca.fr", "pch.nic.sb"}, n, n, "whois.nic.net.sb", e, e, 0xa0, f},
	{"sbi", r, x, s{"a0.nic.sbi", "a2.nic.sbi", "b0.nic.sbi", "c0.nic.sbi"}, n, n, "whois.nic.sbi", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sbs", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.sbs", e, "https://newgtlds.icann.org/", 0x42, t},
	{"sc", r, z[4218:4223], s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "ns1.nic.sc"}, n, n, "whois2.afilias-grs.net", e, e, 0xe0, t},
	{"sca", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.sca", e, "https://newgtlds.icann.org/", 0x42, t},
	{"scb", r, x, s{"a.nic.scb", "b.nic.scb", "c.nic.scb", "d.nic.scb"}, n, n, "whois.nic.scb", e, "https://newgtlds.icann.org/", 0x42, t},
	{"schaeffler", r, x, s{"a0.nic.schaeffler", "a2.nic.schaeffler", "b0.nic.schaeffler", "c0.nic.schaeffler"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"schmidt", r, x, s{"a.nic.schmidt", "b.nic.schmidt", "c.nic.schmidt", "d.nic.schmidt"}, n, n, "whois.nic.schmidt", e, "https://newgtlds.icann.org/", 0x42, f},
	{"scholarships", r, x, s{"a0.nic.scholarships", "a2.nic.scholarships", "b0.nic.scholarships", "c0.nic.scholarships"}, n, n, "whois.nic.scholarships", e, "https://newgtlds.icann.org/", 0x40, f},
	{"school", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.school", e, "https://newgtlds.icann.org/", 0x40, t},
	{"schule", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.schule", e, e, 0x40, t},
	{"schwarz", r, x, s{"a.nic.schwarz", "b.nic.schwarz", "c.nic.schwarz", "d.nic.schwarz"}, n, n, "whois.nic.schwarz", e, "https://newgtlds.icann.org/", 0x42, t},
	{"schwarzgroup", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"science", r, x, s{"ns1.dns.nic.science", "ns2.dns.nic.science", "ns3.dns.nic.science", "ns4.dns.nic.science", "ns5.dns.nic.science", "ns6.dns.nic.science"}, n, n, "whois.nic.science", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"scjohnson", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.scjohnson", e, "https://newgtlds.icann.org/", 0x42, f},
	{"scor", r, x, n, n, n, "whois.nic.scor", e, "https://newgtlds.icann.org/", 0x42, f},
	{"scot", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, s{"GB-SCT"}, "whois.nic.scot", e, e, 0x440, t},
	{"sd", r, z[4223:4231], s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "pch.sis.sd", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0xa0, f},
	{"se", r, z[4231:4263], s{"a.ns.se", "b.ns.se", "c.ns.se", "f.ns.se", "g.ns.se", "i.ns.se", "m.ns.se", "x.ns.se", "y.ns.se", "z.ns.se"}, n, n, "whois.iis.se", e, e, 0xa0, t},
	{"search", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"seat", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.seat", e, "https://newgtlds.icann.org/", 0x42, f},
	{"secure", r, x, s{"dns1.nic.secure", "dns2.nic.secure", "dns3.nic.secure", "dns4.nic.secure", "dnsa.nic.secure", "dnsb.nic.secure", "dnsc.nic.secure", "dnsd.nic.secure"}, n, n, "whois.nic.secure", e, "https://newgtlds.icann.org/", 0x40, t},
	{"security", r, x, s{"a.nic.security", "b.nic.security", "e.nic.security", "f.nic.security"}, n, n, "whois.nic.security", e, "https://newgtlds.icann.org/", 0x40, t},
	{"seek", r, x, s{"a.nic.seek", "b.nic.seek", "c.nic.seek", "d.nic.seek"}, n, n, "whois.nic.seek", e, "https://newgtlds.icann.org/", 0x42, f},
	{"select", r, x, s{"a.nic.select", "b.nic.select", "c.nic.select", "d.nic.select"}, n, n, "whois.nic.select", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sener", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"services", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.services", e, e, 0x40, t},
	{"ses", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.ses", e, "https://newgtlds.icann.org/", 0x42, f},
	{"seven", r, x, s{"a.nic.seven", "b.nic.seven", "c.nic.seven", "d.nic.seven"}, n, n, "whois.nic.seven", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sew", r, x, s{"a0.nic.sew", "a2.nic.sew", "b0.nic.sew", "c0.nic.sew"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sex", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns5.uniregistry.net", "ns6.uniregistry.info"}, n, n, "whois.registrar.adult", e, "http://nic.sex/", 0x41, t},
	{"sexy", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.sexy/", 0x41, t},
	{"sfr", r, x, s{"a.nic.sfr", "b.nic.sfr", "c.nic.sfr", "d.nic.sfr"}, n, n, "whois.nic.sfr", e, "https://newgtlds.icann.org/", 0x42, t},
	{"sg", r, z[4263:4269], s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "ns4.apnic.net", "pch.sgzones.sg"}, n, n, "whois.sgnic.sg", e, e, 0xa0, t},
	{"sh", r, z[4269:4276], s{"a0.nic.sh", "a2.nic.sh", "b0.nic.sh", "c0.nic.sh"}, n, n, "whois.nic.sh", e, "https://www.nic.sh/", 0xa0, t},
	{"shangrila", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.shangrila", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sharp", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"shaw", r, x, s{"a0.nic.shaw", "a2.nic.shaw", "b0.nic.shaw", "c0.nic.shaw"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"shell", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.shell", e, "https://newgtlds.icann.org/", 0x42, t},
	{"shia", r, x, s{"a.ns.nic.shia", "b.ns.nic.shia", "ns.cocca.fr"}, n, s{"Iran"}, "whois.nic.shia", e, "https://newgtlds.icann.org/", 0x40, f},
	{"shiksha", r, x, s{"a0.nic.shiksha", "a2.nic.shiksha", "b0.nic.shiksha", "c0.nic.shiksha"}, n, n, "whois.afilias.net", e, "http://nic.shiksha/", 0x40, f},
	{"shoes", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.shoes", e, e, 0x40, t},
	{"shop", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.shop", e, "https://newgtlds.icann.org/", 0x40, f},
	{"shopping", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.shopping", e, "https://newgtlds.icann.org/", 0x40, t},
	{"shopyourway", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"shouji", r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.teleinfo.cn", e, "https://newgtlds.icann.org/", 0x42, f},
	{"show", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.show", e, "https://newgtlds.icann.org/", 0x40, t},
	{"showtime", r, x, s{"a0.nic.showtime", "a2.nic.showtime", "b0.nic.showtime", "c0.nic.showtime"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"shriram", r, x, s{"a0.nic.shriram", "a2.nic.shriram", "b0.nic.shriram", "c0.nic.shriram"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"si", r, z[4276:4283], s{"b.dns.si", "f.dns.si", "g.dns.si", "h.dns.si", "i.dns.si", "k.dns.si", "l.dns.si"}, n, n, "whois.register.si", e, e, 0xa0, t},
	{"silk", r, x, s{"dns1.nic.silk", "dns2.nic.silk", "dns3.nic.silk", "dns4.nic.silk", "dnsa.nic.silk", "dnsb.nic.silk", "dnsc.nic.silk", "dnsd.nic.silk"}, n, n, "whois.nic.silk", e, "https://newgtlds.icann.org/", 0x42, t},
	{"sina", r, x, s{"a0.nic.sina", "a2.nic.sina", "b0.nic.sina", "c0.nic.sina"}, n, n, "whois.nic.sina", e, "https://newgtlds.icann.org/", 0x42, f},
	{"singles", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.singles", e, e, 0x40, t},
	{"site", r, x, s{"a.nic.site", "b.nic.site", "e.nic.site", "f.nic.site"}, n, n, "whois.nic.site", e, "https://newgtlds.icann.org/", 0x40, t},
	{"sj", r, x, s{"nac.no", "nn.uninett.no", "server.nordu.net"}, n, n, e, e, e, 0xa8, f},
	{"sk", r, x, s{"a.tld.sk", "b.tld.sk", "c.tld.sk", "e.tld.sk", "f.tld.sk", "g.tld.sk", "h.tld.sk"}, n, n, "whois.sk-nic.sk", e, e, 0xa0, f},
	{"ski", r, x, s{"a0.nic.ski", "a2.nic.ski", "b0.nic.ski", "c0.nic.ski"}, n, n, "whois.afilias.net", e, "http://nic.ski/", 0x40, t},
	{"skin", r, x, s{"a.nic.skin", "b.nic.skin", "c.nic.skin", "d.nic.skin"}, n, n, "whois.nic.skin", e, "https://newgtlds.icann.org/", 0x40, f},
	{"skolkovo", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"sky", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.sky", e, "https://newgtlds.icann.org/", 0x42, t},
	{"skydrive", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"skype", r, x, s{"ns1.dns.nic.skype", "ns2.dns.nic.skype", "ns3.dns.nic.skype", "ns4.dns.nic.skype", "ns5.dns.nic.skype", "ns6.dns.nic.skype"}, n, n, "whois.nic.skype", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sl", r, z[4283:4288], s{"ns1.neoip.com", "ns2.neoip.com"}, n, n, "whois.nic.sl", "http://www.nic.sl", e, 0xa0, f},
	{"sling", r, x, s{"a0.nic.sling", "a2.nic.sling", "b0.nic.sling", "c0.nic.sling"}, n, n, "whois.nic.sling", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sm", r, x, s{"dns.intelcom.sm", "dns.omniway.sm", "ns3.telecomitalia.sm", "sm.cctld.authdns.ripe.net"}, n, n, "whois.nic.sm", e, e, 0xa0, f},
	{"smart", r, x, s{"a.nic.smart", "b.nic.smart", "c.nic.smart", "d.nic.smart"}, n, n, "whois.nic.smart", e, "https://newgtlds.icann.org/", 0x42, f},
	{"smile", r, x, s{"dns1.nic.smile", "dns2.nic.smile", "dns3.nic.smile", "dns4.nic.smile", "dnsa.nic.smile", "dnsb.nic.smile", "dnsc.nic.smile", "dnsd.nic.smile"}, n, n, "whois.nic.smile", e, "https://newgtlds.icann.org/", 0x40, t},
	{"sn", r, z[4288:4295], s{"censvrns0001.ird.fr", "ns-sn.nic.fr", "ns.ucad.sn", "ns1.sonatel.sn", "sn.cctld.authdns.ripe.net"}, n, n, "whois.nic.sn", e, e, 0xa8, f},
	{"sncf", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.sncf", e, "https://newgtlds.icann.org/", 0x42, t},
	{"so", r, z[4295:4299], s{"d.nic.so", "e.nic.so"}, n, n, "whois.nic.so", e, e, 0xa0, f},
	{"soccer", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.soccer", e, "https://newgtlds.icann.org/", 0x40, t},
	{"social", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.social", e, e, 0x40, t},
	{"softbank", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.softbank", e, "https://newgtlds.icann.org/", 0x42, f},
	{"software", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.software", e, "https://newgtlds.icann.org/", 0x40, t},
	{"sohu", r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.sohu", e, "https://newgtlds.icann.org/", 0x42, t},
	{"solar", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.solar", e, e, 0x40, t},
	{"solutions", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.solutions", e, e, 0x40, t},
	{"song", r, x, s{"ns1.dns.nic.song", "ns2.dns.nic.song", "ns3.dns.nic.song", "ns4.dns.nic.song", "ns5.dns.nic.song", "ns6.dns.nic.song"}, n, n, "whois.nic.song", e, "https://newgtlds.icann.org/", 0x42, t},
	{"sony", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.sony", e, "https://newgtlds.icann.org/", 0x42, f},
	{"soy", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"spa", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"space", r, z[4299:4300], s{"a.nic.space", "b.nic.space", "e.nic.space", "f.nic.space"}, n, n, "whois.nic.space", e, "https://newgtlds.icann.org/", 0x40, t},
	{"spiegel", r, x, n, n, n, "whois.ksregistry.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"sport", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.sport", e, "https://newgtlds.icann.org/", 0x40, f},
	{"sports", r, x, n, n, n, e, e, "https://gtldresult.icann.org/applicationstatus/applicationdetails/604", 0x2040, t},
	{"spot", r, x, s{"dns1.nic.spot", "dns2.nic.spot", "dns3.nic.spot", "dns4.nic.spot", "dnsa.nic.spot", "dnsb.nic.spot", "dnsc.nic.spot", "dnsd.nic.spot"}, n, n, "whois.nic.spot", e, "https://newgtlds.icann.org/", 0x40, t},
	{"spreadbetting", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.spreadbetting", e, "https://bostonivy.co/", 0x40, f},
	{"sr", r, x, s{"ns1.sr.net", "ns2.sr.net"}, n, n, e, "http://www.register.sr", e, 0xe0, f},
	{"srl", r, x, s{"a0.nic.srl", "a2.nic.srl", "b0.nic.srl", "c0.nic.srl"}, n, n, "whois.afilias-srs.net", e, "http://nic.srl/", 0x40, f},
	{"srt", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ss", r, z[4300:4307], s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "pch.nic.ss", "root.nic.ss", "ssnic.anycastdns.cz"}, n, n, "whois.nic.ss", e, e, 0x0, t},
	{"st", r, z[4307:4320], s{"dns-au.st", "dns-st.bahnhof.net", "dns-us.st", "ns1.bahnhof.net"}, n, n, "whois.nic.st", e, e, 0xa0, f},
	{"stada", r, x, s{"a0.nic.stada", "a2.nic.stada", "b0.nic.stada", "c0.nic.stada"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"staples", r, x, s{"ns1.dns.nic.staples", "ns2.dns.nic.staples", "ns3.dns.nic.staples", "ns4.dns.nic.staples", "ns5.dns.nic.staples", "ns6.dns.nic.staples"}, n, n, "whois.nic.staples", e, "https://newgtlds.icann.org/", 0x42, f},
	{"star", r, x, s{"a0.nic.star", "a2.nic.star", "b0.nic.star", "c0.nic.star"}, n, n, "whois.nic.star", e, "https://newgtlds.icann.org/", 0x42, f},
	{"starhub", r, x, n, n, n, "whois.nic.starhub", e, "https://newgtlds.icann.org/", 0x42, f},
	{"statebank", r, x, s{"a0.nic.statebank", "a2.nic.statebank", "b0.nic.statebank", "c0.nic.statebank"}, n, n, "whois.nic.statebank", e, "https://newgtlds.icann.org/", 0x42, f},
	{"statefarm", r, x, s{"ns1.dns.nic.statefarm", "ns2.dns.nic.statefarm", "ns3.dns.nic.statefarm", "ns4.dns.nic.statefarm", "ns5.dns.nic.statefarm", "ns6.dns.nic.statefarm"}, n, n, "whois.nic.statefarm", e, "https://newgtlds.icann.org/", 0x42, f},
	{"statoil", r, x, n, n, n, "whois.nic.statoil", e, "https://newgtlds.icann.org/", 0x42, f},
	{"stc", r, x, s{"a.nic.stc", "b.nic.stc", "c.nic.stc", "d.nic.stc"}, n, n, "whois.nic.stc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"stcgroup", r, x, s{"a.nic.stcgroup", "b.nic.stcgroup", "c.nic.stcgroup", "d.nic.stcgroup"}, n, n, "whois.nic.stcgroup", e, "https://newgtlds.icann.org/", 0x42, f},
	{"stockholm", r, x, s{"a0.nic.stockholm", "a2.nic.stockholm", "b0.nic.stockholm", "c0.nic.stockholm"}, n, s{"Stockholm", "SE-AB"}, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0xc4, t},
	{"storage", r, x, s{"a.nic.storage", "b.nic.storage", "c.nic.storage", "d.nic.storage"}, n, n, "whois.nic.storage", e, "https://newgtlds.icann.org/", 0x40, t},
	{"store", r, x, s{"a.nic.store", "b.nic.store", "e.nic.store", "f.nic.store"}, n, n, "whois.nic.store", e, "https://newgtlds.icann.org/", 0x40, t},
	{"stream", r, x, s{"ns1.dns.nic.stream", "ns2.dns.nic.stream", "ns3.dns.nic.stream", "ns4.dns.nic.stream", "ns5.dns.nic.stream", "ns6.dns.nic.stream"}, n, n, "whois.nic.stream", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"stroke", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, f},
	{"studio", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.studio", e, "https://newgtlds.icann.org/", 0x40, t},
	{"study", r, x, s{"a.nic.study", "b.nic.study", "c.nic.study", "d.nic.study"}, n, n, "whois.nic.study", e, "https://newgtlds.icann.org/", 0x40, f},
	{"style", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.style", e, "https://newgtlds.icann.org/", 0x40, t},
	{"su", r, z[4320:4372], s{"a.dns.ripn.net", "b.dns.ripn.net", "d.dns.ripn.net", "e.dns.ripn.net", "f.dns.ripn.net"}, n, n, "whois.tcinet.ru", e, e, 0xe0, t},
	{"sucks", r, x, s{"a.nic.sucks", "b.nic.sucks", "c.nic.sucks", "d.nic.sucks"}, n, n, "whois.nic.sucks", e, "https://newgtlds.icann.org/", 0x40, f},
	{"supersport", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"supplies", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.supplies", e, e, 0x40, t},
	{"supply", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.supply", e, e, 0x40, t},
	{"support", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.support", e, e, 0x40, t},
	{"surf", r, x, s{"dns1.nic.surf", "dns2.nic.surf", "dns3.nic.surf", "dns4.nic.surf", "dnsa.nic.surf", "dnsb.nic.surf", "dnsc.nic.surf", "dnsd.nic.surf"}, n, n, "whois.nic.surf", e, "http://nic.surf/", 0x40, t},
	{"surgery", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.surgery", e, e, 0x40, t},
	{"suzuki", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.suzuki", e, "https://newgtlds.icann.org/", 0x42, t},
	{"sv", r, z[4372:4377], s{"a.lactld.org", "auth02.ns.uu.net", "cir.red.sv", "dns-ext.nic.cr", "ns.dns.br", "ns.uu.net", "sir.red.sv", "sv.cctld.authdns.ripe.net"}, n, n, e, "http://www.svnet.org.sv/", e, 0xa0, f},
	{"svr", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"swatch", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.swatch", e, "https://newgtlds.icann.org/", 0x42, t},
	{"swiftcover", r, x, s{"ns1.dns.nic.swiftcover", "ns2.dns.nic.swiftcover", "ns3.dns.nic.swiftcover", "ns4.dns.nic.swiftcover", "ns5.dns.nic.swiftcover", "ns6.dns.nic.swiftcover"}, n, n, "whois.nic.swiftcover", e, "https://newgtlds.icann.org/", 0x42, f},
	{"swiss", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net", "g.nic.swiss", "ns15.rcode0.net", "u.nic.swiss"}, n, n, "whois.nic.swiss", e, "https://newgtlds.icann.org/", 0x50, t},
	{"sx", r, x, s{"ns1.ns.sx", "ns2.ns.sx"}, n, n, "whois.sx", e, "http://en.wikipedia.org/wiki/.sx", 0xa0, f},
	{"sy", r, z[4377:4383], s{"ns1.tld.sy", "pch.anycast.tld.sy", "sy.cctld.authdns.ripe.net"}, n, n, "whois.tld.sy", e, "http://www.ste.gov.sy/", 0xa0, f},
	{"sydney", r, x, s{"a.nic.sydney", "b.nic.sydney", "c.nic.sydney", "d.nic.sydney"}, n, s{"Sydney"}, "whois.nic.sydney", e, "http://nic.sydney/", 0xc4, f},
	{"symantec", r, x, n, n, n, "whois.nic.symantec", e, "https://newgtlds.icann.org/", 0x42, t},
	{"systems", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.systems", e, e, 0x40, t},
	{"sz", r, z[4383:4386], s{"ns1.sispa.org.sz", "rip.psg.com", "sz.cctld.authdns.ripe.net"}, n, n, e, e, e, 0xa0, f},
	{"tab", r, x, s{"a.nic.tab", "b.nic.tab", "c.nic.tab", "d.nic.tab"}, n, n, "whois.nic.tab", e, "https://newgtlds.icann.org/", 0x42, f},
	{"taipei", r, x, s{"ns1.dns.nic.taipei", "ns2.dns.nic.taipei", "ns3.dns.nic.taipei", "ns4.dns.nic.taipei", "ns5.dns.nic.taipei", "ns6.dns.nic.taipei"}, n, s{"Taipei", "TW-TPQ"}, "whois.nic.taipei", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"talk", r, x, s{"dns1.nic.talk", "dns2.nic.talk", "dns3.nic.talk", "dns4.nic.talk", "dnsa.nic.talk", "dnsb.nic.talk", "dnsc.nic.talk", "dnsd.nic.talk"}, n, n, "whois.nic.talk", e, "https://newgtlds.icann.org/", 0x40, t},
	{"taobao", r, x, s{"ns1.dns.nic.taobao", "ns2.dns.nic.taobao", "ns3.dns.nic.taobao", "ns4.dns.nic.taobao", "ns5.dns.nic.taobao", "ns6.dns.nic.taobao"}, n, n, "whois.nic.taobao", e, "https://newgtlds.icann.org/", 0x42, f},
	{"target", r, x, s{"ns1.dns.nic.target", "ns2.dns.nic.target", "ns3.dns.nic.target", "ns4.dns.nic.target", "ns5.dns.nic.target", "ns6.dns.nic.target"}, n, n, "whois.nic.target", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tata", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"tatamotors", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.tatamotors", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tatar", r, x, s{"a.dns.ripn.net", "b.dns.ripn.net", "d.dns.ripn.net", "e.dns.ripn.net", "f.dns.ripn.net"}, n, s{"RU-TA"}, "whois.nic.tatar", e, "https://newgtlds.icann.org/", 0x440, f},
	{"tattoo", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.uniregistry.net", e, "http://nic.tattoo/", 0x40, t},
	{"tax", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.tax", e, e, 0x40, t},
	{"taxi", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.taxi", e, "https://newgtlds.icann.org/", 0x40, t},
	{"tc", r, z[4386:4420], s{"root1.zone.tc", "root2.zone.tc", "root3.zone.tc", "root4.zone.tc", "root5.zone.tc", "root6.zone.tc", "root7.zone.tc", "root8.zone.tc"}, n, n, "whois.nic.tc", e, e, 0xa0, f},
	{"tci", r, x, s{"a.ns.nic.tci", "b.ns.nic.tci", "ns.cocca.fr"}, n, n, "whois.nic.tci", e, "https://newgtlds.icann.org/", 0x42, f},
	{"td", r, z[4420:4424], s{"ns-td.afrinic.net", "ns.cocca.fr", "nsa.nic.td", "pch.nic.td"}, n, n, "whois.nic.td", "http://www.nic.td/", e, 0xa0, f},
	{"tdk", r, x, s{"ns1.dns.nic.tdk", "ns2.dns.nic.tdk", "ns3.dns.nic.tdk", "ns4.dns.nic.tdk", "ns5.dns.nic.tdk", "ns6.dns.nic.tdk"}, n, n, "whois.nic.tdk", e, "https://newgtlds.icann.org/", 0x42, f},
	{"team", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.team", e, "https://newgtlds.icann.org/", 0x40, t},
	{"tech", r, x, s{"a.nic.tech", "b.nic.tech", "e.nic.tech", "f.nic.tech"}, n, n, "whois.nic.tech", e, "https://newgtlds.icann.org/", 0x40, t},
	{"technology", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.technology", e, e, 0x40, t},
	{"tel", r, x, s{"ns1.dns.nic.tel", "ns2.dns.nic.tel", "ns3.dns.nic.tel", "ns4.dns.nic.tel", "ns5.dns.nic.tel", "ns6.dns.nic.tel", "ns7.dns.nic.tel", "ns8.dns.nic.tel"}, n, n, "whois.nic.tel", e, e, 0x1040, t},
	{"telecity", r, x, n, n, n, "whois.nic.telecity", e, "https://newgtlds.icann.org/", 0x42, f},
	{"telefonica", r, x, n, n, n, "whois-fe.telefonica.tango.knipp.de", e, "https://newgtlds.icann.org/", 0x42, f},
	{"temasek", r, x, s{"a0.nic.temasek", "a2.nic.temasek", "b0.nic.temasek", "c0.nic.temasek"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"tennis", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.tennis", e, "https://newgtlds.icann.org/", 0x40, t},
	{"terra", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"teva", r, x, s{"ns1.dns.nic.teva", "ns2.dns.nic.teva", "ns3.dns.nic.teva", "ns4.dns.nic.teva", "ns5.dns.nic.teva", "ns6.dns.nic.teva"}, n, n, "whois.nic.teva", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tf", r, z[4424:4438], s{"d.nic.fr", "e.ext.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.tf", e, e, 0xa0, t},
	{"tg", r, x, s{"ns1.admin.net", "ns1.nic.tg", "ns2.admin.net", "ns2.nic.tg", "ns3.admin.net", "ns4.admin.net", "ns5.admin.net", "tld.cafe.tg"}, n, n, "whois.nic.tg", "http://www.nic.tg/", e, 0xa0, f},
	{"th", r, z[4438:4445], s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, "whois.thnic.co.th", e, "http://www.thnic.co.th/", 0xa8, t},
	{"thai", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"thd", r, x, s{"a0.nic.thd", "a2.nic.thd", "b0.nic.thd", "c0.nic.thd"}, n, n, "whois.nic.thd", e, "https://newgtlds.icann.org/", 0x42, f},
	{"theater", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.theater", e, "https://newgtlds.icann.org/", 0x40, t},
	{"theatre", r, x, s{"a.nic.theatre", "b.nic.theatre", "c.nic.theatre", "d.nic.theatre"}, n, n, "whois.nic.theatre", e, "https://newgtlds.icann.org/", 0x40, t},
	{"theguardian", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"thehartford", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"tiaa", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.tiaa", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tickets", r, x, s{"a.nic.tickets", "b.nic.tickets", "c.nic.tickets", "d.nic.tickets"}, n, n, "whois.nic.tickets", e, "https://newgtlds.icann.org/", 0x40, t},
	{"tienda", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.tienda", e, e, 0x40, t},
	{"tiffany", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.tiffany", e, "https://newgtlds.icann.org/", 0x42, t},
	{"tiffay", r, x, n, n, n, "whois.nic.tiffany", e, e, 0x0, t},
	{"tiia", r, x, n, n, n, e, e, e, 0x0, t},
	{"tips", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.tips", e, e, 0x40, t},
	{"tires", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.tires", e, "https://newgtlds.icann.org/", 0x40, t},
	{"tirol", r, x, s{"dns.ryce-rsp.com", "ns1.dns.business", "ns1.ryce-rsp.com"}, n, s{"AT-7"}, "whois.nic.tirol", e, "https://newgtlds.icann.org/", 0x440, t},
	{"tj", r, z[4445:4466], s{"ns1.nic.tj", "ns2.tojikiston.com", "phloem.uoregon.edu", "tj.cctld.authdns.ripe.net"}, n, n, e, "http://www.nic.tj/whois.html", e, 0xa0, f},
	{"tjmaxx", r, x, s{"ns1.dns.nic.tjmaxx", "ns2.dns.nic.tjmaxx", "ns3.dns.nic.tjmaxx", "ns4.dns.nic.tjmaxx", "ns5.dns.nic.tjmaxx", "ns6.dns.nic.tjmaxx"}, n, n, "whois.nic.tjmaxx", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tjx", r, x, s{"ns1.dns.nic.tjx", "ns2.dns.nic.tjx", "ns3.dns.nic.tjx", "ns4.dns.nic.tjx", "ns5.dns.nic.tjx", "ns6.dns.nic.tjx"}, n, n, "whois.nic.tjx", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tk", r, x, s{"a.ns.tk", "b.ns.tk", "c.ns.tk", "d.ns.tk"}, n, n, "whois.dot.tk", e, e, 0xa0, t},
	{"tkmaxx", r, x, s{"ns1.dns.nic.tkmaxx", "ns2.dns.nic.tkmaxx", "ns3.dns.nic.tkmaxx", "ns4.dns.nic.tkmaxx", "ns5.dns.nic.tkmaxx", "ns6.dns.nic.tkmaxx"}, n, n, "whois.nic.tkmaxx", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tl", r, z[4466:4473], s{"ns.anycast.nic.tl", "ns.cocca.fr"}, n, n, "whois.nic.tl", e, e, 0xa0, f},
	{"tm", r, z[4473:4481], s{"ns-a1.tm", "ns-a2.tm", "ns-a3.tm", "ns-a4.tm", "ns-d1.tm", "ns-l1.tm", "ns-y1.tm"}, n, n, "whois.nic.tm", e, "http://nic.tm/", 0xa0, t},
	{"tmall", r, x, s{"ns1.dns.nic.tmall", "ns2.dns.nic.tmall", "ns3.dns.nic.tmall", "ns4.dns.nic.tmall", "ns5.dns.nic.tmall", "ns6.dns.nic.tmall"}, n, n, "whois.nic.tmall", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tn", r, z[4481:4500], s{"ns-tn.afrinic.net", "ns1.ati.tn", "ns2.ati.tn", "ns2.nic.fr", "pch.ati.tn", "rip.psg.com"}, n, n, "whois.ati.tn", e, e, 0xa0, f},
	{"to", r, x, s{"colo.tonic.to", "frankfurt.tonic.to", "helsinki.tonic.to", "newyork.tonic.to", "singapore.tonic.to", "sydney.tonic.to", "tonic.to"}, n, n, "whois.tonic.to", e, "http://www.tonic.to/", 0xa0, t},
	{"today", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.today", e, e, 0x40, t},
	{"tokyo", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, s{"Tokyo", "JP-13"}, "whois.nic.tokyo", e, e, 0xc4, t},
	{"tools", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.tools", e, e, 0x40, t},
	{"top", r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.top", e, "http://www.nic.top/", 0x40, t},
	{"toray", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.toray", e, "https://newgtlds.icann.org/", 0x42, f},
	{"toshiba", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.toshiba", e, "https://newgtlds.icann.org/", 0x42, t},
	{"total", r, x, s{"d.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.total", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tour", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"tours", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.tours", e, "https://newgtlds.icann.org/", 0x40, t},
	{"town", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.town", e, e, 0x40, t},
	{"toyota", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.toyota", e, "https://newgtlds.icann.org/", 0x42, f},
	{"toys", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.toys", e, e, 0x40, t},
	{"tp", r, z[4500:4503], n, n, n, e, e, e, 0x8a0, f},
	{"tr", r, z[4503:4524], s{"ns21.nic.tr", "ns22.nic.tr", "ns31.nic.tr", "ns41.nic.tr", "ns42.nic.tr", "ns61.nic.tr"}, n, n, "whois.nic.tr", e, "https://www.nic.tr/", 0xa8, t},
	{"trade", r, x, s{"ns1.dns.nic.trade", "ns2.dns.nic.trade", "ns3.dns.nic.trade", "ns4.dns.nic.trade", "ns5.dns.nic.trade", "ns6.dns.nic.trade"}, n, n, "whois.nic.trade", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"tradershotels", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"trading", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.trading", e, "https://bostonivy.co/", 0x40, f},
	{"training", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.training", e, e, 0x40, t},
	{"transformers", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"translations", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"transunion", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"travel", r, x, s{"a.gtld.travel", "b.gtld.travel", "c.gtld.travel", "d.gtld.travel", "e.gtld.travel", "f.gtld.travel"}, n, n, "whois.nic.travel", e, "http://www.travel.travel/", 0x1040, f},
	{"travelchannel", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.travelchannel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"travelers", r, x, s{"a0.nic.travelers", "a2.nic.travelers", "b0.nic.travelers", "c0.nic.travelers"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"travelersinsurance", r, x, s{"a0.nic.travelersinsurance", "a2.nic.travelersinsurance", "b0.nic.travelersinsurance", "c0.nic.travelersinsurance"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"travelguard", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"trust", r, x, s{"a.nic.trust", "b.nic.trust", "c.nic.trust", "d.nic.trust"}, n, n, "whois.nic.trust", e, "https://newgtlds.icann.org/", 0x40, f},
	{"trv", r, x, s{"a0.nic.trv", "a2.nic.trv", "b0.nic.trv", "c0.nic.trv"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tt", r, z[4524:4556], s{"a.lactld.org", "ns3.nic.mx", "pch.nic.tt", "ripe.nic.tt"}, n, n, e, "http://www.nic.tt/cgi-bin/search.pl", e, 0xa0, f},
	{"tube", r, x, s{"ns1.dns.nic.tube", "ns2.dns.nic.tube", "ns3.dns.nic.tube", "ns4.dns.nic.tube", "ns5.dns.nic.tube", "ns6.dns.nic.tube"}, n, n, "whois.nic.tube", e, "https://newgtlds.icann.org/", 0x40, f},
	{"tui", r, x, s{"a.nic.tui", "b.nic.tui", "c.nic.tui", "d.nic.tui"}, n, n, "whois.nic.tui", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tunes", r, x, s{"dns1.nic.tunes", "dns2.nic.tunes", "dns3.nic.tunes", "dns4.nic.tunes", "dnsa.nic.tunes", "dnsb.nic.tunes", "dnsc.nic.tunes", "dnsd.nic.tunes"}, n, n, "whois.nic.tunes", e, "https://newgtlds.icann.org/", 0x48, t},
	{"tushu", r, x, s{"dns1.nic.tushu", "dns2.nic.tushu", "dns3.nic.tushu", "dns4.nic.tushu", "dnsa.nic.tushu", "dnsb.nic.tushu", "dnsc.nic.tushu", "dnsd.nic.tushu"}, n, n, "whois.nic.tushu", e, "https://newgtlds.icann.org/", 0x42, t},
	{"tv", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "tvwhois.verisign-grs.com", e, e, 0xe0, t},
	{"tvs", r, x, s{"a0.nic.tvs", "a2.nic.tvs", "b0.nic.tvs", "c0.nic.tvs"}, n, n, "whois.nic.tvs", e, "https://newgtlds.icann.org/", 0x42, f},
	{"tw", r, z[4556:4569], s{"a.dns.tw", "anytld.apnic.net", "b.dns.tw", "c.dns.tw", "d.dns.tw", "e.dns.tw", "f.dns.tw", "g.dns.tw", "h.dns.tw", "ns.twnic.net"}, n, n, "whois.twnic.net.tw", e, e, 0xa0, t},
	{"tz", r, z[4569:4581], s{"d.ext.nic.cz", "fork.sth.dnsnode.net", "ns-tz.afrinic.net", "ns.anycast.co.tz", "ns2.tznic.or.tz", "rip.psg.com"}, n, n, "whois.tznic.or.tz", e, e, 0xa8, f},
	{"ua", r, z[4581:4647], s{"cd1.ns.ua", "ho1.ns.ua", "in1.ns.ua", "pch.ns.ua"}, n, n, "whois.ua", e, "http://www.nic.net.ua/", 0xa0, t},
	{"ubank", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.ubank", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ubs", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.ubs", e, "https://newgtlds.icann.org/", 0x42, f},
	{"uconnect", r, x, n, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ug", r, z[4647:4656], s{"anycast.eahd.or.ug", "ns-ug.afrinic.net", "ns.icann.org", "root.eahd.or.ug", "ug.cctld.authdns.ripe.net"}, n, n, "whois.co.ug", e, e, 0xa0, f},
	{"uk", r, z[4656:4666], s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, "whois.nic.uk", e, "https://www.nominet.uk/", 0xa0, f},
	{"ultrabook", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"um", r, x, n, n, n, e, e, e, 0x8a0, f},
	{"ummah", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2042, f},
	{"unicom", r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.unicom", e, "https://newgtlds.icann.org/", 0x42, f},
	{"unicorn", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"university", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.university", e, e, 0x40, t},
	{"uno", r, x, s{"a.nic.uno", "b.nic.uno", "c.nic.uno", "d.nic.uno"}, n, n, "whois.nic.uno", e, e, 0x40, f},
	{"uol", r, x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, "whois.gtlds.nic.br", e, "https://newgtlds.icann.org/", 0x42, t},
	{"ups", r, x, s{"a0.nic.ups", "a2.nic.ups", "b0.nic.ups", "c0.nic.ups"}, n, n, "whois.nic.ups", e, "https://newgtlds.icann.org/", 0x42, f},
	{"us", r, z[4666:4726], s{"a.cctld.us", "b.cctld.us", "c.cctld.us", "e.cctld.us", "f.cctld.us", "k.cctld.us"}, n, n, "whois.nic.us", e, e, 0xa0, f},
	{"uy", r, z[4726:4732], s{"a.lactld.org", "a.nic.uy", "b.nic.uy", "d.nic.uy", "ns.dns.br", "ns1.anteldata.com.uy", "ns2.anteldata.com.uy", "ns3.nic.mx"}, n, n, "whois.nic.org.uy", e, e, 0xa0, f},
	{"uz", r, z[4732:4746], s{"ns.uz", "ns2.uz", "ns3.uz", "ns4.uz", "ns5.uz", "ns6.uz", "ns7.uz"}, n, n, "whois.cctld.uz", e, e, 0xa0, f},
	{"va", r, x, s{"dns.nic.it", "john.vatican.va", "michael.vatican.va", "osiris.namex.it", "seth.namex.it", "va.cctld.authdns.ripe.net"}, n, n, "whois.iana.org", e, e, 0xa0, f},
	{"vacations", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.vacations", e, e, 0x40, t},
	{"vana", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.vana", e, "https://newgtlds.icann.org/", 0x42, f},
	{"vanguard", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.vanguard", e, "https://newgtlds.icann.org/", 0x42, f},
	{"vanish", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"vc", r, z[4746:4749], s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, "whois2.afilias-grs.net", e, e, 0xe0, f},
	{"ve", r, z[4749:4760], s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, "whois.nic.ve", e, e, 0xa8, t},
	{"vegas", r, x, s{"a0.nic.vegas", "a2.nic.vegas", "b0.nic.vegas", "c0.nic.vegas"}, n, s{"Las Vegas"}, "whois.afilias-srs.net", e, "http://www.nic.vegas/", 0xc4, f},
	{"ventures", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.ventures", e, e, 0x40, t},
	{"verisign", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.verisign", e, "https://newgtlds.icann.org/", 0x42, t},
	{"xn--vermgensberater-ctb" /* vermögensberater */, r, x, s{"a.nic.xn--vermgensberater-ctb", "b.nic.xn--vermgensberater-ctb", "c.nic.xn--vermgensberater-ctb", "d.nic.xn--vermgensberater-ctb"}, n, n, "whois.nic.xn--vermgensberater-ctb", e, "https://newgtlds.icann.org/", 0x48, f},
	{"xn--vermgensberatung-pwb" /* vermögensberatung */, r, x, s{"a.nic.xn--vermgensberatung-pwb", "b.nic.xn--vermgensberatung-pwb", "c.nic.xn--vermgensberatung-pwb", "d.nic.xn--vermgensberatung-pwb"}, n, n, "whois.nic.xn--vermgensberatung-pwb", e, "https://newgtlds.icann.org/", 0x48, f},
	{"versicherung", r, x, s{"a.dns.nic.versicherung", "m.dns.nic.versicherung", "n.dns.nic.versicherung"}, n, n, "whois.nic.versicherung", e, e, 0x40, t},
	{"vet", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.vet", e, e, 0x40, t},
	{"vg", r, z[4760:4761], s{"a.nic.vg", "b.nic.vg", "c.nic.vg", "d.nic.vg"}, s{"88.198.29.97"}, n, "whois.nic.vg", e, e, 0xa0, f},
	{"vi", r, z[4761:4767], s{"auth100.ns.uu.net", "auth110.ns.uu.net", "ns3.nic.vi", "pch.nic.vi"}, n, n, e, "https://secure.nic.vi/whois-lookup/", "http://www.nic.vi/", 0xa8, f},
	{"viajes", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.viajes", e, e, 0x40, t},
	{"video", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.video", e, "https://newgtlds.icann.org/", 0x40, t},
	{"vig", r, x, s{"a0.nic.vig", "a2.nic.vig", "b0.nic.vig", "c0.nic.vig"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"viking", r, x, s{"a0.nic.viking", "a2.nic.viking", "b0.nic.viking", "c0.nic.viking"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"villas", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.villas", e, e, 0x40, t},
	{"vin", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.vin", e, "https://newgtlds.icann.org/", 0x40, t},
	{"vip", r, x, s{"dns1.nic.vip", "dns2.nic.vip", "dns3.nic.vip", "dns4.nic.vip", "dnsa.nic.vip", "dnsb.nic.vip", "dnsc.nic.vip", "dnsd.nic.vip"}, n, n, "whois.nic.vip", e, "http://nic.vip/", 0x40, t},
	{"virgin", r, x, s{"dns1.nic.virgin", "dns2.nic.virgin", "dns3.nic.virgin", "dns4.nic.virgin", "dnsa.nic.virgin", "dnsb.nic.virgin", "dnsc.nic.virgin", "dnsd.nic.virgin"}, n, n, "whois.nic.virgin", e, "https://newgtlds.icann.org/", 0x42, f},
	{"visa", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.visa", e, "https://newgtlds.icann.org/", 0x42, t},
	{"vision", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.vision", e, e, 0x40, t},
	{"vista", r, x, n, n, n, "whois.nic.vista", e, "https://newgtlds.icann.org/", 0x42, f},
	{"vistaprint", r, x, n, n, n, "whois.nic.vistaprint", e, "https://newgtlds.icann.org/", 0x42, f},
	{"viva", r, x, s{"a.nic.viva", "b.nic.viva", "c.nic.viva", "d.nic.viva"}, n, n, "whois.nic.viva", e, "https://newgtlds.icann.org/", 0x42, f},
	{"vivo", r, x, s{"ns1.dns.nic.vivo", "ns2.dns.nic.vivo", "ns3.dns.nic.vivo", "ns4.dns.nic.vivo", "ns5.dns.nic.vivo", "ns6.dns.nic.vivo"}, n, n, "whois.nic.vivo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"vlaanderen", r, x, s{"a.nic.vlaanderen", "b.nic.vlaanderen", "c.ns.dns.be", "d.ns.dns.be", "y.ns.dns.be", "z.nsset.vlaanderen"}, n, s{"BE-VLG"}, "whois.nic.vlaanderen", e, "https://newgtlds.icann.org/", 0x440, t},
	{"vn", r, z[4767:4779], s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, "http://www.vnnic.vn/en/domain", e, 0xa0, t},
	{"vodka", r, x, s{"dns1.nic.vodka", "dns2.nic.vodka", "dns3.nic.vodka", "dns4.nic.vodka", "dnsa.nic.vodka", "dnsb.nic.vodka", "dnsc.nic.vodka", "dnsd.nic.vodka"}, n, n, "whois.nic.vodka", e, "http://nic.vodka/", 0x40, t},
	{"volkswagen", r, x, s{"a0.nic.volkswagen", "a2.nic.volkswagen", "b0.nic.volkswagen", "c0.nic.volkswagen"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, t},
	{"volvo", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.volvo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"vons", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"vote", r, x, s{"a0.nic.vote", "a2.nic.vote", "b0.nic.vote", "c0.nic.vote"}, n, n, "whois.afilias.net", e, "http://nic.vote/", 0x40, f},
	{"voting", r, x, s{"a.nic.voting", "b.nic.voting", "c.nic.voting", "d.nic.voting"}, n, n, "whois.nic.voting", e, e, 0x40, t},
	{"voto", r, x, s{"a0.nic.voto", "a2.nic.voto", "b0.nic.voto", "c0.nic.voto"}, n, n, "whois.afilias.net", e, "http://nic.voto/", 0x40, f},
	{"voyage", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.voyage", e, e, 0x40, t},
	{"vu", r, z[4779:4784], s{"ns1.neustar.vu", "ns2.neustar.vu", "ns3.neustar.vu", "ns4.neustar.vu"}, n, n, "whois.dnrs.neustar", e, e, 0xa0, f},
	{"vuelos", r, x, s{"ns1.dns.nic.vuelos", "ns2.dns.nic.vuelos", "ns3.dns.nic.vuelos", "ns4.dns.nic.vuelos", "ns5.dns.nic.vuelos", "ns6.dns.nic.vuelos"}, n, n, "whois.nic.vuelos", e, "https://newgtlds.icann.org/", 0x40, f},
	{"wales", r, x, s{"dns1.nic.wales", "dns2.nic.wales", "dns3.nic.wales", "dns4.nic.wales", "dnsa.nic.wales", "dnsb.nic.wales", "dnsc.nic.wales", "dnsd.nic.wales"}, n, s{"GB-WLS"}, "whois.nic.wales", e, "http://nic.wales/", 0x4c0, t},
	{"walmart", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.walmart", e, "https://newgtlds.icann.org/", 0x42, f},
	{"walter", r, x, s{"a.nic.walter", "b.nic.walter", "c.nic.walter", "d.nic.walter"}, n, n, "whois.nic.walter", e, "https://newgtlds.icann.org/", 0x42, f},
	{"wang", r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, e, 0x40, t},
	{"wanggou", r, x, s{"dns1.nic.wanggou", "dns2.nic.wanggou", "dns3.nic.wanggou", "dns4.nic.wanggou", "dnsa.nic.wanggou", "dnsb.nic.wanggou", "dnsc.nic.wanggou", "dnsd.nic.wanggou"}, n, n, "whois.nic.wanggou", e, "https://newgtlds.icann.org/", 0x48, t},
	{"warman", r, x, n, n, n, "whois.nic.warman", e, "https://newgtlds.icann.org/", 0x42, f},
	{"watch", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.watch", e, e, 0x40, t},
	{"watches", r, x, s{"ns1.dns.nic.watches", "ns2.dns.nic.watches", "ns3.dns.nic.watches", "ns4.dns.nic.watches", "ns5.dns.nic.watches", "ns6.dns.nic.watches"}, n, n, "whois.nic.watches", e, "https://newgtlds.icann.org/", 0x40, f},
	{"weather", r, x, s{"ns1.dns.nic.weather", "ns2.dns.nic.weather", "ns3.dns.nic.weather", "ns4.dns.nic.weather", "ns5.dns.nic.weather", "ns6.dns.nic.weather"}, n, n, "whois.nic.weather", e, "https://newgtlds.icann.org/", 0x40, f},
	{"weatherchannel", r, x, s{"ns1.dns.nic.weatherchannel", "ns2.dns.nic.weatherchannel", "ns3.dns.nic.weatherchannel", "ns4.dns.nic.weatherchannel", "ns5.dns.nic.weatherchannel", "ns6.dns.nic.weatherchannel"}, n, n, "whois.nic.weatherchannel", e, "https://newgtlds.icann.org/", 0x42, f},
	{"web", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"webcam", r, x, s{"ns1.dns.nic.webcam", "ns2.dns.nic.webcam", "ns3.dns.nic.webcam", "ns4.dns.nic.webcam", "ns5.dns.nic.webcam", "ns6.dns.nic.webcam"}, n, n, "whois.nic.webcam", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"weber", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.weber", e, "https://newgtlds.icann.org/", 0x42, t},
	{"webjet", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"webs", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"website", r, x, s{"a.nic.website", "b.nic.website", "e.nic.website", "f.nic.website"}, n, n, "whois.nic.website", e, e, 0x40, t},
	{"wed", r, x, s{"dns1.emdns.uk", "dns2.emdns.uk", "dns3.emdns.uk", "dns4.emdns.uk", "dnsa.emdns.uk", "dnsb.emdns.uk", "dnsc.emdns.uk", "dnsd.emdns.uk"}, n, n, "whois.nic.wed", e, "https://newgtlds.icann.org/", 0x40, f},
	{"wedding", r, x, s{"dns1.nic.wedding", "dns2.nic.wedding", "dns3.nic.wedding", "dns4.nic.wedding", "dnsa.nic.wedding", "dnsb.nic.wedding", "dnsc.nic.wedding", "dnsd.nic.wedding"}, n, n, "whois.nic.wedding", e, "http://nic.wedding/", 0x40, t},
	{"weibo", r, x, s{"a0.nic.weibo", "a2.nic.weibo", "b0.nic.weibo", "c0.nic.weibo"}, n, n, "whois.nic.weibo", e, "https://newgtlds.icann.org/", 0x40, f},
	{"weir", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"wf", r, x, s{"d.nic.fr", "e.ext.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.wf", e, e, 0xa0, t},
	{"whoswho", r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.whoswho", e, "https://newgtlds.icann.org/", 0x40, t},
	{"wien", r, x, s{"dns.ryce-rsp.com", "ns1.dns.business", "ns1.ryce-rsp.com"}, n, s{"Vienna", "AT-9"}, "whois.nic.wien", e, e, 0xc4, t},
	{"wiki", r, x, s{"a.nic.wiki", "b.nic.wiki", "c.nic.wiki", "d.nic.wiki"}, n, n, "whois.nic.wiki", e, e, 0x40, t},
	{"williamhill", r, x, s{"ns1.dns.nic.williamhill", "ns2.dns.nic.williamhill", "ns3.dns.nic.williamhill", "ns4.dns.nic.williamhill", "ns5.dns.nic.williamhill", "ns6.dns.nic.williamhill"}, n, n, "whois.nic.williamhill", e, "https://newgtlds.icann.org/", 0x42, f},
	{"wilmar", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x42, f},
	{"win", r, x, s{"ns1.dns.nic.win", "ns2.dns.nic.win", "ns3.dns.nic.win", "ns4.dns.nic.win", "ns5.dns.nic.win", "ns6.dns.nic.win"}, n, n, "whois.nic.win", e, "https://www.famousfourmedia.com/", 0x40, t},
	{"windows", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"wine", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.wine", e, "https://newgtlds.icann.org/", 0x40, t},
	{"winners", r, x, s{"ns1.dns.nic.winners", "ns2.dns.nic.winners", "ns3.dns.nic.winners", "ns4.dns.nic.winners", "ns5.dns.nic.winners", "ns6.dns.nic.winners"}, n, n, "whois.nic.winners", e, "https://newgtlds.icann.org/", 0x40, f},
	{"wme", r, x, s{"a.nic.wme", "b.nic.wme", "c.nic.wme", "d.nic.wme"}, n, n, "whois.nic.wme", e, "https://newgtlds.icann.org/", 0x42, t},
	{"wolterskluwer", r, x, s{"a0.nic.wolterskluwer", "a2.nic.wolterskluwer", "b0.nic.wolterskluwer", "c0.nic.wolterskluwer"}, n, n, "whois.nic.wolterskluwer", e, "https://newgtlds.icann.org/", 0x42, f},
	{"woodside", r, x, s{"a.nic.woodside", "b.nic.woodside", "c.nic.woodside", "d.nic.woodside"}, n, n, "whois.nic.woodside", e, "https://newgtlds.icann.org/", 0x42, f},
	{"work", r, x, s{"dns1.nic.work", "dns2.nic.work", "dns3.nic.work", "dns4.nic.work", "dnsa.nic.work", "dnsb.nic.work", "dnsc.nic.work", "dnsd.nic.work"}, n, n, "whois.nic.work", e, "http://nic.work/", 0x40, t},
	{"works", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.works", e, e, 0x40, t},
	{"world", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.world", e, "https://newgtlds.icann.org/", 0x40, t},
	{"wow", r, x, s{"dns1.nic.wow", "dns2.nic.wow", "dns3.nic.wow", "dns4.nic.wow", "dnsa.nic.wow", "dnsb.nic.wow", "dnsc.nic.wow", "dnsd.nic.wow"}, n, n, "whois.nic.wow", e, "https://newgtlds.icann.org/", 0x40, t},
	{"ws", r, z[4784:4789], s{"ns2.dns.ws", "ns3.dns.ws", "ns4.dns.ws", "ns5.dns.ws", "ns6.dns.ws", "ns7.dns.ws"}, s{"64.70.19.203"}, n, "whois.website.ws", e, "http://nic.ws/", 0xe0, t},
	{"wtc", r, x, s{"a.nic.wtc", "b.nic.wtc", "c.nic.wtc", "d.nic.wtc"}, n, n, "whois.nic.wtc", e, "https://newgtlds.icann.org/", 0x42, f},
	{"wtf", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.wtf", e, e, 0x40, t},
	{"xbox", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x42, t},
	{"xerox", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xerox", e, "https://newgtlds.icann.org/", 0x42, f},
	{"xfinity", r, x, s{"dns1.nic.xfinity", "dns2.nic.xfinity", "dns3.nic.xfinity", "dns4.nic.xfinity", "dnsa.nic.xfinity", "dnsb.nic.xfinity", "dnsc.nic.xfinity", "dnsd.nic.xfinity"}, n, n, "whois.nic.xfinity", e, "https://newgtlds.icann.org/", 0x42, f},
	{"xihuan", r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.teleinfo.cn", e, "https://newgtlds.icann.org/", 0x40, f},
	{"xin", r, x, s{"a0.nic.xin", "a2.nic.xin", "b0.nic.xin", "c0.nic.xin"}, n, n, "whois.nic.xin", e, "https://newgtlds.icann.org/", 0x40, f},
	{"xperia", r, x, n, n, n, "whois.nic.xperia", e, "https://newgtlds.icann.org/", 0x42, f},
	{"xxx", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns5.uniregistry.net", "ns6.uniregistry.info"}, n, n, "whois.registrar.adult", e, "http://nic.xxx/", 0x41, t},
	{"xyz", r, x, s{"generationxyz.nic.xyz", "x.nic.xyz", "y.nic.xyz", "z.nic.xyz"}, n, n, "whois.nic.xyz", e, e, 0x40, t},
	{"yachts", r, x, s{"a0.nic.yachts", "a2.nic.yachts", "b0.nic.yachts", "c0.nic.yachts"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x40, f},
	{"yahoo", r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.yahoo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"yamaxun", r, x, s{"dns1.nic.yamaxun", "dns2.nic.yamaxun", "dns3.nic.yamaxun", "dns4.nic.yamaxun", "dnsa.nic.yamaxun", "dnsb.nic.yamaxun", "dnsc.nic.yamaxun", "dnsd.nic.yamaxun"}, n, n, "whois.nic.yamaxun", e, "https://newgtlds.icann.org/", 0x42, t},
	{"yandex", r, x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, "whois.nic.yandex", e, "https://newgtlds.icann.org/", 0x42, f},
	{"ye", r, z[4789:4797], s{"ns1.yemen.net.ye", "ns2.yemen.net.ye", "sah1.ye", "sah2.ye"}, n, n, e, e, e, 0xa8, f},
	{"yellowpages", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x48, f},
	{"yodobashi", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, n, "whois.nic.gmo", e, "https://newgtlds.icann.org/", 0x42, t},
	{"yoga", r, x, s{"dns1.nic.yoga", "dns2.nic.yoga", "dns3.nic.yoga", "dns4.nic.yoga", "dnsa.nic.yoga", "dnsb.nic.yoga", "dnsc.nic.yoga", "dnsd.nic.yoga"}, n, n, "whois.nic.yoga", e, "http://nic.yoga/", 0x40, t},
	{"yokohama", r, x, s{"a.gmoregistry.net", "b.gmoregistry.net", "k.gmoregistry.net", "l.gmoregistry.net"}, n, s{"Yokohama"}, "whois.nic.yokohama", e, e, 0xc4, t},
	{"you", r, x, s{"dns1.nic.you", "dns2.nic.you", "dns3.nic.you", "dns4.nic.you", "dnsa.nic.you", "dnsb.nic.you", "dnsc.nic.you", "dnsd.nic.you"}, n, n, "whois.nic.you", e, "https://newgtlds.icann.org/", 0x40, t},
	{"youtube", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"yt", r, x, s{"d.nic.fr", "e.ext.nic.fr", "f.ext.nic.fr", "g.ext.nic.fr"}, n, n, "whois.nic.yt", e, e, 0xa0, t},
	{"yu", r, z[4797:4803], n, n, n, e, e, e, 0x8a0, f},
	{"yun", r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.teleinfo.cn", e, "https://newgtlds.icann.org/", 0x40, f},
	{"za", r, z[4803:4830], s{"nsza.is.co.za", "za-ns.anycast.pch.net", "za1.dnsnode.net"}, n, n, "whois.nic.za", e, e, 0xa8, f},
	{"zappos", r, x, s{"dns1.nic.zappos", "dns2.nic.zappos", "dns3.nic.zappos", "dns4.nic.zappos", "dnsa.nic.zappos", "dnsb.nic.zappos", "dnsc.nic.zappos", "dnsd.nic.zappos"}, n, n, "whois.nic.zappos", e, "https://newgtlds.icann.org/", 0x42, t},
	{"zara", r, x, s{"a0.nic.zara", "a2.nic.zara", "b0.nic.zara", "c0.nic.zara"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x42, f},
	{"zero", r, x, s{"ns1.dns.nic.zero", "ns2.dns.nic.zero", "ns3.dns.nic.zero", "ns4.dns.nic.zero", "ns5.dns.nic.zero", "ns6.dns.nic.zero"}, n, n, "whois.nic.zero", e, "https://newgtlds.icann.org/", 0x40, t},
	{"zip", r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"zippo", r, x, n, n, n, "whois.nic.zippo", e, "https://newgtlds.icann.org/", 0x42, f},
	{"zm", r, z[4830:4838], s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, "whois.zicta.zm", e, e, 0xa0, f},
	{"zone", r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.zone", e, e, 0x40, t},
	{"zuerich", r, x, s{"a.nic.zuerich", "b.nic.zuerich", "c.nic.zuerich", "d.nic.zuerich"}, n, s{"Zurich", "CH-ZH"}, "whois.nic.zuerich", e, "https://newgtlds.icann.org/", 0xc4, f},
	{"zulu", r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, f},
	{"zw", r, z[4838:4842], s{"ns1.liquidtelecom.net", "ns1.telone.co.zw", "ns1zim.telone.co.zw", "ns2.liquidtelecom.net", "ns2.telone.co.zw", "ns2zim.telone.co.zw", "zw-ns.anycast.pch.net"}, n, n, e, "http://www.zispa.org.zw", e, 0xa0, f},
	{"xn--jxalpdlp" /* δοκιμή */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--qxam" /* ελ */, r, x, s{"estia.ics.forth.gr", "gr-at.ics.forth.gr", "gr-c.ics.forth.gr", "gr-d.ics.forth.gr", "grdns.ics.forth.gr"}, n, n, e, "https://grweb.ics.forth.gr/public/whois.jsp?lang=en", e, 0x0, t},
	{"xn--qxa6a" /* ευ */, r, x, s{"nl.dns.eu", "si.dns.eu", "w.dns.eu", "x.dns.eu", "y.dns.eu"}, n, n, "whois.eu", e, e, 0x0, t},
	{"xn--90ae" /* бг */, r, x, s{"a.nic.bg", "b.nic.bg", "c.nic.bg", "d.nic.bg", "e.nic.bg", "p.nic.bg"}, n, n, "whois.imena.bg", e, e, 0x0, t},
	{"xn--90ais" /* бел */, r, x, s{"dns1.tld.tutby.com", "dns2.tld.tutby.com", "dns3.tld.tutby.com", "dns4.tld.tutby.com", "dns5.tld.tutby.com"}, n, n, "whois.cctld.by", e, e, 0x40, t},
	{"xn--d1acj3b" /* дети */, r, x, s{"a.dns.ripn.net", "b.dns.ripn.net", "d.dns.ripn.net", "e.dns.ripn.net", "f.dns.ripn.net"}, n, n, "whois.nic.xn--d1acj3b", e, e, 0x40, t},
	{"xn--e1a4c" /* ею */, r, x, s{"nl.dns.eu", "si.dns.eu", "w.dns.eu", "x.dns.eu", "y.dns.eu"}, n, n, "whois.eu", e, e, 0x0, t},
	{"xn--80akhbyknj4f" /* испытание */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--80aqecdr1a" /* католик */, r, x, s{"a.nic.xn--80aqecdr1a", "b.nic.xn--80aqecdr1a", "c.nic.xn--80aqecdr1a", "d.nic.xn--80aqecdr1a"}, n, n, "whois.nic.xn--80aqecdr1a", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--j1aef" /* ком */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--j1aef", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--d1alf" /* мкд */, r, x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, "whois.marnet.mk", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--l1acc" /* мон */, r, x, s{"ns1.idn.mn", "ns2.idn.mn", "ns3.idn.mn"}, n, n, e, e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--80adxhks" /* москва */, r, x, s{"a.dns.flexireg.ru", "b.dns.flexireg.net", "c.dns.flexireg.org", "d.dns.flexireg.domains"}, n, s{"Moscow"}, "whois.nic.xn--80adxhks", e, e, 0xc4, t},
	{"xn--80asehdb" /* онлайн */, r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.xn--80asehdb", e, e, 0x40, t},
	{"xn--c1avg" /* орг */, r, x, s{"a0.nic.xn--c1avg", "a2.nic.xn--c1avg", "b0.nic.xn--c1avg", "c0.nic.xn--c1avg"}, n, n, "whois.publicinterestregistry.net", e, "https://pir.org/products/opr-domain/", 0x40, t},
	{"xn--p1acf" /* рус */, r, z[4842:5042], s{"ns.cocca.fr", "ns1.nic.xn--p1acf", "ns2.nic.xn--p1acf"}, n, n, "whois.nic.xn--p1acf", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--p1ai" /* рф */, r, z[5042:5045], s{"a.dns.ripn.net", "b.dns.ripn.net", "d.dns.ripn.net", "e.dns.ripn.net", "f.dns.ripn.net"}, n, n, "whois.tcinet.ru", e, "https://cctld.ru/", 0x0, t},
	{"xn--80aswg" /* сайт */, r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.xn--80aswg", e, e, 0x40, t},
	{"xn--90a3ac" /* срб */, r, z[5045:5050], s{"a.nic.rs", "b.nic.rs", "f.nic.rs", "g.nic.rs", "h.nic.rs", "l.nic.rs"}, n, n, "whois.rnids.rs", e, e, 0x40, t},
	{"xn--j1amh" /* укр */, r, x, s{"dns1.u-registry.com", "dns2.u-registry.net", "dns3.dotukr.com", "nsi.uanic.net", "tier1.num.net.ua"}, n, n, "whois.dotukr.com", e, e, 0x40, t},
	{"xn--80ao21a" /* қаз */, r, x, s{"ns.nic.kz", "ns1.nic.kz"}, n, n, "whois.nic.kz", e, e, 0x40, t},
	{"xn--y9a3aq" /* հայ */, r, x, s{"fork.sth.dnsnode.net", "ns-cdn.amnic.net", "ns-pch.amnic.net", "ns-pri.nic.am"}, n, n, "whois.amnic.net", e, e, 0x40, t},
	{"xn--deba0ad" /* טעסט */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--9dbq2a" /* קום */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--9dbq2a", e, e, 0x0, t},
	{"xn--hgbk6aj7f53bba" /* آزمایشی */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--kgbechtv" /* إختبار */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--mgbca7dzdo" /* ابوظبي */, r, x, s{"gtld.alpha.aridns.net.au", "gtld.beta.aridns.net.au", "gtld.delta.aridns.net.au", "gtld.gamma.aridns.net.au"}, n, n, "whois.nic.xn--mgbca7dzdo", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbaakc7dvf" /* اتصالات */, r, x, s{"a.nic.xn--mgbaakc7dvf", "b.nic.xn--mgbaakc7dvf", "c.nic.xn--mgbaakc7dvf", "d.nic.xn--mgbaakc7dvf"}, n, n, "whois.centralnic.com", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgba3a3ejt" /* ارامكو */, r, x, s{"ns1.dns.nic.xn--mgba3a3ejt", "ns2.dns.nic.xn--mgba3a3ejt", "ns3.dns.nic.xn--mgba3a3ejt", "ns4.dns.nic.xn--mgba3a3ejt", "ns5.dns.nic.xn--mgba3a3ejt", "ns6.dns.nic.xn--mgba3a3ejt"}, n, n, "whois.nic.xn--mgba3a3ejt", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbayh7gpa" /* الاردن */, r, x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, "http://idn.jo/whois_a.aspx", e, 0x40, t},
	{"xn--mgbcpq6gpa1a" /* البحرين */, r, x, s{"a.nic.xn--mgbcpq6gpa1a", "b.nic.xn--mgbcpq6gpa1a", "c.nic.xn--mgbcpq6gpa1a", "d.nic.xn--mgbcpq6gpa1a"}, n, n, e, e, e, 0x0, t},
	{"xn--lgbbat1ad8j" /* الجزائر */, r, x, s{"idn1.nic.dz", "idn2.nic.dz"}, n, n, "whois.nic.dz", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgberp4a5d4ar" /* السعودية */, r, x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, "whois.nic.net.sa", e, e, 0x40, t},
	{"xn--mgba7c0bbn0a" /* العليان */, r, x, s{"a.nic.xn--mgba7c0bbn0a", "b.nic.xn--mgba7c0bbn0a", "c.nic.xn--mgba7c0bbn0a", "d.nic.xn--mgba7c0bbn0a"}, n, n, "whois.nic.xn--mgba7c0bbn0a", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbc0a9azcg" /* المغرب */, r, x, s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, "whois.iam.net.ma", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbaam7a8h" /* امارات */, r, x, s{"ns1.aedns.ae", "ns2.aedns.ae", "nsext-pch.aedns.ae"}, n, n, "whois.aeda.net.ae", e, e, 0x40, t},
	{"xn--mgba3a4f16a" /* ایران */, r, x, s{"a.nic.ir", "ns.irnic.ir"}, n, n, "whois.nic.ir", e, e, 0x40, t},
	{"xn--mgbbh1a" /* بارت */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--mgbab2bd" /* بازار */, r, x, s{"anycast10.irondns.net", "anycast23.irondns.net", "anycast24.irondns.net", "anycast9.irondns.net"}, n, n, "whois.nic.xn--mgbab2bd", e, e, 0x40, t},
	{"xn--ngbe9e0a" /* بيتك */, r, x, s{"a.nic.xn--ngbe9e0a", "b.nic.xn--ngbe9e0a", "c.nic.xn--ngbe9e0a", "d.nic.xn--ngbe9e0a"}, n, n, "whois.nic.xn--ngbe9e0a", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbbh1a71e" /* بھارت */, r, z[5050:5051], s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--pgbs0dh" /* تونس */, r, x, s{"ns-tn.afrinic.net", "ns1.ati.tn", "ns2.ati.tn", "ns2.nic.fr", "pch.ati.tn", "rip.psg.com"}, n, n, "whois.ati.tn", e, e, 0x40, t},
	{"xn--mgbpl2fh" /* سودان */, r, x, s{"ans1.sis.sd", "pch.sis.sd"}, n, n, e, e, e, 0x40, t},
	{"xn--ogbpf8fl" /* سورية */, r, x, s{"ns1.tld.sy", "pch.anycast.tld.sy", "sy.cctld.authdns.ripe.net"}, n, n, "whois.tld.sy", e, e, 0x40, t},
	{"xn--ngbc5azd" /* شبكة */, r, x, s{"a.nic.xn--ngbc5azd", "b.nic.xn--ngbc5azd", "c.nic.xn--ngbc5azd", "d.nic.xn--ngbc5azd"}, n, n, "whois.nic.xn--ngbc5azd", e, "http://www.dotshabaka.com/", 0x40, t},
	{"xn--mgbtx2b" /* عراق */, r, x, s{"dyn1.cmc.iq", "dyn2.cmc.iq", "ns1.cmc.iq", "nsp-anycast.cmc.iq"}, n, n, "whois.cmc.iq", e, e, 0x0, t},
	{"xn--ngbrx" /* عرب */, r, x, s{"gtld.alpha.aridns.net.au", "gtld.beta.aridns.net.au", "gtld.delta.aridns.net.au", "gtld.gamma.aridns.net.au"}, n, n, "whois.nic.xn--ngbrx", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgb9awbf" /* عمان */, r, x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, "whois.registry.om", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--ygbi2ammx" /* فلسطين */, r, x, s{"dns1.gov.ps", "dns3.gov.ps", "idn.pnina.ps", "ns1.pnina.ps"}, n, n, "whois.pnina.ps", e, e, 0x40, t},
	{"xn--wgbl6a" /* قطر */, r, x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, "whois.registry.qa", e, e, 0x40, t},
	{"xn--mgbi4ecexp" /* كاثوليك */, r, x, s{"a.nic.xn--mgbi4ecexp", "b.nic.xn--mgbi4ecexp", "c.nic.xn--mgbi4ecexp", "d.nic.xn--mgbi4ecexp"}, n, n, "whois.nic.xn--mgbi4ecexp", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--fhbei" /* كوم */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--fhbei", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--pgb3ceoj" /* كيوتل */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--wgbh1c" /* مصر */, r, x, s{"ns1.dotmasr.eg", "ns2.dotmasr.eg", "ns3.dotmasr.eg"}, n, n, "whois.dotmasr.eg", e, e, 0x40, t},
	{"xn--mgbx4cd0ab" /* مليسيا */, r, x, s{"a.mynic.centralnic-dns.com", "a.nic.my", "a1.nic.my", "b.mynic.centralnic-dns.com", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, "whois.mynic.my", e, e, 0x40, t},
	{"xn--mgbb9fbpob" /* موبايلي */, r, x, n, n, n, "whois.nic.xn--mgbb9fbpob", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbah1a3hjkrd" /* موريتانيا */, r, x, s{"ns-mr.afrinic.net", "ns-mr.nic.fr", "ns1.nic.mr", "ns2.nic.mr", "ns3.nic.mr"}, n, n, "whois.nic.mr", e, e, 0x0, t},
	{"xn--mgbv6cfpo" /* موزايك */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--4gbrim" /* موقع */, r, x, s{"a0.nic.xn--4gbrim", "a2.nic.xn--4gbrim", "b0.nic.xn--4gbrim", "c0.nic.xn--4gbrim"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbt3dhd" /* همراه */, r, x, s{"a.ns.nic.xn--mgbt3dhd", "b.ns.nic.xn--mgbt3dhd", "ns.cocca.fr"}, n, s{"Iran"}, "whois.nic.xn--mgbt3dhd", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--mgbai9azgqp6j" /* پاکستان */, r, x, s{"ns.ntc.net.pk", "ns1.ntc.net.pk", "ns2.ntc.net.pk"}, n, n, e, e, e, 0x0, t},
	{"xn--mgbgu82a" /* ڀارت */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--11b4c3d" /* कॉम */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--11b4c3d", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--c2br7g" /* नेट */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--c2br7g", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--11b5bs3a9aj6g" /* परीक्षा */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--h2brj9c" /* भारत */, r, z[5051:5052], s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x40, t},
	{"xn--h2breg3eve" /* भारतम् */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--h2brj9c8c" /* भारोत */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--i1b6b1a6a2e" /* संगठन */, r, x, s{"a0.nic.xn--i1b6b1a6a2e", "a2.nic.xn--i1b6b1a6a2e", "b0.nic.xn--i1b6b1a6a2e", "c0.nic.xn--i1b6b1a6a2e"}, n, n, "whois.publicinterestregistry.net", e, "https://pir.org/products/hindi-domain/", 0x40, t},
	{"xn--54b7fta0cc" /* বাংলা */, r, x, s{"bayanno.btcl.net.bd", "bd-ns.anycast.pch.net", "ekushey.btcl.net.bd"}, n, n, e, e, e, 0x0, t},
	{"xn--45brj9c" /* ভারত */, r, z[5052:5054], s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--45br5cyl" /* ভাৰত */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--s9brj9c" /* ਭਾਰਤ */, r, z[5054:5055], s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--gecrj9c" /* ભારત */, r, z[5055:5056], s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--3hcrj9c" /* ଭାରତ */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--xkc2dl3a5ee0h" /* இந்தியா */, r, z[5056:5057], s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--xkc2al3hye2a" /* இலங்கை */, r, x, s{"lk.communitydns.net", "nic.lk-anycast.pch.net", "ns-c.nic.lk", "ns-d.nic.lk", "ns-l.nic.lk", "ns-t.nic.lk", "ns1.ac.lk", "ns3.ac.lk"}, n, n, "whois.nic.lk", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--clchc0ea0b2g2a9gcd" /* சிங்கப்பூர் */, r, x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "ns4.apnic.net", "pch.sgzones.sg"}, n, n, "whois.sgnic.sg", e, e, 0x40, t},
	{"xn--hlcj6aya9esc7a" /* பரிட்சை */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--fpcrj9c3d" /* భారత్ */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--2scrj9c" /* ಭಾರತ */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--rvc1e0am3e" /* ഭാരതം */, r, x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.registry.in", e, e, 0x0, t},
	{"xn--fzc2c9e2c" /* ලංකා */, r, x, s{"lk.communitydns.net", "nic.lk-anycast.pch.net", "ns-c.nic.lk", "ns-d.nic.lk", "ns-l.nic.lk", "ns-t.nic.lk", "ns1.ac.lk", "ns3.ac.lk"}, n, n, "whois.nic.lk", e, e, 0x40, t},
	{"xn--42c2d9a" /* คอม */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--42c2d9a", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--o3cw4h" /* ไทย */, r, z[5057:5058], s{"a.thains.co.th", "b.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, "whois.thnic.co.th", e, e, 0x40, t},
	{"xn--q7ce6a" /* ລາວ */, r, x, s{"a.xn--q7ce6a.centralnic-dns.com", "b.xn--q7ce6a.centralnic-dns.com", "c.xn--q7ce6a.centralnic-dns.com", "d.xn--q7ce6a.centralnic-dns.com"}, n, n, "whois.nic.la", e, e, 0x0, t},
	{"xn--node" /* გე */, r, x, s{"a.xn--node.globalanycastcloud.freenom.net", "b.xn--node.globalanycastcloud.freenom.net", "c.xn--node.globalanycastcloud.freenom.net", "d.xn--node.globalanycastcloud.freenom.net", "xn--node.ns.anycast.pch.net"}, s{"188.93.95.11"}, n, "whois.itdc.ge", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--q9jyb4c" /* みんな */, r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x40, t},
	{"xn--cckwcxetd" /* アマゾン */, r, x, s{"dns1.nic.xn--cckwcxetd", "dns2.nic.xn--cckwcxetd", "dns3.nic.xn--cckwcxetd", "dns4.nic.xn--cckwcxetd", "dnsa.nic.xn--cckwcxetd", "dnsb.nic.xn--cckwcxetd", "dnsc.nic.xn--cckwcxetd", "dnsd.nic.xn--cckwcxetd"}, n, n, "whois.nic.xn--cckwcxetd", e, "https://newgtlds.icann.org/", 0x2040, t},
	{"xn--gckr3f0f" /* クラウド */, r, x, s{"ns1.dns.nic.xn--gckr3f0f", "ns2.dns.nic.xn--gckr3f0f", "ns3.dns.nic.xn--gckr3f0f", "ns4.dns.nic.xn--gckr3f0f", "ns5.dns.nic.xn--gckr3f0f", "ns6.dns.nic.xn--gckr3f0f"}, n, n, "whois.nic.xn--gckr3f0f", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--qcka1pmc" /* グーグル */, r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"xn--tckwe" /* コム */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--tckwe", e, e, 0x0, t},
	{"xn--cck2b3b" /* ストア */, r, x, s{"ns1.dns.nic.xn--cck2b3b", "ns2.dns.nic.xn--cck2b3b", "ns3.dns.nic.xn--cck2b3b", "ns4.dns.nic.xn--cck2b3b", "ns5.dns.nic.xn--cck2b3b", "ns6.dns.nic.xn--cck2b3b"}, n, n, "whois.nic.xn--cck2b3b", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--1ck2e1b" /* セール */, r, x, s{"ns1.dns.nic.xn--1ck2e1b", "ns2.dns.nic.xn--1ck2e1b", "ns3.dns.nic.xn--1ck2e1b", "ns4.dns.nic.xn--1ck2e1b", "ns5.dns.nic.xn--1ck2e1b", "ns6.dns.nic.xn--1ck2e1b"}, n, n, "whois.nic.xn--1ck2e1b", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--zckzah" /* テスト */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--bck1b9a5dre4c" /* ファッション */, r, x, s{"ns1.dns.nic.xn--bck1b9a5dre4c", "ns2.dns.nic.xn--bck1b9a5dre4c", "ns3.dns.nic.xn--bck1b9a5dre4c", "ns4.dns.nic.xn--bck1b9a5dre4c", "ns5.dns.nic.xn--bck1b9a5dre4c", "ns6.dns.nic.xn--bck1b9a5dre4c"}, n, n, "whois.nic.xn--bck1b9a5dre4c", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--eckvdtc9d" /* ポイント */, r, x, s{"ns1.dns.nic.xn--eckvdtc9d", "ns2.dns.nic.xn--eckvdtc9d", "ns3.dns.nic.xn--eckvdtc9d", "ns4.dns.nic.xn--eckvdtc9d", "ns5.dns.nic.xn--eckvdtc9d", "ns6.dns.nic.xn--eckvdtc9d"}, n, n, "whois.nic.xn--eckvdtc9d", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--4gq48lf9j" /* 一号店 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--rhqv96g" /* 世界 */, r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.nic.xn--rhqv96g", e, e, 0x0, t},
	{"xn--fiq64b" /* 中信 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, "https://newgtlds.icann.org/", 0x42, t},
	{"xn--fiqs8s" /* 中国 */, r, x, s{"h.dns.cn", "i.dns.cn", "j.dns.cn", "k.dns.cn", "l.dns.cn", "m.dns.cn", "n.dns.cn"}, s{"218.241.116.40"}, n, "cwhois.cnnic.cn", e, e, 0x0, t},
	{"xn--fiqz9s" /* 中國 */, r, x, s{"h.dns.cn", "i.dns.cn", "j.dns.cn", "k.dns.cn", "l.dns.cn", "m.dns.cn", "n.dns.cn"}, s{"218.241.116.40"}, n, "cwhois.cnnic.cn", e, e, 0x80, t},
	{"xn--fiq228c5hs" /* 中文网 */, r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.teleinfo.cn", e, e, 0x40, t},
	{"xn--jlq480n2rg" /* 亚马逊 */, r, x, s{"dns1.nic.xn--jlq480n2rg", "dns2.nic.xn--jlq480n2rg", "dns3.nic.xn--jlq480n2rg", "dns4.nic.xn--jlq480n2rg", "dnsa.nic.xn--jlq480n2rg", "dnsb.nic.xn--jlq480n2rg", "dnsc.nic.xn--jlq480n2rg", "dnsd.nic.xn--jlq480n2rg"}, n, n, "whois.nic.xn--jlq480n2rg", e, "https://newgtlds.icann.org/", 0x2040, t},
	{"xn--vhquv" /* 企业 */, r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.xn--vhquv", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--1qqw23a" /* 佛山 */, r, x, s{"ta.ngtld.cn", "tb.ngtld.cn", "tc.ngtld.cn", "td.ngtld.cn", "te.ngtld.cn"}, n, s{"Foshan"}, "whois.ngtld.cn", e, "https://newgtlds.icann.org/", 0xc4, t},
	{"xn--vuq861b" /* 信息 */, r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.teleinfo.cn", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--nyqy26a" /* 健康 */, r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.nic.xn--nyqy26a", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--45q11c" /* 八卦 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.xn--45q11c", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--55qx5d" /* 公司 */, r, x, s{"a.ngtld.cn", "b.ngtld.cn", "c.ngtld.cn", "d.ngtld.cn", "e.ngtld.cn"}, n, n, "whois.ngtld.cn", e, e, 0x0, t},
	{"xn--55qw42g" /* 公益 */, r, x, s{"ns1.conac.cn", "ns2.conac.cn", "ns3.conac.cn", "ns4.conac.cn", "ns5.conac.cn"}, n, n, "whois.conac.cn", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--kprw13d" /* 台湾 */, r, x, s{"anytld.apnic.net", "d.dns.tw", "e.dns.tw", "f.dns.tw", "g.dns.tw", "h.dns.tw"}, n, n, "whois.twnic.net.tw", e, e, 0x0, t},
	{"xn--kpry57d" /* 台灣 */, r, x, s{"anytld.apnic.net", "d.dns.tw", "e.dns.tw", "f.dns.tw", "g.dns.tw", "h.dns.tw"}, n, n, "whois.twnic.net.tw", e, e, 0x0, t},
	{"xn--czru2d" /* 商城 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, e, 0x0, t},
	{"xn--czrs0t" /* 商店 */, r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.xn--czrs0t", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--czr694b" /* 商标 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--w4rs40l" /* 嘉里 */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--w4rs40l", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--w4r85el8fhu5dnra" /* 嘉里大酒店 */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--w4r85el8fhu5dnra", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--3ds443g" /* 在线 */, r, x, s{"ns1.teleinfo.cn", "ns2.teleinfoo.com", "ns3.teleinfo.cn", "ns4.teleinfoo.com"}, n, n, "whois.teleinfo.cn", e, e, 0x0, t},
	{"xn--3oq18vl8pn36a" /* 大众汽车 */, r, x, s{"a0.nic.xn--3oq18vl8pn36a", "a2.nic.xn--3oq18vl8pn36a", "b0.nic.xn--3oq18vl8pn36a", "c0.nic.xn--3oq18vl8pn36a"}, n, n, "whois.nic.xn--3oq18vl8pn36a", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--pssy2u" /* 大拿 */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--pssy2u", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--tiq49xqyj" /* 天主教 */, r, x, s{"a.nic.xn--tiq49xqyj", "b.nic.xn--tiq49xqyj", "c.nic.xn--tiq49xqyj", "d.nic.xn--tiq49xqyj"}, n, n, "whois.nic.xn--tiq49xqyj", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--fjq720a" /* 娱乐 */, r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.xn--fjq720a", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--fct429k" /* 家電 */, r, x, s{"ns1.dns.nic.xn--fct429k", "ns2.dns.nic.xn--fct429k", "ns3.dns.nic.xn--fct429k", "ns4.dns.nic.xn--fct429k", "ns5.dns.nic.xn--fct429k", "ns6.dns.nic.xn--fct429k"}, n, n, "whois.nic.xn--fct429k", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--estv75g" /* 工行 */, r, x, n, n, n, "whois.nic.xn--estv75g", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--xhq521b" /* 广东 */, r, x, s{"ta.ngtld.cn", "tb.ngtld.cn", "tc.ngtld.cn", "td.ngtld.cn", "te.ngtld.cn"}, n, n, "whois.ngtld.cn", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--6rtwn" /* 广州 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2000, t},
	{"xn--9krt00a" /* 微博 */, r, x, s{"a0.nic.xn--9krt00a", "a2.nic.xn--9krt00a", "b0.nic.xn--9krt00a", "c0.nic.xn--9krt00a"}, n, n, "whois.nic.xn--9krt00a", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--30rr7y" /* 慈善 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--6qq986b3xl" /* 我爱你 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--kput3i" /* 手机 */, r, x, s{"a0.nic.xn--kput3i", "a2.nic.xn--kput3i", "b0.nic.xn--kput3i", "c0.nic.xn--kput3i"}, n, n, "whois.nic.xn--kput3i", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--kpu716f" /* 手表 */, r, x, n, n, n, "whois.nic.xn--kpu716f", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--otu796d" /* 招聘 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--zfr164b" /* 政务 */, r, x, s{"ns1.conac.cn", "ns2.conac.cn", "ns3.conac.cn", "ns4.conac.cn", "ns5.conac.cn"}, n, n, "whois.conac.cn", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--mxtq1m" /* 政府 */, r, x, s{"a.nic.xn--mxtq1m", "b.nic.xn--mxtq1m", "c.nic.xn--mxtq1m", "d.nic.xn--mxtq1m"}, n, n, "whois.nic.xn--mxtq1m", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--yfro4i67o" /* 新加坡 */, r, x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "ns4.apnic.net", "pch.sgzones.sg"}, n, n, "whois.sgnic.sg", e, e, 0x40, t},
	{"xn--efvy88h" /* 新闻 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.xn--efvy88h", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--9et52u" /* 时尚 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--kcrx7bb75ajk3b" /* 普利司通 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, t},
	{"xn--rovu88b" /* 書籍 */, r, x, s{"ns1.dns.nic.xn--rovu88b", "ns2.dns.nic.xn--rovu88b", "ns3.dns.nic.xn--rovu88b", "ns4.dns.nic.xn--rovu88b", "ns5.dns.nic.xn--rovu88b", "ns6.dns.nic.xn--rovu88b"}, n, n, "whois.nic.xn--rovu88b", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--nqv7f" /* 机构 */, r, x, s{"a0.nic.xn--nqv7f", "a2.nic.xn--nqv7f", "b0.nic.xn--nqv7f", "c0.nic.xn--nqv7f"}, n, n, "whois.publicinterestregistry.net", e, "https://pir.org/products/chinese2char-domain/", 0x40, t},
	{"xn--tqq33ed31aqia" /* 机构体制 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--dkwm73cwpn" /* 欧莱雅 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, t},
	{"xn--0zwm56d" /* 测试 */, r, x, n, n, n, e, e, e, 0x0, t},
	{"xn--b4w605ferd" /* 淡马锡 */, r, x, s{"a0.nic.xn--b4w605ferd", "a2.nic.xn--b4w605ferd", "b0.nic.xn--b4w605ferd", "c0.nic.xn--b4w605ferd"}, n, n, "whois.afilias-srs.net", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--fes124c" /* 深圳 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2000, t},
	{"xn--g6w251d" /* 測試 */, r, x, n, n, n, e, e, e, 0x0, t},
	{"xn--unup4y" /* 游戏 */, r, x, s{"demand.alpha.aridns.net.au", "demand.beta.aridns.net.au", "demand.delta.aridns.net.au", "demand.gamma.aridns.net.au"}, n, n, "whois.nic.xn--unup4y", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--mix891f" /* 澳門 */, r, x, s{"a.monic.mo", "b.monic.mo", "c.monic.mo", "d.monic.mo", "e.monic.mo", "ns17.cdns.net", "ns2.cuhk.edu.hk"}, n, n, "whois.monic.mo", e, e, 0x0, t},
	{"xn--3pxu8k" /* 点看 */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--3pxu8k", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--pbt977c" /* 珠宝 */, r, x, n, n, n, "whois.nic.xn--pbt977c", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--hxt035cmppuel" /* 盛貿飯店 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--6frz82g" /* 移动 */, r, x, s{"a0.nic.xn--6frz82g", "a2.nic.xn--6frz82g", "b0.nic.xn--6frz82g", "c0.nic.xn--6frz82g"}, n, n, "whois.afilias.net", e, e, 0x0, t},
	{"xn--nqv7fs00ema" /* 组织机构 */, r, x, s{"a0.nic.xn--nqv7fs00ema", "a2.nic.xn--nqv7fs00ema", "b0.nic.xn--nqv7fs00ema", "c0.nic.xn--nqv7fs00ema"}, n, n, "whois.nic.xn--nqv7fs00ema", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--ses554g" /* 网址 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.xn--ses554g", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--hxt814e" /* 网店 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.xn--hxt814e", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--5tzm5g" /* 网站 */, r, x, s{"a0.nic.xn--5tzm5g", "a2.nic.xn--5tzm5g", "b0.nic.xn--5tzm5g", "c0.nic.xn--5tzm5g"}, n, n, "whois.nic.xn--5tzm5g", e, "https://nic.xn--/-1e5cp6j", 0x0, t},
	{"xn--io0a7i" /* 网络 */, r, x, s{"a.ngtld.cn", "b.ngtld.cn", "c.ngtld.cn", "d.ngtld.cn", "e.ngtld.cn"}, n, n, "whois.ngtld.cn", e, e, 0x0, t},
	{"xn--8y0a063a" /* 联通 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.nic.xn--8y0a063a", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--jlq61u9w7b" /* 诺基亚 */, r, x, s{"a0.nic.xn--jlq61u9w7b", "a2.nic.xn--jlq61u9w7b", "b0.nic.xn--jlq61u9w7b", "c0.nic.xn--jlq61u9w7b"}, n, n, "whois.nic.xn--jlq61u9w7b", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--flw351e" /* 谷歌 */, r, x, s{"ns-tld1.charlestonroadregistry.com", "ns-tld2.charlestonroadregistry.com", "ns-tld3.charlestonroadregistry.com", "ns-tld4.charlestonroadregistry.com", "ns-tld5.charlestonroadregistry.com"}, n, n, "whois.nic.google", e, "https://www.registry.google/", 0x42, t},
	{"xn--g2xx48c" /* 购物 */, r, x, s{"ns1.dns.nic.xn--g2xx48c", "ns2.dns.nic.xn--g2xx48c", "ns3.dns.nic.xn--g2xx48c", "ns4.dns.nic.xn--g2xx48c", "ns5.dns.nic.xn--g2xx48c", "ns6.dns.nic.xn--g2xx48c"}, n, n, "whois.nic.xn--g2xx48c", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--55qx5d8y0buji4b870u" /* 通用电气公司 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--gk3at1e" /* 通販 */, r, x, s{"ns1.dns.nic.xn--gk3at1e", "ns2.dns.nic.xn--gk3at1e", "ns3.dns.nic.xn--gk3at1e", "ns4.dns.nic.xn--gk3at1e", "ns5.dns.nic.xn--gk3at1e", "ns6.dns.nic.xn--gk3at1e"}, n, n, "whois.nic.xn--gk3at1e", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--3bst00m" /* 集团 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, "whois.gtld.knet.cn", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--fzys8d69uvgm" /* 電訊盈科 */, r, x, s{"a0.nic.xn--fzys8d69uvgm", "a2.nic.xn--fzys8d69uvgm", "b0.nic.xn--fzys8d69uvgm", "c0.nic.xn--fzys8d69uvgm"}, n, n, "whois.nic.xn--fzys8d69uvgm", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--kcrx77d1x4a" /* 飞利浦 */, r, x, s{"a.nic.xn--kcrx77d1x4a", "b.nic.xn--kcrx77d1x4a", "c.nic.xn--kcrx77d1x4a", "d.nic.xn--kcrx77d1x4a"}, n, n, "whois.nic.xn--kcrx77d1x4a", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--jvr189m" /* 食品 */, r, x, s{"ns1.dns.nic.xn--jvr189m", "ns2.dns.nic.xn--jvr189m", "ns3.dns.nic.xn--jvr189m", "ns4.dns.nic.xn--jvr189m", "ns5.dns.nic.xn--jvr189m", "ns6.dns.nic.xn--jvr189m"}, n, n, "whois.nic.xn--jvr189m", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--imr513n" /* 餐厅 */, r, x, s{"a.zdnscloud.com", "b.zdnscloud.com", "c.zdnscloud.com", "d.zdnscloud.com", "f.zdnscloud.com", "g.zdnscloud.com", "i.zdnscloud.com", "j.zdnscloud.com"}, n, n, e, e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--5su34j936bgsg" /* 香格里拉 */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--5su34j936bgsg", e, "https://newgtlds.icann.org/", 0x40, t},
	{"xn--j6w193g" /* 香港 */, r, z[5058:5064], s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, "whois.hkirc.hk", e, e, 0x0, t},
	{"xn--j6w470d71issc" /* 香港電訊 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x2040, t},
	{"xn--c1yn36f" /* 點看 */, r, x, n, n, n, e, e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--t60b56a" /* 닷넷 */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--t60b56a", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--mk1bu44c" /* 닷컴 */, r, x, s{"ac1.nstld.com", "ac2.nstld.com", "ac3.nstld.com", "ac4.nstld.com"}, n, n, "whois.nic.xn--mk1bu44c", e, "https://newgtlds.icann.org/", 0x0, t},
	{"xn--cg4bki" /* 삼성 */, r, x, s{"ns1.xn--cg4bki.centralnic-dns.com", "ns2.xn--cg4bki.centralnic-dns.com", "ns3.xn--cg4bki.centralnic-dns.com", "ns4.xn--cg4bki.centralnic-dns.com"}, n, n, "whois.kr", e, "https://newgtlds.icann.org/", 0x42, t},
	{"xn--9t4b11yi5a" /* 테스트 */, r, x, n, n, n, e, e, e, 0x40, t},
	{"xn--3e0b707e" /* 한국 */, r, x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, "whois.kr", e, e, 0x0, t},
	{"com.ac", &z[10], x, n, n, n, e, e, e, 0x800, f},
	{"gov.ac", &z[10], x, n, n, n, e, e, e, 0x800, f},
	{"mil.ac", &z[10], x, n, n, n, e, e, e, 0x0, f},
	{"net.ac", &z[10], x, n, n, n, e, e, e, 0x800, f},
	{"org.ac", &z[10], x, n, n, n, e, e, e, 0x800, f},
	{"nom.ad", &z[19], x, s{"dnsc.ad", "dnsm.ad"}, n, n, e, e, e, 0x0, f},
	{"ac.ae", &z[23], x, s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, e, e, e, 0x0, f},
	{"co.ae", &z[23], x, s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, e, e, e, 0x0, t},
	{"gov.ae", &z[23], x, s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, e, e, e, 0x0, f},
	{"mil.ae", &z[23], x, s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, e, e, e, 0x0, f},
	{"name.ae", &z[23], x, n, n, n, e, e, e, 0x0, f},
	{"net.ae", &z[23], x, s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, e, e, e, 0x0, f},
	{"org.ae", &z[23], x, s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, e, e, e, 0x0, f},
	{"pro.ae", &z[23], x, n, n, n, e, e, e, 0x0, f},
	{"sch.ae", &z[23], x, s{"ns1.aedns.ae", "ns2.aedns.ae", "ns4.apnic.net", "nsext-pch.aedns.ae"}, n, n, e, e, e, 0x0, f},
	{"airport.aero", &z[25], x, n, n, n, e, e, e, 0x0, t},
	{"cargo.aero", &z[25], x, n, n, n, e, e, e, 0x0, t},
	{"charter.aero", &z[25], x, n, n, n, e, e, e, 0x0, t},
	{"bank.af", &z[27], x, s{"ns-us.1and1-dns.com", "ns-us.1and1-dns.us"}, n, n, e, e, e, 0x0, f},
	{"com.af", &z[27], x, s{"ns.anycast.nic.af", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"edu.af", &z[27], x, s{"ns.anycast.nic.af", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"gov.af", &z[27], x, s{"ns.anycast.nic.af", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"hotel.af", &z[27], x, n, n, n, e, e, e, 0x0, f},
	{"law.af", &z[27], x, n, n, n, e, e, e, 0x0, f},
	{"music.af", &z[27], x, s{"josh.ns.cloudflare.com", "lady.ns.cloudflare.com"}, n, n, e, e, e, 0x0, f},
	{"net.af", &z[27], x, s{"ns.anycast.nic.af", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"org.af", &z[27], x, s{"ns.anycast.nic.af", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"tv.af", &z[27], x, s{"ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"co.ag", &z[32], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"com.ag", &z[32], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"net.ag", &z[32], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"nom.ag", &z[32], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"ok.ag", &z[32], x, s{"ns1.domainname.at", "ns3.domainname.at", "ns4.domainname.at"}, n, n, e, e, e, 0x0, t},
	{"org.ag", &z[32], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"com.ai", &z[35], x, s{"ns.cocca.fr", "pch.whois.ai"}, n, n, e, e, e, 0x0, f},
	{"net.ai", &z[35], x, s{"ns.cocca.fr", "pch.whois.ai"}, n, n, e, e, e, 0x0, f},
	{"off.ai", &z[35], x, s{"ns.cocca.fr", "pch.whois.ai"}, n, n, e, e, e, 0x0, f},
	{"org.ai", &z[35], x, s{"ns.cocca.fr", "pch.whois.ai"}, n, n, e, e, e, 0x0, f},
	{"com.al", &z[42], x, s{"al.cctld.authdns.ripe.net", "ns-al.isti.cnr.it", "ns1.nic.al", "ns2.nic.al", "nsx.nic.al", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"edu.al", &z[42], x, s{"al.cctld.authdns.ripe.net", "ns-al.isti.cnr.it", "ns1.nic.al", "ns2.nic.al", "nsx.nic.al", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"gov.al", &z[42], x, s{"al.cctld.authdns.ripe.net", "ns-al.isti.cnr.it", "ns1.nic.al", "ns2.nic.al", "nsx.nic.al", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"inima.al", &z[42], x, s{"ns1.he.net", "ns2.he.net", "ns3.he.net", "ns4.he.net", "ns5.he.net"}, n, n, e, e, e, 0x0, f},
	{"net.al", &z[42], x, s{"al.cctld.authdns.ripe.net", "ns-al.isti.cnr.it", "ns1.nic.al", "ns2.nic.al", "nsx.nic.al", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"org.al", &z[42], x, s{"al.cctld.authdns.ripe.net", "ns-al.isti.cnr.it", "ns1.nic.al", "ns2.nic.al", "nsx.nic.al", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"soros.al", &z[42], x, s{"ns1.hostmonster.com", "ns2.hostmonster.com"}, n, n, e, e, e, 0x0, f},
	{"tirana.al", &z[42], x, s{"ns3.albtelecom.net", "ns4.albtelecom.net"}, n, n, e, e, e, 0x0, f},
	{"uniti.al", &z[42], x, n, n, n, e, e, e, 0x0, f},
	{"upt.al", &z[42], x, s{"abcom.abcom.com.al", "smtphub.abcom.com.al"}, n, n, e, e, e, 0x0, f},
	{"co.am", &z[54], x, n, n, n, e, e, e, 0x0, f},
	{"com.am", &z[54], x, n, n, n, e, e, e, 0x0, f},
	{"net.am", &z[54], x, n, n, n, e, e, e, 0x0, f},
	{"north.am", &z[54], x, s{"ns1.instradns.com", "ns2.instradns.com"}, n, n, e, e, e, 0x0, f},
	{"org.am", &z[54], x, n, n, n, e, e, e, 0x0, f},
	{"radio.am", &z[54], x, s{"a.nic.fm", "b.nic.fm"}, n, n, e, e, e, 0x0, t},
	{"south.am", &z[54], x, s{"ns1.instradns.com", "ns2.instradns.com"}, n, n, e, e, e, 0x0, f},
	{"com.an", &z[63], x, n, n, n, e, e, e, 0x800, f},
	{"edu.an", &z[63], x, n, n, n, e, e, e, 0x800, f},
	{"net.an", &z[63], x, n, n, n, e, e, e, 0x800, f},
	{"org.an", &z[63], x, n, n, n, e, e, e, 0x800, f},
	{"co.ao", &z[71], z[5064:5066], s{"fred.nic.ao", "ns-ext.nic.cz", "ns0.nic.ao", "ns02.fccn.pt", "ns2.reg.it.ao"}, n, n, e, e, e, 0x0, f},
	{"ed.ao", &z[71], x, n, n, n, e, e, e, 0x0, f},
	{"gv.ao", &z[71], x, n, n, n, e, e, e, 0x0, f},
	{"it.ao", &z[71], x, s{"fred.nic.ao", "ns-ext.nic.cz", "ns0.nic.ao", "ns02.fccn.pt", "ns2.reg.it.ao"}, n, n, e, e, e, 0x0, f},
	{"og.ao", &z[71], x, n, n, n, e, e, e, 0x0, f},
	{"pb.ao", &z[71], x, n, n, n, e, e, e, 0x0, f},
	{"com.aq", &z[76], x, s{"ns1.internet.com.pe", "ns2.internet.com.pe"}, n, n, e, e, e, 0x0, f},
	{"com.ar", &z[79], x, s{"a.dns.ar", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, t},
	{"edu.ar", &z[79], z[5066:5067], s{"a.riu.edu.ar", "b.riu.edu.ar", "noc.uncu.edu.ar", "ns1.uba.ar", "ns2.switch.ch", "unlp.unlp.edu.ar"}, n, n, e, e, e, 0x0, f},
	{"gob.ar", &z[79], x, s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, f},
	{"gov.ar", &z[79], x, s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, f},
	{"int.ar", &z[79], x, s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, t},
	{"mil.ar", &z[79], x, s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, t},
	{"net.ar", &z[79], x, s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, t},
	{"org.ar", &z[79], x, s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, t},
	{"tur.ar", &z[79], x, s{"a.dns.ar", "ar.cctld.authdns.ripe.net", "b.dns.ar", "c.dns.ar", "e.dns.ar", "f.dns.ar"}, n, n, e, e, e, 0x0, t},
	{"e164.arpa", &z[85], x, s{"ns3.afrinic.net", "ns3.lacnic.net", "ns4.apnic.net", "pri.authdns.ripe.net", "tinnie.arin.net"}, n, n, "whois.ripe.net", e, e, 0x8, f},
	{"in-addr.arpa", &z[85], x, s{"a.in-addr-servers.arpa", "b.in-addr-servers.arpa", "c.in-addr-servers.arpa", "d.in-addr-servers.arpa", "e.in-addr-servers.arpa", "f.in-addr-servers.arpa"}, n, n, e, e, e, 0x8, f},
	{"ip6.arpa", &z[85], x, s{"a.ip6-servers.arpa", "b.ip6-servers.arpa", "c.ip6-servers.arpa", "d.ip6-servers.arpa", "e.ip6-servers.arpa", "f.ip6-servers.arpa"}, n, n, e, e, e, 0x8, f},
	{"iris.arpa", &z[85], x, s{"a.iana-servers.net", "b.iana-servers.net", "c.iana-servers.net", "ns3.lacnic.net", "ns4.apnic.net"}, n, n, e, e, e, 0x8, f},
	{"uri.arpa", &z[85], x, s{"a.iana-servers.net", "b.iana-servers.net", "c.iana-servers.net", "ns3.lacnic.net", "ns4.apnic.net"}, n, n, e, e, e, 0x8, f},
	{"urn.arpa", &z[85], x, s{"a.iana-servers.net", "b.iana-servers.net", "c.iana-servers.net", "ns3.lacnic.net", "ns4.apnic.net"}, n, n, e, e, e, 0x8, f},
	{"ac.at", &z[93], x, s{"d.ns.at", "n.ns.at", "ns1.univie.ac.at", "ns2.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"co.at", &z[93], x, n, n, n, e, e, e, 0x0, f},
	{"gv.at", &z[93], x, s{"dns1.statistik.gv.at", "ns12.govix.at", "ns3.wien.at", "ns4.wien.gv.at", "ns7.univie.ac.at", "ns8.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"or.at", &z[93], x, n, n, n, e, e, e, 0x0, f},
	{"priv.at", &z[93], x, s{"adns3.utanet.at", "mosthamster.nic.priv.at", "ns2.inode.at", "ns2.nextlayer.at", "ns5.univie.ac.at", "priv-ns.sil.at", "sec1.rcode0.net"}, n, n, "whois.nic.priv.at", e, e, 0x0, t},
	{"act.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"asn.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"com.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"conf.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"csiro.au", &z[96], x, s{"ns1.aarnet.net.au", "ns1.csiro.au", "ns2.aarnet.net.au", "ns2.csiro.au", "ns3.aarnet.net.au", "ns3.csiro.au"}, n, n, e, e, e, 0x0, f},
	{"edu.au", &z[96], z[5067:5075], s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, "http://www.domainname.edu.au/", 0x0, f},
	{"gov.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"id.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"info.au", &z[96], x, n, n, n, e, e, "http://www.aunic.net/", 0x800, f},
	{"net.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, "eleanba.connect.com.au", e, e, 0x0, t},
	{"nsw.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, s{"AU-NSW"}, e, e, e, 0x80, f},
	{"nt.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"org.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"oz.au", &z[96], x, s{"munnari.oz.au", "ns.sw.oz.au", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"qld.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"sa.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"tas.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"telememo.au", &z[96], x, n, n, n, e, e, e, 0x800, f},
	{"vic.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, "http://www.aucd.org.au/", 0x0, f},
	{"wa.au", &z[96], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, f},
	{"com.aw", &z[108], x, s{"ns1.setarnet.aw", "ns2.setarnet.aw"}, n, n, e, e, e, 0x0, f},
	{"bilesuvar.az", &z[113], x, n, n, n, e, e, e, 0x0, t},
	{"biz.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"co.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"com.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"edu.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"ganja.az", &z[113], x, n, n, n, e, e, e, 0x0, t},
	{"gov.az", &z[113], x, s{"ns1.gov.az", "ns2.gov.az", "ns3.gov.az", "ns4.gov.az"}, n, n, e, e, e, 0x0, f},
	{"imishli.az", &z[113], x, n, n, n, e, e, e, 0x0, t},
	{"info.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"int.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"mil.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"name.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"net.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"org.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"pp.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"pro.az", &z[113], x, n, n, n, e, e, e, 0x0, f},
	{"samux.az", &z[113], x, n, n, n, e, e, e, 0x0, t},
	{"shamaxi.az", &z[113], x, n, n, n, e, e, e, 0x0, t},
	{"shusha.az", &z[113], x, s{"ns1.gov.az", "ns2.gov.az"}, n, n, e, e, e, 0x0, t},
	{"sumgait.az", &z[113], x, n, n, n, e, e, e, 0x0, t},
	{"zaqatala.az", &z[113], x, n, n, n, e, e, e, 0x0, t},
	{"co.ba", &z[115], x, s{"ns1.co.ba", "ns2.co.ba", "ns3.co.ba"}, s{"176.9.45.78"}, n, e, e, e, 0x0, t},
	{"com.ba", &z[115], x, s{"ns1.hosting.bhtelecom.ba", "ns2.hosting.bhtelecom.ba", "ns3.hosting.bhtelecom.ba"}, s{"195.222.33.180"}, n, e, e, e, 0x0, f},
	{"edu.ba", &z[115], x, s{"bosna.utic.net.ba", "sava.utic.net.ba", "una.utic.net.ba"}, n, n, e, e, e, 0x0, f},
	{"gov.ba", &z[115], x, s{"bosna.utic.net.ba", "sava.utic.net.ba", "una.utic.net.ba"}, n, n, e, e, e, 0x0, f},
	{"mil.ba", &z[115], x, s{"bosna.utic.net.ba", "sava.utic.net.ba"}, n, n, e, e, e, 0x0, f},
	{"net.ba", &z[115], x, s{"bosna.utic.net.ba", "sava.utic.net.ba", "una.utic.net.ba"}, n, n, e, e, e, 0x0, f},
	{"org.ba", &z[115], x, s{"bosna.utic.net.ba", "sava.utic.net.ba", "una.utic.net.ba"}, n, n, e, e, e, 0x0, f},
	{"rs.ba", &z[115], x, s{"a.ns.rs.ba", "b.ns.rs.ba", "c.ns.rs.ba"}, n, n, e, e, e, 0x0, f},
	{"unbi.ba", &z[115], x, s{"linhost01.utic.net.ba"}, n, n, e, e, e, 0x0, f},
	{"unmo.ba", &z[115], x, s{"dns2019.unmo.ba", "pdc2019.unmo.ba", "web2019.unmo.ba"}, n, n, e, e, e, 0x0, f},
	{"unsa.ba", &z[115], x, s{"bosna.utic.net.ba", "sava.utic.net.ba", "una.utic.net.ba"}, n, n, e, e, e, 0x0, f},
	{"untz.ba", &z[115], x, s{"gradina.untz.ba", "slatina.untz.ba"}, n, n, e, e, e, 0x0, f},
	{"unze.ba", &z[115], x, s{"ns1.first-ns.de", "pi.unze.ba", "robotns2.second-ns.de", "robotns3.second-ns.com"}, n, n, e, e, e, 0x0, f},
	{"biz.bb", &z[133], x, s{"bds-tlcm-ns-001.gov.bb", "bds-tlcm-ns-002.gov.bb", "ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, e, e, 0x0, f},
	{"co.bb", &z[133], x, s{"bds-tlcm-ns-001.gov.bb", "bds-tlcm-ns-002.gov.bb", "ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, e, e, 0x0, f},
	{"com.bb", &z[133], x, s{"bds-tlcm-ns-001.gov.bb", "bds-tlcm-ns-002.gov.bb", "ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, e, e, 0x0, f},
	{"gov.bb", &z[133], x, s{"bds-tlcm-ns-001.gov.bb", "bds-tlcm-ns-002.gov.bb", "ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, e, e, 0x0, f},
	{"info.bb", &z[133], x, s{"bds-tlcm-ns-001.gov.bb", "bds-tlcm-ns-002.gov.bb", "ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, e, e, 0x0, f},
	{"net.bb", &z[133], x, s{"bds-tlcm-ns-001.gov.bb", "bds-tlcm-ns-002.gov.bb", "ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, e, e, 0x0, f},
	{"org.bb", &z[133], x, s{"bds-tlcm-ns-001.gov.bb", "bds-tlcm-ns-002.gov.bb", "ns1.nic.bb", "ns2.nic.bb", "ns3.nic.bb", "ns4.nic.bb", "ns5.nic.bb"}, n, n, e, e, e, 0x0, f},
	{"store.bb", &z[133], x, n, n, n, e, e, e, 0x0, f},
	{"tv.bb", &z[133], x, n, n, n, e, e, e, 0x0, f},
	{"ac.bd", &z[140], x, s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, e, e, 0x0, f},
	{"com.bd", &z[140], x, s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, e, e, 0x0, f},
	{"edu.bd", &z[140], x, s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, e, e, 0x0, f},
	{"gov.bd", &z[140], x, s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, e, e, 0x0, f},
	{"mil.bd", &z[140], x, s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, e, e, 0x0, f},
	{"net.bd", &z[140], x, s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, e, e, 0x0, f},
	{"org.bd", &z[140], x, s{"bd-ns.anycast.pch.net", "dns.bd", "jamuna.btcl.net.bd", "surma.btcl.net.bd"}, n, n, e, e, e, 0x0, f},
	{"gov.bf", &z[151], x, s{"ntoo.gov.bf", "oubri.gov.bf"}, n, n, e, e, e, 0x0, f},
	{"0.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"1.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"2.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"3.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"4.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"5.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"6.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"7.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"8.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"9.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"a.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"b.bg", &z[152], x, n, n, n, e, e, "https://www.register.bg/user/", 0x0, f},
	{"c.bg", &z[152], x, n, n, n, e, e, "https://www.register.bg/user/", 0x0, f},
	{"d.bg", &z[152], x, n, n, n, e, e, "https://www.register.bg/user/", 0x0, f},
	{"e.bg", &z[152], x, n, n, n, e, e, "https://www.register.bg/user/", 0x0, f},
	{"f.bg", &z[152], x, n, n, n, e, e, "https://www.register.bg/user/", 0x0, f},
	{"g.bg", &z[152], x, n, n, n, e, e, "https://www.register.bg/user/", 0x0, f},
	{"h.bg", &z[152], x, n, n, n, e, e, "https://www.register.bg/user/", 0x0, f},
	{"i.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"j.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"k.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"l.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"m.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"n.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"o.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"p.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"q.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"r.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"s.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"t.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"u.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"v.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"w.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"x.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"y.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"z.bg", &z[152], x, n, n, n, e, e, e, 0x0, f},
	{"biz.bh", &z[153], x, s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"cc.bh", &z[153], x, s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"com.bh", &z[153], x, s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"edu.bh", &z[153], x, s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"gov.bh", &z[153], x, s{"ns1.gov.bh", "ns2.gov.bh"}, n, n, e, e, e, 0x0, f},
	{"info.bh", &z[153], x, s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"net.bh", &z[153], x, s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"org.bh", &z[153], x, s{"a.bh.centralnic-dns.com", "b.bh.centralnic-dns.com", "c.bh.centralnic-dns.com", "d.bh.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"co.bi", &z[155], x, s{"anyns.nic.bi", "bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, e, e, e, 0x0, f},
	{"com.bi", &z[155], x, s{"anyns.nic.bi", "bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, e, e, e, 0x0, f},
	{"edu.bi", &z[155], x, s{"bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, e, e, e, 0x0, f},
	{"gov.bi", &z[155], x, s{"anyns.nic.bi", "bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, e, e, e, 0x0, t},
	{"info.bi", &z[155], x, s{"bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns-bi.ripe.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, e, e, e, 0x0, t},
	{"mo.bi", &z[155], x, s{"ns1.hostinger.com", "ns2.hostinger.com", "ns3.hostinger.com", "ns4.hostinger.com"}, n, n, e, e, e, 0x0, t},
	{"net.bi", &z[155], x, n, n, n, e, e, e, 0x0, t},
	{"or.bi", &z[155], x, s{"anyns.nic.bi", "bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, e, e, e, 0x0, f},
	{"org.bi", &z[155], x, s{"anyns.nic.bi", "bi.cctld.authdns.ripe.net", "ns-bi.afrinic.net", "ns.nic.bi", "ns1.nic.bi"}, n, n, e, e, e, 0x0, f},
	{"ote.bi", &z[155], x, n, n, n, e, e, e, 0x0, t},
	{"1x.biz", &z[162], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "1x.biz"}, n, e, e, e, 0x200, t},
	{"auz.biz", &z[162], x, s{"ns1.instradns.com", "ns2.instradns.com", "ns3.instradns.com"}, n, n, e, e, e, 0x0, f},
	{"asso.bj", &z[163], x, s{"ns1.dns.com", "ns2.dns.com"}, n, n, e, e, e, 0x0, f},
	{"barreau.bj", &z[163], x, s{"ns1.dns.com", "ns2.dns.com"}, n, n, e, e, e, 0x0, f},
	{"com.bj", &z[163], x, s{"ns.cocca.fr", "ns1.nic.bj", "pch.nic.bj"}, n, n, e, e, e, 0x0, f},
	{"edu.bj", &z[163], x, s{"ns.cocca.fr", "ns1.nic.bj", "pch.nic.fr"}, n, n, e, e, e, 0x0, f},
	{"gouv.bj", &z[163], x, s{"ns01.gouv.bj", "ns02.gouv.bj"}, n, n, e, e, e, 0x0, f},
	{"gov.bj", &z[163], x, s{"nakayo.leland.bj", "ns1.intnet.bj"}, n, n, e, e, e, 0x0, f},
	{"mil.bj", &z[163], x, s{"ns01.gouv.bj", "ns1.jenysas.bj"}, n, n, e, e, e, 0x0, f},
	{"art.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "art.blog"}, n, e, e, e, 0x0, t},
	{"business.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "business.blog"}, n, e, e, e, 0x0, t},
	{"car.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "car.blog"}, n, e, e, e, 0x0, t},
	{"code.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "code.blog"}, n, e, e, e, 0x0, t},
	{"family.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "family.blog"}, n, e, e, e, 0x0, t},
	{"fashion.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "fashion.blog"}, n, e, e, e, 0x0, t},
	{"finance.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "finance.blog"}, n, e, e, e, 0x0, t},
	{"fitness.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "fitness.blog"}, n, e, e, e, 0x0, t},
	{"food.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "food.blog"}, n, e, e, e, 0x0, t},
	{"game.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "game.blog"}, n, e, e, e, 0x0, t},
	{"health.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "health.blog"}, n, e, e, e, 0x0, t},
	{"home.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "home.blog"}, n, e, e, e, 0x0, t},
	{"law.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "law.blog"}, n, e, e, e, 0x0, t},
	{"movie.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "movie.blog"}, n, e, e, e, 0x0, t},
	{"music.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "music.blog"}, n, e, e, e, 0x0, t},
	{"news.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "news.blog"}, n, e, e, e, 0x0, t},
	{"photo.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "photo.blog"}, n, e, e, e, 0x0, t},
	{"poetry.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "poetry.blog"}, n, e, e, e, 0x0, t},
	{"politics.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "politics.blog"}, n, e, e, e, 0x0, t},
	{"school.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "school.blog"}, n, e, e, e, 0x0, t},
	{"science.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "science.blog"}, n, e, e, e, 0x0, t},
	{"sport.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "sport.blog"}, n, e, e, e, 0x0, t},
	{"tech.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "tech.blog"}, n, e, e, e, 0x0, t},
	{"travel.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "travel.blog"}, n, e, e, e, 0x0, t},
	{"video.blog", &z[168], x, s{"ns1.automattic.com", "ns2.automattic.com", "ns3.automattic.com", "ns4.automattic.com"}, s{"192.0.78.30", "192.0.78.31", "video.blog"}, n, e, e, e, 0x0, t},
	{"water.blog", &z[168], x, s{"ns1.wordpress.com", "ns2.wordpress.com", "ns3.wordpress.com"}, s{"192.0.78.24", "192.0.78.25", "water.blog"}, n, e, e, e, 0x0, t},
	{"com.bm", &z[172], x, n, n, n, e, e, e, 0x0, f},
	{"edu.bm", &z[172], x, n, n, n, e, e, e, 0x0, f},
	{"gov.bm", &z[172], x, s{"dns1.gov.bm", "dns2.gov.bm", "dns3.gov.bm"}, n, n, e, e, e, 0x0, f},
	{"net.bm", &z[172], x, n, n, n, e, e, e, 0x0, f},
	{"org.bm", &z[172], x, n, n, n, e, e, e, 0x0, f},
	{"com.bn", &z[175], x, s{"bn-ns.anycast.pch.net", "ns1.bnnic.bn", "ns2.bnnic.bn", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"edu.bn", &z[175], x, s{"bn-ns.anycast.pch.net", "ns1.bnnic.bn", "ns2.bnnic.bn", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"gov.bn", &z[175], x, s{"bn-ns.anycast.pch.net", "ns1.bnnic.bn", "ns2.bnnic.bn", "ns4.apnic.net"}, n, n, e, e, e, 0x0, t},
	{"net.bn", &z[175], x, s{"bn-ns.anycast.pch.net", "ns1.bnnic.bn", "ns2.bnnic.bn", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"org.bn", &z[175], x, s{"bn-ns.anycast.pch.net", "ns1.bnnic.bn", "ns2.bnnic.bn", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"com.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"edu.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"gob.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"gov.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"int.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"mil.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"net.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"org.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"tv.bo", &z[178], x, n, n, n, e, e, e, 0x0, f},
	{"abc.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"adm.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"adv.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"agr.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"am.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"aparecida.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"arq.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"art.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"ato.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"b.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"belem.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"bhz.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"bio.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"blog.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"bmd.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"boavista.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"bsb.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"campinas.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"caxias.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"cim.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"cng.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"cnt.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"com.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"coop.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"curitiba.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"ecn.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"eco.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"edu.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"emp.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"eng.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"esp.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"etc.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"eti.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"far.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"flog.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"floripa.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"fm.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"fnd.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"fortal.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"fot.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"foz.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"fst.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"g12.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"ggf.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"gov.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"gru.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"imb.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"ind.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"inf.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"jampa.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"jor.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"jus.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"lel.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"macapa.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"maceio.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"manaus.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"mat.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"med.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"mil.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"mus.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"natal.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"net.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"nom.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"not.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"ntr.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"odo.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"org.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"palmas.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"poa.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"ppg.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"pro.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"psc.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"psi.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"qsl.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"radio.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"rec.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"recife.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"rep.br", &z[194], z[5075:5076], s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"rio.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"salvador.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"sec3.br", &z[194], x, n, n, n, e, e, e, 0x0, t},
	{"sjc.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"slg.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"srv.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"taxi.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"teo.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"tmp.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"trd.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"tur.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"tv.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"vet.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"vix.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"vlog.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"wiki.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"zlg.br", &z[194], x, s{"a.dns.br", "b.dns.br", "c.dns.br", "d.dns.br", "e.dns.br", "f.dns.br"}, n, n, e, e, e, 0x0, t},
	{"com.bs", &z[201], x, n, n, n, e, e, e, 0x0, f},
	{"edu.bs", &z[201], x, n, n, n, e, e, e, 0x0, f},
	{"gov.bs", &z[201], x, s{"ib-ext1.gov.bs", "ib-ext2.gov.bs", "ibgb-ext1.gov.bs", "ibgb-ext2.gov.bs"}, n, n, e, e, e, 0x0, f},
	{"net.bs", &z[201], x, n, n, n, e, e, e, 0x0, f},
	{"org.bs", &z[201], x, n, n, n, e, e, e, 0x0, f},
	{"we.bs", &z[201], x, s{"ns1.nic.we.bs", "ns2.nic.we.bs"}, n, n, e, e, e, 0x0, t},
	{"com.bt", &z[202], x, s{"ns1.druknet.bt", "ns2.druknet.bt", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"edu.bt", &z[202], x, s{"ns1.druknet.bt", "ns2.druknet.bt", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, t},
	{"gov.bt", &z[202], x, s{"ns1.druknet.bt", "ns2.druknet.bt"}, n, n, e, e, e, 0x0, t},
	{"net.bt", &z[202], x, s{"ns1.druknet.bt", "ns2.druknet.bt"}, n, n, e, e, e, 0x0, t},
	{"org.bt", &z[202], x, s{"ns1.druknet.bt", "ns2.druknet.bt", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, t},
	{"ac.bw", &z[212], x, s{"dns1.nic.net.bw", "dns2.nic.net.bw", "master.btc.net.bw", "ns-bw.afrinic.net", "pch.nic.net.bw"}, n, n, e, e, e, 0x0, t},
	{"co.bw", &z[212], x, s{"dns1.nic.net.bw", "ns-bw.afrinic.net", "pch.nic.net.bw"}, n, n, e, e, e, 0x0, f},
	{"net.bw", &z[212], x, s{"dns1.nic.net.bw", "ns-bw.afrinic.net", "pch.nic.net.bw"}, n, n, e, e, e, 0x0, f},
	{"org.bw", &z[212], x, s{"dns1.nic.net.bw", "ns-bw.afrinic.net", "pch.nic.net.bw"}, n, n, e, e, e, 0x0, f},
	{"com.by", &z[214], x, s{"a1.domain.by", "a2.domain.by"}, n, n, e, e, e, 0x0, f},
	{"gov.by", &z[214], x, s{"u1.hoster.by", "u2.hoster.by"}, n, n, e, e, e, 0x0, f},
	{"mil.by", &z[214], x, s{"ns1.oac.gov.by", "u1.hoster.by", "u2.hoster.by"}, n, n, e, e, e, 0x0, f},
	{"minsk.by", &z[214], x, s{"a1.domain.by", "a2.domain.by"}, n, n, e, e, e, 0x0, f},
	{"net.by", &z[214], x, s{"a1.domain.by", "a2.domain.by"}, n, n, e, e, e, 0x0, f},
	{"co.bz", &z[215], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"com.bz", &z[215], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"edu.bz", &z[215], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"gov.bz", &z[215], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"net.bz", &z[215], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"org.bz", &z[215], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"za.bz", &z[215], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net", "ns5.centralnic.net"}, n, n, "whois.centralnic.com", e, e, 0x0, t},
	{"ab.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"bc.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"co.ca", &z[217], x, s{"primary.relay.co.ca", "quaternary.relay.co.ca", "quinary.relay.co.ca", "secondary.relay.co.ca", "senary.relay.co.ca", "tertiary.relay.co.ca"}, n, n, "whois.co.ca", e, e, 0x200, t},
	{"gc.ca", &z[217], x, s{"dns1.nrc.ca", "dns2.nrc.ca", "ns1.d-zone.ca", "ns2.d-zone.ca"}, n, n, e, e, e, 0x0, f},
	{"mb.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"nb.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"nf.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"nl.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"ns.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"nt.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"nu.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"on.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"pe.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"qc.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"sk.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"yk.ca", &z[217], x, n, n, n, e, e, e, 0x0, f},
	{"com.cc", &z[256], x, s{"ns-1287.awsdns-32.org", "ns-1613.awsdns-09.co.uk", "ns-472.awsdns-59.com", "ns-680.awsdns-21.net"}, n, n, e, e, e, 0x0, t},
	{"edu.cc", &z[256], x, s{"ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, t},
	{"net.cc", &z[256], x, s{"ns-1028.awsdns-00.org", "ns-1980.awsdns-55.co.uk", "ns-218.awsdns-27.com", "ns-779.awsdns-33.net"}, n, n, e, e, e, 0x0, t},
	{"org.cc", &z[256], x, s{"ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, t},
	{"ac.cd", &z[257], x, s{"igubu.saix.net", "ns-root-1.scpt-network.com", "ns-root-2.scpt-network.com", "ns-root-4.scpt-network.com", "ns-root-5.scpt-network.com", "sabela.saix.net", "sangoma.saix.net"}, n, n, e, e, e, 0x0, t},
	{"com.cd", &z[257], x, s{"igubu.saix.net", "ns-root-1.scpt-network.com", "ns-root-2.scpt-network.com", "ns-root-5.scpt-network.com", "sabela.saix.net", "sangoma.saix.net"}, n, n, e, e, e, 0x0, t},
	{"edu.cd", &z[257], x, s{"igubu.saix.net", "ns-root-1.scpt-network.com", "ns-root-2.scpt-network.com", "ns-root-5.scpt-network.com", "sabela.saix.net", "sangoma.saix.net"}, n, n, e, e, e, 0x0, t},
	{"gouv.cd", &z[257], x, s{"igubu.saix.net", "ns-root-1.scpt-network.net", "ns-root-2.scpt-network.net", "ns-root-5.scpt-network.net", "sabela.saix.net", "sangoma.saix.net"}, n, n, e, e, e, 0x0, t},
	{"net.cd", &z[257], x, s{"igubu.saix.net", "ns-root-1.scpt-network.com", "ns-root-2.scpt-network.com", "ns-root-5.scpt-network.com", "sabela.saix.net", "sangoma.saix.net"}, n, n, e, e, e, 0x0, f},
	{"org.cd", &z[257], x, s{"igubu.saix.net", "ns-root-1.scpt-network.com", "ns-root-2.scpt-network.com", "ns-root-5.scpt-network.com", "sabela.saix.net", "sangoma.saix.net"}, n, n, e, e, e, 0x0, f},
	{"ac.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "ns1.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"aeroport.ci", &z[285], x, n, n, n, e, e, e, 0x0, f},
	{"asso.ci", &z[285], x, s{"f1g1ns1.dnspod.net", "f1g1ns2.dnspod.net"}, n, n, e, e, "http://www.nic.ci/", 0x0, t},
	{"assoc.ci", &z[285], x, n, n, n, e, e, e, 0x0, t},
	{"co.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"com.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.cctld.authdns.ripe.net", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"ed.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.cctld.authdns.ripe.net", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "ns1.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"edu.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "ns1.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"go.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"gov.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, t},
	{"in.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "ns1.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, t},
	{"int.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"net.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"nom.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.cctld.authdns.ripe.net", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, t},
	{"or.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"org.ci", &z[285], x, s{"any.nic.ci", "censvrns0001.ird.fr", "ci.hosting.nic.fr", "ns-ci.afrinic.net", "ns.nic.ci", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"presse.ci", &z[285], x, s{"ns1.dns.com", "ns2.dns.com"}, n, n, e, e, e, 0x0, f},
	{"biz.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"co.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"edu.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"gen.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"gov.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"info.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"net.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"org.ck", &z[295], x, n, n, n, e, e, e, 0x0, f},
	{"co.cm", &z[306], x, s{"a.cm.dyntld.net", "b.cm.dyntld.net", "ns1.nic.cm", "ns2.nic.cm"}, s{"85.25.140.105"}, n, e, e, e, 0x0, f},
	{"com.cm", &z[306], x, s{"a.cm.dyntld.net", "b.cm.dyntld.net", "ns1.nic.cm", "ns2.nic.cm"}, n, n, e, e, e, 0x0, f},
	{"edu.cm", &z[306], x, s{"ns1.nic.cm", "ns2.nic.cm"}, s{"85.25.140.105"}, n, e, e, e, 0x0, t},
	{"net.cm", &z[306], x, s{"a.cm.dyntld.net", "b.cm.dyntld.net", "ns1.nic.cm", "ns2.nic.cm"}, s{"85.25.140.105"}, n, e, e, e, 0x0, f},
	{"ac.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"ah.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, "http://www.belizenic.bz/", 0x0, f},
	{"bj.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"com.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"cq.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"edu.cn", &z[307], x, s{"deneb.dfn.de", "dns.edu.cn", "dns2.edu.cn", "ns2.cernet.net", "ns2.cuhk.hk"}, n, n, "whois.edu.cn", e, e, 0x0, f},
	{"fj.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"gd.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"gov.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"gs.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"gx.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"gz.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"ha.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"hb.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"he.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"hi.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"hk.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"hl.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"hn.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"jl.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"js.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"jx.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"keyword.cn", &z[307], z[5076:5077], s{"ns11.xincache.com", "ns12.xincache.com"}, n, n, e, e, e, 0x0, t},
	{"ln.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"mil.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn", "ns3.mil.cn", "ns4.mil.cn"}, n, n, e, e, e, 0x0, t},
	{"mo.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"net.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"nm.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"nx.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"org.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"qh.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"sc.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"sd.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"sh.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"sn.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"sx.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"tj.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"tw.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"xj.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"xz.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"yn.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"zj.cn", &z[307], x, s{"a.dns.cn", "b.dns.cn", "c.dns.cn", "cns.cernet.net", "d.dns.cn", "e.dns.cn", "f.dns.cn", "g.dns.cn"}, n, n, e, e, e, 0x0, f},
	{"com.co", &z[308], x, n, n, n, e, e, e, 0x0, f},
	{"edu.co", &z[308], x, n, n, n, e, e, e, 0x0, f},
	{"gov.co", &z[308], x, s{"ns-1462.awsdns-54.org", "ns-1823.awsdns-35.co.uk", "ns-479.awsdns-59.com", "ns-943.awsdns-53.net"}, n, n, e, e, e, 0x0, f},
	{"mil.co", &z[308], x, n, n, n, e, e, e, 0x0, f},
	{"net.co", &z[308], x, n, n, n, e, e, e, 0x0, f},
	{"nom.co", &z[308], x, n, n, n, e, e, e, 0x0, f},
	{"org.co", &z[308], x, n, n, n, e, e, e, 0x0, f},
	{"4u.com", &z[314], x, s{"ns1.registry-servers.4u.com", "ns2.registry-servers.4u.com", "ns3.registry-servers.4u.com", "ns4.registry-servers.4u.com", "ns5.registry-servers.4u.com", "ns6.registry-servers.4u.com"}, n, n, e, e, e, 0x200, t},
	{"ae.com", &z[314], x, s{"asia3.akam.net", "eur2.akam.net", "eur5.akam.net", "ns1-161.akam.net", "ns1-163.akam.net", "usc3.akam.net", "use4.akam.net", "usw1.akam.net"}, n, n, e, e, e, 0x200, t},
	{"africa.com", &z[314], x, s{"ns2.dns.business", "ns3.dns.business", "ns4.dns.business"}, n, n, "whois.centralnic.com", e, e, 0x200, f},
	{"ar.com", &z[314], x, s{"ns69.domaincontrol.com", "ns70.domaincontrol.com"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"asia.com", &z[314], x, s{"pdns1.ultradns.net", "pdns2.ultradns.net", "pdns3.ultradns.org", "pdns4.ultradns.org", "pdns5.ultradns.info", "pdns6.ultradns.co.uk"}, s{"72.55.150.59"}, n, e, e, e, 0x200, f},
	{"au.com", &z[314], x, s{"dns103.kddi.ne.jp", "dns104.kddi.ne.jp", "dnsa01.kddi.ne.jp", "dnsa02.kddi.ne.jp"}, n, n, e, e, e, 0x200, f},
	{"br.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "br.com"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"cn.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "cn.com"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"co.com", &z[314], x, s{"ns1.nic.co.com", "ns2.nic.co.com", "ns3.nic.co.com", "ns4.nic.co.com"}, s{"173.192.115.17"}, n, "whois.centralnic.net", e, "http://registry.co.com/", 0x200, t},
	{"de.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "de.com"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"eu.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "eu.com"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"gb.com", &z[314], x, s{"ns71.domaincontrol.com", "ns72.domaincontrol.com"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"gr.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"72.34.38.11"}, n, "whois.centralnic.com", e, e, 0x200, f},
	{"hk.com", &z[314], x, s{"a.udrtld.net", "b.udrtld.net", "c.udrtld.net", "dns7.cloudns.net", "dns8.cloudns.net"}, n, n, "whois.registry.hk.com", e, e, 0x200, f},
	{"hu.com", &z[314], x, s{"ns3.dns.com", "ns4.dns.com"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"jpn.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "jpn.com"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"kr.com", &z[314], x, s{"ns1.dns.com", "ns2.dns.com"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"mex.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "mex.com"}, n, e, e, e, 0x200, f},
	{"no.com", &z[314], x, s{"ns29.domaincontrol.com", "ns30.domaincontrol.com"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"nv.com", &z[314], x, s{"a.root-servers.nv.com", "b.root-servers.nv.com", "c.root-servers.nv.com", "d.root-servers.nv.com", "e.root-servers.nv.com", "f.root-servers.nv.com", "g.root-servers.nv.com"}, s{"205.159.223.111", "hosting.gi.net"}, n, e, e, e, 0x200, f},
	{"pty-ltd.com", &z[314], x, s{"ns1.instradns.com", "ns2.instradns.com", "ns3.instradns.com"}, n, n, e, e, e, 0x200, f},
	{"qb.com", &z[314], x, s{"f1g1ns1.dnspod.net", "f1g1ns2.dnspod.net"}, n, n, e, e, e, 0x200, f},
	{"qc.com", &z[314], x, s{"ns71.domaincontrol.com", "ns72.domaincontrol.com"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"ru.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"141.8.226.34"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"sa.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"141.8.226.34"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"se.com", &z[314], x, s{"ns1.perf1.com", "ns2.perf1.fr", "ns3.perf1.eu", "ns4.perf1.de", "ns5.perf1.asia"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"uk.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "uk.com"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"us.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "us.com"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"uy.com", &z[314], x, s{"ns49.domaincontrol.com", "ns50.domaincontrol.com"}, n, n, "whois.centralnic.com", e, e, 0x200, t},
	{"za.com", &z[314], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"141.8.226.34"}, n, "whois.centralnic.com", e, e, 0x200, t},
	{"de.cool", &z[330], x, s{"jake.ns.cloudflare.com", "jill.ns.cloudflare.com"}, s{"2a00:f48:2000:affe::50", "91.216.248.20", "91.216.248.21", "91.216.248.22"}, n, e, e, e, 0x0, t},
	{"ac.cr", &z[339], x, s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, e, e, e, 0x0, f},
	{"co.cr", &z[339], x, s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, e, e, e, 0x0, f},
	{"ed.cr", &z[339], x, s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, e, e, e, 0x0, t},
	{"eu.cr", &z[339], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "eu.cr"}, n, e, e, e, 0x200, t},
	{"fi.cr", &z[339], x, s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, e, e, e, 0x0, f},
	{"go.cr", &z[339], x, s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, e, e, e, 0x0, f},
	{"or.cr", &z[339], x, s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, e, e, e, 0x0, f},
	{"sa.cr", &z[339], x, s{"a.lactld.org", "ca1.nic.cr", "ca2.nic.cr", "de.nic.cr", "dns.nic.cr", "p.nic.cr"}, n, n, e, e, e, 0x0, f},
	{"co.cu", &z[349], x, s{"ns3.etecsa.net", "ns3.etecsa.net.cu", "ns4.etecsa.net", "ns4.etecsa.net.cu", "ns5.etecsa.net"}, n, n, e, e, e, 0x0, f},
	{"com.cu", &z[349], x, s{"canada.cuba.cu", "ns.ceniai.net.cu", "ns.citmatel.com.cu"}, n, n, e, e, e, 0x0, f},
	{"cuba.cu", &z[349], x, n, n, n, e, e, e, 0x0, f},
	{"cyt.cu", &z[349], x, s{"mail1.tur.cu", "mail2.tur.cu", "ns1.tur.cu"}, n, n, e, e, e, 0x0, f},
	{"edu.cu", &z[349], x, s{"canada.cuba.cu", "cu.cctld.authdns.ripe.net", "ns.ceniai.net.cu", "ns.citmatel.com.cu", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"get.cu", &z[349], x, s{"mail1.tur.cu", "mail2.tur.cu", "ns1.tur.cu"}, n, n, e, e, e, 0x0, f},
	{"gov.cu", &z[349], x, n, n, n, e, e, e, 0x0, f},
	{"inf.cu", &z[349], x, n, n, n, e, e, e, 0x0, f},
	{"net.cu", &z[349], x, n, n, n, e, e, e, 0x0, f},
	{"org.cu", &z[349], x, n, n, n, e, e, e, 0x0, f},
	{"tur.cu", &z[349], x, s{"ns.ceniai.net.cu", "ns1.g4its.com", "ns1.tur.cu", "ns2.g4its.com", "ns2.tur.cu", "ns3.tur.cu", "ns4.tur.cu", "ns5.tur.cu"}, n, n, e, e, e, 0x0, f},
	{"com.cv", &z[351], x, n, n, n, e, e, e, 0x0, f},
	{"edu.cv", &z[351], x, n, n, n, e, e, e, 0x0, t},
	{"gov.cv", &z[351], x, s{"ns1.gov.cv", "ns2.gov.cv"}, n, n, e, e, e, 0x0, f},
	{"int.cv", &z[351], x, n, n, n, e, e, e, 0x0, f},
	{"net.cv", &z[351], x, n, n, n, e, e, e, 0x0, f},
	{"nome.cv", &z[351], x, n, n, n, e, e, e, 0x0, f},
	{"org.cv", &z[351], x, n, n, n, e, e, e, 0x0, f},
	{"publ.cv", &z[351], x, n, n, n, e, e, e, 0x0, f},
	{"com.cw", &z[352], x, n, n, n, e, e, e, 0x0, f},
	{"net.cw", &z[352], x, n, n, n, e, e, e, 0x0, f},
	{"com.cx", &z[353], x, s{"ns.anycast.nic.cx", "ns.cocca.fr"}, n, n, e, e, e, 0x0, t},
	{"edu.cx", &z[353], x, s{"ns.anycast.nic.cx", "ns.cocca.fr"}, n, n, e, e, e, 0x0, t},
	{"gov.cx", &z[353], x, s{"ns.anycast.nic.cx", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"net.cx", &z[353], x, s{"ns.anycast.nic.cx", "ns.cocca.fr"}, n, n, e, e, e, 0x0, t},
	{"org.cx", &z[353], x, s{"ns.anycast.nic.cx", "ns.cocca.fr"}, n, n, e, e, e, 0x0, t},
	{"ac.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"biz.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"com.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"ekloges.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"gov.cy", &z[354], x, s{"dns.cit.cornell.edu", "ns01.gov.cy", "ns02.gov.cy", "sns0.grnet.gr", "sns1.grnet.gr"}, n, n, e, e, e, 0x0, f},
	{"ltd.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"name.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"net.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"org.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"parliament.cy", &z[354], x, s{"ns01.gov.cy", "ns02.gov.cy"}, n, n, e, e, e, 0x0, f},
	{"press.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"pro.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"tm.cy", &z[354], x, s{"cy-ns.anycast.pch.net", "cynic.dns.cy", "cynic4.dns.cy", "cynic6.dns.cy", "estia.ics.forth.gr", "ns02.savvis.net", "ns31.rcode0.net", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"co.cz", &z[357], x, s{"ns1.anycastdns.cz", "ns2.anycastdns.cz"}, n, n, e, e, e, 0x0, f},
	{"1x.de", &z[368], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "1x.de"}, n, e, e, e, 0x200, t},
	{"co.de", &z[368], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "co.de"}, n, "whois.co.de", e, e, 0x0, t},
	{"com.de", &z[368], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "com.de"}, n, "whois.centralnic.com", e, e, 0x0, f},
	{"biz.dk", &z[397], x, s{"dns2000.euro-isp.net", "dns2001.euro-isp.net", "mail.digitalmarketing.net", "ns.digitalmarketing.net", "ns1.dk.org", "post.digitalmarketing.net", "root-dns.euro-isp.net"}, n, n, e, e, e, 0x0, f},
	{"co.dk", &z[397], x, s{"dns2000.euro-isp.net", "dns2001.euro-isp.net", "mail.digitalmarketing.net", "ns.digitalmarketing.net", "ns1.dk.org", "post.digitalmarketing.net", "root-dns.euro-isp.net"}, n, n, e, e, e, 0x0, f},
	{"co.dm", &z[398], x, s{"ns.blacknightsolutions.com", "ns2.blacknightsolutions.com", "ns2.nic.dm", "ns34.cdns.net"}, n, n, e, e, e, 0x0, f},
	{"com.dm", &z[398], x, s{"ns.blacknightsolutions.com", "ns2.blacknightsolutions.com", "ns2.nic.dm", "ns34.cdns.net"}, n, n, e, e, e, 0x0, f},
	{"edu.dm", &z[398], x, s{"ns.blacknightsolutions.com", "ns2.blacknightsolutions.com", "ns2.nic.dm", "ns34.cdns.net"}, n, n, e, e, e, 0x0, f},
	{"gov.dm", &z[398], x, s{"ns.blacknightsolutions.com", "ns2.blacknightsolutions.com", "ns2.nic.dm", "ns34.cdns.net"}, n, n, e, e, e, 0x0, f},
	{"net.dm", &z[398], x, s{"ns.blacknightsolutions.com", "ns2.blacknightsolutions.com", "ns2.nic.dm", "ns34.cdns.net"}, n, n, e, e, e, 0x0, f},
	{"org.dm", &z[398], x, s{"ns.blacknightsolutions.com", "ns2.blacknightsolutions.com", "ns2.nic.dm", "ns34.cdns.net"}, n, n, e, e, e, 0x0, f},
	{"art.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"com.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"edu.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"gob.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"gov.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"mil.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"net.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"org.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"sid.do", &z[401], x, n, n, n, e, e, e, 0x0, t},
	{"sld.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"web.do", &z[401], x, s{"a.lactld.org", "ns.nic.do", "ns1.nic.do", "ns2.nic.do", "ns3.nic.mx", "ns4.nic.do", "ns5.nic.do", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"art.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"asso.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"com.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"edu.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"gov.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"net.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"org.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"pol.dz", &z[425], x, s{"ns1.nic.dz", "ns2.nic.dz"}, n, n, e, e, e, 0x0, f},
	{"com.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"edu.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"fin.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"gob.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, t},
	{"gov.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"info.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"med.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"mil.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"net.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"org.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"pro.ec", &z[428], x, s{"a.lactld.org", "n2.nic.ec", "n3.dns.ec"}, n, n, e, e, e, 0x0, f},
	{"co.ee", &z[434], x, s{"ns.elkdata.ee", "ns2.elkdata.ee"}, n, n, e, e, e, 0x0, f},
	{"com.ee", &z[434], x, n, n, n, e, e, e, 0x0, f},
	{"edu.ee", &z[434], x, s{"ns.eenet.ee", "ns2.eenet.ee"}, n, n, e, e, e, 0x0, f},
	{"fie.ee", &z[434], x, n, n, n, e, e, e, 0x0, f},
	{"gov.ee", &z[434], x, s{"ans2.aso.ee", "company.e-resident.gov.ee", "ns.gov.ee"}, n, n, e, e, e, 0x0, f},
	{"hiiumaa.ee", &z[434], x, s{"ns.zone.eu", "ns2.zone.ee", "ns3.zonedata.net"}, s{"217.146.69.46"}, n, e, e, e, 0x0, f},
	{"kul.ee", &z[434], x, s{"ans2.aso.ee", "ns1.rmit.ee", "ns2.rmit.ee"}, n, n, e, e, e, 0x0, f},
	{"med.ee", &z[434], x, n, n, n, e, e, e, 0x0, t},
	{"org.ee", &z[434], x, s{"ns.eenet.ee", "ns2.eenet.ee"}, n, n, e, e, e, 0x0, f},
	{"parnu.ee", &z[434], x, s{"ns.eenet.ee", "ns2.eenet.ee"}, n, n, e, e, e, 0x0, f},
	{"parnumaa.ee", &z[434], x, s{"ns.elkdata.ee", "ns2.elkdata.ee", "ns3.elkdata.net"}, n, n, e, e, e, 0x0, f},
	{"polvamaa.ee", &z[434], x, s{"ns.zone.eu", "ns2.zone.ee", "ns3.zonedata.net"}, n, n, e, e, e, 0x0, f},
	{"pri.ee", &z[434], x, n, n, n, e, e, e, 0x0, f},
	{"tartu.ee", &z[434], x, s{"ns.eenet.ee", "ns2.eenet.ee"}, n, n, e, e, e, 0x0, f},
	{"com.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"edu.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"eun.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"gov.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"info.eg", &z[435], x, s{"frcu.eun.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"mil.eg", &z[435], x, s{"frcu.eun.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"name.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"net.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"org.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com", "www.frcu.eun.eg"}, n, n, e, e, e, 0x0, f},
	{"sci.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"sport.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, t},
	{"tv.eg", &z[435], x, s{"frcu.eun.eg", "ns.idsc.gov.eg", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"com.er", &z[446], x, s{"er.cctld.authdns.ripe.net", "ns0.punchdown.org", "ns1.punchdown.net", "sawanew.noc.net.er", "zaranew.noc.net.er"}, n, n, e, e, e, 0x0, t},
	{"edu.er", &z[446], x, s{"er.cctld.authdns.ripe.net", "ns0.punchdown.org", "ns1.punchdown.net", "sawanew.noc.net.er", "zaranew.noc.net.er"}, n, n, e, e, e, 0x0, f},
	{"gov.er", &z[446], x, s{"er.cctld.authdns.ripe.net", "ns0.punchdown.org", "ns1.punchdown.net", "sawanew.noc.net.er", "zaranew.noc.net.er"}, n, n, e, e, e, 0x0, f},
	{"ind.er", &z[446], x, s{"er.cctld.authdns.ripe.net", "ns0.punchdown.org", "ns1.punchdown.net", "sawanew.noc.net.er", "sawaold.noc.net.er", "zaranew.noc.net.er", "zaraold.noc.net.er"}, n, n, e, e, e, 0x0, f},
	{"mil.er", &z[446], x, s{"er.cctld.authdns.ripe.net", "ns0.punchdown.org", "ns1.punchdown.net", "sawanew.noc.net.er", "sawaold.noc.net.er", "zaranew.noc.net.er", "zaraold.noc.net.er"}, n, n, e, e, e, 0x0, f},
	{"net.er", &z[446], x, s{"er.cctld.authdns.ripe.net", "ns0.punchdown.org", "ns1.punchdown.net", "sawanew.noc.net.er", "zaranew.noc.net.er"}, n, n, e, e, e, 0x0, f},
	{"org.er", &z[446], x, s{"er.cctld.authdns.ripe.net", "ns0.punchdown.org", "ns1.punchdown.net", "sawanew.noc.net.er", "zaranew.noc.net.er"}, n, n, e, e, e, 0x0, f},
	{"com.es", &z[449], x, s{"fnicdos.rediris.es", "g.nic.es", "h.nic.es", "n3ns.nic.es", "ns3.nic.mx"}, n, n, e, e, e, 0x0, f},
	{"edu.es", &z[449], x, s{"fnicdos.rediris.es", "g.nic.es", "h.nic.es", "n3ns.nic.es", "ns3.nic.mx"}, n, n, e, e, e, 0x0, f},
	{"gob.es", &z[449], x, s{"fnicdos.rediris.es", "g.nic.es", "h.nic.es", "n3ns.nic.es", "ns3.nic.mx"}, n, n, e, e, e, 0x0, f},
	{"nom.es", &z[449], x, s{"fnicdos.rediris.es", "g.nic.es", "h.nic.es", "n3ns.nic.es", "ns3.nic.mx"}, n, n, e, e, e, 0x0, f},
	{"org.es", &z[449], x, s{"fnicdos.rediris.es", "g.nic.es", "h.nic.es", "n3ns.nic.es", "ns3.nic.mx"}, n, n, e, e, e, 0x0, f},
	{"biz.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"com.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"edu.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"gov.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"info.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"name.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"net.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"org.et", &z[453], x, s{"a.nic.et", "b.nic.et"}, n, n, e, e, e, 0x0, f},
	{"24.eu", &z[455], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.eu"}, n, e, e, e, 0x200, t},
	{"ecb.eu", &z[455], x, s{"auth02.ns.de.uu.net", "auth52.ns.de.uu.net", "ns1.de.colt.net", "ns8.colt.net"}, n, n, e, e, e, 0x0, f},
	{"europa.eu", &z[455], x, s{"ns1.bt.net", "ns1bru.europa.eu", "ns1lux.europa.eu", "ns2bru.europa.eu", "ns2eu.bt.net", "ns2lux.europa.eu", "ns3bru.europa.eu", "ns3lux.europa.eu", "ns4az1.europa.eu"}, n, n, e, e, e, 0x0, f},
	{"ac.fj", &z[497], x, n, n, n, e, e, e, 0x0, t},
	{"biz.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"com.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"gov.fj", &z[497], x, s{"dnssecondary.auth-servers.net", "itcns1.gov.fj", "itcns2.gov.fj", "ns-ext.vix.com", "tabua.tfl.com.fj"}, n, n, e, e, e, 0x0, t},
	{"info.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"mil.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"name.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"net.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"org.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"pro.fj", &z[497], x, n, n, n, e, e, e, 0x0, f},
	{"school.fj", &z[497], x, s{"drua.tfl.com.fj", "ns-ext.isc.org", "tabua.tfl.com.fj"}, n, n, e, e, e, 0x0, t},
	{"ac.fk", &z[498], x, n, n, n, e, e, e, 0x0, f},
	{"co.fk", &z[498], x, n, n, n, e, e, e, 0x0, f},
	{"gov.fk", &z[498], x, s{"ns1.horizon.net.fk", "ns2.horizon.net.fk"}, n, n, e, e, e, 0x0, f},
	{"net.fk", &z[498], x, n, n, n, e, e, e, 0x0, f},
	{"nom.fk", &z[498], x, n, n, n, e, e, e, 0x0, f},
	{"org.fk", &z[498], x, n, n, n, e, e, e, 0x0, f},
	{"0.fm", &z[507], x, s{"ns1.bb-online.net", "ns2.bb-online.net"}, s{"0.fm", "139.162.244.72"}, n, e, e, e, 0x0, t},
	{"2.fm", &z[507], x, s{"ns1.idnz.net", "ns2.idnz.net", "ns3.idnz.net"}, s{"93.190.235.135"}, n, e, e, e, 0x0, t},
	{"4.fm", &z[507], x, s{"ns1.bb-online.net", "ns2.bb-online.net"}, s{"139.162.244.72", "4.fm"}, n, e, e, e, 0x0, t},
	{"6.fm", &z[507], x, s{"ns1.bb-online.net", "ns2.bb-online.net"}, s{"139.162.244.72", "6.fm"}, n, e, e, e, 0x0, t},
	{"8.fm", &z[507], x, s{"ns1.bb-online.net", "ns2.bb-online.net"}, s{"139.162.244.72", "8.fm"}, n, e, e, e, 0x0, t},
	{"radio.fm", &z[507], x, s{"a.nic.fm", "b.nic.fm", "c.nic.fm", "d.nic.fm"}, n, n, e, e, e, 0x0, t},
	{"aero.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"biz.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"co.fo", &z[508], x, s{"ns1-07.azure-dns.com", "ns2-07.azure-dns.net"}, n, n, e, e, e, 0x0, f},
	{"com.fo", &z[508], x, s{"ns1-03.azure-dns.com", "ns2-03.azure-dns.net"}, n, n, e, e, e, 0x0, f},
	{"coop.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"edu.fo", &z[508], x, s{"ns1.nic.fo", "ns2.nic.fo", "ns3.nic.fo"}, n, n, e, e, e, 0x0, f},
	{"flp.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"ftp.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"gov.fo", &z[508], x, s{"ns1.olivant.fo", "ns2.olivant.fo"}, n, n, e, e, e, 0x0, f},
	{"info.fo", &z[508], x, s{"ns1.voodoo.com", "ns2.voodoo.com"}, s{"192.64.147.231"}, n, e, e, e, 0x0, f},
	{"int.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"internet.fo", &z[508], x, s{"ns1.olivant.fo", "ns2.olivant.fo"}, n, n, e, e, e, 0x0, f},
	{"irc.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"mail.fo", &z[508], x, s{"ns1.olivant.fo", "ns2.olivant.fo"}, n, n, e, e, e, 0x0, f},
	{"mil.fo", &z[508], x, s{"ns1.afriregister.com", "ns3.afriregister.com"}, n, n, e, e, e, 0x0, f},
	{"museum.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"name.fo", &z[508], x, s{"ns1.gratisdns.dk", "ns2.gratisdns.dk"}, n, n, e, e, e, 0x0, f},
	{"org.fo", &z[508], x, s{"ns1.nic.fo", "ns2.nic.fo", "ns3.nic.fo"}, n, n, e, e, e, 0x0, f},
	{"telenet.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"telnet.fo", &z[508], x, n, n, n, e, e, e, 0x0, f},
	{"web.fo", &z[508], x, s{"ns1.xn--kisnavn-p1a.fo", "ns2.xn--kisnavn-p1a.fo", "ns3.xn--kisnavn-p1a.fo"}, n, n, e, e, e, 0x0, f},
	{"www.fo", &z[508], x, s{"ns1.nic.fo", "ns2.nic.fo", "ns3.nic.fo"}, n, n, e, e, e, 0x0, f},
	{"aeroport.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"asso.fr", &z[519], x, n, n, n, e, e, e, 0x800, f},
	{"avocat.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"chambagri.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"chirurgiens-dentistes.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"com.fr", &z[519], x, n, n, n, e, e, e, 0x800, f},
	{"experts-comptables.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"geometre-expert.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"gouv.fr", &z[519], x, n, n, n, e, e, e, 0x0, f},
	{"medecin.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"nom.fr", &z[519], x, n, n, n, e, e, e, 0x0, f},
	{"notaires.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"pharmacien.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"port.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"prd.fr", &z[519], x, s{"ns1.renater.fr", "ns2.renater.fr", "ns4.cnrs.fr"}, n, n, e, e, e, 0x0, f},
	{"presse.fr", &z[519], x, n, n, n, e, e, e, 0x0, f},
	{"tm.fr", &z[519], x, n, n, n, e, e, e, 0x800, f},
	{"veterinaire.fr", &z[519], x, s{"ns1.smallregistry.net", "ns2.smallregistry.net", "ns3.smallregistry.net", "ns4.smallregistry.net"}, n, n, "whois.smallregistry.net", e, e, 0x0, t},
	{"ac.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"aeroport.ga", &z[534], x, s{"ns81.rookdns.com", "ns82.rookdns.com"}, s{"141.8.224.221"}, n, e, e, e, 0x0, f},
	{"asso.ga", &z[534], x, s{"ns1.aninf.ga", "ns2.aninf.ga", "ns3.aninf.ga"}, n, n, e, e, e, 0x0, f},
	{"co.ga", &z[534], x, s{"isp1.ib.ga", "isp2.ib.ga", "ns.ripe.net", "nsi1.inet.ga", "nsi2.inet.ga"}, n, n, e, e, e, 0x0, f},
	{"com.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"ed.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"edu.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"go.ga", &z[534], x, s{"ns81.rookdns.com", "ns82.rookdns.com"}, s{"141.8.224.221"}, n, e, e, e, 0x0, f},
	{"int.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"net.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"or.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"org.ga", &z[534], x, s{"isp1.ib.ga", "isp2.ib.ga", "nsi1.inet.ga", "nsi2.inet.ga"}, n, n, e, e, e, 0x0, f},
	{"presse.ga", &z[534], x, n, n, n, e, e, e, 0x0, f},
	{"hmg.gb", &z[545], x, n, n, n, e, e, e, 0x800, f},
	{"com.gd", &z[548], x, n, n, n, e, e, e, 0x0, t},
	{"edu.gd", &z[548], x, s{"a.nic.gd", "b.nic.gd", "c.nic.gd", "d.nic.gd"}, n, n, e, e, e, 0x800, f},
	{"gov.gd", &z[548], x, s{"a.nic.gd", "b.nic.gd", "c.nic.gd", "d.nic.gd"}, n, n, e, e, e, 0x0, f},
	{"mlt.gd", &z[548], x, n, n, n, e, e, e, 0x0, f},
	{"net.gd", &z[548], x, n, n, n, e, e, e, 0x0, f},
	{"org.gd", &z[548], x, n, n, n, e, e, e, 0x0, f},
	{"sci.gd", &z[548], x, n, n, n, e, e, e, 0x0, f},
	{"com.ge", &z[550], x, s{"auth02.ns.uu.net", "ns.nic.ge"}, n, n, e, e, e, 0x0, f},
	{"edu.ge", &z[550], x, s{"auth02.ns.uu.net", "ns.nic.ge"}, n, n, e, e, e, 0x0, f},
	{"gov.ge", &z[550], x, s{"ns1.gov.ge", "ns2.gov.ge", "ns3.gov.ge"}, n, n, e, e, e, 0x0, f},
	{"mil.ge", &z[550], x, n, n, n, e, e, e, 0x0, f},
	{"net.ge", &z[550], x, s{"auth02.ns.uu.net", "ns.nic.ge"}, n, n, e, e, e, 0x0, f},
	{"org.ge", &z[550], x, s{"auth02.ns.uu.net", "ns.nic.ge"}, n, n, e, e, e, 0x0, f},
	{"pvt.ge", &z[550], x, s{"auth02.ns.uu.net", "ns.nic.ge"}, n, n, e, e, e, 0x0, f},
	{"school.ge", &z[550], x, s{"ns.nic.ge", "ns2.nic.ge"}, n, n, e, e, e, 0x0, t},
	{"24.gg", &z[558], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.gg"}, n, e, e, e, 0x200, t},
	{"ac.gg", &z[558], x, s{"ns1.rapidswitch.com", "ns2.rapidswitch.com", "ns3.rapidswitch.com"}, n, n, e, e, e, 0x0, f},
	{"co.gg", &z[558], x, s{"b.ci-servers.com", "c.ci-servers.org", "dns1.nominetdns.uk", "f.ci-servers.je", "g.ci-servers.gg"}, n, n, e, e, e, 0x0, f},
	{"eu.gg", &z[558], x, s{"ns5.myhostadmin.net", "ns6.myhostadmin.net"}, n, n, e, e, e, 0x200, t},
	{"gov.gg", &z[558], x, s{"dns1.name-s.net", "dns2.name-s.net", "dns3.mtgsy.com", "dns4.mtgsy.com", "gsy1.ns.mtgsy.com"}, n, n, e, e, e, 0x0, f},
	{"net.gg", &z[558], x, s{"b.ci-servers.com", "c.ci-servers.org", "dns1.nominetdns.uk", "f.ci-servers.je", "g.ci-servers.gg"}, n, n, e, e, e, 0x0, f},
	{"org.gg", &z[558], x, s{"b.ci-servers.com", "c.ci-servers.org", "dns1.nominetdns.uk", "f.ci-servers.je", "g.ci-servers.gg"}, n, n, e, e, e, 0x0, f},
	{"sch.gg", &z[558], x, s{"dns1.name-s.net", "dns2.name-s.net", "dns3.mtgsy.com", "dns4.mtgsy.com", "gsy1.ns.mtgsy.com"}, n, n, e, e, e, 0x0, f},
	{"tr.gg", &z[558], x, s{"ns01.webme.com", "ns02.webme.com"}, s{"193.238.27.36"}, n, e, e, e, 0x0, f},
	{"tv.gg", &z[558], x, n, n, n, e, e, e, 0x200, t},
	{"web.gg", &z[558], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "web.gg"}, n, e, e, e, 0x200, t},
	{"com.gh", &z[560], x, s{"ns.dns.br", "ns1.nic.gh", "ns2.nic.gh"}, n, n, e, e, e, 0x0, f},
	{"edu.gh", &z[560], x, s{"ns.dns.br", "ns1.nic.gh", "ns2.nic.gh"}, n, n, e, e, e, 0x0, f},
	{"gov.gh", &z[560], x, s{"ns.dns.br", "ns1.nic.gh", "ns2.nic.gh"}, n, n, e, e, e, 0x0, f},
	{"mil.gh", &z[560], x, s{"ns.dns.br", "ns1.nic.gh", "ns2.nic.gh"}, n, n, e, e, e, 0x0, f},
	{"net.gh", &z[560], x, s{"ns.dns.br", "ns1.nic.gh", "ns2.nic.gh"}, n, n, e, e, e, 0x0, t},
	{"org.gh", &z[560], x, s{"ns.dns.br", "ns1.nic.gh", "ns2.nic.gh"}, n, n, e, e, e, 0x0, f},
	{"com.gi", &z[561], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"edu.gi", &z[561], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"gov.gi", &z[561], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"ltd.gi", &z[561], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"mod.gi", &z[561], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"org.gi", &z[561], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"co.gl", &z[566], x, s{"a.nuuk.nic.gl", "d.nic.gl"}, n, n, e, e, e, 0x0, f},
	{"com.gl", &z[566], x, s{"a.nuuk.nic.gl", "d.nic.gl"}, n, n, e, e, e, 0x0, f},
	{"edu.gl", &z[566], x, s{"a.nuuk.nic.gl", "d.nic.gl"}, n, n, e, e, e, 0x0, f},
	{"net.gl", &z[566], x, s{"a.nuuk.nic.gl", "d.nic.gl"}, n, n, e, e, e, 0x0, f},
	{"org.gl", &z[566], x, s{"a.nuuk.nic.gl", "d.nic.gl"}, n, n, e, e, e, 0x0, f},
	{"ac.gn", &z[579], x, n, n, n, e, e, e, 0x0, f},
	{"co.gn", &z[579], x, n, n, n, e, e, e, 0x0, f},
	{"com.gn", &z[579], x, n, n, n, e, e, e, 0x0, t},
	{"gov.gn", &z[579], x, n, n, n, e, e, e, 0x0, f},
	{"net.gn", &z[579], x, n, n, n, e, e, e, 0x0, f},
	{"org.gn", &z[579], x, n, n, n, e, e, e, 0x0, f},
	{"24.gp", &z[593], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.gp"}, n, e, e, e, 0x200, t},
	{"asia.gp", &z[593], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "asia.gp"}, n, e, e, e, 0x200, t},
	{"asso.gp", &z[593], x, s{"ns-gp.nic.fr", "ns1.nic.gp", "ns2.nic.gp"}, n, n, e, e, e, 0x0, f},
	{"co.gp", &z[593], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "co.gp"}, n, e, e, e, 0x200, t},
	{"com.gp", &z[593], x, s{"ns-gp.nic.fr", "ns1.nic.gp", "ns2.nic.gp"}, n, n, e, e, e, 0x0, f},
	{"edu.gp", &z[593], x, s{"ns-gp.nic.fr", "ns1.nic.gp", "ns2.nic.gp"}, n, n, e, e, e, 0x0, t},
	{"eu.gp", &z[593], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "eu.gp"}, n, e, e, e, 0x200, t},
	{"mobi.gp", &z[593], x, s{"ns-gp.nic.fr", "ns1.nic.gp", "ns2.nic.gp"}, n, n, e, e, e, 0x0, f},
	{"net.gp", &z[593], x, s{"ns-gp.nic.fr", "ns1.nic.gp", "ns2.nic.gp"}, n, n, e, e, e, 0x0, f},
	{"online.gp", &z[593], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "online.gp"}, n, e, e, e, 0x200, t},
	{"org.gp", &z[593], x, s{"ns-gp.nic.fr", "ns1.nic.gp", "ns2.nic.gp"}, n, n, e, e, e, 0x0, f},
	{"com.gr", &z[595], x, s{"estia.ics.forth.gr", "gr-at.ics.forth.gr", "gr-c.ics.forth.gr", "gr-d.ics.forth.gr", "grdns-m.ics.forth.gr", "grdns.ics.forth.gr"}, n, n, e, e, e, 0x0, f},
	{"edu.gr", &z[595], x, s{"estia.ics.forth.gr", "gr-at.ics.forth.gr", "gr-c.ics.forth.gr", "gr-d.ics.forth.gr", "grdns-m.ics.forth.gr", "grdns.ics.forth.gr"}, n, n, e, e, e, 0x0, f},
	{"gov.gr", &z[595], x, s{"estia.ics.forth.gr", "gr-at.ics.forth.gr", "gr-c.ics.forth.gr", "gr-d.ics.forth.gr", "grdns-m.ics.forth.gr", "grdns.ics.forth.gr"}, n, n, e, e, e, 0x0, f},
	{"net.gr", &z[595], x, s{"estia.ics.forth.gr", "gr-at.ics.forth.gr", "gr-c.ics.forth.gr", "gr-d.ics.forth.gr", "grdns-m.ics.forth.gr", "grdns.ics.forth.gr"}, n, n, e, e, e, 0x0, f},
	{"org.gr", &z[595], x, s{"estia.ics.forth.gr", "gr-at.ics.forth.gr", "gr-c.ics.forth.gr", "gr-d.ics.forth.gr", "grdns-m.ics.forth.gr", "grdns.ics.forth.gr"}, n, n, e, e, e, 0x0, f},
	{"com.gt", &z[605], x, s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"edu.gt", &z[605], x, s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"gob.gt", &z[605], x, s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"ind.gt", &z[605], x, s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"mil.gt", &z[605], x, s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"net.gt", &z[605], x, s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"org.gt", &z[605], x, s{"a.lactld.org", "gt.anycastdns.cz", "ns-cz.gt", "ns.dns.br", "pch.gt", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"com.gu", &z[606], x, s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"edu.gu", &z[606], x, s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"gov.gu", &z[606], x, s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"guam.gu", &z[606], x, s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, t},
	{"net.gu", &z[606], x, s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"org.gu", &z[606], x, s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"web.gu", &z[606], x, s{"gold.uog.edu", "green.uog.edu", "gu.cctld.authdns.ripe.net", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, t},
	{"co.gy", &z[616], x, s{"a.lactld.org", "gy-ns.anycast.pch.net", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"com.gy", &z[616], x, s{"a.lactld.org", "gy-ns.anycast.pch.net", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"net.gy", &z[616], x, s{"a.lactld.org", "gy-ns.anycast.pch.net", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"org.gy", &z[616], x, s{"a.lactld.org", "gy-ns.anycast.pch.net", "ns.cocca.fr"}, n, n, e, e, e, 0x0, t},
	{"com.hk", &z[639], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, f},
	{"edu.hk", &z[639], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, f},
	{"gov.hk", &z[639], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, f},
	{"idv.hk", &z[639], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, f},
	{"inc.hk", &z[639], x, s{"a.udrtld.net", "b.udrtld.net", "c.udrtld.net", "dns7.cloudns.net", "dns8.cloudns.net"}, n, n, "whois.registry.hk.com", e, e, 0x0, f},
	{"ltd.hk", &z[639], x, s{"a.udrtld.net", "b.udrtld.net", "c.udrtld.net", "dns7.cloudns.net", "dns8.cloudns.net"}, n, n, "whois.registry.hk.com", e, e, 0x0, f},
	{"net.hk", &z[639], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, f},
	{"org.hk", &z[639], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, f},
	{"xn--55qx5d.hk" /* 公司.hk */, &z[639], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, t},
	{"com.hn", &z[642], x, s{"nicmx-anycast.rds.org.hn", "pch-anycast.rds.org.hn"}, n, n, e, e, e, 0x0, f},
	{"edu.hn", &z[642], x, s{"nicmx-anycast.rds.org.hn", "pch-anycast.rds.org.hn"}, n, n, e, e, e, 0x0, t},
	{"gob.hn", &z[642], x, s{"nicmx-anycast.rds.org.hn", "pch-anycast.rds.org.hn"}, n, n, e, e, e, 0x0, t},
	{"mil.hn", &z[642], x, s{"nicmx-anycast.rds.org.hn", "pch-anycast.rds.org.hn"}, n, n, e, e, e, 0x0, t},
	{"net.hn", &z[642], x, s{"nicmx-anycast.rds.org.hn", "pch-anycast.rds.org.hn"}, n, n, e, e, e, 0x0, f},
	{"org.hn", &z[642], x, s{"nicmx-anycast.rds.org.hn", "pch-anycast.rds.org.hn"}, n, n, e, e, e, 0x0, f},
	{"com.hr", &z[665], x, s{"dns-ez-1.carnet.hr", "dns1.com.hr", "dns2.com.hr"}, n, n, e, e, e, 0x0, f},
	{"from.hr", &z[665], x, s{"dns-ez-1.carnet.hr", "dns1.from.hr", "dns2.from.hr"}, n, n, e, e, e, 0x0, f},
	{"iz.hr", &z[665], x, s{"dns-ez-1.carnet.hr", "dns1.from.hr", "dns1.iz.hr", "dns2.from.hr", "dns2.iz.hr"}, n, n, e, e, e, 0x0, f},
	{"name.hr", &z[665], x, s{"dns-ez-1.carnet.hr", "dns1.from.hr", "dns1.name.hr", "dns2.from.hr", "dns2.name.hr"}, n, n, e, e, e, 0x0, f},
	{"adult.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x1, f},
	{"art.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"asso.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"com.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"coop.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"edu.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"firm.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"gouv.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"info.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"med.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"net.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"org.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"perso.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"pol.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"pro.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"rel.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"shop.ht", &z[667], x, s{"ns.cocca.fr", "ns1.nic.ht", "ns1.polymtl.ca", "ns3.nic.fr", "pch.nic.ht"}, n, n, e, e, e, 0x0, f},
	{"2000.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"ac.hu", &z[669], x, n, n, n, e, e, e, 0x0, f},
	{"agrar.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"bolt.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"casino.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"city.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"co.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu", "ns12.communitydns.net"}, n, n, e, e, e, 0x0, f},
	{"edu.hu", &z[669], x, s{"ns2.iif.hu", "ns2.sztaki.hbone.hu"}, n, n, e, e, e, 0x0, f},
	{"erotica.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"erotika.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"film.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"forum.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"games.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"gov.hu", &z[669], x, s{"adns0.gov.hu", "adns1.gov.hu", "adns2.gov.hu"}, n, n, e, e, e, 0x0, f},
	{"hotel.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"info.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"ingatlan.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"jogasz.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"konyvelo.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"lakas.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"media.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"news.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"org.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"priv.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"reklam.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"sex.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x1, f},
	{"shop.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"sport.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"suli.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"szex.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"tm.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"tozsde.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"utazas.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"video.hu", &z[669], x, s{"a.hu", "b.hu", "c.hu", "d.hu", "ns-s.nic.hu"}, n, n, e, e, e, 0x0, f},
	{"ac.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"biz.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"co.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"desa.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, t},
	{"go.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"mi.id", &z[677], x, n, n, n, e, e, e, 0x0, t},
	{"mil.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"my.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"net.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"or.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"sch.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"web.id", &z[677], x, s{"b.dns.id", "c.dns.id", "d.dns.id", "e.dns.id"}, n, n, e, e, e, 0x0, f},
	{"com.ie", &z[679], x, n, n, n, e, e, e, 0x800, f},
	{"gov.ie", &z[679], x, s{"cwext.gn.gov.ie", "ext3.gn.gov.ie", "gbext.gn.gov.ie"}, n, n, e, e, e, 0x0, f},
	{"net.ie", &z[679], x, n, n, n, e, e, e, 0x800, f},
	{"nli.ie", &z[679], x, s{"ns.heanet.ie", "vax1.baker.ie"}, n, n, e, e, e, 0x0, f},
	{"org.ie", &z[679], x, n, n, n, e, e, e, 0x800, f},
	{"ac.il", &z[684], x, s{"ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, e, e, e, 0x0, f},
	{"co.il", &z[684], x, s{"ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, e, e, "http://www.isoc.org.il/domains/", 0x0, f},
	{"gov.il", &z[684], x, s{"dns3.gov.il", "ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, e, e, e, 0x0, f},
	{"idf.il", &z[684], x, s{"asia3.akam.net", "asia4.akam.net", "dns3.gov.il", "eur2.akam.net", "eur6.akam.net", "ns1-111.akam.net", "ns1-69.akam.net", "use4.akam.net", "usw2.akam.net"}, n, n, e, e, e, 0x0, f},
	{"k12.il", &z[684], x, s{"ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, e, e, e, 0x0, f},
	{"muni.il", &z[684], x, s{"ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, e, e, e, 0x0, f},
	{"net.il", &z[684], x, s{"ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, e, e, "http://www.isoc.org.il/domains/", 0x0, f},
	{"org.il", &z[684], x, s{"ilns.ilan.net.il", "lookup.iucc.ac.il", "ns1.ns.il", "ns3.ns.il", "ns4.ns.il", "nsa.ns.il", "nsb.ns.il", "nse.ns.il"}, n, n, e, e, "http://www.isoc.org.il/domains/", 0x0, f},
	{"ac.im", &z[685], x, n, n, n, e, e, e, 0x0, f},
	{"co.im", &z[685], z[5077:5079], n, n, n, e, e, e, 0x0, f},
	{"com.im", &z[685], x, n, n, n, e, e, e, 0x0, f},
	{"gov.im", &z[685], x, s{"barney.advsys.co.uk", "hoppy.iom.com", "pebbles.iom.com"}, n, n, e, e, e, 0x0, f},
	{"net.im", &z[685], x, n, n, n, e, e, e, 0x0, f},
	{"org.im", &z[685], x, n, n, n, e, e, e, 0x0, f},
	{"ac.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.ncst.ernet.in", e, e, 0x0, f},
	{"co.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.inregistry.net", e, e, 0x0, f},
	{"edu.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.ncst.ernet.in", e, e, 0x0, f},
	{"ernet.in", &z[690], x, s{"dns.ernet.in", "dns1.ernet.in", "dns2.ernet.in", "dns3.ernet.in", "dns4.ernet.in", "e-eihq01.eis.ernet.in", "e-eihq02.eis.ernet.in"}, n, n, e, e, e, 0x0, t},
	{"firm.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.inregistry.net", e, e, 0x0, f},
	{"gen.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.inregistry.net", e, e, 0x0, f},
	{"gov.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.ncst.ernet.in", e, e, 0x0, f},
	{"ind.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, e, e, e, 0x0, f},
	{"mil.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.ncst.ernet.in", e, e, 0x0, f},
	{"net.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.inregistry.net", e, e, 0x0, f},
	{"org.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.inregistry.net", e, e, 0x0, f},
	{"res.in", &z[690], x, s{"ns1.registry.in", "ns2.registry.in", "ns3.registry.in", "ns4.registry.in", "ns5.registry.in", "ns6.registry.in"}, n, n, "whois.ncst.ernet.in", e, e, 0x0, f},
	{"auz.info", &z[695], x, s{"ns1.instradns.com", "ns2.instradns.com", "ns3.instradns.com"}, n, n, e, e, e, 0x0, f},
	{"eu.int", &z[703], x, s{"ns1.be.colt.net", "ns1.bt.net", "ns1bru.europa.eu", "ns1lux.europa.eu", "ns2bru.europa.eu", "ns2eu.bt.net", "ns2lux.europa.eu"}, n, n, e, e, e, 0x0, f},
	{"com.io", &z[708], x, n, n, n, e, e, e, 0x800, t},
	{"org.io", &z[708], x, n, n, n, e, e, e, 0x800, t},
	{"biz.iq", &z[710], x, s{"dyn1.cmc.iq", "dyn2.cmc.iq", "ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, t},
	{"com.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, f},
	{"edu.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, f},
	{"gov.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, f},
	{"info.iq", &z[710], x, s{"ns23.cmc.iq", "ns24.cmc.iq"}, n, n, e, e, e, 0x0, t},
	{"mil.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, f},
	{"name.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq"}, n, n, e, e, e, 0x0, t},
	{"net.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, t},
	{"org.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, f},
	{"tv.iq", &z[710], x, s{"ns.cocca.fr", "ns1.cmc.iq", "nsp-anycast.cmc.iq", "sns-pb.isc.org"}, n, n, e, e, e, 0x0, t},
	{"ac.ir", &z[711], x, s{"a.nic.ir", "b.nic.ir", "dns-ir.univie.ac.at", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"co.ir", &z[711], x, s{"a.nic.ir", "b.nic.ir", "dns-ir.univie.ac.at", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"gov.ir", &z[711], x, s{"a.nic.ir", "b.nic.ir", "dns-ir.univie.ac.at", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"id.ir", &z[711], x, s{"a.nic.ir", "b.nic.ir", "dns-ir.univie.ac.at", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"net.ir", &z[711], x, s{"a.nic.ir", "b.nic.ir", "dns-ir.univie.ac.at", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"org.ir", &z[711], x, s{"a.nic.ir", "b.nic.ir", "dns-ir.univie.ac.at", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"sch.ir", &z[711], x, s{"a.nic.ir", "b.nic.ir", "dns-ir.univie.ac.at", "ir.cctld.authdns.ripe.net", "ns5.univie.ac.at"}, n, n, e, e, e, 0x0, f},
	{"abr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"abruzzo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ag.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"agrigento.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"al.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"alessandria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"alto-adige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"altoadige.it", &z[720], x, s{"guy.ns.cloudflare.com", "rita.ns.cloudflare.com"}, n, n, e, e, e, 0x0, t},
	{"an.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ancona.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"andria-barletta-trani.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"andria-trani-barletta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"andriabarlettatrani.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"andriatranibarletta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ao.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"aosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"aoste.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ap.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"aq.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"aquila.it", &z[720], x, s{"ns1.parkingcrew.net", "ns2.parkingcrew.net"}, s{"104.247.82.54"}, n, e, e, e, 0x0, t},
	{"ar.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"arezzo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ascoli-piceno.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ascolipiceno.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"asti.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"at.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"av.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"avellino.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ba.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"balsan.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bari.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"barletta-trani-andria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"barlettatraniandria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bas.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"basilicata.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"belluno.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"benevento.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bergamo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bg.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bi.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"biella.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bl.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bn.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bologna.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bolzano.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bozen.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"br.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"brescia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"brindisi.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bs.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bt.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"bz.it", &z[720], x, n, n, n, e, e, e, 0x0, f},
	{"ca.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cagliari.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cal.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"calabria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"caltanissetta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cam.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"campania.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"campidano-medio.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"campidanomedio.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"campobasso.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"carbonia-iglesias.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"carboniaiglesias.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"carrara-massa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"carraramassa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"caserta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"catania.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"catanzaro.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cb.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ce.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cesena-forli.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cesenaforli.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ch.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"chieti.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ci.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cl.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cn.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"co.it", &z[720], x, n, n, n, e, e, e, 0x0, f},
	{"como.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cosenza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cremona.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"crotone.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cs.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ct.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cuneo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"cz.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"dell-ogliastra.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"dellogliastra.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"edu.it", &z[720], x, s{"a.dns.it", "dns.edu.it", "m.dns.it", "r.dns.it"}, n, n, e, e, e, 0x0, f},
	{"emilia-romagna.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"emiliaromagna.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"emr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"en.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"enna.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fc.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fe.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fermo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ferrara.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fg.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fi.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"firenze.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"florence.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fm.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"foggia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"forli-cesena.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"forlicesena.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuli-v-giulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuli-ve-giulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuli-vegiulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuli-venezia-giulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuli-veneziagiulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuli-vgiulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuliv-giulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friulive-giulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friulivegiulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friulivenezia-giulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friuliveneziagiulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"friulivgiulia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"frosinone.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"fvg.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ge.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"genoa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"genova.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"go.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"gorizia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"gov.it", &z[720], x, s{"dns1.fweds-spc.it", "dns2.fweds-spc.it"}, n, n, e, e, e, 0x0, f},
	{"gr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"grosseto.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"iglesias-carbonia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"iglesiascarbonia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"im.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"imperia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"is.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"isernia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"kr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"la-spezia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"laquila.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"laspezia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"latina.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"laz.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lazio.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lc.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"le.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lecce.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lecco.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"li.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lig.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"liguria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"livorno.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lodi.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lom.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lombardia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lombardy.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lt.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lu.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lucania.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"lucca.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"macerata.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mantova.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mar.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"marche.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"massa-carrara.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"massacarrara.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"matera.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mb.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mc.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"me.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"medio-campidano.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mediocampidano.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"messina.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mi.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"milan.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"milano.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mn.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"modena.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"molise.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"monza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"monza-brianza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"monza-e-della-brianza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"monzabrianza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"monzaebrianza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"monzaedellabrianza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ms.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"mt.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"na.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"naples.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"napoli.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"no.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"novara.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"nu.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"nuoro.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"og.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ogliastra.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"olbia-tempio.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"olbiatempio.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"or.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"oristano.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ot.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"padova.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"padua.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"palermo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"parma.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pavia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pc.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pd.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pe.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"perugia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pesaro-urbino.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pesarourbino.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pescara.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pg.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pi.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"piacenza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"piedmont.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"piemonte.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pisa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pistoia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pmn.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pn.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"po.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pordenone.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"potenza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"prato.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pt.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pu.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pug.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"puglia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pv.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"pz.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ra.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ragusa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ravenna.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rc.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"re.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"reggio-calabria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"reggio-emilia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"reggiocalabria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"reggioemilia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rg.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ri.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rieti.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rimini.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rm.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rn.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ro.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"roma.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rome.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"rovigo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"salerno.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sar.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sardegna.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sardinia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sassari.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"savona.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"si.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sic.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sicilia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sicily.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"siena.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"siracusa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"so.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sondrio.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sp.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ss.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"suedtirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"sv.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"taa.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"taranto.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"te.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tempio-olbia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tempioolbia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"teramo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"terni.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tn.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"to.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"torino.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tos.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"toscana.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tp.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trani-andria-barletta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trani-barletta-andria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"traniandriabarletta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tranibarlettaandria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trapani.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-a-adige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-aadige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-alto-adige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-altoadige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-s-tirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-stirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-sud-tirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-sudtirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-sued-tirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentino-suedtirol.it", &z[720], x, s{"dns3.aknet.it", "dns4.aknet.it"}, n, n, e, e, e, 0x0, t},
	{"trentinoa-adige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentinoaadige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentinoalto-adige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentinoaltoadige.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentinos-tirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentinosud-tirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentinosudtirol.it", &z[720], x, s{"dns.widhost.net", "dns2.widhost.net"}, n, n, e, e, e, 0x0, t},
	{"trentinosued-tirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trentinosuedtirol.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trento.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"treviso.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"trieste.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ts.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"turin.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tuscany.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"tv.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ud.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"udine.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"umb.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"umbria.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"urbino-pesaro.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"urbinopesaro.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"va.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"val-d-aosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"val-daosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vald-aosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"valdaosta.it", &z[720], x, s{"dns2.alsitech.it", "dns4.alsitech.it"}, n, n, e, e, e, 0x0, t},
	{"valle-d-aosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"valle-daosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"valled-aosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"valledaosta.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vao.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"varese.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vb.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vc.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vda.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ve.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"ven.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"veneto.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"venezia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"venice.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"verbania.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vercelli.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"verona.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vi.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vibo-valentia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vibovalentia.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vicenza.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"viterbo.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vr.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vs.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vt.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"vv.it", &z[720], x, n, n, n, e, e, e, 0x0, t},
	{"24.je", &z[729], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.je"}, n, e, e, e, 0x200, t},
	{"co.je", &z[729], x, s{"b.ci-servers.com", "c.ci-servers.org", "dns1.nominetdns.uk", "f.ci-servers.je", "g.ci-servers.gg"}, n, n, e, e, e, 0x0, f},
	{"gov.je", &z[729], x, s{"ns1.gov.je", "ns2.gov.je"}, n, n, e, e, e, 0x0, f},
	{"net.je", &z[729], x, s{"b.ci-servers.com", "c.ci-servers.org", "dns1.nominetdns.uk", "f.ci-servers.je", "g.ci-servers.gg"}, n, n, e, e, e, 0x0, f},
	{"org.je", &z[729], x, s{"b.ci-servers.com", "c.ci-servers.org", "dns1.nominetdns.uk", "f.ci-servers.je", "g.ci-servers.gg"}, n, n, e, e, e, 0x0, f},
	{"sch.je", &z[729], x, s{"ns1.gov.je", "ns2.gov.je"}, n, n, e, e, e, 0x0, f},
	{"com.jm", &z[736], x, n, n, n, e, e, e, 0x0, f},
	{"edu.jm", &z[736], x, n, n, n, e, e, e, 0x0, f},
	{"gov.jm", &z[736], x, n, n, n, e, e, e, 0x0, f},
	{"mil.jm", &z[736], x, n, n, n, e, e, e, 0x0, f},
	{"net.jm", &z[736], x, n, n, n, e, e, e, 0x0, f},
	{"org.jm", &z[736], x, n, n, n, e, e, e, 0x0, f},
	{"com.jo", &z[739], x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"edu.jo", &z[739], x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, e, e, 0x0, t},
	{"gov.jo", &z[739], x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, s{"193.188.66.238"}, n, e, e, e, 0x0, f},
	{"mil.jo", &z[739], x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"name.jo", &z[739], x, n, n, n, e, e, e, 0x0, f},
	{"net.jo", &z[739], x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"org.jo", &z[739], x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"sch.jo", &z[739], x, s{"amra.nic.gov.jo", "jo.cctld.authdns.ripe.net", "jordan1st.nic.gov.jo", "petra.nic.gov.jo", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"ac.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"ad.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"aichi.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"akita.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"aomori.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"chiba.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"co.jp", &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"ed.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"ehime.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"fukui.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"fukuoka.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"fukushima.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"gifu.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"go.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"gr.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"gunma.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"hiroshima.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"hokkaido.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"hyogo.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"ibaraki.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"ishikawa.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"iwate.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"kagawa.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"kagoshima.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"kanagawa.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"kochi.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"kumamoto.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"kyoto.jp", &z[744], x, n, n, s{"Kyoto"}, e, e, e, 0x84, f},
	{"lg.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"mie.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"miyagi.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"miyazaki.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"nagano.jp", &z[744], x, n, n, s{"Nagano", "JP-20"}, e, e, e, 0x84, f},
	{"nagasaki.jp", &z[744], x, n, n, s{"Nagasaki"}, e, e, e, 0x84, f},
	{"nara.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"ne.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"niigata.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"oita.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"okayama.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"okinawa.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"or.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"osaka.jp", &z[744], x, n, n, s{"Osaka"}, e, e, e, 0x84, f},
	{"saga.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"saitama.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"shiga.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"shimane.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"shizuoka.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"tochigi.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"tokushima.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"tokyo.jp", &z[744], x, n, n, s{"Tokyo"}, e, e, e, 0x84, f},
	{"tottori.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"toyama.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"wakayama.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"yamagata.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"yamaguchi.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"yamanashi.jp", &z[744], x, n, n, n, e, e, e, 0x0, f},
	{"xn--ehqz56n.jp" /* 三重.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--1lqs03n.jp" /* 京都.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--qqqt11m.jp" /* 佐賀.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--f6qx53a.jp" /* 兵庫.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--djrs72d6uy.jp" /* 北海道.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--mkru45i.jp" /* 千葉.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--0trq7p7nn.jp" /* 和歌山.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--5js045d.jp" /* 埼玉.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--kbrq7o.jp" /* 大分.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--pssu33l.jp" /* 大阪.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--ntsq17g.jp" /* 奈良.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--uisz3g.jp" /* 宮城.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--6btw5a.jp" /* 宮崎.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--1ctwo.jp" /* 富山.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--6orx2r.jp" /* 山口.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--rht61e.jp" /* 山形.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--rht27z.jp" /* 山梨.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--nit225k.jp" /* 岐阜.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--rht3d.jp" /* 岡山.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--djty4k.jp" /* 岩手.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--klty5x.jp" /* 島根.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--kltx9a.jp" /* 広島.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--kltp7d.jp" /* 徳島.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--c3s14m.jp" /* 愛媛.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--vgu402c.jp" /* 愛知.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--efvn9s.jp" /* 新潟.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--1lqs71d.jp" /* 東京.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--4pvxs.jp" /* 栃木.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--uuwu58a.jp" /* 沖縄.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--zbx025d.jp" /* 滋賀.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--8pvr4u.jp" /* 熊本.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--5rtp49c.jp" /* 石川.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--ntso0iqx3a.jp" /* 神奈川.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--elqq16h.jp" /* 福井.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--4it168d.jp" /* 福岡.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--klt787d.jp" /* 福島.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--rny31h.jp" /* 秋田.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--7t0a264c.jp" /* 群馬.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--uist22h.jp" /* 茨城.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--8ltr62k.jp" /* 長崎.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--2m4a15e.jp" /* 長野.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--32vp30h.jp" /* 青森.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--4it797k.jp" /* 静岡.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--5rtq34k.jp" /* 香川.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--k7yn95e.jp" /* 高知.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--tor131o.jp" /* 鳥取.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"xn--d5qv7z876c.jp" /* 鹿児島.jp */, &z[744], x, n, n, n, e, e, e, 0x0, t},
	{"ac.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"co.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"go.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"info.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"me.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"mobi.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"ne.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"or.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"sc.ke", &z[753], x, s{"b.ns.tznic.or.tz", "kenic.anycastdns.cz", "mzizi.kenic.or.ke", "ns-ke.afrinic.net", "ns.anycast.kenic.or.ke", "ns2ke.dns.business"}, n, n, e, e, e, 0x0, f},
	{"com.kg", &z[761], x, s{"as.asiainfo.kg", "kg.cctld.authdns.ripe.net", "ns-kg.ripe.net", "ns.kg"}, n, n, e, e, e, 0x0, f},
	{"edu.kg", &z[761], x, s{"as.asiainfo.kg", "kg.cctld.authdns.ripe.net", "ns-kg.ripe.net", "ns.kg"}, n, n, e, e, e, 0x0, t},
	{"gov.kg", &z[761], x, s{"as.asiainfo.kg", "kg.cctld.authdns.ripe.net", "ns-kg.ripe.net", "ns.kg"}, n, n, e, e, e, 0x0, f},
	{"mil.kg", &z[761], x, s{"as.asiainfo.kg", "ns.kg", "ns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"net.kg", &z[761], x, s{"as.asiainfo.kg", "kg.cctld.authdns.ripe.net", "ns-kg.ripe.net", "ns.kg"}, n, n, e, e, e, 0x0, f},
	{"org.kg", &z[761], x, s{"as.asiainfo.kg", "kg.cctld.authdns.ripe.net", "ns-kg.ripe.net", "ns.kg"}, n, n, e, e, e, 0x0, f},
	{"com.kh", &z[762], x, s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"edu.kh", &z[762], x, s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"gov.kh", &z[762], x, s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"mil.kh", &z[762], x, s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"net.kh", &z[762], x, s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"org.kh", &z[762], x, s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"per.kh", &z[762], x, s{"dns1.online.com.kh", "ns.camnet.com.kh", "ns1.dns.net.kh", "ns4.apnic.net"}, n, n, e, e, e, 0x0, f},
	{"biz.ki", &z[763], x, s{"ns.cocca.fr", "pch.nic.ki"}, n, n, e, e, e, 0x0, f},
	{"com.ki", &z[763], x, s{"ns.cocca.fr", "pch.nic.ki"}, n, n, e, e, e, 0x0, f},
	{"edu.ki", &z[763], x, s{"ns.cocca.fr", "pch.nic.ki"}, n, n, e, e, e, 0x0, f},
	{"eu.ki", &z[763], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "eu.ki"}, n, e, e, e, 0x200, t},
	{"gov.ki", &z[763], x, s{"ns.cocca.fr", "pch.nic.ki"}, n, n, e, e, e, 0x0, f},
	{"info.ki", &z[763], x, s{"ns.cocca.fr", "pch.nic.ki"}, n, n, e, e, e, 0x0, f},
	{"mob.ki", &z[763], x, n, n, n, e, e, e, 0x0, f},
	{"mobi.ki", &z[763], x, n, n, n, e, e, e, 0x0, f},
	{"net.ki", &z[763], x, s{"ns.cocca.fr", "pch.nic.ki"}, n, n, e, e, e, 0x0, f},
	{"org.ki", &z[763], x, s{"ns.cocca.fr", "pch.nic.ki"}, n, n, e, e, e, 0x0, f},
	{"phone.ki", &z[763], x, n, n, n, e, e, e, 0x0, f},
	{"tel.ki", &z[763], x, n, n, n, e, e, e, 0x0, f},
	{"asso.km", &z[773], x, n, n, n, e, e, e, 0x800, f},
	{"com.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"coop.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"edu.km", &z[773], x, s{"dns1.nic.km", "dns2.nic.km"}, n, n, e, e, e, 0x0, f},
	{"gouv.km", &z[773], x, s{"dns1.nic.km", "dns2.nic.km"}, n, n, e, e, e, 0x0, f},
	{"medecin.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"mil.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"nom.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"notaires.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"org.km", &z[773], x, s{"dns1.nic.km", "dns2.nic.km"}, n, n, e, e, e, 0x0, t},
	{"pharmaciens.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"presse.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"tm.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"veterinaire.km", &z[773], x, n, n, n, e, e, e, 0x0, f},
	{"co.kn", &z[774], x, s{"ns.cocca.fr", "pch.nic.kn"}, n, n, e, e, e, 0x0, t},
	{"com.kn", &z[774], x, s{"ns.cocca.fr", "pch.nic.kn"}, n, n, e, e, e, 0x0, f},
	{"edu.kn", &z[774], x, s{"ns.cocca.fr", "pch.nic.kn"}, n, n, e, e, e, 0x0, f},
	{"gov.kn", &z[774], x, s{"ns.cocca.fr", "pch.nic.kn"}, n, n, e, e, e, 0x0, f},
	{"net.kn", &z[774], x, s{"ns.cocca.fr", "ns.coccaregistry.org", "pch.nic.kn"}, n, n, e, e, e, 0x0, f},
	{"org.kn", &z[774], x, s{"ns.cocca.fr", "ns.coccaregistry.org", "pch.nic.kn"}, n, n, e, e, e, 0x0, f},
	{"com.kp", &z[780], x, s{"ns1.com.kp", "ns2.com.kp"}, n, n, e, e, e, 0x0, f},
	{"net.kp", &z[780], x, s{"ns1.net.kp", "ns2.net.kp"}, n, n, e, e, e, 0x0, f},
	{"org.kp", &z[780], x, s{"ns1.org.kp", "ns2.org.kp"}, n, n, e, e, e, 0x0, f},
	{"rep.kp", &z[780], x, s{"ns1.rep.kp", "ns2.rep.kp"}, n, n, e, e, e, 0x0, f},
	{"ac.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"busan.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"chungbuk.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"chungnam.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"co.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"daegu.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"daejeon.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"es.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"gangwon.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"go.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"gwangju.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"gyeongbuk.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"gyeonggi.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"gyeongnam.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"hs.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"incheon.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"jeju.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"jeonbuk.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"jeonnam.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"kg.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"mil.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"ms.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"ne.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"or.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"pe.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"re.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"sc.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"seoul.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"ulsan.kr", &z[783], x, s{"b.dns.kr", "c.dns.kr", "d.dns.kr", "e.dns.kr", "f.dns.kr", "g.dns.kr"}, n, n, e, e, e, 0x0, f},
	{"com.kw", &z[787], x, s{"a.nic.kw", "b.nic.kw", "c.nic.kw", "d.nic.kw", "e.nic.kw", "pch.nic.kw"}, n, n, e, e, e, 0x0, f},
	{"edu.kw", &z[787], x, s{"a.nic.kw", "b.nic.kw", "c.nic.kw", "d.nic.kw", "e.nic.kw", "pch.nic.kw"}, n, n, e, e, e, 0x0, f},
	{"gov.kw", &z[787], x, s{"a.nic.kw", "b.nic.kw", "c.nic.kw", "d.nic.kw", "e.nic.kw", "pch.nic.kw"}, n, n, e, e, e, 0x0, f},
	{"net.kw", &z[787], x, s{"a.nic.kw", "b.nic.kw", "c.nic.kw", "d.nic.kw", "e.nic.kw", "pch.nic.kw"}, n, n, e, e, e, 0x0, f},
	{"org.kw", &z[787], x, s{"a.nic.kw", "b.nic.kw", "c.nic.kw", "d.nic.kw", "e.nic.kw", "pch.nic.kw"}, n, n, e, e, e, 0x0, f},
	{"com.ky", &z[788], x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, e, e, e, 0x0, f},
	{"edu.ky", &z[788], x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, e, e, e, 0x0, f},
	{"gov.ky", &z[788], x, s{"ns.gov.ky", "ns2.gov.ky"}, n, n, e, e, e, 0x0, f},
	{"net.ky", &z[788], x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, e, e, e, 0x0, f},
	{"org.ky", &z[788], x, s{"ns1.uniregistry.net", "ns2.uniregistry.info", "ns3.uniregistry.net", "ns4.uniregistry.info"}, n, n, e, e, e, 0x0, f},
	{"com.kz", &z[791], x, s{"ns.nic.kz", "ns2.nic.kz"}, n, n, e, e, e, 0x0, f},
	{"edu.kz", &z[791], x, s{"ns.nic.kz", "ns2.nic.kz"}, n, n, e, e, e, 0x0, f},
	{"gov.kz", &z[791], x, s{"ns.nic.kz", "ns2.nic.kz"}, n, n, e, e, e, 0x0, f},
	{"mil.kz", &z[791], x, s{"ns.nic.kz", "ns2.nic.kz"}, n, n, e, e, e, 0x0, f},
	{"net.kz", &z[791], x, s{"ns.nic.kz", "ns2.nic.kz"}, n, n, e, e, e, 0x0, f},
	{"org.kz", &z[791], x, s{"ns.nic.kz", "ns2.nic.kz"}, n, n, e, e, e, 0x0, f},
	{"com.lb", &z[809], x, s{"magma.aub.edu.lb", "rip.psg.com", "zeina.aub.edu.lb"}, n, n, e, e, e, 0x0, f},
	{"edu.lb", &z[809], x, s{"magma.aub.edu.lb", "rip.psg.com", "zeina.aub.edu.lb"}, n, n, e, e, e, 0x0, f},
	{"gov.lb", &z[809], x, s{"magma.aub.edu.lb", "rip.psg.com", "zeina.aub.edu.lb"}, n, n, e, e, e, 0x0, f},
	{"net.lb", &z[809], x, s{"magma.aub.edu.lb", "rip.psg.com", "zeina.aub.edu.lb"}, n, n, e, e, e, 0x0, f},
	{"org.lb", &z[809], x, s{"magma.aub.edu.lb", "rip.psg.com", "zeina.aub.edu.lb"}, n, n, e, e, e, 0x0, f},
	{"24.lc", &z[810], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.lc"}, n, e, e, e, 0x200, t},
	{"co.lc", &z[810], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"com.lc", &z[810], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"edu.lc", &z[810], x, s{"dns2.server.ag", "ns2.dnsserver.ag"}, n, n, e, e, e, 0x0, f},
	{"gov.lc", &z[810], x, s{"dns2.server.ag", "ns2.dnsserver.ag"}, n, n, e, e, e, 0x0, f},
	{"l.lc", &z[810], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"net.lc", &z[810], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"org.lc", &z[810], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"p.lc", &z[810], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org", "dns.server.ag"}, n, n, e, e, e, 0x0, f},
	{"assn.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"com.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"edu.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"gov.lk", &z[838], x, s{"c.nic.lk", "d.nic.lk", "m.nic.lk", "ns1.gov.lk", "ns2.gov.lk"}, n, n, e, e, e, 0x0, f},
	{"grp.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"hotel.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"int.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"ltd.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"net.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"ngo.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"org.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"sch.lk", &z[838], x, s{"ns1.sch.lk"}, n, n, e, e, e, 0x0, f},
	{"soc.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"web.lk", &z[838], x, n, n, n, e, e, e, 0x0, f},
	{"com.lr", &z[854], x, n, n, n, e, e, e, 0x0, f},
	{"edu.lr", &z[854], x, n, n, n, e, e, e, 0x0, f},
	{"gov.lr", &z[854], x, n, n, n, e, e, e, 0x0, f},
	{"net.lr", &z[854], x, n, n, n, e, e, e, 0x0, f},
	{"org.lr", &z[854], x, n, n, n, e, e, e, 0x0, f},
	{"vcom.lr", &z[854], x, n, n, n, e, e, e, 0x0, f},
	{"ac.ls", &z[855], x, s{"ls-ns.anycast.pch.net", "ns-ls.afrinic.net", "ns1.nic.ls", "ns2.nic.ls", "thaba.nul.ls"}, n, n, e, e, e, 0x0, t},
	{"co.ls", &z[855], x, s{"ls-ns.anycast.pch.net", "ns-ls.afrinic.net", "ns1.nic.ls", "ns2.nic.ls"}, n, n, e, e, e, 0x0, f},
	{"gov.ls", &z[855], x, s{"acst23ns01.gov.ls", "afdp23ns01.gov.ls", "secdns1.posix.co.za", "thaba.nul.ls"}, n, n, e, e, e, 0x0, t},
	{"net.ls", &z[855], x, s{"ls-ns.anycast.pch.net", "ns-ls.afrinic.net", "ns1.leo.co.ls", "ns1.nic.ls", "sas.leo.co.ls"}, n, n, e, e, e, 0x0, t},
	{"org.ls", &z[855], x, s{"ls-ns.anycast.pch.net", "ns-ls.afrinic.net", "ns1.nic.ls", "ns2.nic.ls"}, n, n, e, e, e, 0x0, f},
	{"parliament.ls", &z[855], x, s{"ls-ns.anycast.pch.net", "ns-ls.afrinic.net", "ns1.leo.co.ls", "sas.leo.co.ls"}, n, n, e, e, e, 0x0, t},
	{"gov.lt", &z[856], x, s{"ns2.domreg.lt", "ns3.domreg.lt", "ns3.is.lt", "ns4.is.lt"}, n, n, e, e, e, 0x0, f},
	{"asn.lv", &z[864], x, n, n, n, e, e, e, 0x0, f},
	{"com.lv", &z[864], x, n, n, n, e, e, e, 0x0, f},
	{"conf.lv", &z[864], x, n, n, n, e, e, e, 0x0, f},
	{"edu.lv", &z[864], x, n, n, n, e, e, e, 0x0, f},
	{"gov.lv", &z[864], x, s{"a.gov.lv", "b.gov.lv"}, n, n, e, e, e, 0x0, f},
	{"id.lv", &z[864], x, n, n, n, e, e, e, 0x0, f},
	{"mil.lv", &z[864], x, s{"ns1.mil.lv", "ns2.mil.lv"}, n, n, e, e, e, 0x0, f},
	{"net.lv", &z[864], x, n, n, n, e, e, e, 0x0, f},
	{"org.lv", &z[864], x, n, n, n, e, e, e, 0x0, f},
	{"com.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"edu.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"gov.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"id.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"med.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"net.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"org.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"plc.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"sch.ly", &z[865], x, n, n, n, e, e, e, 0x0, f},
	{"ac.ma", &z[866], x, s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "dns.inria.fr", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, e, e, e, 0x0, f},
	{"co.ma", &z[866], x, s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "dns.inria.fr", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, e, e, e, 0x0, f},
	{"gov.ma", &z[866], x, s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "dns.inria.fr", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, e, e, e, 0x0, f},
	{"net.ma", &z[866], x, s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "dns.inria.fr", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, e, e, e, 0x0, f},
	{"org.ma", &z[866], x, s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "dns.inria.fr", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, e, e, e, 0x0, f},
	{"press.ma", &z[866], x, s{"a.tld.ma", "b.tld.ma", "c.tld.ma", "d.tld.ma", "dns.inria.fr", "e.tld.ma", "f.tld.ma", "ns-ma.nic.fr"}, n, n, e, e, e, 0x0, f},
	{"asso.mc", &z[887], x, s{"mc.cctld.authdns.ripe.net", "ns1.nic.mc", "ns2.nic.mc"}, n, n, e, e, e, 0x0, f},
	{"tm.mc", &z[887], x, s{"mc.cctld.authdns.ripe.net", "ns1.nic.mc", "ns2.nic.mc"}, n, n, e, e, e, 0x0, f},
	{"ac.me", &z[892], x, s{"ns.ac.me", "ns2.ac.me"}, n, n, e, e, e, 0x0, f},
	{"co.me", &z[892], x, s{"a0.nic.me", "a2.nic.me", "b0.nic.me", "b2.nic.me", "c0.nic.me"}, n, n, e, e, e, 0x0, f},
	{"edu.me", &z[892], x, s{"ns.edu.me", "ns2.edu.me"}, n, n, e, e, e, 0x0, f},
	{"gov.me", &z[892], x, s{"ns.gov.me", "ns1.gov.me"}, n, n, e, e, e, 0x0, f},
	{"its.me", &z[892], x, s{"a0.nic.me", "a2.nic.me", "b0.nic.me", "b2.nic.me", "c0.nic.me"}, n, n, e, e, e, 0x0, f},
	{"net.me", &z[892], x, s{"a0.nic.me", "a2.nic.me", "b0.nic.me", "b2.nic.me", "c0.nic.me"}, n, n, e, e, e, 0x0, f},
	{"org.me", &z[892], x, s{"a0.nic.me", "a2.nic.me", "b0.nic.me", "b2.nic.me", "c0.nic.me"}, n, n, e, e, e, 0x0, f},
	{"priv.me", &z[892], x, s{"a0.nic.me", "a2.nic.me", "b0.nic.me", "b2.nic.me", "c0.nic.me"}, n, n, e, e, e, 0x0, f},
	{"co.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns-mg.malagasy.com", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"com.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns-mg.malagasy.com", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"edu.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"gov.mg", &z[907], x, s{"ns.gov.mg", "ns2.gov.mg"}, n, n, e, e, e, 0x0, f},
	{"in.mg", &z[907], x, s{"ns1.in.mg", "ns2.in.mg"}, n, n, e, e, e, 0x0, t},
	{"mil.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"net.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns-mg.malagasy.com", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"nom.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns-mg.malagasy.com", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"org.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns-mg.malagasy.com", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"prd.mg", &z[907], x, s{"censvrns0001.ird.fr", "ns-mg.malagasy.com", "ns.dts.mg", "ns.nic.mg", "pch.nic.mg"}, n, n, e, e, e, 0x0, f},
	{"tm.mg", &z[907], x, n, n, n, e, e, e, 0x0, f},
	{"com.mk", &z[919], x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, e, e, e, 0x0, f},
	{"edu.mk", &z[919], x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, e, e, e, 0x0, f},
	{"gov.mk", &z[919], x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, e, e, e, 0x0, f},
	{"inf.mk", &z[919], x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, e, e, e, 0x0, f},
	{"name.mk", &z[919], x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, e, e, e, 0x0, f},
	{"net.mk", &z[919], x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, e, e, e, 0x0, f},
	{"org.mk", &z[919], x, s{"d.ext.nic.cz", "dns-mk.univie.ac.at", "ns2.arnes.si", "tld1.marnet.mk"}, n, n, e, e, e, 0x0, f},
	{"pro.mk", &z[919], x, s{"ns1.pro.mk", "ns2.pro.mk", "ns3.pro.mk", "ns4.pro.mk"}, s{"162.218.232.95"}, n, e, e, e, 0x0, t},
	{"com.ml", &z[920], x, s{"djamako.nic.ml", "dns.gouv.ml"}, n, n, e, e, e, 0x0, f},
	{"edu.ml", &z[920], x, s{"dns01.gouv.ml", "dns02.gouv.ml"}, n, n, e, e, e, 0x0, t},
	{"gov.ml", &z[920], x, s{"dns01.gouv.ml", "dns02.gouv.ml"}, n, n, e, e, e, 0x0, f},
	{"net.ml", &z[920], x, s{"dns01.gouv.ml", "dns02.gouv.ml"}, n, n, e, e, e, 0x0, f},
	{"org.ml", &z[920], x, s{"dns01.gouv.ml", "dns02.gouv.ml"}, n, n, e, e, e, 0x0, f},
	{"presse.ml", &z[920], x, s{"ns1.nicdumali.presse.ml", "ns2.nicdumali.presse.ml", "ns3.nicdumali.presse.ml"}, n, n, e, e, e, 0x0, f},
	{"biz.mm", &z[923], x, s{"a.nic.net.mm", "b.nic.net.mm", "c.nic.net.mm", "d.nic.net.mm"}, n, n, e, e, e, 0x0, f},
	{"com.mm", &z[923], x, s{"a.nic.net.mm", "b.nic.net.mm", "c.nic.net.mm", "d.nic.net.mm"}, n, n, e, e, e, 0x0, f},
	{"edu.mm", &z[923], x, s{"a.nic.net.mm", "b.nic.net.mm", "c.nic.net.mm", "d.nic.net.mm"}, n, n, e, e, e, 0x0, f},
	{"gov.mm", &z[923], x, s{"a.nic.net.mm", "b.nic.net.mm", "c.nic.net.mm", "d.nic.net.mm"}, n, n, e, e, e, 0x0, f},
	{"mil.mm", &z[923], x, s{"master.mil.mm", "ns1.mil.mm", "ns2.mil.mm"}, n, n, e, e, e, 0x0, t},
	{"net.mm", &z[923], x, s{"a.nic.net.mm", "b.nic.net.mm", "c.nic.net.mm", "d.nic.net.mm"}, n, n, e, e, e, 0x0, f},
	{"org.mm", &z[923], x, s{"a.nic.net.mm", "b.nic.net.mm", "c.nic.net.mm", "d.nic.net.mm"}, n, n, e, e, e, 0x0, f},
	{"per.mm", &z[923], x, n, n, n, e, e, e, 0x0, f},
	{"edu.mn", &z[925], x, s{"ns.erdemnet.mn", "ns2.erdemnet.mn"}, n, n, e, e, e, 0x0, f},
	{"gov.mn", &z[925], x, s{"ns.gov.mn", "ns1.gov.mn", "ns3.gov.mn", "ns4.gov.mn"}, n, n, e, e, e, 0x0, f},
	{"org.mn", &z[925], x, s{"ns1.magic.mn", "ns3.magic.mn"}, n, n, e, e, e, 0x0, f},
	{"co.mo", &z[927], x, n, n, n, e, e, e, 0x0, t},
	{"com.mo", &z[927], x, s{"a.monic.mo", "b.monic.mo", "c.monic.mo", "d.monic.mo", "e.monic.mo", "ns17.cdns.net", "ns2.cuhk.edu.hk"}, n, n, e, e, e, 0x0, f},
	{"edu.mo", &z[927], x, s{"a.monic.mo", "b.monic.mo", "c.monic.mo", "d.monic.mo", "e.monic.mo", "ns17.cdns.net", "ns2.cuhk.edu.hk"}, n, n, e, e, e, 0x0, f},
	{"gov.mo", &z[927], x, s{"ns1.gov.mo", "ns2.gov.mo", "ns3.gov.mo", "ns4.gov.mo", "ns5.gov.mo"}, n, n, e, e, e, 0x0, f},
	{"net.mo", &z[927], x, s{"a.monic.mo", "b.monic.mo", "c.monic.mo", "d.monic.mo", "e.monic.mo", "ns17.cdns.net", "ns2.cuhk.edu.hk"}, n, n, e, e, e, 0x0, f},
	{"org.mo", &z[927], x, s{"a.monic.mo", "b.monic.mo", "c.monic.mo", "d.monic.mo", "e.monic.mo", "ns17.cdns.net", "ns2.cuhk.edu.hk"}, n, n, e, e, e, 0x0, f},
	{"co.mp", &z[949], x, s{"ns1.nic.net.mp", "ns2.nic.net.mp"}, n, n, e, e, e, 0x0, t},
	{"com.mp", &z[949], x, n, n, n, e, e, e, 0x0, f},
	{"gov.mp", &z[949], x, s{"ns1.nic.net.mp", "ns2.nic.net.mp"}, n, n, e, e, e, 0x0, f},
	{"org.mp", &z[949], x, s{"ns1.nic.net.mp", "ns2.nic.net.mp"}, n, n, e, e, e, 0x0, f},
	{"edu.mr", &z[951], x, s{"ns-mr.afrinic.net", "ns-mr.nic.fr", "ns-mr.nic.tn", "ns1.nic.mr", "ns2.nic.mr", "ns3.nic.mr"}, n, n, e, e, e, 0x0, t},
	{"gov.mr", &z[951], x, s{"dns.mauritania.mr", "dns2.mauritania.mr", "ns-mr.afrinic.net", "ns-mr.nic.fr", "ns-mr.nic.tn", "ns1.nic.mr"}, n, n, e, e, e, 0x0, f},
	{"org.mr", &z[951], x, s{"ns-mr.afrinic.net", "ns-mr.nic.fr", "ns-mr.nic.tn", "ns1.nic.mr", "ns2.nic.mr", "ns3.nic.mr"}, n, n, e, e, e, 0x0, t},
	{"perso.mr", &z[951], x, s{"ns-mr.afrinic.net", "ns-mr.nic.fr", "ns-mr.nic.tn", "ns1.nic.mr", "ns2.nic.mr", "ns3.nic.mr"}, n, n, e, e, e, 0x0, t},
	{"co.ms", &z[954], x, s{"ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"com.ms", &z[954], x, s{"ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"net.ms", &z[954], x, n, n, n, e, e, e, 0x0, t},
	{"org.ms", &z[954], x, s{"ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"com.mt", &z[956], x, s{"a.ns.mt", "b.ns.mt", "f.ns.mt", "p.ns.mt"}, n, n, e, e, e, 0x0, f},
	{"edu.mt", &z[956], x, s{"a.ns.mt", "b.ns.mt", "f.ns.mt", "p.ns.mt"}, n, n, e, e, e, 0x0, f},
	{"gov.mt", &z[956], x, s{"ns1-09.azure-dns.com", "ns2-09.azure-dns.net", "ns3-09.azure-dns.org", "ns4-09.azure-dns.info"}, n, n, e, e, e, 0x0, f},
	{"net.mt", &z[956], x, s{"a.ns.mt", "b.ns.mt", "f.ns.mt", "p.ns.mt"}, n, n, e, e, e, 0x0, f},
	{"org.mt", &z[956], x, s{"a.ns.mt", "b.ns.mt", "f.ns.mt", "p.ns.mt"}, n, n, e, e, e, 0x0, f},
	{"24.mu", &z[960], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.mu"}, n, e, e, e, 0x200, t},
	{"ac.mu", &z[960], x, s{"anycast1.irondns.net", "mu1.dyntld.net", "mu2.dyntld.net", "mu3.dyntld.net", "mu4.dyntld.net", "udns1.tld.mu"}, n, n, e, e, e, 0x0, f},
	{"co.mu", &z[960], x, s{"anycast1.irondns.net", "mu1.dyntld.net", "mu2.dyntld.net", "mu3.dyntld.net", "mu4.dyntld.net", "udns1.tld.mu"}, n, n, e, e, e, 0x0, t},
	{"com.mu", &z[960], x, s{"anycast1.irondns.net", "mu1.dyntld.net", "mu2.dyntld.net", "mu3.dyntld.net", "mu4.dyntld.net", "udns1.tld.mu"}, n, n, e, e, e, 0x0, f},
	{"gov.mu", &z[960], x, s{"ns0.gov.mu", "ns1.gov.mu", "ns2.gov.mu", "ns3.gov.mu", "ns4.gov.mu"}, n, n, e, e, e, 0x0, f},
	{"net.mu", &z[960], x, s{"anycast1.irondns.net", "mu1.dyntld.net", "mu2.dyntld.net", "mu3.dyntld.net", "mu4.dyntld.net", "udns1.tld.mu"}, n, n, e, e, e, 0x0, f},
	{"nom.mu", &z[960], x, s{"ns1.mu-dns.net", "ns2.mu-dns.net"}, s{"185.243.56.15"}, n, e, e, e, 0x0, f},
	{"or.mu", &z[960], x, s{"anycast1.irondns.net", "mu1.dyntld.net", "mu2.dyntld.net", "mu3.dyntld.net", "mu4.dyntld.net", "udns1.tld.mu"}, n, n, e, e, e, 0x0, f},
	{"org.mu", &z[960], x, s{"anycast1.irondns.net", "mu1.dyntld.net", "mu2.dyntld.net", "mu3.dyntld.net", "mu4.dyntld.net", "udns1.tld.mu"}, n, n, e, e, e, 0x0, f},
	{"aero.mv", &z[967], x, s{"mv-ns.anycast.pch.net", "ns-cache01.dhivehinet.net.mv", "ns.aero.mv", "ns2.dhivehinet.net.mv"}, n, n, e, e, "http://www.brunet.bn/products_webrelated_domain_main.htm", 0x0, f},
	{"biz.mv", &z[967], x, s{"webns.mv"}, n, n, e, e, e, 0x0, f},
	{"com.mv", &z[967], x, s{"mv-ns.anycast.pch.net", "ns.com.mv", "ns.dhivehinet.net.mv", "ns2.dhivehinet.net.mv"}, n, n, e, e, e, 0x0, f},
	{"coop.mv", &z[967], x, n, n, n, e, e, e, 0x0, f},
	{"edu.mv", &z[967], x, s{"mv-ns.anycast.pch.net", "ns.edu.mv", "ns1.edu.mv", "ns2.edu.mv"}, n, n, e, e, e, 0x0, f},
	{"gov.mv", &z[967], x, s{"mv-ns.anycast.pch.net", "ns.dhivehinet.net.mv", "ns.gov.mv", "ns2.dhivehinet.net.mv"}, n, n, e, e, e, 0x0, f},
	{"info.mv", &z[967], x, n, n, n, e, e, e, 0x0, f},
	{"int.mv", &z[967], x, n, n, n, e, e, e, 0x0, f},
	{"mil.mv", &z[967], x, n, n, n, e, e, e, 0x0, f},
	{"museum.mv", &z[967], x, n, n, n, e, e, e, 0x0, f},
	{"name.mv", &z[967], x, n, n, n, e, e, e, 0x0, f},
	{"net.mv", &z[967], x, s{"mv-ns.anycast.pch.net", "ns.net.mv", "ns2.dhivehinet.net.mv"}, n, n, e, e, e, 0x0, f},
	{"org.mv", &z[967], x, s{"mv-ns.anycast.pch.net", "ns.org.mv", "ns2.dhivehinet.net.mv"}, n, n, e, e, e, 0x0, f},
	{"pro.mv", &z[967], x, s{"host13.dhivehinet.net.mv"}, n, n, e, e, e, 0x0, f},
	{"ac.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "mw.cctld.authdns.ripe.net", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"co.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"com.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"coop.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "pch1.nic.mw", "rip.psg.com", "rip.psg.mw"}, n, n, e, e, e, 0x0, f},
	{"edu.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "mw.cctld.authdns.ripe.net", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"gov.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "mw.cctld.authdns.ripe.net", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"int.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "pch1.nic.mw", "rip.psg.com", "rip.psg.mw"}, n, n, e, e, e, 0x0, f},
	{"museum.mw", &z[968], x, s{"ns1.dns.com", "ns2.dns.com"}, n, n, e, e, e, 0x0, f},
	{"net.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"org.mw", &z[968], x, s{"chambo.sdnp.org.mw", "d.ext.nic.cz", "domwe.sdn.mw", "mw.cctld.authdns.ripe.net", "ns4.apnic.net", "pch1.nic.mw", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"com.mx", &z[969], x, s{"c.mx-ns.mx", "e.mx-ns.mx", "i.mx-ns.mx", "m.mx-ns.mx", "o.mx-ns.mx", "x.mx-ns.mx"}, n, n, e, e, e, 0x0, f},
	{"edu.mx", &z[969], x, s{"c.mx-ns.mx", "e.mx-ns.mx", "i.mx-ns.mx", "m.mx-ns.mx", "o.mx-ns.mx", "x.mx-ns.mx"}, n, n, e, e, e, 0x0, f},
	{"gob.mx", &z[969], x, s{"c.mx-ns.mx", "e.mx-ns.mx", "i.mx-ns.mx", "m.mx-ns.mx", "o.mx-ns.mx", "x.mx-ns.mx"}, n, n, e, e, e, 0x0, f},
	{"net.mx", &z[969], x, s{"c.mx-ns.mx", "e.mx-ns.mx", "i.mx-ns.mx", "m.mx-ns.mx", "o.mx-ns.mx", "x.mx-ns.mx"}, n, n, e, e, e, 0x0, f},
	{"org.mx", &z[969], x, s{"c.mx-ns.mx", "e.mx-ns.mx", "i.mx-ns.mx", "m.mx-ns.mx", "o.mx-ns.mx", "x.mx-ns.mx"}, n, n, e, e, e, 0x0, f},
	{"com.my", &z[970], x, s{"a.mynic.centralnic-dns.com", "b.mynic.centralnic-dns.com", "b.nic.my", "b1.nic.my", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, e, e, "http://about.museum/", 0x0, t},
	{"edi.my", &z[970], x, n, n, n, e, e, e, 0x800, t},
	{"edu.my", &z[970], x, s{"a.mynic.centralnic-dns.com", "b.mynic.centralnic-dns.com", "b.nic.my", "b1.nic.my", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"gov.my", &z[970], x, s{"a.mynic.centralnic-dns.com", "b.mynic.centralnic-dns.com", "b.nic.my", "b1.nic.my", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"mil.my", &z[970], x, s{"a.mynic.centralnic-dns.com", "b.mynic.centralnic-dns.com", "b.nic.my", "b1.nic.my", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"name.my", &z[970], x, s{"a.mynic.centralnic-dns.com", "b.mynic.centralnic-dns.com", "b.nic.my", "b1.nic.my", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"net.my", &z[970], x, s{"a.mynic.centralnic-dns.com", "b.mynic.centralnic-dns.com", "b.nic.my", "b1.nic.my", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"org.my", &z[970], x, s{"a.mynic.centralnic-dns.com", "b.mynic.centralnic-dns.com", "b.nic.my", "b1.nic.my", "c.mynic.centralnic-dns.com", "d.mynic.centralnic-dns.com"}, n, n, e, e, e, 0x0, f},
	{"ac.mz", &z[971], x, s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, e, e, e, 0x0, f},
	{"adv.mz", &z[971], x, s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, e, e, e, 0x0, f},
	{"co.mz", &z[971], x, s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, e, e, e, 0x0, f},
	{"edu.mz", &z[971], x, s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, e, e, e, 0x0, f},
	{"gov.mz", &z[971], x, s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, e, e, e, 0x0, f},
	{"net.mz", &z[971], x, s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, e, e, e, 0x0, t},
	{"org.mz", &z[971], x, s{"anyns.uem.mz", "dzowo.uem.mz", "ns-mz.afrinic.net", "oceano.uem.mz", "phloem.uoregon.edu", "zebra.uem.mz"}, n, n, e, e, e, 0x0, f},
	{"alt.na", &z[973], x, s{"katima.omadhina.net", "na-ns.anycast.pch.net", "ns-na.afrinic.net", "oneu.omadhina.co.na"}, n, n, e, e, e, 0x0, f},
	{"cc.na", &z[973], x, s{"beau.ns.cloudflare.com", "reza.ns.cloudflare.com"}, n, n, e, e, e, 0x0, f},
	{"co.na", &z[973], x, s{"katima.omadhina.net", "na-ns.anycast.pch.net", "ns-na.afrinic.net", "oneu.omadhina.net", "secdns1.posix.co.za"}, n, n, e, e, e, 0x0, f},
	{"com.na", &z[973], x, s{"katima.omadhina.net", "na-ns.anycast.pch.net", "ns-na.afrinic.net"}, n, n, e, e, e, 0x0, f},
	{"dr.na", &z[973], x, s{"ns1.click.na", "ns2.click.na"}, n, n, e, e, e, 0x0, f},
	{"edu.na", &z[973], x, s{"katima.omadhina.net", "na-ns.anycast.pch.net", "ns-na.afrinic.net", "oneu.omadhina.co.na"}, n, n, e, e, e, 0x0, f},
	{"in.na", &z[973], x, s{"ns21.cloudns.net", "ns22.cloudns.net", "ns23.cloudns.net", "ns24.cloudns.net"}, n, n, e, e, e, 0x0, f},
	{"info.na", &z[973], x, s{"clint.ns.cloudflare.com", "jocelyn.ns.cloudflare.com"}, n, n, e, e, e, 0x0, f},
	{"mobi.na", &z[973], x, n, n, n, e, e, e, 0x0, f},
	{"name.na", &z[973], x, n, n, n, e, e, e, 0x0, f},
	{"net.na", &z[973], x, s{"katima.omadhina.net", "na-ns.anycast.pch.net", "ns-na.afrinic.net", "oneu.omadhina.co.na"}, n, n, e, e, e, 0x0, f},
	{"of.na", &z[973], x, n, n, n, e, e, e, 0x0, f},
	{"or.na", &z[973], x, n, n, n, e, e, e, 0x0, f},
	{"org.na", &z[973], x, s{"katima.omadhina.net", "na-ns.anycast.pch.net", "ns-na.afrinic.net", "oneu.omadhina.co.na"}, n, n, e, e, e, 0x0, f},
	{"pro.na", &z[973], x, n, n, n, e, e, e, 0x800, f},
	{"school.na", &z[973], x, s{"beau.ns.cloudflare.com", "reza.ns.cloudflare.com"}, n, n, e, e, e, 0x0, f},
	{"tv.na", &z[973], x, n, n, n, e, e, e, 0x0, f},
	{"ws.na", &z[973], x, n, n, n, e, e, e, 0x0, f},
	{"kyrylkov.name", &z[977], x, n, n, n, e, e, e, 0x0, t},
	{"puig.name", &z[977], x, n, n, n, e, e, e, 0x0, t},
	{"santos.name", &z[977], x, n, n, n, e, e, e, 0x0, t},
	{"asso.nc", &z[983], x, s{"any-ns1.nc", "ns1.nc", "ns2.nc"}, n, n, e, e, e, 0x0, f},
	{"com.nc", &z[983], x, n, n, n, e, e, e, 0x0, t},
	{"nom.nc", &z[983], x, s{"any-ns1.nc", "ns1.nc", "ns2.nc"}, n, n, e, e, e, 0x0, f},
	{"com.ne", &z[984], x, n, n, n, e, e, e, 0x0, f},
	{"info.ne", &z[984], x, n, n, n, e, e, e, 0x0, f},
	{"int.ne", &z[984], x, n, n, n, e, e, e, 0x0, f},
	{"org.ne", &z[984], x, s{"sdns2.ovh.net", "vps241916.ovh.net"}, n, n, e, e, e, 0x0, f},
	{"perso.ne", &z[984], x, n, n, n, e, e, e, 0x0, f},
	{"1x.net", &z[986], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "1x.net"}, n, e, e, e, 0x200, t},
	{"auz.net", &z[986], x, s{"ns1.instradns.com", "ns2.instradns.com", "ns3.instradns.com"}, n, n, e, e, e, 0x0, f},
	{"gb.net", &z[986], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "gb.net"}, n, "whois.centralnic.com", e, e, 0x0, t},
	{"hu.net", &z[986], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "hu.net"}, n, "whois.centralnic.com", e, e, 0x0, f},
	{"in.net", &z[986], x, s{"ns1.nic.in.net", "ns2.nic.in.net", "ns3.nic.in.net", "ns4.nic.in.net"}, n, n, "whois.centralnic.com", e, e, 0x0, f},
	{"jp.net", &z[986], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"205.164.14.88"}, n, "whois.centralnic.com", e, e, 0x0, f},
	{"ru.net", &z[986], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"se.net", &z[986], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "se.net"}, n, "whois.centralnic.com", e, e, 0x0, t},
	{"uk.net", &z[986], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "uk.net"}, n, "whois.centralnic.com", e, e, 0x0, t},
	{"za.net", &z[986], x, s{"igubu.saix.net", "ns0.is.co.za", "ns0.plig.net", "ns1.plig.net", "ns2.plig.net", "ns3.iafrica.com"}, n, n, "whois.za.net", e, e, 0x0, t},
	{"arts.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"com.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"firm.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"info.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"net.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"org.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"other.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"per.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"rec.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"store.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"us.nf", &z[998], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "us.nf"}, n, e, e, e, 0x200, t},
	{"web.nf", &z[998], x, s{"ns.anycast.nic.nf", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"com.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"edu.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"gov.ng", &z[1000], z[5079:5080], s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"i.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, t},
	{"mil.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, t},
	{"mobi.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"name.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"net.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"org.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"sch.ng", &z[1000], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, f},
	{"ac.ni", &z[1003], x, s{"auth01.ns.uu.net", "dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"biz.ni", &z[1003], x, s{"auth01.ns.uu.net", "dns-ext.nic.cr", "dns.nic.cr", "ns.ibw.com.ni", "ns.ideay.net.ni", "ns.ni", "ns.tmx.com.ni", "ns.uu.net", "ns1.bb-online.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"co.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"com.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"edu.ni", &z[1003], x, s{"auth01.ns.uu.net", "dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"gob.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"gov.ni", &z[1003], x, n, n, n, e, e, e, 0x0, t},
	{"in.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"info.ni", &z[1003], x, s{"auth01.ns.uu.net", "dns-ext.nic.cr", "dns.nic.cr", "ns.ibw.com.ni", "ns.ideay.net.ni", "ns.ni", "ns.tmx.com.ni", "ns.uu.net", "ns1.bb-online.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"int.ni", &z[1003], x, s{"auth01.ns.uu.net", "dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns1.bb-online.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"mil.ni", &z[1003], x, s{"auth01.ns.uu.net", "dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"net.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"nom.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"org.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"web.ni", &z[1003], x, s{"dns-ext.nic.cr", "ns.ideay.net.ni", "ns.ni", "ns.uu.net", "ns2.ni", "ns3.ni"}, n, n, e, e, e, 0x0, f},
	{"24.nl", &z[1010], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.nl"}, n, e, e, e, 0x200, t},
	{"co.nl", &z[1010], x, s{"a.nic.co.nl", "b.nic.co.nl", "c.nic.co.nl", "d.nic.co.nl"}, n, n, e, e, e, 0x200, f},
	{"com.nl", &z[1010], x, s{"ns1.com.nl", "ns2.com.nl"}, s{"185.85.211.136"}, n, e, e, e, 0x200, f},
	{"net.nl", &z[1010], x, s{"ns1.com.nl", "ns2.com.nl"}, s{"185.85.211.136"}, n, e, e, e, 0x200, f},
	{"nom.nl", &z[1010], x, s{"ns1.hostnet.nl", "ns2.hostnetbv.com", "ns3.hostnetbv.nl"}, s{"136.144.154.12"}, n, e, e, e, 0x0, f},
	{"punt.nl", &z[1010], x, s{"ns1.metaregistrar.nl", "ns2.metaregistrar.nl"}, s{"2a05:d018:964:c0a:a58f:6b32:e401:3d8a", "34.240.216.169", "hosting-1a.mijndomein-ws.nl"}, n, e, e, "http://punt.nl", 0x200, f},
	{"co.no", &z[1011], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, n, n, e, e, "http://www.norid.no/index.en.html", 0x0, t},
	{"fhs.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"folkebibl.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"fylkesbibl.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"gs.no", &z[1011], x, s{"ns1.hyp.net", "ns2.hyp.net", "ns3.hyp.net"}, n, n, e, e, e, 0x0, f},
	{"idrett.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"museum.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"priv.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"uenorge.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"vgs.no", &z[1011], x, s{"x.nic.no", "y.nic.no", "z.nic.no"}, n, n, e, e, e, 0x0, f},
	{"academy.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"accountants.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"actor.np", &z[1019], x, s{"manaslu.mos.com.np", "np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np", "sungava.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"aero.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"agency.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"asia.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"associates.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"audio.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"bar.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"bargains.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"beer.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"bid.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"bike.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"bio.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"biz.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"black.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"blue.np", &z[1019], x, s{"np-ns.npix.net.np", "pch.nnic.np", "sec2.apnic.net"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"boutique.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"build.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"builders.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"buzz.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"cab.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"camera.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"camp.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"capital.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"cards.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"care.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"careers.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"cash.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"catering.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"center.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"ceo.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"christmas.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"clinic.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"clothing.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"club.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"codes.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"coffee.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"college.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"com.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"community.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"company.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"computer.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"cool.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"coop.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np", "sungava.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"country.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"credit.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"creditcard.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"dental.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"diamonds.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"edu.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns2.cosmicnepal.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"email.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"engineering.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"estate.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"events.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"expert.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"finance.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"financial.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"fish.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"fishing.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"fitness.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"flights.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"florist.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"fund.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"furniture.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"futbol.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"gallery.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"gov.np", &z[1019], x, s{"koshi.nitc.gov.np", "mechi.nitc.gov.np", "np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns-ext.vix.com", "ns-np.ripe.net", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "http://nitc.gov.np", 0x0, f},
	{"guitars.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"guru.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"hiphop.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"hiv.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"house.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"industries.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"info.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"ink.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"jobs.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"limited.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"link.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"management.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"marketing.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"media.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"menu.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"mil.np", &z[1019], x, s{"np.cctld.authdns.ripe.net", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"mobi.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"museum.np", &z[1019], x, s{"np-ns.npix.net.np", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"name.np", &z[1019], x, s{"np-ns.npix.net.np", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"net.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"ninja.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"onl.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"org.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"partners.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"parts.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"photo.np", &z[1019], x, s{"np-ns.npix.net.np", "np.cctld.authdns.ripe.net", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"photos.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"pics.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"pink.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"pro.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"productions.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"products.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"properties.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"pub.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"red.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"rentals.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"repair.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"rest.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"rocks.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"services.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"shiksha.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"shoes.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"social.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"solar.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"solutions.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"space.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"supplies.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"supply.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"support.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"surf.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"surgery.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"systems.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"tattoo.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"tax.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"technology.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"tel.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"tips.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"today.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"tools.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"town.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"trade.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"training.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"travel.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"university.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"vacations.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"ventures.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"villas.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"vision.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"vodka.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"voting.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"voyage.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"watch.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"webcam.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"wiki.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"works.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"wtf.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"xyz.np", &z[1019], x, s{"np-ns.npix.net.np", "ns-ext.vix.com", "ns4.apnic.net", "pch.nnic.np", "sec2.apnic.net", "shikhar.mos.com.np"}, n, n, e, e, "https://register.com.np", 0x0, f},
	{"zone.np", &z[1019], x, n, n, n, e, e, "https://register.com.np", 0x0, f},
	{"biz.nr", &z[1020], x, s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "ns2.cenpac.net.nr"}, n, n, e, e, e, 0x0, f},
	{"com.nr", &z[1020], x, s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "ns2.cenpac.net.nr", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"edu.nr", &z[1020], x, s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "ns2.cenpac.net.nr"}, n, n, e, e, e, 0x0, f},
	{"gov.nr", &z[1020], x, s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"info.nr", &z[1020], x, s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "ns2.cenpac.net.nr"}, n, n, e, e, e, 0x0, f},
	{"net.nr", &z[1020], x, s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "ns2.cenpac.net.nr", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"org.nr", &z[1020], x, s{"ns0.cenpac.net.nr", "ns1.cenpac.net.nr", "ns2.cenpac.net.nr", "phloem.uoregon.edu"}, n, n, e, e, e, 0x0, f},
	{"co.nu", &z[1024], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "co.nu"}, n, e, e, e, 0x200, t},
	{"com.nu", &z[1024], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "com.nu"}, n, e, e, e, 0x200, t},
	{"eu.nu", &z[1024], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "eu.nu"}, n, e, e, e, 0x200, t},
	{"ie.nu", &z[1024], x, s{"brain.bb-online.co.uk", "ns1.bb-online.net", "ns2.bb-online.net", "ns5.bb-online.net"}, n, n, e, e, e, 0x0, t},
	{"info.nu", &z[1024], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "info.nu"}, n, e, e, e, 0x200, t},
	{"ac.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"co.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"cri.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"geek.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"gen.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"govt.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"health.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, t},
	{"iwi.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"kiwi.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"maori.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"mil.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"net.nz", &z[1026], z[5080:5081], s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"org.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"parliament.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"school.nz", &z[1026], x, s{"ns1.dns.net.nz", "ns2.dns.net.nz", "ns3.dns.net.nz", "ns4.dns.net.nz", "ns5.dns.net.nz", "ns6.dns.net.nz", "ns7.dns.net.nz"}, n, n, e, e, e, 0x0, f},
	{"ac.om", &z[1037], x, n, n, n, e, e, e, 0x0, f},
	{"biz.om", &z[1037], x, n, n, n, e, e, e, 0x0, f},
	{"co.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"com.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"edu.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"gov.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"med.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"mil.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"museum.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"net.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"org.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"pro.om", &z[1037], x, s{"cctld.alpha.aridns.net.au", "cctld.beta.aridns.net.au", "cctld.delta.aridns.net.au", "cctld.gamma.aridns.net.au", "ns1.registry.om", "ns2.registry.om"}, n, n, e, e, e, 0x0, f},
	{"sch.om", &z[1037], x, n, n, n, e, e, e, 0x0, f},
	{"ae.org", &z[1048], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "ae.org"}, n, "whois.centralnic.com", e, e, 0x0, t},
	{"eu.org", &z[1048], z[5081:5133], s{"auth1.dns.elm.net", "dns4.gandi.net", "gra.wolfhugel.eu", "hobbes.bsd-dk.dk", "ns.bortzmeyer.eu.org", "ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net", "wombat.billaud.eu.org"}, n, n, "whois.eu.org", e, e, 0x0, t},
	{"hk.org", &z[1048], x, s{"a.udrtld.net", "b.udrtld.net", "c.udrtld.net", "dns7.cloudns.net", "dns8.cloudns.net"}, n, n, "whois.registry.hk.com", e, e, 0x0, f},
	{"js.org", &z[1048], x, s{"miles.ns.cloudflare.com", "pam.ns.cloudflare.com"}, n, n, e, e, e, 0x0, t},
	{"us.org", &z[1048], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, s{"54.153.56.183", "us.org"}, n, "whois.centralnic.com", e, e, 0x0, f},
	{"za.org", &z[1048], x, s{"igubu.saix.net", "ns0.is.co.za", "ns0.plig.net", "ns1.plig.net", "ns2.plig.net", "ns3.iafrica.com", "ns4.iafrica.com"}, n, n, "whois.za.org", e, e, 0x0, t},
	{"abo.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"ac.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"com.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"edu.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"gob.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"ing.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"med.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"net.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"nom.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"org.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"sld.pa", &z[1058], x, s{"dns-ext.nic.cr", "ns.dns.br", "ns.nic.pa", "ns.pa", "ns2.pa", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"com.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, f},
	{"edu.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, f},
	{"gob.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, f},
	{"gov.pe", &z[1074], x, n, n, n, e, e, e, 0x0, t},
	{"mil.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, f},
	{"net.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, f},
	{"nom.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, f},
	{"org.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, f},
	{"sld.pe", &z[1074], x, s{"a.lactld.org", "pch.rcp.pe", "pe1.dnsnode.net", "quipu.rcp.net.pe"}, n, n, e, e, e, 0x0, t},
	{"asso.pf", &z[1078], x, n, n, n, e, e, e, 0x0, f},
	{"com.pf", &z[1078], x, n, n, n, e, e, e, 0x0, f},
	{"edu.pf", &z[1078], x, n, n, n, e, e, e, 0x0, f},
	{"gov.pf", &z[1078], x, s{"ns1.gov.pf", "ns1.mana.pf", "ns2.gov.pf", "ns2.mana.pf", "reverse.gov.pf"}, n, n, e, e, e, 0x0, f},
	{"org.pf", &z[1078], x, n, n, n, e, e, e, 0x0, f},
	{"ac.pg", &z[1080], x, n, n, n, e, e, e, 0x0, f},
	{"com.pg", &z[1080], x, n, n, n, e, e, e, 0x0, f},
	{"gov.pg", &z[1080], x, n, n, n, e, e, e, 0x0, f},
	{"mil.pg", &z[1080], x, n, n, n, e, e, e, 0x0, f},
	{"net.pg", &z[1080], x, n, n, n, e, e, e, 0x0, f},
	{"org.pg", &z[1080], x, n, n, n, e, e, e, 0x0, f},
	{"com.ph", &z[1081], x, n, s{"45.79.222.138"}, n, e, e, e, 0x0, f},
	{"edi.ph", &z[1081], x, s{"ns1.dp47.parklogic.com", "ns2.dp47.parklogic.com", "ns3.dp47.parklogic.com", "ns4.dp47.parklogic.com", "ns5.dp47.parklogic.com"}, s{"72.52.179.175", "edi.ph"}, n, e, e, e, 0x0, t},
	{"edu.ph", &z[1081], x, s{"evans.gov.ph", "gabriela.ph.net", "gomez.ph.net", "ph.wegen-energy.com"}, n, n, e, e, e, 0x0, f},
	{"gov.ph", &z[1081], x, s{"gabriela.ph.net", "gomez.ph.net", "ns1.gov.ph", "ns2.gov.ph"}, n, n, e, e, e, 0x0, f},
	{"i.ph", &z[1081], x, s{"nsi1.domains.ph", "nsi2.domains.ph"}, n, n, e, e, e, 0x0, f},
	{"mil.ph", &z[1081], x, n, s{"45.79.222.138"}, n, e, e, e, 0x0, f},
	{"net.ph", &z[1081], x, n, s{"45.79.222.138"}, n, e, e, e, 0x0, f},
	{"ngo.ph", &z[1081], x, n, s{"45.79.222.138"}, n, e, e, e, 0x0, f},
	{"org.ph", &z[1081], x, n, s{"45.79.222.138"}, n, e, e, e, 0x0, f},
	{"biz.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"com.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"edu.pk", &z[1102], x, n, n, n, e, e, e, 0x0, t},
	{"fam.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"gkp.pk", &z[1102], x, n, n, n, e, e, e, 0x0, t},
	{"gob.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"gog.pk", &z[1102], x, n, n, n, e, e, e, 0x0, t},
	{"gok.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"gon.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"gop.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"gos.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"gov.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"net.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"org.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"web.pk", &z[1102], x, n, n, n, e, e, e, 0x0, f},
	{"agro.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, "http://tld.by/", 0x0, f},
	{"aid.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"art.pl", &z[1103], x, s{"bilbo.nask.org.pl", "hermes.sgh.waw.pl", "ns.tpnet.pl", "ns1.agh.edu.pl", "ns1.net.icm.edu.pl", "ns2.net.icm.edu.pl"}, n, n, e, e, e, 0x0, f},
	{"atm.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"augustow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"auto.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"babia-gora.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"bedzin.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"beskidy.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"bialowieza.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, t},
	{"bialystok.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"bielawa.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"bieszczady.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"biz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"boleslawiec.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"bydgoszcz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"bytom.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ciesyn.pl", &z[1103], x, n, n, n, e, e, e, 0x0, t},
	{"cieszyn.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"co.pl", &z[1103], x, s{"ns1.co.pl", "ns2.co.pl"}, n, n, "whois.co.pl", e, e, 0x0, t},
	{"com.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"czeladz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"czest.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"dlugoleka.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"edu.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"elblag.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"elk.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"gda.pl", &z[1103], x, s{"bilbo.nask.org.pl", "ns.tpnet.pl", "ns1.task.gda.pl", "ns2.task.gda.pl"}, n, n, e, e, e, 0x0, f},
	{"gdansk.pl", &z[1103], x, s{"bilbo.nask.org.pl", "ns.tpnet.pl", "ns1.task.gda.pl", "ns2.task.gda.pl"}, n, n, e, e, e, 0x0, f},
	{"glogow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"gmina.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"gniezno.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"gniezon.pl", &z[1103], x, n, n, n, e, e, e, 0x0, t},
	{"gorlice.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"gov.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"grajewo.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"gsm.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ilawa.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"info.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"jaworzno.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"jaworzono.pl", &z[1103], x, n, n, n, e, e, e, 0x0, t},
	{"jelenia-gora.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"jgora.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"kalisz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"karpacz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"kartuzy.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"kaszuby.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"katowice.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"kazimierz-dolny.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"kepno.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ketrzyn.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"klodzko.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"kobierzyce.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"kolobrzeg.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"konin.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"konskowola.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"krakow.pl", &z[1103], x, s{"bilbo.nask.org.pl", "dns.fuw.edu.pl", "info.cyf-kr.edu.pl", "nms.cyf-kr.edu.pl"}, n, n, e, e, e, 0x0, f},
	{"ksazuby.pl", &z[1103], x, n, n, n, e, e, e, 0x0, t},
	{"kutno.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"lapy.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"lebork.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"legnica.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"lezajsk.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"limanowa.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"lodz.pl", &z[1103], x, s{"dns.man.lodz.pl", "dns2.man.lodz.pl", "dns4.man.lodz.pl", "ns1.tpnet.pl"}, n, n, e, e, e, 0x0, f},
	{"lomza.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"lowicz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"lubin.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"lublin.pl", &z[1103], x, s{"bilbo.nask.org.pl", "ns1.lublin.pl", "ns2.lublin.pl"}, n, n, e, e, e, 0x0, f},
	{"lukow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"mail.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"malbork.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"malopolska.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"mazowsze.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"mazury.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"media.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"miasta.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"mielec.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"mielno.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"mil.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"mragowo.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"naklo.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"net.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ngo.pl", &z[1103], x, s{"ns1.ngo.pl", "ns2.ngo.pl"}, n, n, e, e, e, 0x0, f},
	{"nieruchomosci.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"nom.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"nowaruda.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"nysa.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"olawa.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"olecko.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"olkusz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"olsztyn.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"opoczno.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"opole.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"org.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ostroda.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ostroleka.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ostrowiec.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ostrowwlkp.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"pc.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"pila.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"pisz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"podhale.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"podlasie.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"polkowice.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"pomorskie.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"pomorze.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"powiat.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"poznan.pl", &z[1103], x, s{"bilbo.nask.org.pl", "dns.amu.edu.pl", "dns3.amu.edu.pl", "kirdan.nask.net.pl"}, n, n, e, e, e, 0x0, f},
	{"priv.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"prochowice.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"pruszkow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"przeworsk.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"pulawy.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"radom.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"rawa-maz.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"realestate.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"rel.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"rybnik.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"rzeszow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"sanok.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"sejny.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"sex.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x1, f},
	{"shop.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"sklep.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"skoczow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"slask.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"slupsk.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"sos.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"sosnowiec.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"stalowa-wola.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"starachowice.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"stargard.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"suwalki.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"swidnica.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"swiebodzin.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"swinoujscie.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"szczecin.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"szczytno.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"szkola.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"targi.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"tarnobrzeg.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"tgory.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"tm.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"torun.pl", &z[1103], x, s{"bilbo.nask.org.pl", "blackbox.uci.uni.torun.pl", "flis.man.torun.pl", "koala.uci.uni.torun.pl"}, n, n, e, e, e, 0x0, f},
	{"tourism.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"travel.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"turek.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"turystyka.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "d-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"tychy.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"ustka.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"walbrzych.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"warmia.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"warszawa.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"waw.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"wegrow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"wielun.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"wlocl.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"wloclawek.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"wodzislaw.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"wolomin.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"wroc.pl", &z[1103], x, s{"bilbo.nask.org.pl", "kirdan.nask.net.pl", "ldhpux.immt.pwr.wroc.pl", "ns1.net.icm.edu.pl", "sun2.pwr.wroc.pl", "wask.wask.wroc.pl"}, n, n, e, e, e, 0x0, f},
	{"wroclaw.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"zachpomor.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"zagan.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"zarow.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"zgora.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"zgorzelec.pl", &z[1103], x, s{"a-dns.pl", "b-dns.pl", "c-dns.pl", "e-dns.pl", "f-dns.pl", "g-dns.pl", "h-dns.pl", "i-dns.pl"}, n, n, e, e, e, 0x0, f},
	{"at.pn", &z[1110], z[5133:5134], n, n, n, e, e, e, 0x0, f},
	{"au.pn", &z[1110], z[5134:5135], n, n, n, e, e, e, 0x0, f},
	{"ca.pn", &z[1110], x, n, n, n, e, e, e, 0x0, f},
	{"ch.pn", &z[1110], x, n, n, n, e, e, e, 0x0, f},
	{"cn.pn", &z[1110], x, n, n, n, e, e, e, 0x0, f},
	{"co.pn", &z[1110], x, s{"dns1.nominetdns.uk", "dns4.nominetdns.uk", "ns0.pitcairn.net.pn", "ns1.pitcairn.net.pn"}, n, n, e, e, e, 0x0, f},
	{"de.pn", &z[1110], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"edu.pn", &z[1110], x, s{"dns1.nominetdns.uk", "dns4.nominetdns.uk", "ns0.pitcairn.net.pn", "ns1.pitcairn.net.pn"}, n, n, e, e, e, 0x0, f},
	{"es.pn", &z[1110], x, s{"ns-1377.awsdns-44.org", "ns-1574.awsdns-04.co.uk", "ns-29.awsdns-03.com", "ns-723.awsdns-26.net"}, n, n, e, e, e, 0x0, f},
	{"eu.pn", &z[1110], x, n, n, n, e, e, e, 0x800, f},
	{"fr.pn", &z[1110], x, n, n, n, e, e, e, 0x800, f},
	{"gov.pn", &z[1110], x, s{"dns1.nominetdns.uk", "dns4.nominetdns.uk", "ns0.pitcairn.net.pn", "ns1.pitcairn.net.pn"}, n, n, e, e, e, 0x0, f},
	{"in.pn", &z[1110], x, s{"ns-1425.awsdns-50.org", "ns-1677.awsdns-17.co.uk", "ns-441.awsdns-55.com", "ns-906.awsdns-49.net"}, n, n, e, e, e, 0x0, t},
	{"it.pn", &z[1110], x, s{"ns1.speedydns.net", "ns2.speedydns.net"}, n, n, e, e, e, 0x0, f},
	{"jp.pn", &z[1110], x, n, n, n, e, e, e, 0x800, f},
	{"net.pn", &z[1110], x, s{"dns1.nominetdns.uk", "dns4.nominetdns.uk", "ns0.pitcairn.net.pn", "ns1.pitcairn.net.pn"}, n, n, e, e, e, 0x0, f},
	{"org.pn", &z[1110], x, s{"dns1.nominetdns.uk", "dns4.nominetdns.uk", "ns0.pitcairn.net.pn", "ns1.pitcairn.net.pn"}, n, n, e, e, e, 0x0, f},
	{"uk.pn", &z[1110], z[5135:5136], n, n, n, e, e, e, 0x800, f},
	{"us.pn", &z[1110], x, n, n, n, e, e, e, 0x0, f},
	{"ac.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"ag.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"ai.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"alumni.pr", &z[1118], x, s{"descartes.nic.pr", "golomb.nic.pr", "pascal.nic.pr", "pr-dns.denic.de", "pr-ns.anycast.pch.net"}, n, n, e, e, e, 0x0, t},
	{"at.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"au.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"aw.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"bb.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"biz.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"bm.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"br.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"bs.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"ch.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"cl.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"cn.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"com.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"de.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"dm.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"do.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"edu.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"en.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"es.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"est.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"eu.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"exalumnos.pr", &z[1118], x, s{"descartes.nic.pr", "golomb.nic.pr", "pascal.nic.pr", "pr-dns.denic.de", "pr-ns.anycast.pch.net"}, n, n, e, e, e, 0x0, t},
	{"fr.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"gd.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"gov.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"gp.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"ht.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"info.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"isla.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"it.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"jm.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"jp.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"ky.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"lc.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"ms.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"mx.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"name.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"net.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"nl.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"nom.pr", &z[1118], x, n, n, n, e, e, e, 0x0, f},
	{"org.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"pro.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"prof.pr", &z[1118], x, s{"a0.pr.afilias-nst.info", "a2.pr.afilias-nst.info", "b0.pr.afilias-nst.org", "b2.pr.afilias-nst.org", "c0.pr.afilias-nst.info", "d0.pr.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"tc.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"tt.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"uk.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"us.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"vg.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"vi.pr", &z[1118], x, n, n, n, e, e, e, 0x800, f},
	{"aaa.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"aca.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"acct.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"arc.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"avocat.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"bar.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"bus.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"cfp.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"chi.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"chiro.pro", &z[1123], x, s{"dns111.ovh.net", "ns111.ovh.net"}, n, n, e, e, e, 0x0, f},
	{"cpa.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"dds.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"den.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"dent.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"ed.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"eng.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"jur.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"law.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"med.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"min.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"nitr.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"nur.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"nurse.pro", &z[1123], x, s{"park1.encirca.net", "park2.encirca.net"}, s{"107.23.61.162", "52.207.204.172", "52.70.72.251", "54.87.195.23"}, n, e, e, e, 0x0, f},
	{"opt.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"pa.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"pha.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"pharma.pro", &z[1123], x, s{"ns1.sedoparking.com", "ns2.sedoparking.com"}, s{"91.195.241.136"}, n, e, e, e, 0x0, f},
	{"pod.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"pr.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"prof.pro", &z[1123], x, s{"dns1.encirca.net", "dns2.encirca.net"}, n, n, e, e, e, 0x0, f},
	{"prx.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"pt.pro", &z[1123], x, n, n, n, e, e, e, 0x0, t},
	{"recht.pro", &z[1123], x, s{"a0.pro.afilias-nst.info", "a2.pro.afilias-nst.info", "b0.pro.afilias-nst.org", "b2.pro.afilias-nst.org", "c0.pro.afilias-nst.info", "d0.pro.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"rel.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"teach.pro", &z[1123], x, s{"curitiba.porkbun.com", "fortaleza.porkbun.com", "maceio.porkbun.com", "salvador.porkbun.com"}, s{"44.227.76.166", "pixie.porkbun.com"}, n, e, e, e, 0x0, f},
	{"vet.pro", &z[1123], x, n, n, n, e, e, e, 0x0, f},
	{"com.ps", &z[1134], x, s{"ns1.pnina.ps", "ns2.pnina.ps", "ote.pnina.ps", "ps-ns.anycast.pch.net", "ps.cctld.authdns.ripe.net", "rip.psg.com"}, n, n, e, e, "http://www.pnina.ps/domains/registration-policy/", 0x0, f},
	{"edu.ps", &z[1134], x, s{"dns1.gov.ps", "dns3.gov.ps", "dns4.pna.ps", "ns1.gov.ps", "ns1.pnina.ps", "ns2.pnina.ps", "ote.pnina.ps"}, n, n, e, e, "http://www.tonic.to/", 0x0, f},
	{"gov.ps", &z[1134], x, s{"dns1.gov.ps", "ns1.gov.ps", "ns1.palgov.net"}, n, n, e, e, e, 0x0, f},
	{"mobi.ps", &z[1134], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "mobi.ps"}, n, e, e, e, 0x200, t},
	{"mun.ps", &z[1134], x, s{"dns1.gov.ps", "dns2.gov.ps", "ns1.gov.ps", "ns2.pnina.ps"}, n, n, e, e, e, 0x0, f},
	{"net.ps", &z[1134], x, s{"ns1.pnina.ps", "ns2.pnina.ps", "ote.pnina.ps", "ps-ns.anycast.pch.net", "ps.cctld.authdns.ripe.net", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"org.ps", &z[1134], x, s{"ns1.pnina.ps", "ns2.pnina.ps", "ote.pnina.ps", "ps-ns.anycast.pch.net", "ps.cctld.authdns.ripe.net", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"plo.ps", &z[1134], x, s{"dns3.gov.ps", "dns4.pna.ps"}, n, n, e, e, e, 0x0, t},
	{"sch.ps", &z[1134], x, s{"dns1.gov.ps", "dns3.gov.ps", "ns1.gov.ps", "ns1.pnina.ps", "ns2.pnina.ps"}, n, n, e, e, e, 0x0, f},
	{"co.pt", &z[1135], x, s{"os1.eurotux.com", "os3.eurotux.com"}, s{"195.22.20.163"}, n, e, e, e, 0x0, t},
	{"com.pt", &z[1135], x, n, n, n, e, e, e, 0x0, t},
	{"edu.pt", &z[1135], x, n, n, n, e, e, e, 0x0, f},
	{"gov.pt", &z[1135], x, s{"a.dns.pt", "dns1.gov.pt", "europe1.dnsnode.net", "ns02.fccn.pt", "nsp.dnsnode.net"}, n, n, e, e, e, 0x0, f},
	{"int.pt", &z[1135], x, n, n, n, e, e, e, 0x0, f},
	{"net.pt", &z[1135], x, n, n, n, e, e, e, 0x0, f},
	{"nome.pt", &z[1135], x, n, n, n, e, e, e, 0x0, f},
	{"org.pt", &z[1135], x, n, n, n, e, e, e, 0x0, f},
	{"publ.pt", &z[1135], x, n, n, n, e, e, e, 0x0, f},
	{"belau.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, f},
	{"co.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, t},
	{"com.pw", &z[1137], x, s{"ns13.xincache.com", "ns14.xincache.com"}, n, n, e, e, e, 0x0, f},
	{"ed.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, t},
	{"edu.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, t},
	{"go.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, t},
	{"gov.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, f},
	{"ne.pw", &z[1137], x, s{"ns1.dns.com", "ns2.dns.com"}, n, n, e, e, e, 0x0, t},
	{"net.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, f},
	{"or.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, t},
	{"org.pw", &z[1137], x, s{"ns1390.ztomy.com", "ns2390.ztomy.com"}, s{"141.8.226.59"}, n, e, e, e, 0x0, f},
	{"com.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"coop.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"edu.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"gov.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"mil.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"net.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"org.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "l.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"una.py", &z[1139], x, s{"b.dns.py", "c.dns.py", "m.dns.py", "p.dns.py", "u.dns.py"}, n, n, e, e, e, 0x0, f},
	{"com.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, f},
	{"edu.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, t},
	{"gov.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, t},
	{"mil.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, t},
	{"name.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, f},
	{"net.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, f},
	{"org.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, t},
	{"sch.qa", &z[1140], x, s{"a.registry.qa", "b.registry.qa", "c.registry.qa", "d.registry.qa", "e.registry.qa", "f.registry.qa", "g.registry.qa", "h.registry.qa", "i.registry.qa"}, n, n, e, e, e, 0x0, t},
	{"asso.re", &z[1150], x, n, n, n, e, e, e, 0x0, f},
	{"com.re", &z[1150], x, n, n, n, e, e, e, 0x0, f},
	{"nom.re", &z[1150], x, n, n, n, e, e, e, 0x0, f},
	{"arts.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"co.ro", &z[1185], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, n, n, e, e, e, 0x0, f},
	{"com.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"firm.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"info.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"ne.ro", &z[1185], x, s{"ns1.eunoc.net", "ns2.eunoc.net", "ns3.eunoc.net"}, s{"185.27.255.9", "now.co.ro"}, n, e, e, e, 0x0, f},
	{"nom.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"nt.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"or.ro", &z[1185], x, s{"ns1.eunoc.net", "ns2.eunoc.net", "ns3.eunoc.net"}, s{"185.27.255.9", "now.co.ro"}, n, e, e, e, 0x0, f},
	{"org.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"rec.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"ro.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"sa.ro", &z[1185], x, s{"ns1.eunoc.net", "ns2.eunoc.net", "ns3.eunoc.net"}, s{"185.27.255.9", "now.co.ro"}, n, e, e, e, 0x0, f},
	{"srl.ro", &z[1185], x, s{"ns1.eunoc.net", "ns2.eunoc.net", "ns3.eunoc.net"}, s{"185.27.255.9", "now.co.ro"}, n, e, e, e, 0x0, f},
	{"store.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"tm.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"www.ro", &z[1185], x, n, n, n, e, e, e, 0x0, f},
	{"ac.rs", &z[1194], x, s{"ban.junis.ni.ac.rs", "gaea.rcub.bg.ac.rs", "ns.etf.bg.ac.rs", "ns.rcub.bg.ac.rs", "ns.unic.kg.ac.rs", "ns1.uns.ac.rs", "ns2.iif.hu", "odisej.telekom.rs"}, n, n, e, e, e, 0x0, t},
	{"co.rs", &z[1194], x, s{"a.nic.rs", "b.nic.rs", "g.nic.rs", "h.nic.rs", "l.nic.rs"}, n, n, e, e, e, 0x0, f},
	{"edu.rs", &z[1194], x, s{"a.nic.rs", "b.nic.rs", "g.nic.rs", "h.nic.rs", "l.nic.rs"}, n, n, e, e, e, 0x0, f},
	{"gov.rs", &z[1194], x, s{"dagda1.isp.telekom.rs", "ns1.gov.rs", "ns1.nic.rs", "ns2.gov.rs"}, n, n, e, e, e, 0x0, f},
	{"in.rs", &z[1194], x, s{"a.nic.rs", "b.nic.rs", "g.nic.rs", "h.nic.rs", "l.nic.rs"}, n, n, e, e, e, 0x0, f},
	{"org.rs", &z[1194], x, s{"a.nic.rs", "b.nic.rs", "g.nic.rs", "h.nic.rs", "l.nic.rs"}, n, n, e, e, e, 0x0, f},
	{"ac.ru", &z[1196], x, s{"ns-soa.darenet.dk", "ns1.free.net", "ns2.free.net"}, n, n, e, e, e, 0x0, f},
	{"adygeya.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"bashkiria.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"bir.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"cbg.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"com.ru", &z[1196], x, s{"ns3-com.nic.ru", "ns4-com.nic.ru", "ns8-com.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, f},
	{"dagestan.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"edu.ru", &z[1196], x, s{"ns.informika.ru", "ns.msu.ru", "ns.runnet.ru", "ns2.free.net", "ns2.informika.ru"}, n, n, "whois.informika.ru", e, e, 0x0, f},
	{"gov.ru", &z[1196], x, s{"acl.dns.ripn.net", "bcl.dns.ripn.net", "ccl.dns.ripn.net", "ns.gov.ru", "ns2.gov.ru"}, n, n, e, e, e, 0x0, f},
	{"grozny.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"int.ru", &z[1196], x, s{"ns.macomnet.ru", "ns2.macomnet.ru", "ns3.macomnet.ru"}, n, n, e, e, e, 0x0, f},
	{"kalmykia.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"kustanai.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"marine.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"mil.ru", &z[1196], x, s{"ns1.mil.ru", "ns2.mil.ru", "ns4.mil.ru"}, n, n, e, e, e, 0x0, f},
	{"mordovia.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"msk.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"185.76.145.93"}, n, e, e, e, 0x0, f},
	{"mytis.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"nalchik.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"net.ru", &z[1196], x, s{"a.dns-servers.net.ru", "b.dns-servers.net.ru", "d.dns-servers.net.ru", "e.dns-servers.net.ru", "f.dns-servers.net.ru"}, n, n, e, e, e, 0x0, f},
	{"nov.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"org.ru", &z[1196], x, s{"a.dns-servers.net.ru", "b.dns-servers.net.ru", "d.dns-servers.net.ru", "e.dns-servers.net.ru", "f.dns-servers.net.ru"}, n, n, e, e, e, 0x0, f},
	{"pp.ru", &z[1196], x, s{"a.dns-servers.net.ru", "b.dns-servers.net.ru", "d.dns-servers.net.ru", "e.dns-servers.net.ru", "f.dns-servers.net.ru"}, n, n, e, e, e, 0x0, f},
	{"pyatigorsk.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"relarn.ru", &z[1196], x, s{"int2.dns.ripn.net", "int3.dns.ripn.net", "ns.relarn.ru"}, n, n, e, e, e, 0x0, f},
	{"spb.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, f},
	{"vladikavkaz.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"vladimir.ru", &z[1196], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"ac.rw", &z[1200], x, s{"fork.sth.dnsnode.net", "ns-rw.afrinic.net", "ns1.ricta.org.rw", "ns3.ricta.org.rw", "pch.ricta.org.rw"}, n, n, e, e, e, 0x0, f},
	{"co.rw", &z[1200], x, s{"fork.sth.dnsnode.net", "ns-rw.afrinic.net", "ns1.ricta.org.rw", "ns3.ricta.org.rw", "pch.ricta.org.rw"}, n, n, e, e, e, 0x0, f},
	{"com.rw", &z[1200], x, n, n, n, e, e, e, 0x0, f},
	{"edu.rw", &z[1200], x, s{"fork.sth.dnsnode.net", "ns-rw.afrinic.net", "ns1.ricta.org.rw", "pch.ricta.org.rw"}, n, n, e, e, e, 0x0, f},
	{"gouv.rw", &z[1200], x, n, n, n, e, e, e, 0x0, f},
	{"gov.rw", &z[1200], x, s{"ns1.rdb.rw", "ns2.aos.rw", "ns3.aos.rw"}, n, n, e, e, e, 0x0, f},
	{"int.rw", &z[1200], x, n, n, n, e, e, e, 0x0, f},
	{"mil.rw", &z[1200], x, s{"fork.sth.dnsnode.net", "ns-rw.afrinic.net", "ns1.ricta.org.rw", "ns3.ricta.org.rw", "pch.ricta.org.rw"}, n, n, e, e, e, 0x0, f},
	{"net.rw", &z[1200], x, s{"fork.sth.dnsnode.net", "ns-rw.afrinic.net", "ns1.ricta.org.rw", "ns3.ricta.org.rw", "pch.ricta.org.rw"}, n, n, e, e, e, 0x0, f},
	{"org.rw", &z[1200], x, s{"fork.sth.dnsnode.net", "ns-rw.afrinic.net", "ns1.ricta.org.rw", "ns3.ricta.org.rw", "pch.ricta.org.rw"}, n, n, e, e, e, 0x0, f},
	{"com.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"edu.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"gov.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"med.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"net.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"org.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"pub.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"sch.sa", &z[1203], x, s{"c1.dns.sa", "c2.dns.sa", "i1.dns.sa", "n1.dns.sa", "p1.dns.sa", "s1.dns.sa", "s2.dns.sa"}, n, n, e, e, e, 0x0, f},
	{"com.sb", &z[1223], x, s{"ns.cocca.fr", "pch.nic.sb"}, n, n, e, e, e, 0x0, f},
	{"edu.sb", &z[1223], x, s{"ns.cocca.fr", "pch.nic.sb"}, n, n, e, e, e, 0x0, f},
	{"gov.sb", &z[1223], x, s{"ns.cocca.fr", "pch.nic.sb"}, n, n, e, e, e, 0x0, f},
	{"net.sb", &z[1223], x, s{"ns.cocca.fr", "pch.nic.sb"}, n, n, e, e, e, 0x0, f},
	{"org.sb", &z[1223], x, s{"ns.cocca.fr", "pch.nic.sb"}, n, n, e, e, e, 0x0, f},
	{"com.sc", &z[1226], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"edu.sc", &z[1226], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"gov.sc", &z[1226], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"net.sc", &z[1226], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"org.sc", &z[1226], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"com.sd", &z[1240], x, s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "ns.cocca.fr", "ns1.uaenic.ae", "ns2.uaenic.ae", "pch.sis.sd", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"edu.sd", &z[1240], x, s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "ns.cocca.fr", "pch.sis.sd", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"gov.sd", &z[1240], x, s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "ns.cocca.fr", "ns1.uaenic.ae", "ns2.uaenic.ae", "pch.sis.sd", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"info.sd", &z[1240], x, s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "ns.cocca.fr", "pch.sis.sd", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"med.sd", &z[1240], x, s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "ns.cocca.fr", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"net.sd", &z[1240], x, s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "ns.cocca.fr", "pch.sis.sd", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"org.sd", &z[1240], x, s{"ans1.canar.sd", "ans1.sis.sd", "ans2.canar.sd", "ns-sd.afrinic.net", "ns.cocca.fr", "pch.sis.sd", "sd.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"tv.sd", &z[1240], x, s{"ns1.domains.sd", "ns2.domains.sd"}, n, n, e, e, e, 0x0, f},
	{"a.se", &z[1241], x, n, n, n, e, e, e, 0x0, t},
	{"ac.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"b.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"bd.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"c.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"com.se", &z[1241], x, s{"ns1.centralnic.net", "ns2.centralnic.net", "ns3.centralnic.net", "ns4.centralnic.net"}, n, n, "whois.centralnic.com", e, e, 0x0, f},
	{"d.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"e.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"f.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"g.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"h.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"i.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"k.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"l.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"m.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"mil.se", &z[1241], x, s{"dns6.telia.com", "ns.defence.se", "ns.mil.se", "ns2.mil.se", "ns3.mil.se", "pitea.dns.swip.net"}, n, n, e, e, e, 0x0, f},
	{"n.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"o.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"org.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"p.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"parti.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"pp.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"press.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"r.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"s.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"t.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"tm.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"u.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"w.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"x.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"y.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"z.se", &z[1241], x, n, n, n, e, e, e, 0x0, f},
	{"com.sg", &z[1256], x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "pch.sgzones.sg"}, n, n, e, e, e, 0x0, t},
	{"edu.sg", &z[1256], x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "pch.sgzones.sg"}, n, n, e, e, e, 0x0, f},
	{"gov.sg", &z[1256], x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "pch.sgzones.sg"}, n, n, e, e, e, 0x0, f},
	{"net.sg", &z[1256], x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "pch.sgzones.sg"}, n, n, e, e, e, 0x0, f},
	{"org.sg", &z[1256], x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "pch.sgzones.sg"}, n, n, e, e, e, 0x0, f},
	{"per.sg", &z[1256], x, s{"dsany.sgnic.sg", "dsany2.sgnic.sg", "dsany3.sgnic.sg", "pch.sgzones.sg"}, n, n, e, e, e, 0x0, f},
	{"co.sh", &z[1257], x, n, n, n, e, e, e, 0x800, t},
	{"com.sh", &z[1257], x, n, n, n, e, e, e, 0x800, t},
	{"edu.sh", &z[1257], x, n, n, n, e, e, e, 0x800, t},
	{"gov.sh", &z[1257], x, n, n, n, e, e, e, 0x800, t},
	{"net.sh", &z[1257], x, n, n, n, e, e, e, 0x800, t},
	{"nom.sh", &z[1257], x, n, n, n, e, e, e, 0x800, t},
	{"org.sh", &z[1257], x, n, n, n, e, e, e, 0x800, t},
	{"ae.si", &z[1272], x, s{"ns1.anycastdns.cz", "ns2.anycastdns.cz"}, n, n, e, e, e, 0x0, f},
	{"at.si", &z[1272], x, s{"ns1.anycastdns.cz", "ns2.anycastdns.cz"}, n, n, e, e, e, 0x0, f},
	{"cn.si", &z[1272], x, s{"ns1.anycastdns.cz", "ns2.anycastdns.cz"}, n, n, e, e, e, 0x0, f},
	{"co.si", &z[1272], x, s{"b.ns14.net", "c.ns14.net", "d.ns14.net", "ns.2020.si"}, n, n, e, e, e, 0x0, f},
	{"de.si", &z[1272], x, s{"ns1.anycastdns.cz", "ns2.anycastdns.cz"}, n, n, e, e, e, 0x0, f},
	{"uk.si", &z[1272], x, s{"ns1.anycastdns.cz", "ns2.anycastdns.cz"}, n, n, e, e, e, 0x0, f},
	{"us.si", &z[1272], x, s{"ns1.anycastdns.cz", "ns2.anycastdns.cz"}, n, n, e, e, e, 0x0, f},
	{"com.sl", &z[1285], x, s{"ns1.neoip.com", "ns2.neoip.com"}, n, n, e, e, e, 0x0, f},
	{"edu.sl", &z[1285], x, s{"ns1.neoip.com"}, n, n, e, e, e, 0x0, t},
	{"gov.sl", &z[1285], x, s{"ns1.neoip.com", "ns2.neoip.com"}, n, n, e, e, e, 0x0, f},
	{"net.sl", &z[1285], x, s{"ns1.neoip.com", "ns2.neoip.com"}, n, n, e, e, e, 0x0, f},
	{"org.sl", &z[1285], x, s{"ns1.neoip.com", "ns2.neoip.com"}, n, n, e, e, e, 0x0, f},
	{"art.sn", &z[1290], x, s{"dns.ucad.sn", "ns.nic.sn", "ns.ucad.sn"}, n, n, e, e, e, 0x0, f},
	{"com.sn", &z[1290], x, s{"dns.ucad.sn", "ns.nic.sn", "ns.ucad.sn"}, n, n, e, e, e, 0x0, f},
	{"edu.sn", &z[1290], x, s{"dns.ucad.sn", "ns.nic.sn", "ns.ucad.sn"}, n, n, e, e, e, 0x0, f},
	{"gouv.sn", &z[1290], x, s{"ns.gouv.sn", "ns.ucad.sn", "ns2.gouv.sn", "ns3.gouv.sn"}, n, n, e, e, e, 0x0, t},
	{"org.sn", &z[1290], x, s{"dns.ucad.sn", "ns.nic.sn", "ns.ucad.sn"}, n, n, e, e, e, 0x0, f},
	{"perso.sn", &z[1290], x, s{"ns1.dns.com", "ns2.dns.com"}, n, n, e, e, e, 0x0, f},
	{"univ.sn", &z[1290], x, s{"dns.ucad.sn", "ns.nic.sn", "ns.ucad.sn"}, n, n, e, e, e, 0x0, t},
	{"com.so", &z[1292], x, s{"d.nic.so", "e.nic.so", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"edu.so", &z[1292], x, s{"d.nic.so", "e.nic.so", "ns.cocca.fr"}, n, n, e, e, e, 0x0, t},
	{"net.so", &z[1292], x, s{"d.nic.so", "e.nic.so", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"org.so", &z[1292], x, s{"d.nic.so", "e.nic.so", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"uber.space", &z[1304], x, s{"ns1.jonaspasche.com", "ns2.jonaspasche.com", "ns3.jonaspasche.com"}, n, n, e, e, e, 0x0, t},
	{"biz.ss", &z[1313], x, s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "pch.nic.ss"}, n, n, e, e, e, 0x0, t},
	{"com.ss", &z[1313], x, s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "pch.nic.ss"}, n, n, e, e, e, 0x0, t},
	{"edu.ss", &z[1313], x, s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "ssnic.anycastdns.cz"}, n, n, e, e, e, 0x0, t},
	{"me.ss", &z[1313], x, s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "root.nic.ss", "ssnic.anycastdns.cz"}, n, n, e, e, e, 0x0, t},
	{"net.ss", &z[1313], x, s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "pch.nic.ss"}, n, n, e, e, e, 0x0, t},
	{"org.ss", &z[1313], x, s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "pch.nic.ss"}, n, n, e, e, e, 0x0, t},
	{"sch.ss", &z[1313], x, s{"b.ns.tznic.or.tz", "ns-ss.afrinic.net", "ssnic.anycastdns.cz"}, n, n, e, e, e, 0x0, t},
	{"co.st", &z[1314], x, s{"ns1-se.ns.gov.st", "ns1-us.ns.gov.st", "ns2-se.ns.gov.st"}, n, n, e, e, e, 0x0, f},
	{"com.st", &z[1314], x, s{"ns1-se.ns.gov.st", "ns1-us.ns.gov.st", "ns2-se.ns.gov.st"}, n, n, e, e, e, 0x0, f},
	{"consulado.st", &z[1314], x, s{"ns1.bahnhof.net", "ns2.bahnhof.net"}, n, n, e, e, e, 0x0, f},
	{"edu.st", &z[1314], x, s{"ns1.nic.st", "ns2.nic.st", "ns3.nic.st"}, n, n, e, e, e, 0x0, f},
	{"embaixada.st", &z[1314], x, s{"ns1.bahnhof.net", "ns2.bahnhof.net"}, n, n, e, e, e, 0x0, t},
	{"embaizada.st", &z[1314], x, n, n, n, e, e, e, 0x0, f},
	{"gov.st", &z[1314], x, s{"ns1.gov.st", "ns2.gov.st"}, n, n, e, e, e, 0x0, f},
	{"mil.st", &z[1314], x, s{"ns.bahnhof.se", "ns2.bahnhof.net"}, n, n, e, e, e, 0x0, f},
	{"net.st", &z[1314], x, s{"ns1.nic.st", "ns2.nic.st", "ns3.nic.st"}, n, n, e, e, e, 0x0, f},
	{"org.st", &z[1314], x, s{"ns1.webhosting.st", "ns2.webhosting.st"}, n, n, e, e, e, 0x0, f},
	{"principe.st", &z[1314], x, s{"ns1.govhost.st", "ns2.govhost.st", "ns3.govhost.st"}, n, n, e, e, e, 0x0, f},
	{"saotome.st", &z[1314], x, s{"ns1.govhost.st", "ns2.govhost.st"}, n, n, e, e, e, 0x0, f},
	{"store.st", &z[1314], x, s{"ns.bahnhof.se", "ns2.bahnhof.net"}, n, n, e, e, e, 0x0, f},
	{"abkhazia.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"adygeya.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"aktyubinsk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"arkhangelsk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"armenia.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"ashgabad.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"azerbaijan.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"balashov.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"bashkiria.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"bryansk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"bukhara.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"chimkent.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"dagestan.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"east-kazakhstan.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"exnet.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"georgia.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"grozny.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"ivanovo.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"jambyl.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"kalmykia.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"kaluga.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"karacol.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"karaganda.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"karelia.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"khakassia.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"krasnodar.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"kurgan.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"kustanai.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"lenug.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"mangyshlak.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"mordovia.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"msk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"murmansk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"nalchik.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"navoi.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"north-kazakhstan.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"nov.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"obninsk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"penza.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"pokrovsk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"sochi.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"spb.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"tashkent.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"termez.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"togliatti.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"troitsk.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"tselinograd.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"tula.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"tuva.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"vladikavkaz.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"vladimir.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"vologda.su", &z[1332], x, s{"ns3-geo.nic.ru", "ns4-geo.nic.ru", "ns8-geo.nic.ru"}, s{"178.210.89.119"}, n, e, e, e, 0x0, t},
	{"com.sv", &z[1341], x, n, n, n, e, e, e, 0x0, f},
	{"edu.sv", &z[1341], x, n, n, n, e, e, e, 0x0, f},
	{"gob.sv", &z[1341], x, n, n, n, e, e, e, 0x0, f},
	{"org.sv", &z[1341], x, n, n, n, e, e, e, 0x0, f},
	{"red.sv", &z[1341], x, n, n, n, e, e, e, 0x0, f},
	{"com.sy", &z[1347], x, s{"ns1.tld.sy", "pch.anycast.tld.sy", "sy.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"edu.sy", &z[1347], x, s{"ns1.tld.sy", "pch.anycast.tld.sy", "sy.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"gov.sy", &z[1347], x, s{"ns1.tld.sy", "pch.anycast.tld.sy", "sy.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"mil.sy", &z[1347], x, s{"ns31.cloudns.net", "ns32.cloudns.net", "ns33.cloudns.net", "ns34.cloudns.net"}, n, n, e, e, e, 0x0, f},
	{"net.sy", &z[1347], x, s{"ns1.tld.sy", "pch.anycast.tld.sy", "sy.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"org.sy", &z[1347], x, s{"ns1.tld.sy", "pch.anycast.tld.sy", "sy.cctld.authdns.ripe.net"}, n, n, e, e, e, 0x0, f},
	{"ac.sz", &z[1351], x, n, n, n, e, e, e, 0x0, f},
	{"co.sz", &z[1351], x, n, n, n, e, e, e, 0x0, f},
	{"org.sz", &z[1351], x, n, n, n, e, e, e, 0x0, f},
	{"at.tc", &z[1363], z[5136:5137], s{"ns2572.servers-servers.com", "ns2573.servers-servers.com"}, n, n, e, e, e, 0x0, f},
	{"au.tc", &z[1363], z[5137:5138], s{"hera.ns.cloudflare.com", "jerome.ns.cloudflare.com"}, n, n, e, e, e, 0x0, f},
	{"be.tc", &z[1363], x, s{"ns1.be.tc", "ns2.be.tc"}, s{"213.136.89.177"}, n, e, e, e, 0x0, f},
	{"bg.tc", &z[1363], x, s{"dnsm1.nic.tc", "dnsm2.nic.tc", "dnsm3.nic.tc", "dnsm4.nic.tc"}, n, n, e, e, e, 0x800, f},
	{"biz.tc", &z[1363], x, s{"ns1.nudrv.com", "ns2.nudrv.com"}, s{"64.136.20.39"}, n, e, e, "http://www.biz.tc/", 0x0, f},
	{"br.tc", &z[1363], x, s{"dorthy.ns.cloudflare.com", "luke.ns.cloudflare.com"}, n, n, e, e, e, 0x0, f},
	{"ch.tc", &z[1363], x, s{"dns.voxel.sh", "voxeldns.net"}, n, n, e, e, e, 0x0, f},
	{"com.tc", &z[1363], x, s{"root1.zone.tc", "root2.zone.tc", "root3.zone.tc", "root4.zone.tc", "root5.zone.tc", "root6.zone.tc", "root7.zone.tc", "root8.zone.tc"}, n, n, e, e, e, 0x0, t},
	{"cz.tc", &z[1363], x, s{"ns1.ispapi.net", "ns2.ispapi.net", "ns3.ispapi.net"}, n, n, e, e, e, 0x0, f},
	{"de.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"dk.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"edu.tc", &z[1363], x, s{"root1.zone.tc", "root2.zone.tc", "root3.zone.tc", "root4.zone.tc", "root5.zone.tc", "root6.zone.tc", "root7.zone.tc", "root8.zone.tc"}, n, n, e, e, e, 0x0, f},
	{"es.tc", &z[1363], x, s{"ns1.es.tc", "ns2.es.tc"}, n, n, e, e, e, 0x0, t},
	{"eu.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"hk.tc", &z[1363], x, s{"drew.ns.cloudflare.com", "kia.ns.cloudflare.com"}, n, n, e, e, e, 0x0, f},
	{"hu.tc", &z[1363], x, n, n, n, e, e, e, 0x800, f},
	{"ie.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"int.tc", &z[1363], x, s{"ns1.int.tc", "ns2.int.tc"}, n, n, e, e, e, 0x0, f},
	{"it.tc", &z[1363], x, s{"ns0.dnsmadeeasy.com", "ns1.dnsmadeeasy.com", "ns3.dnsmadeeasy.com", "ns4.dnsmadeeasy.com"}, n, n, e, e, e, 0x0, f},
	{"kr.tc", &z[1363], x, s{"ns.udag.de", "ns.udag.net", "ns.udag.org"}, s{"89.31.143.1"}, n, e, e, e, 0x0, f},
	{"mx.tc", &z[1363], x, s{"leah.ns.cloudflare.com", "noah.ns.cloudflare.com"}, s{"104.27.156.189", "104.27.157.189", "172.67.175.218", "2606:4700:3031::681b:9cbd", "2606:4700:3034::681b:9dbd", "2606:4700:3036::ac43:afda"}, n, e, e, e, 0x0, f},
	{"net.tc", &z[1363], x, s{"root1.zone.tc", "root2.zone.tc", "root3.zone.tc", "root4.zone.tc", "root5.zone.tc", "root6.zone.tc", "root7.zone.tc"}, n, n, e, e, e, 0x0, f},
	{"no.tc", &z[1363], x, s{"betty.ns.cloudflare.com", "kai.ns.cloudflare.com"}, s{"77.79.104.210"}, n, e, e, e, 0x0, f},
	{"org.tc", &z[1363], x, s{"root1.zone.tc", "root2.zone.tc", "root3.zone.tc", "root4.zone.tc", "root5.zone.tc", "root6.zone.tc", "root7.zone.tc", "root8.zone.tc"}, n, n, e, e, e, 0x0, t},
	{"ph.tc", &z[1363], x, s{"ns1.openprovider.nl", "ns2.openprovider.be", "ns3.openprovider.eu"}, s{"196.196.233.154"}, n, e, e, e, 0x0, f},
	{"pl.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"pro.tc", &z[1363], x, s{"root1.zone.tc", "root2.zone.tc", "root3.zone.tc", "root4.zone.tc", "root5.zone.tc", "root6.zone.tc", "root7.zone.tc", "root8.zone.tc"}, n, n, e, e, e, 0x0, f},
	{"ru.tc", &z[1363], x, s{"ns17.above.com", "ns18.above.com"}, s{"103.224.182.250"}, n, e, e, e, 0x0, f},
	{"se.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"shop.tc", &z[1363], x, s{"ns.onshore.net", "ns2.onshore.net"}, n, n, e, e, e, 0x0, f},
	{"th.tc", &z[1363], x, s{"ns-cloud-b1.googledomains.com", "ns-cloud-b2.googledomains.com", "ns-cloud-b3.googledomains.com", "ns-cloud-b4.googledomains.com"}, n, n, e, e, e, 0x0, f},
	{"ua.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"uk.tc", &z[1363], z[5138:5141], s{"ns1.uk.tc", "ns2.uk.tc"}, n, n, e, e, e, 0x0, f},
	{"us.tc", &z[1363], x, n, n, n, e, e, e, 0x0, f},
	{"com.td", &z[1365], x, s{"ns-td.afrinic.net", "ns.cocca.fr", "pch.nic.td"}, n, n, e, e, e, 0x0, f},
	{"net.td", &z[1365], x, s{"ns-td.afrinic.net", "ns.cocca.fr", "nsa.nic.td", "pch.nic.td"}, n, n, e, e, e, 0x0, f},
	{"org.td", &z[1365], x, s{"ns-td.afrinic.net", "ns.cocca.fr", "nsa.nic.td", "pch.nic.td"}, n, n, e, e, e, 0x0, f},
	{"tourism.td", &z[1365], x, s{"ns.cocca.fr", "nsa.nic.td"}, n, n, e, e, e, 0x0, f},
	{"at.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"bg.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"ca.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"ch.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"cz.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"de.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"edu.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"eu.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"int.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"net.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"pl.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"ru.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"sg.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"us.tf", &z[1377], x, s{"ns1.idnscan.net", "ns2.idnscan.net"}, n, n, e, e, e, 0x0, f},
	{"ac.th", &z[1379], x, s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, e, e, e, 0x0, f},
	{"co.th", &z[1379], x, s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, e, e, e, 0x0, f},
	{"go.th", &z[1379], x, s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, e, e, e, 0x0, f},
	{"in.th", &z[1379], x, s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, e, e, e, 0x0, f},
	{"mi.th", &z[1379], x, s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, e, e, e, 0x0, f},
	{"net.th", &z[1379], x, s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, e, e, e, 0x0, f},
	{"or.th", &z[1379], x, s{"a.thains.co.th", "b.thains.co.th", "c.thains.co.th", "ns.thnic.net", "p.thains.co.th"}, n, n, e, e, e, 0x0, f},
	{"ac.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"aero.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"biz.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"co.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"com.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"coop.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"dyn.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"edu.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"go.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"gov.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"info.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"int.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"mil.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"museum.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"my.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"name.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"net.tj", &z[1395], x, n, n, n, e, e, e, 0x800, f},
	{"org.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"per.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"pro.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"web.tj", &z[1395], x, n, n, n, e, e, e, 0x0, f},
	{"24.tl", &z[1400], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "24.tl"}, n, e, e, e, 0x200, t},
	{"com.tl", &z[1400], x, s{"ns.anycast.nic.tl", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"gov.tl", &z[1400], x, s{"ns.anycast.nic.tl", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"in.tl", &z[1400], x, n, n, n, e, e, e, 0x800, f},
	{"na.tl", &z[1400], x, s{"ns1.afraid.org", "ns2.afraid.org", "ns3.afraid.org", "ns4.afraid.org"}, n, n, e, e, e, 0x0, t},
	{"net.tl", &z[1400], x, s{"ns.anycast.nic.tl", "ns.cocca.fr"}, n, n, e, e, e, 0x0, f},
	{"org.tl", &z[1400], x, s{"ns.anycast.nic.tl", "ns.cocca.fr", "ns.coccaregistry.org"}, n, n, e, e, e, 0x0, f},
	{"co.tm", &z[1401], x, s{"webns1.telecom.tm", "webns2.telecom.tm"}, n, n, e, e, e, 0x0, t},
	{"com.tm", &z[1401], x, s{"webns1.telecom.tm", "webns2.telecom.tm"}, n, n, e, e, e, 0x0, f},
	{"edu.tm", &z[1401], x, s{"webns1.telecom.tm", "webns2.telecom.tm"}, n, n, e, e, e, 0x0, f},
	{"gov.tm", &z[1401], x, s{"webns1.telecom.tm", "webns2.telecom.tm"}, n, n, e, e, e, 0x0, f},
	{"mil.tm", &z[1401], x, s{"webns1.telecom.tm", "webns2.telecom.tm"}, n, n, e, e, e, 0x0, t},
	{"net.tm", &z[1401], x, s{"ns05.telecom.tm", "ns06.telecom.tm", "webns1.telecom.tm", "webns2.telecom.tm"}, n, n, e, e, e, 0x0, f},
	{"nom.tm", &z[1401], x, n, n, n, e, e, e, 0x800, t},
	{"org.tm", &z[1401], x, s{"dns01.nic.tm", "dns1.nic.tm", "dns2.nic.tm", "dns3.nic.tm", "dns4.nic.tm", "dns5.nic.tm", "dns6.nic.tm", "dns7.nic.tm"}, n, n, e, e, e, 0x0, f},
	{"agrinet.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"com.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"defense.tn", &z[1403], x, s{"ns1.defense.tn", "ns2.defense.tn"}, n, n, e, e, e, 0x0, f},
	{"edunet.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"ens.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"fin.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"gov.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"ind.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"info.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"intl.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"mincom.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"nat.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"net.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"org.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"perso.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"rnrt.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"rns.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"rnu.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"tourism.tn", &z[1403], x, s{"ns1.ati.tn", "ns2.ati.tn"}, n, n, e, e, e, 0x0, f},
	{"com.tp", &z[1417], x, n, n, n, e, e, e, 0x800, f},
	{"or.tp", &z[1417], x, n, n, n, e, e, e, 0x800, f},
	{"org.tp", &z[1417], x, n, n, n, e, e, e, 0x800, f},
	{"av.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"bbs.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"bel.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"biz.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"com.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"dr.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"edu.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"gen.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"gov.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"info.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"k12.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"mil.tr", &z[1418], x, n, n, n, e, e, e, 0x0, t},
	{"name.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"nc.tr", &z[1418], x, s{"ns1.nc.tr", "ns2.nc.tr"}, n, n, e, e, e, 0x0, t},
	{"net.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"org.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"pol.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"tel.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"tsk.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"tv.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"web.tr", &z[1418], x, s{"lns21.nic.tr", "lns22.nic.tr", "lns31.nic.tr", "lns34.nic.tr", "lns35.nic.tr", "lns41.nic.tr", "lns42.nic.tr", "lns5.nic.tr", "lns61.nic.tr"}, n, n, e, e, e, 0x0, t},
	{"aero.tt", &z[1433], x, n, n, n, e, e, e, 0x0, t},
	{"at.tt", &z[1433], z[5141:5142], s{"a.ns.viennaweb.at", "b.ns.viennaweb.at"}, s{"195.225.236.206"}, n, e, e, e, 0x0, f},
	{"au.tt", &z[1433], z[5142:5143], n, n, n, e, e, e, 0x0, f},
	{"be.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"biz.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"ca.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"cat.tt", &z[1433], x, s{"ns-1084.awsdns-07.org", "ns-1826.awsdns-36.co.uk", "ns-455.awsdns-56.com", "ns-732.awsdns-27.net"}, n, n, e, e, e, 0x0, t},
	{"ch.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"co.tt", &z[1433], x, n, n, n, e, e, e, 0x0, t},
	{"com.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"coop.tt", &z[1433], x, n, n, n, e, e, e, 0x0, t},
	{"de.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"edu.tt", &z[1433], x, s{"ns1.edu.tt", "ns2.edu.tt"}, n, n, e, e, e, 0x0, f},
	{"es.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"eu.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"fr.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"gov.tt", &z[1433], x, s{"dns5.gov.tt", "dns6.gov.tt", "dns7.gov.tt", "dns8.gov.tt"}, n, n, e, e, e, 0x0, f},
	{"info.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"int.tt", &z[1433], x, s{"ns1.dnsdun.com", "ns1.dnsdun.net"}, n, n, e, e, e, 0x0, t},
	{"it.tt", &z[1433], x, s{"ns1.dnsv2.com", "ns2.dnsv2.com"}, n, n, e, e, e, 0x0, f},
	{"jobs.tt", &z[1433], x, s{"dns1.zoneedit.com", "dns2.zoneedit.com"}, n, n, e, e, e, 0x0, t},
	{"mobi.tt", &z[1433], x, n, n, n, e, e, e, 0x0, t},
	{"museum.tt", &z[1433], x, n, n, n, e, e, e, 0x0, t},
	{"name.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"net.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"nl.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"org.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"pro.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"tel.tt", &z[1433], x, n, n, n, e, e, e, 0x0, t},
	{"travel.tt", &z[1433], x, n, n, n, e, e, e, 0x800, t},
	{"uk.tt", &z[1433], z[5143:5146], n, n, n, e, e, e, 0x0, f},
	{"us.tt", &z[1433], x, n, n, n, e, e, e, 0x0, f},
	{"club.tw", &z[1440], x, s{"a.twnic.net.tw", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.dns.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"com.tw", &z[1440], x, s{"a.twnic.net.tw", "anytld.apnic.net", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.dns.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"ebiz.tw", &z[1440], x, s{"a.twnic.net.tw", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.dns.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"edu.tw", &z[1440], x, s{"a.twnic.net.tw", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "edudns-a2.edu.tw", "edudns-a3.edu.tw", "moemoon.edu.tw", "moestar.edu.tw"}, n, n, e, e, e, 0x0, t},
	{"game.tw", &z[1440], x, s{"a.twnic.net.tw", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.dns.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"gov.tw", &z[1440], x, s{"a.twnic.net.tw", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"idv.tw", &z[1440], x, s{"a.twnic.net.tw", "anytld.apnic.net", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.dns.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"mil.tw", &z[1440], x, s{"dns1.mil.tw", "dns2.mil.tw"}, n, n, e, e, e, 0x0, t},
	{"net.tw", &z[1440], x, s{"a.twnic.net.tw", "anytld.apnic.net", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.dns.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"org.tw", &z[1440], x, s{"a.twnic.net.tw", "anytld.apnic.net", "b.twnic.net.tw", "c.twnic.net.tw", "d.twnic.net.tw", "e.twnic.net.tw", "f.twnic.net.tw", "g.twnic.net.tw", "h.dns.tw", "h.twnic.net.tw"}, n, n, e, e, e, 0x0, t},
	{"xn--czrw28b.tw" /* 商業.tw */, &z[1440], x, n, n, n, e, e, "http://www.twnic.net.tw/", 0x0, t},
	{"xn--uc0atv.tw" /* 組織.tw */, &z[1440], x, n, n, n, e, e, "http://www.twnic.net.tw/", 0x0, t},
	{"xn--zf0ao64a.tw" /* 網路.tw */, &z[1440], x, n, n, n, e, e, "http://www.twnic.net.tw/", 0x0, t},
	{"ac.tz", &z[1441], x, s{"d.ext.nic.cz", "fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"co.tz", &z[1441], x, s{"d.ext.nic.cz", "fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"go.tz", &z[1441], x, s{"d.ext.nic.cz", "fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"hotel.tz", &z[1441], x, s{"fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz"}, n, n, e, e, e, 0x0, f},
	{"info.tz", &z[1441], x, s{"fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz"}, n, n, e, e, e, 0x0, f},
	{"me.tz", &z[1441], x, s{"fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz"}, n, n, e, e, e, 0x0, f},
	{"mil.tz", &z[1441], x, s{"fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz"}, n, n, e, e, e, 0x0, f},
	{"mobi.tz", &z[1441], x, s{"fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz"}, n, n, e, e, e, 0x0, f},
	{"ne.tz", &z[1441], x, s{"d.ext.nic.cz", "fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"or.tz", &z[1441], x, s{"d.ext.nic.cz", "fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"sc.tz", &z[1441], x, s{"fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz"}, n, n, e, e, e, 0x0, f},
	{"tv.tz", &z[1441], x, s{"fork.sth.dnsnode.net", "ns.anycast.co.tz", "ns2.tznic.or.tz"}, n, n, e, e, e, 0x0, f},
	{"biz.ua", &z[1442], x, s{"ns1.uadns.com", "ns2.uadns.com", "ns3.uadns.com"}, n, n, e, e, e, 0x0, f},
	{"cherkassy.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns2.km.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"cherkasy.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns2.km.ua"}, n, n, e, e, e, 0x0, t},
	{"chernigov.ua", &z[1442], x, s{"nix.ns.ua", "ns.dn.ua", "ns3.cn.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"chernivtsi.ua", &z[1442], x, s{"nix.ns.ua", "ns.cv.ua", "ns.kharkov.ua", "ns2.km.ua"}, n, n, e, e, e, 0x0, t},
	{"chernovtsy.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns.cv.ua", "ns2.km.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"ck.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns2.km.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"cn.ua", &z[1442], x, s{"nix.ns.ua", "ns.dn.ua", "ns3.cn.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"co.ua", &z[1442], x, s{"ns1.uadns.com", "ns2.uadns.com", "ns3.uadns.com"}, n, n, "whois.co.ua", e, e, 0x0, f},
	{"com.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.com.ua", "k.ns.com.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"crimea.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.crimea.ua", "nix.ns.ua", "ns.crimea.ua"}, n, n, "whois.crimea.ua", e, "http://www.nic.net.ua/", 0x0, f},
	{"cv.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns.cv.ua", "ns2.km.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"dn.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"dnepropetrovsk.ua", &z[1442], x, s{"ns.dp.ua", "s1.ns.dp.ua", "s2.ns.dp.ua", "s3.ns.dp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"dnipropetrovsk.ua", &z[1442], x, s{"ns.dp.ua", "s1.ns.dp.ua", "s2.ns.dp.ua", "s3.ns.dp.ua"}, n, n, e, e, e, 0x0, t},
	{"donetsk.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"dp.ua", &z[1442], x, s{"ns.dp.ua", "s1.ns.dp.ua", "s2.ns.dp.ua", "s3.ns.dp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"edu.ua", &z[1442], x, s{"ba1.ns.ua", "deneb.dfn.de", "ho1.ns.edu.ua", "nix.ns.ua"}, n, n, e, e, e, 0x0, f},
	{"gov.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.gov.ua", "nix.ns.ua"}, n, n, e, e, e, 0x0, f},
	{"if.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.if.ua", "nix.ns.ua", "ns.dn.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"in.ua", &z[1442], x, s{"ho1.ns.od.ua", "ns.in.ua", "nss.ukr.net"}, n, n, "whois.in.ua", e, e, 0x0, f},
	{"ivano-frankivsk.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.if.ua", "nix.ns.ua", "ns.dn.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"kh.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"kharkiv.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, e, 0x0, t},
	{"kharkov.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"kherson.ua", &z[1442], x, s{"ho1.ns.ks.ua", "nix.ns.ua", "ns.dn.ua", "ns.kharkov.ua", "ns.ks-host.com"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"khmelnitskiy.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns.km.ua", "ns2.km.ua", "ns3.km.ua"}, n, n, e, e, e, 0x0, f},
	{"kiev.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.kiev.ua", "k.ns.com.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"kirovograd.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns.host.kr.ua", "ns.infocom.kr.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"km.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns.km.ua", "ns2.km.ua", "ns3.km.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"kr.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns.host.kr.ua", "ns.infocom.kr.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"ks.ua", &z[1442], x, s{"ho1.ns.ks.ua", "nix.ns.ua", "ns.dn.ua", "ns.kharkov.ua", "ns.ks-host.com"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"kyiv.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.kiev.ua", "k.ns.com.ua", "nix.ns.ua"}, n, n, e, e, e, 0x0, t},
	{"lg.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"lt.ua", &z[1442], x, s{"ho1.ns.lutsk.ua", "nix.ns.ua", "ns.cv.ua"}, n, n, e, e, e, 0x0, f},
	{"lugansk.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"lutsk.ua", &z[1442], x, s{"ho1.ns.lutsk.ua", "nix.ns.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"lviv.ua", &z[1442], x, s{"eta.uar.net", "iota.uar.net", "kappa.uar.net", "ns.lviv.ua", "theta.uar.net", "zeta.uar.net"}, n, n, "whois.lviv.ua", e, "http://www.nic.net.ua/", 0x0, f},
	{"mk.ua", &z[1442], x, s{"ba1.ns.ua", "epp.ns.od.ua", "ho1.ns.od.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"net.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.net.ua", "nix.ns.ua", "ns.dn.ua", "ns.kh.ua", "ns.net.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, "whois.net.ua", e, e, 0x0, f},
	{"nikolaev.ua", &z[1442], x, s{"ba1.ns.ua", "epp.ns.od.ua", "ho1.ns.od.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"od.ua", &z[1442], x, s{"ho1.ns.od.ua", "nix.ns.ua", "ns.od.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"odesa.ua", &z[1442], x, s{"ho1.ns.od.ua", "nix.ns.ua", "ns.od.ua"}, n, n, e, e, e, 0x0, f},
	{"odessa.ua", &z[1442], x, s{"ho1.ns.od.ua", "nix.ns.ua", "ns.od.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"org.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.org.ua", "nix.ns.ua", "ns.dn.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"pl.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.pl.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"poltava.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.pl.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"pp.ua", &z[1442], x, s{"ns1.uadns.com", "ns2.uadns.com", "ns3.uadns.com"}, n, n, "whois.pp.ua", e, e, 0x0, f},
	{"rivne.ua", &z[1442], x, s{"ba1.ns.ua", "ns5.dnsmadeeasy.com", "ns6.dnsmadeeasy.com", "ns7.dnsmadeeasy.com"}, n, n, e, e, e, 0x0, t},
	{"rovno.ua", &z[1442], x, s{"ba1.ns.ua", "ns5.dnsmadeeasy.com", "ns6.dnsmadeeasy.com", "ns7.dnsmadeeasy.com"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"rv.ua", &z[1442], x, s{"ba1.ns.ua", "ns5.dnsmadeeasy.com", "ns6.dnsmadeeasy.com", "ns7.dnsmadeeasy.com"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"sebastopol.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.crimea.ua", "nix.ns.ua", "ns.crimea.ua"}, n, n, "whois.sebastopol.ua", e, "http://www.nic.net.ua/", 0x0, f},
	{"sm.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, e, 0x0, f},
	{"sumy.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"te.ua", &z[1442], x, s{"nix.ns.ua", "ns.dn.ua", "ns.te.ua", "ns2.km.ua", "ns2.uar.net"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"ternopil.ua", &z[1442], x, s{"nix.ns.ua", "ns.dn.ua", "ns.te.ua", "ns2.km.ua", "ns2.uar.net"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"uz.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.uz.ua", "nix.ns.ua", "ns.dn.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"uzhgorod.ua", &z[1442], x, s{"ba1.ns.ua", "ho1.ns.uz.ua", "nix.ns.ua", "ns.dn.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"vinnica.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns1.vn.ua", "ns1.vsmu.vinnica.ua", "ns4.nest.vn.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"vn.ua", &z[1442], x, s{"ba1.ns.ua", "nix.ns.ua", "ns1.vn.ua", "ns1.vsmu.vinnica.ua", "ns4.nest.vn.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"volyn.ua", &z[1442], x, s{"ho1.ns.lutsk.ua", "nix.ns.ua", "ns.zp.ua"}, n, n, e, e, e, 0x0, f},
	{"yalta.ua", &z[1442], x, s{"ho1.ns.crimea.ua", "nix.ns.ua", "ns.crimea.ua"}, n, n, "whois.yalta.ua", e, e, 0x0, f},
	{"zaporizhzhe.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"zhitomir.ua", &z[1442], x, s{"ba1.ns.ua", "impuls.zhitomir.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"zp.ua", &z[1442], x, s{"ho1.eunic.net.ua", "ns.dn.ua", "ns.kh.ua", "ns.sm.ua", "ns.zp.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"zt.ua", &z[1442], x, s{"ba1.ns.ua", "impuls.zhitomir.ua", "nix.ns.ua"}, n, n, e, e, "http://www.nic.net.ua/", 0x0, f},
	{"ac.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"co.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"com.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"go.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"mil.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"ne.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"or.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"org.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"sc.ug", &z[1446], x, n, n, n, e, e, e, 0x0, f},
	{"ac.uk", &z[1447], x, s{"auth03.ns.uu.net", "dns-3.dfn.de", "ns0.ja.net", "ns1.surfnet.nl", "ns2.ja.net", "ns3.ja.net", "ns4.ja.net"}, n, n, "whois.ja.net", e, e, 0x0, f},
	{"co.uk", &z[1447], x, s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, "whois.nic.uk", e, e, 0x0, f},
	{"gov.uk", &z[1447], x, s{"auth00.ns.de.uu.net", "auth50.ns.de.uu.net", "ns0.ja.net", "ns1.surfnet.nl", "ns2.ja.net", "ns3.ja.net", "ns4.ja.net"}, n, n, "whois.ja.net", e, e, 0x0, f},
	{"ltd.uk", &z[1447], x, s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, e, e, e, 0x0, f},
	{"me.uk", &z[1447], x, s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, e, e, e, 0x0, f},
	{"mod.uk", &z[1447], x, s{"ns1.cs.ucl.ac.uk", "ns1.mod.uk", "ns2.mod.uk"}, n, n, e, e, e, 0x0, f},
	{"net.uk", &z[1447], x, s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, e, e, e, 0x0, f},
	{"org.uk", &z[1447], x, s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, e, e, e, 0x0, f},
	{"plc.uk", &z[1447], x, s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, e, e, e, 0x0, f},
	{"sch.uk", &z[1447], z[5146:5161], s{"dns1.nic.uk", "dns2.nic.uk", "dns3.nic.uk", "dns4.nic.uk", "nsa.nic.uk", "nsb.nic.uk", "nsc.nic.uk", "nsd.nic.uk"}, n, n, e, e, e, 0x0, f},
	{"ak.us", &z[1457], x, n, n, n, e, e, "http://doa.alaska.gov/ets/eash/DNSrequestform.html", 0x0, t},
	{"al.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ar.us", &z[1457], x, n, n, n, e, e, e, 0x0, t},
	{"as.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"az.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ca.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"co.us", &z[1457], x, n, n, n, e, e, e, 0x800, f},
	{"ct.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"dc.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"de.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"dni.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"fed.us", &z[1457], x, s{"a.gov-servers.net", "b.gov-servers.net", "c.gov-servers.net", "d.gov-servers.net"}, n, n, "whois.dotgov.gov", e, e, 0x0, f},
	{"fl.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ga.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"gu.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"hi.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ia.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"id.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"il.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"in.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"isa.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"kids.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ks.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ky.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"la.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ma.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"md.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"me.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"mi.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"mn.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"mo.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ms.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"mt.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"nc.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"nd.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ne.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"nh.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"nj.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"nm.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"nsn.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"nv.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ny.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"oh.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ok.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"or.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"pa.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"pr.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ri.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"sc.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"sd.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"tn.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"tx.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"ut.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"va.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"vi.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"vt.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"wa.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"wi.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"wv.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"wy.us", &z[1457], x, n, n, n, e, e, e, 0x0, f},
	{"com.uy", &z[1458], x, s{"ns1.anteldata.com.uy", "ns2.anteldata.com.uy", "seciu.edu.uy"}, n, n, e, "https://nic.anteldata.com.uy/dns/consultaWhois/whois.action", e, 0x0, f},
	{"edu.uy", &z[1458], x, s{"a.lactld.org", "ns.dns.br", "ns1.anteldata.com.uy", "ns2.anteldata.com.uy", "ns3.nic.mx", "seciu.edu.uy", "ultra.edu.uy"}, n, n, e, e, e, 0x0, f},
	{"gub.uy", &z[1458], x, s{"a.lactld.org", "ns.dns.br", "ns1.anteldata.com.uy", "ns2.anteldata.com.uy", "ns3.nic.mx", "seciu.edu.uy", "ultra.edu.uy"}, n, n, e, e, e, 0x0, f},
	{"mil.uy", &z[1458], x, s{"a.lactld.org", "ns.dns.br", "ns1.anteldata.com.uy", "ns2.anteldata.com.uy", "ns3.nic.mx", "seciu.edu.uy", "ultra.edu.uy"}, n, n, e, e, e, 0x0, f},
	{"net.uy", &z[1458], x, s{"a.lactld.org", "ns.dns.br", "ns1.anteldata.com.uy", "ns2.anteldata.com.uy", "ns3.nic.mx", "seciu.edu.uy", "ultra.edu.uy"}, n, n, e, e, e, 0x0, f},
	{"org.uy", &z[1458], x, s{"a.lactld.org", "ns.dns.br", "ns1.anteldata.com.uy", "ns2.anteldata.com.uy", "ns3.nic.mx", "seciu.edu.uy", "ultra.edu.uy"}, n, n, e, e, e, 0x0, f},
	{"ac.uz", &z[1459], x, s{"ns1.sarkor.uz", "ns2.sarkor.uz"}, n, n, e, e, e, 0x0, f},
	{"aero.uz", &z[1459], x, s{"ns3.uzinfocom.uz", "rdns3.uzinfocom.uz"}, n, n, e, e, e, 0x0, f},
	{"biz.uz", &z[1459], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "biz.uz"}, n, e, e, e, 0x200, f},
	{"co.uz", &z[1459], x, s{"ns1.reg.uz", "ns2.reg.uz"}, n, n, e, e, e, 0x0, f},
	{"com.uz", &z[1459], x, s{"ns1.reg.uz", "ns2.reg.uz"}, n, n, e, e, e, 0x0, f},
	{"coop.uz", &z[1459], x, s{"ns3.uzinfocom.uz", "rdns3.uzinfocom.uz"}, n, n, e, e, e, 0x0, f},
	{"edu.uz", &z[1459], x, s{"dns1.webspace.uz", "dns2.webspace.uz"}, n, n, e, e, e, 0x0, f},
	{"info.uz", &z[1459], x, s{"ns.ol.uz", "ns.tshtt.uz"}, n, n, e, e, e, 0x0, f},
	{"int.uz", &z[1459], x, s{"ns3.uzinfocom.uz", "rdns3.uzinfocom.uz"}, n, n, e, e, e, 0x0, f},
	{"museum.uz", &z[1459], x, n, n, n, e, e, e, 0x0, f},
	{"name.uz", &z[1459], x, s{"ns1.billur.com", "ns2.billur.com"}, n, n, e, e, e, 0x0, f},
	{"net.uz", &z[1459], x, s{"ns1.reg.uz", "ns2.reg.uz"}, n, n, e, e, e, 0x0, f},
	{"org.uz", &z[1459], x, s{"ns1.reg.uz", "ns2.reg.uz"}, n, n, e, e, e, 0x0, f},
	{"pro.uz", &z[1459], x, s{"ns3.uzinfocom.uz", "rdns3.uzinfocom.uz"}, n, n, e, e, e, 0x8, f},
	{"com.vc", &z[1465], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"net.vc", &z[1465], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"org.vc", &z[1465], x, s{"a0.cctld.afilias-nst.info", "a2.cctld.afilias-nst.info", "b0.cctld.afilias-nst.org", "b2.cctld.afilias-nst.org", "c0.cctld.afilias-nst.info", "d0.cctld.afilias-nst.org"}, n, n, e, e, e, 0x0, f},
	{"co.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"com.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"edu.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"gob.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"info.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"int.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, t},
	{"mil.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"net.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"org.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"tec.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, t},
	{"web.ve", &z[1466], x, s{"ns3.nic.ve", "ns4.nic.ve", "ns5.nic.ve", "ns6.nic.ve", "ssdns-tld.nic.cl"}, n, n, e, e, e, 0x0, f},
	{"pro.vg", &z[1474], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "pro.vg"}, n, e, e, e, 0x200, t},
	{"biz.vi", &z[1475], x, n, n, n, e, e, e, 0x0, f},
	{"co.vi", &z[1475], x, s{"ns3.nic.vi", "pch.nic.vi"}, n, n, e, e, e, 0x0, f},
	{"com.vi", &z[1475], x, s{"ns3.nic.vi", "pch.nic.vi"}, n, n, e, e, e, 0x0, t},
	{"k12.vi", &z[1475], x, s{"ns3.nic.vi", "pch.nic.vi"}, n, n, e, e, e, 0x0, f},
	{"net.vi", &z[1475], x, s{"ns3.nic.vi", "pch.nic.vi"}, n, n, e, e, e, 0x0, f},
	{"org.vi", &z[1475], x, s{"ns3.nic.vi", "pch.nic.vi"}, n, n, e, e, e, 0x0, f},
	{"ac.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"biz.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"com.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"edu.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"gov.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"health.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"info.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"int.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"name.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"net.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"org.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"pro.vn", &z[1491], x, s{"a.dns-servers.vn", "b.dns-servers.vn", "c.dns-servers.vn", "d.dns-servers.vn", "e.dns-servers.vn", "f.dns-servers.vn", "g.dns-servers.vn"}, n, n, e, e, e, 0x0, f},
	{"co.vu", &z[1500], x, s{"ns1.codotvu.com", "ns2.codotvu.com", "ns3.codotvu.com", "ns4.codotvu.com"}, n, n, e, e, "www.co.vu", 0x0, t},
	{"com.vu", &z[1500], x, s{"ns1.neustar.vu", "ns2.neustar.vu", "ns3.neustar.vu", "ns4.neustar.vu"}, n, n, e, e, e, 0x0, f},
	{"name.vu", &z[1500], x, s{"ns1.subdomain.com", "ns2.subdomain.com"}, s{"144.76.162.245", "name.vu"}, n, e, e, e, 0x200, t},
	{"net.vu", &z[1500], x, s{"ns1.neustar.vu", "ns2.neustar.vu", "ns3.neustar.vu", "ns4.neustar.vu"}, n, n, e, e, e, 0x0, f},
	{"org.vu", &z[1500], x, s{"ns1.neustar.vu", "ns2.neustar.vu", "ns3.neustar.vu", "ns4.neustar.vu"}, n, n, e, e, e, 0x0, f},
	{"com.ws", &z[1539], x, s{"ns2.dns.ws", "ns3.dns.ws", "ns4.dns.ws", "ns5.dns.ws"}, s{"202.4.48.211"}, n, e, e, e, 0x0, f},
	{"edu.ws", &z[1539], x, s{"ns2.dns.ws", "ns3.dns.ws", "ns4.dns.ws", "ns5.dns.ws"}, s{"202.4.48.211"}, n, e, e, e, 0x0, f},
	{"gov.ws", &z[1539], x, s{"ns2.dns.ws", "ns3.dns.ws", "ns4.dns.ws", "ns5.dns.ws"}, n, n, e, e, e, 0x0, f},
	{"net.ws", &z[1539], x, s{"ns2.dns.ws", "ns3.dns.ws", "ns4.dns.ws", "ns5.dns.ws"}, s{"202.4.48.211"}, n, e, e, e, 0x0, f},
	{"org.ws", &z[1539], x, s{"ns2.dns.ws", "ns3.dns.ws", "ns4.dns.ws", "ns5.dns.ws"}, s{"202.4.48.211"}, n, e, e, e, 0x0, f},
	{"co.ye", &z[1554], x, n, n, n, e, e, e, 0x0, f},
	{"com.ye", &z[1554], x, n, n, n, e, e, e, 0x0, f},
	{"gov.ye", &z[1554], x, s{"ns1.yemen.net.ye", "ns2.yemen.net.ye", "pch.nic.ye", "sah1.ye", "sah2.ye"}, n, n, e, e, e, 0x0, t},
	{"ltd.ye", &z[1554], x, n, n, n, e, e, e, 0x0, f},
	{"me.ye", &z[1554], x, s{"ns1.yemen.net.ye", "ns2.yemen.net.ye", "pch.nic.ye", "sah1.ye", "sah2.ye"}, n, n, e, e, e, 0x0, f},
	{"net.ye", &z[1554], x, s{"ns1.yemen.net.ye", "ns2.yemen.net.ye", "pch.nic.ye", "sah1.ye", "sah2.ye"}, n, n, e, e, e, 0x0, f},
	{"org.ye", &z[1554], x, s{"ns1.yemen.net.ye", "ns2.yemen.net.ye", "pch.nic.ye", "sah1.ye", "sah2.ye"}, n, n, e, e, e, 0x0, f},
	{"plc.ye", &z[1554], x, n, n, n, e, e, e, 0x0, f},
	{"ac.yu", &z[1562], z[5161:5162], n, n, n, e, e, e, 0x800, f},
	{"cg.yu", &z[1562], x, n, n, n, e, e, e, 0x800, f},
	{"co.yu", &z[1562], x, n, n, n, e, e, e, 0x800, t},
	{"edu.yu", &z[1562], x, n, n, n, e, e, e, 0x800, f},
	{"gov.yu", &z[1562], x, n, n, n, e, e, e, 0x800, f},
	{"org.yu", &z[1562], x, n, n, n, e, e, e, 0x800, f},
	{"ac.za", &z[1564], x, s{"disa.tenet.ac.za", "ns2us.dns.business", "ns3.dns.business", "ns4.dns.business", "za-ns.anycast.pch.net"}, n, n, "whois.ac.za", e, e, 0x0, f},
	{"agric.za", &z[1564], x, s{"demeter.is.co.za", "jupiter.is.co.za", "titan.is.co.za"}, n, n, e, e, e, 0x0, f},
	{"alt.za", &z[1564], x, s{"mumble.proxima.alt.za", "ns1.iafrica.com", "ns2.iafrica.com", "psg.com", "za-ns.anycast.pch.net"}, n, n, e, e, e, 0x0, f},
	{"bourse.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"city.za", &z[1564], x, n, n, n, e, e, e, 0x0, f},
	{"co.za", &z[1564], x, s{"coza1.dnsnode.net", "ns.coza.net.za", "ns0.is.co.za", "ns2us.dns.business", "ns3.iafrica.com"}, n, n, "whois.coza.net.za", e, e, 0x0, f},
	{"cybernet.za", &z[1564], x, n, n, n, e, e, e, 0x0, f},
	{"db.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"edu.za", &z[1564], x, s{"ns-za.afrinic.net", "ns1.iafrica.com", "ns2.iafrica.com", "za-ns.anycast.pch.net"}, n, n, e, e, e, 0x0, f},
	{"gov.za", &z[1564], x, s{"ns1.gov.za", "ns1.inx.net.za", "ns2.gov.za", "ns2.inx.net.za", "ns3.gov.za", "ns3.inx.net.za"}, n, n, "whois.gov.za", e, e, 0x0, f},
	{"grondar.za", &z[1564], x, s{"grandfather.grondar.org", "ns1.iafrica.com", "ns2.iafrica.com", "rip.psg.com"}, n, n, e, e, e, 0x0, f},
	{"iaccess.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"imt.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"inca.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"landesign.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"law.za", &z[1564], x, s{"ns0.is.co.za", "ns1.dns.net.za", "ns2us.dns.business"}, n, n, e, e, e, 0x0, f},
	{"mil.za", &z[1564], x, s{"ns1.gov.za", "ns2.gov.za", "ns3.gov.za"}, n, n, e, e, e, 0x0, f},
	{"net.za", &z[1564], x, s{"ns0.is.co.za", "za-ns.anycast.pch.net"}, n, n, "net-whois.registry.net.za", e, e, 0x0, f},
	{"ngo.za", &z[1564], x, s{"antares.wisenet.co.za", "ns1.sn.apc.org", "ns2.sn.apc.org"}, n, n, e, e, e, 0x0, f},
	{"nis.za", &z[1564], x, s{"ns1.mywebserver.co.za", "ns2.mywebserver.co.za", "ns3.mywebserver.co.za"}, n, n, e, e, e, 0x0, f},
	{"nom.za", &z[1564], x, s{"ins1.c6dns.com", "ns0.plig.net", "secdns1.posix.co.za", "za-ns.anycast.pch.net"}, s{"78.31.111.139"}, n, e, e, e, 0x0, f},
	{"olivetti.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"org.za", &z[1564], x, s{"ns0.is.co.za", "ns0.plig.net", "ns3.iafrica.com", "ns4.iafrica.com", "za-ns.anycast.pch.net"}, n, n, "org-whois.registry.net.za", e, e, 0x0, f},
	{"pix.za", &z[1564], x, n, n, n, e, e, e, 0x800, f},
	{"school.za", &z[1564], z[5162:5171], s{"ns0.serendipity.org.za", "ochre.school.za", "ucthpx.uct.ac.za"}, n, n, e, e, e, 0x0, f},
	{"tm.za", &z[1564], x, s{"ns0.is.co.za", "ns1.dnsza.co.za", "ns1.iafrica.com", "ns1.lolo.co.za", "ns2.iafrica.com", "ns2.lolo.co.za", "ns3.lolo.co.za", "reaper.org", "sticky.spider.web.za", "za-ns.anycast.pch.net"}, n, n, e, e, e, 0x0, f},
	{"web.za", &z[1564], x, s{"disa.tenet.ac.za", "ns0.is.co.za", "za-ns.anycast.pch.net"}, n, n, "web-whois.registry.net.za", e, e, 0x0, f},
	{"ac.zm", &z[1570], x, s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, f},
	{"co.zm", &z[1570], x, s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, t},
	{"com.zm", &z[1570], x, s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, f},
	{"edu.zm", &z[1570], x, s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, t},
	{"gov.zm", &z[1570], x, s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, t},
	{"net.zm", &z[1570], x, s{"cocca.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, t},
	{"org.zm", &z[1570], x, s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, f},
	{"sch.zm", &z[1570], x, s{"cocca.nic.zm", "gransy.nic.zm", "pch.nic.zm"}, n, n, e, e, e, 0x0, t},
	{"ac.zw", &z[1574], x, s{"ns1.liquidtelecom.net", "ns2.liquidtelecom.net", "uofzns01.uz.ac.zw", "uofzns02.uz.ac.zw"}, n, n, e, e, e, 0x0, f},
	{"co.zw", &z[1574], x, s{"ns1.liquidtelecom.net", "ns1.zispa.org.zw", "ns2.liquidtelecom.net", "ns3.zispa.org.zw"}, n, n, e, e, e, 0x0, t},
	{"com.zw", &z[1574], x, n, n, n, e, e, e, 0x0, t},
	{"org.zw", &z[1574], x, s{"ns1.liquidtelecom.net", "ns1.telone.co.zw", "ns2.liquidtelecom.net", "ns2.telone.co.zw", "zw-ns.anycast.pch.net"}, n, n, e, e, e, 0x0, f},
	{"001.xn--p1acf" /* 001.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"002.xn--p1acf" /* 002.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"003.xn--p1acf" /* 003.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"004.xn--p1acf" /* 004.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"005.xn--p1acf" /* 005.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"006.xn--p1acf" /* 006.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"007.xn--p1acf" /* 007.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"008.xn--p1acf" /* 008.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"009.xn--p1acf" /* 009.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"010.xn--p1acf" /* 010.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"011.xn--p1acf" /* 011.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"012.xn--p1acf" /* 012.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"013.xn--p1acf" /* 013.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"014.xn--p1acf" /* 014.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"015.xn--p1acf" /* 015.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"016.xn--p1acf" /* 016.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"017.xn--p1acf" /* 017.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"018.xn--p1acf" /* 018.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"019.xn--p1acf" /* 019.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"021.xn--p1acf" /* 021.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"022.xn--p1acf" /* 022.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"023.xn--p1acf" /* 023.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"024.xn--p1acf" /* 024.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"025.xn--p1acf" /* 025.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"026.xn--p1acf" /* 026.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"027.xn--p1acf" /* 027.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"028.xn--p1acf" /* 028.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"029.xn--p1acf" /* 029.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"030.xn--p1acf" /* 030.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"031.xn--p1acf" /* 031.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"032.xn--p1acf" /* 032.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"033.xn--p1acf" /* 033.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"034.xn--p1acf" /* 034.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"035.xn--p1acf" /* 035.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"036.xn--p1acf" /* 036.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"037.xn--p1acf" /* 037.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"038.xn--p1acf" /* 038.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"039.xn--p1acf" /* 039.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"040.xn--p1acf" /* 040.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"041.xn--p1acf" /* 041.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"042.xn--p1acf" /* 042.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"043.xn--p1acf" /* 043.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"044.xn--p1acf" /* 044.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"045.xn--p1acf" /* 045.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"046.xn--p1acf" /* 046.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"047.xn--p1acf" /* 047.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"048.xn--p1acf" /* 048.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"049.xn--p1acf" /* 049.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"050.xn--p1acf" /* 050.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"051.xn--p1acf" /* 051.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"052.xn--p1acf" /* 052.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"053.xn--p1acf" /* 053.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"054.xn--p1acf" /* 054.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"055.xn--p1acf" /* 055.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"056.xn--p1acf" /* 056.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"057.xn--p1acf" /* 057.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"058.xn--p1acf" /* 058.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"059.xn--p1acf" /* 059.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"060.xn--p1acf" /* 060.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"061.xn--p1acf" /* 061.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"062.xn--p1acf" /* 062.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"063.xn--p1acf" /* 063.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"064.xn--p1acf" /* 064.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"065.xn--p1acf" /* 065.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"066.xn--p1acf" /* 066.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"067.xn--p1acf" /* 067.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"068.xn--p1acf" /* 068.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"069.xn--p1acf" /* 069.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"070.xn--p1acf" /* 070.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"071.xn--p1acf" /* 071.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"072.xn--p1acf" /* 072.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"073.xn--p1acf" /* 073.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"074.xn--p1acf" /* 074.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"075.xn--p1acf" /* 075.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"076.xn--p1acf" /* 076.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"077.xn--p1acf" /* 077.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"078.xn--p1acf" /* 078.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"079.xn--p1acf" /* 079.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"083.xn--p1acf" /* 083.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"086.xn--p1acf" /* 086.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"087.xn--p1acf" /* 087.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"089.xn--p1acf" /* 089.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"094.xn--p1acf" /* 094.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"095.xn--p1acf" /* 095.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaac0ct.xn--p1acf" /* абакан.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80ae0bp.xn--p1acf" /* авто.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80awd.xn--p1acf" /* алм.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aa1ag9a.xn--p1acf" /* алтай.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aam8ar9di.xn--p1acf" /* анадырь.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaa5csg.xn--p1acf" /* астана.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaa6cmfh0a9d.xn--p1acf" /* астрахань.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80ag7c.xn--p1acf" /* ахг.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80ab2azb.xn--p1acf" /* баку.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aab6birx.xn--p1acf" /* барнаул.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90ais.xn--p1acf" /* бел.рус */, &z[1590], x, s{"ns1.gohost.ru", "ns2.gohost.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90aedc4atap.xn--p1acf" /* белгород.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90amc.xn--p1acf" /* биз.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, s{"77.221.159.235"}, n, e, e, e, 0x200, t},
	{"xn--80abamkjb7bdt.xn--p1acf" /* биробиджан.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90aiiib5f.xn--p1acf" /* бишкек.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80abedla9acxg1b7f.xn--p1acf" /* благовещенск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90aayernio.xn--p1acf" /* бобруйск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90ai6aff.xn--p1acf" /* брест.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90asilg6f.xn--p1acf" /* брянск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90aoxid7ec.xn--p1acf" /* бурятия.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1aadecsaihi0amca3a.xn--p1acf" /* великийновгород.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1amjiu8dp.xn--p1acf" /* вильнюс.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90abjlm5be.xn--p1acf" /* витебск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80adbhunc2aa3al.xn--p1acf" /* владивосток.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaafckyesce.xn--p1acf" /* владикавказ.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80adhqaok7a.xn--p1acf" /* владимир.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80add5ao.xn--p1acf" /* волга.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80addag2buct.xn--p1acf" /* волгоград.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80adde7arb.xn--p1acf" /* вологда.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1agd0aean.xn--p1acf" /* воронеж.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--c1aescj1g.xn--p1acf" /* гомель.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--c1ac1acci.xn--p1acf" /* гродно.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--c1aigpdl4f.xn--p1acf" /* грозный.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--e1aky.xn--p1acf" /* ект.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80adia6bo.xn--p1acf" /* ереван.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80adbv1agb.xn--p1acf" /* иваново.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1afchn5b.xn--p1acf" /* ижевск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--h1aeawgfg.xn--p1acf" /* иркутск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aauks4g.xn--p1acf" /* казань.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaifraljtb8a.xn--p1acf" /* калининград.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aai0ag2c.xn--p1acf" /* калуга.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1afaslnbn.xn--p1acf" /* кемерово.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1afih.xn--p1acf" /* киев.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1alfrj.xn--p1acf" /* киров.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1afiaiu9e.xn--p1acf" /* кишинев.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1aef.xn--p1acf" /* ком.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--h1adgh.xn--p1acf" /* коми.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80atghalgi.xn--p1acf" /* кострома.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aalwqglfe.xn--p1acf" /* краснодар.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80atblfjdfd2l.xn--p1acf" /* красноярск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1ael8b.xn--p1acf" /* крым.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80afuomr.xn--p1acf" /* курган.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1aarei.xn--p1acf" /* курск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--g1afe6db.xn--p1acf" /* кызыл.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--e1afhbv7b.xn--p1acf" /* липецк.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaakg8bm.xn--p1acf" /* магадан.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aai8a2a.xn--p1acf" /* магас.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80asdfng.xn--p1acf" /* майкоп.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aqdibz7g.xn--p1acf" /* марийэл.рус */, &z[1590], x, s{"ns1.nameself.com", "ns2.nameself.com"}, n, n, e, e, e, 0x200, t},
	{"xn--80aqjbv3f.xn--p1acf" /* мариэл.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaaa2chc7eta.xn--p1acf" /* махачкала.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--d1abu.xn--p1acf" /* мед.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--h1aeefu.xn--p1acf" /* минск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--h1ahn.xn--p1acf" /* мир.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1abpmcm0l.xn--p1acf" /* могилёв.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1adp.xn--p1acf" /* мск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aueagpkl.xn--p1acf" /* мурманск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aqgci6d8a.xn--p1acf" /* нальчик.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn----7sbb1ccbue7h4a.xn--p1acf" /* нарьян-мар.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1avn.xn--p1acf" /* нвс.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--m1aa.xn--p1acf" /* нн.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90absbknhbvge.xn--p1acf" /* новосибирск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1adfn.xn--p1acf" /* омск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--c1avg.xn--p1acf" /* орг.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90aee6admdx.xn--p1acf" /* оренбург.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--k1afg2e.xn--p1acf" /* орёл.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80ajgxi.xn--p1acf" /* пенза.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--e1aohf5d.xn--p1acf" /* пермь.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aegbkvxddlre.xn--p1acf" /* петрозаводск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1apmck.xn--p1acf" /* псков.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--c1ajhpcjhd0j.xn--p1acf" /* пятигорск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80afo5a.xn--p1acf" /* рига.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn-----7kcgn5cdbagnnnx.xn--p1acf" /* ростов-на-дону.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1a1ade.xn--p1acf" /* рств.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80antj7do.xn--p1acf" /* рязань.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aamc3a6ac9a.xn--p1acf" /* салехард.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aaa0cvac.xn--p1acf" /* самара.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aa4alnee.xn--p1acf" /* саранск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aag1ciek.xn--p1acf" /* саратов.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80adi0aoagldk8i.xn--p1acf" /* севастополь.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90anb6ab4e.xn--p1acf" /* сибирь.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--e1afkclaggf6a2g.xn--p1acf" /* симферополь.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--e1akbdhdtf.xn--p1acf" /* смоленск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--h1aliz.xn--p1acf" /* сочи.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90a1af.xn--p1acf" /* спб.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80ae1alafffj1i.xn--p1acf" /* ставрополь.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aqialz.xn--p1acf" /* таллин.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80acd2blu.xn--p1acf" /* тамбов.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80akonve2b.xn--p1acf" /* ташкент.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1ag7af7c.xn--p1acf" /* тверь.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1adfnc.xn--p1acf" /* томск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80avue.xn--p1acf" /* тула.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--p1add.xn--p1acf" /* тур.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--e1aner7ci.xn--p1acf" /* тюмень.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--b1aqbiftj7e1a.xn--p1acf" /* ульяновск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80a1bd.xn--p1acf" /* уфа.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aacf4bwnk3a.xn--p1acf" /* хабаровск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80ablvtof7b4b.xn--p1acf" /* чебоксары.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--90ahkico2a6b9d.xn--p1acf" /* челябинск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--e1aaob1aia6b.xn--p1acf" /* черкесск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80ap4as.xn--p1acf" /* чита.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80apizf6d.xn--p1acf" /* элиста.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80af3b0c.xn--p1acf" /* югра.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--41a.xn--p1acf" /* я.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1aaude4e.xn--p1acf" /* якутск.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--80aezclli6gta.xn--p1acf" /* ярославль.рус */, &z[1590], x, s{"ns1.rlnic.ru", "ns2.rlnic.ru"}, n, n, e, e, e, 0x200, t},
	{"xn--j1aef.xn--p1ai" /* ком.рф */, &z[1591], x, s{"ns1.nameself.com", "ns2.nameself.com"}, n, n, e, e, e, 0x200, t},
	{"xn--e1apq.xn--p1ai" /* нет.рф */, &z[1591], x, s{"ns1.nameself.com", "ns2.nameself.com"}, n, n, e, e, e, 0x200, t},
	{"xn--c1avg.xn--p1ai" /* орг.рф */, &z[1591], x, s{"ns1.nameself.com", "ns2.nameself.com"}, n, n, e, e, e, 0x200, t},
	{"xn--o-btb9b.xn--90a3ac" /* oбр.срб */, &z[1593], x, n, n, n, e, e, e, 0x0, t},
	{"xn--o-htb.xn--90a3ac" /* oд.срб */, &z[1593], x, n, n, n, e, e, e, 0x0, t},
	{"xn--80au.xn--90a3ac" /* ак.срб */, &z[1593], x, s{"ban.junis.ni.ac.rs", "gaea.rcub.bg.ac.rs", "ns.etf.bg.ac.rs", "ns.rcub.bg.ac.rs", "ns.unic.kg.ac.rs", "ns1.uns.ac.rs", "ns2.iif.hu", "odisej.telekom.rs"}, n, n, e, e, e, 0x0, t},
	{"xn--o1ac.xn--90a3ac" /* пр.срб */, &z[1593], x, s{"a.nic.rs", "g.nic.rs", "h.nic.rs", "l.nic.rs"}, n, n, e, e, e, 0x0, t},
	{"xn--o1ach.xn--90a3ac" /* упр.срб */, &z[1593], x, s{"dagda1.isp.telekom.rs", "ns1.gov.rs", "ns1.nic.rs", "ns2.gov.rs", "ns3.gov.orion.rs"}, n, n, e, e, e, 0x0, t},
	{"xn--fhbed7t1n.xn--mgbbh1a71e" /* كمپنی.بھارت */, &z[1615], x, n, n, n, e, e, e, 0x0, t},
	{"xn--i1b1b4ch5i.xn--h2brj9c" /* कंपनी.भारत */, &z[1640], x, n, n, n, e, e, e, 0x0, t},
	{"xn--p5b2bfp1g0b0b.xn--45brj9c" /* কম্পেনি.ভারত */, &z[1645], x, n, n, n, e, e, e, 0x0, t},
	{"xn--p5b2bfp5fh3fra.xn--45brj9c" /* কোম্পানি.ভারত */, &z[1645], x, n, n, n, e, e, e, 0x0, t},
	{"xn--d9b2bf3g1k.xn--s9brj9c" /* ਕੰਪਨੀ.ਭਾਰਤ */, &z[1647], x, n, n, n, e, e, e, 0x0, t},
	{"xn--hdc1b4ch5i.xn--gecrj9c" /* કંપની.ભારત */, &z[1648], x, n, n, n, e, e, e, 0x0, t},
	{"xn--vlccpku2dp3h.xn--xkc2dl3a5ee0h" /* நிறுவனம்.இந்தியா */, &z[1650], x, n, n, n, e, e, e, 0x0, t},
	{"xn--12co0c3b4eva.xn--o3cw4h" /* ธุรกิจ.ไทย */, &z[1659], x, s{"a.thains.co.th", "b.thains.co.th", "p.thains.co.th"}, n, n, e, e, e, 0x0, t},
	{"xn--gmqw5a.xn--j6w193g" /* 個人.香港 */, &z[1745], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, t},
	{"xn--55qx5d.xn--j6w193g" /* 公司.香港 */, &z[1745], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, t},
	{"xn--mxtq1m.xn--j6w193g" /* 政府.香港 */, &z[1745], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, t},
	{"xn--wcvs22d.xn--j6w193g" /* 教育.香港 */, &z[1745], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, t},
	{"xn--uc0atv.xn--j6w193g" /* 組織.香港 */, &z[1745], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, t},
	{"xn--od0alg.xn--j6w193g" /* 網絡.香港 */, &z[1745], x, s{"c.hkirc.net.hk", "d.hkirc.net.hk", "t.hkirc.net.hk", "u.hkirc.net.hk", "v.hkirc.net.hk", "x.hkirc.net.hk", "y.hkirc.net.hk", "z.hkirc.net.hk"}, n, n, e, e, e, 0x0, t},
	{"lda.co.ao", &z[1812], x, s{"ns.inventadomains.com", "ns2.inventadomains.com"}, n, n, e, e, e, 0x0, t},
	{"sa.co.ao", &z[1812], x, n, n, n, e, e, e, 0x0, t},
	{"esc.edu.ar", &z[1820], x, s{"ns1.innova-red.net", "ns2.innova-red.net"}, n, n, e, e, e, 0x0, t},
	{"act.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"nsw.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"nt.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"qld.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"sa.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"tas.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"vic.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"wa.edu.au", &z[1844], x, s{"q.au", "r.au", "s.au", "t.au"}, n, n, e, e, e, 0x0, t},
	{"fed.rep.br", &z[2096], x, s{"ns1.nicdumali.presse.ml", "ns2.nicdumali.presse.ml", "ns3.nicdumali.presse.ml"}, n, n, e, e, e, 0x0, t},
	{"wireless.keyword.cn", &z[2218], x, n, n, n, e, e, e, 0x0, t},
	{"ltd.co.im", &z[2670], x, n, n, n, e, e, e, 0x0, t},
	{"plc.co.im", &z[2670], x, n, n, n, e, e, e, 0x0, t},
	{"lg.gov.ng", &z[3535], x, s{"ns1.nic.net.ng", "ns2.nic.net.ng", "ns5.nic.net.ng", "nsa.nic.net.ng"}, n, n, e, e, e, 0x0, t},
	{"co.net.nz", &z[3743], x, s{"ns1.instradns.com", "ns2.instradns.com", "ns3.instradns.com"}, n, n, e, e, e, 0x0, t},
	{"al.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"asso.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"at.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"au.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"be.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"bg.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"ca.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"cd.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"ch.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org", "ns1.imp.ch", "ns2.imp.ch"}, n, n, e, e, e, 0x0, t},
	{"cn.eu.org", &z[3761], x, s{"ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"cy.eu.org", &z[3761], x, s{"ns.eu.org", "ns1.absolight.net", "ns1.tee.gr", "ns2.absolight.net", "ns2.tee.gr", "ns3.absolight.net", "ns4.absolight.net"}, n, n, e, e, e, 0x0, t},
	{"cz.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"de.eu.org", &z[3761], x, s{"ns.oberon.net", "ns1.absolight.net", "ns2.absolight.net", "ns2.lf.net", "ns3.absolight.net", "ns4.absolight.net"}, n, n, e, e, e, 0x0, t},
	{"dk.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"edu.eu.org", &z[3761], x, s{"auth1.dns.elm.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"ee.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"es.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"fi.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"fr.eu.org", &z[3761], x, s{"auth1.dns.elm.net", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"gr.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns.eu.org", "ns1.absolight.net", "ns1.tee.gr", "ns2.absolight.net", "ns2.tee.gr", "ns3.absolight.net", "ns4.absolight.net"}, n, n, e, e, e, 0x0, t},
	{"hr.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"hu.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"ie.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"il.eu.org", &z[3761], x, s{"ns.eu.org", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"in.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"int.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"is.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"it.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"jp.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"kr.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"lt.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"lu.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"lv.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"me.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"mk.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"mt.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"my.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"net.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"ng.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"nl.eu.org", &z[3761], x, s{"auth.dns.suryo.com", "auth1.dns.elm.net", "ns.eu.org", "ns.lf.net", "ns1.elm-consultancy.nl", "ns4.coloclue.net"}, n, n, e, e, e, 0x0, t},
	{"no.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"nz.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"pl.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"pt.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"ro.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"ru.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"se.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"si.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"sk.eu.org", &z[3761], x, s{"hobbes.bsd-dk.dk", "ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"tr.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"uk.eu.org", &z[3761], x, s{"ns1.eriomem.net", "ns1.eu.org", "ns3.keltia.net"}, n, n, e, e, e, 0x0, t},
	{"us.eu.org", &z[3761], x, s{"ns.ankh.fr.eu.org", "ns1.eriomem.net", "ns1.eu.org"}, n, n, e, e, e, 0x0, t},
	{"co.at.pn", &z[3989], x, n, n, n, e, e, e, 0x0, t},
	{"com.au.pn", &z[3990], x, n, n, n, e, e, e, 0x0, t},
	{"co.uk.pn", &z[4006], x, n, n, n, e, e, e, 0x0, t},
	{"co.at.tc", &z[4386], x, n, n, n, e, e, e, 0x0, t},
	{"com.au.tc", &z[4387], x, n, n, n, e, e, e, 0x800, t},
	{"co.uk.tc", &z[4418], x, n, n, n, e, e, e, 0x0, t},
	{"me.uk.tc", &z[4418], x, n, n, n, e, e, e, 0x0, t},
	{"org.uk.tc", &z[4418], x, n, n, n, e, e, e, 0x0, t},
	{"co.at.tt", &z[4525], x, n, s{"195.225.236.206"}, n, e, e, e, 0x0, t},
	{"com.au.tt", &z[4526], x, n, n, n, e, e, e, 0x0, t},
	{"co.uk.tt", &z[4554], x, n, n, n, e, e, e, 0x0, t},
	{"me.uk.tt", &z[4554], x, n, n, n, e, e, e, 0x0, t},
	{"org.uk.tt", &z[4554], x, n, n, n, e, e, e, 0x0, t},
	{"barking-dagenham.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"barnet.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"barnsley.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bathnes.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"beds.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bexley.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bham.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"blackburn.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"blackpool.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bolton.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bournemouth.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bracknell-forest.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bradford.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"brent.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"doncaster.sch.uk", &z[4665], x, n, n, n, e, e, e, 0x0, t},
	{"bg.ac.yu", &z[4797], x, n, n, n, e, e, e, 0x800, t},
	{"ecape.school.za", &z[4827], x, s{"mopani.school.za", "ns0.serendipity.org.za", "ochre.school.za"}, n, n, e, e, e, 0x0, t},
	{"fs.school.za", &z[4827], x, s{"mopani.school.za", "ns0.serendipity.org.za", "nyx.marques.co.za", "ochre.school.za", "ucthpx.uct.ac.za"}, n, n, e, e, e, 0x0, t},
	{"gp.school.za", &z[4827], x, s{"lava.obsidian.co.za", "mopani.school.za", "ns0.serendipity.org.za", "ns2.obsidian.co.za", "ochre.school.za"}, n, n, e, e, e, 0x0, t},
	{"kzn.school.za", &z[4827], x, s{"mopani.school.za", "ns0.serendipity.org.za", "ochre.school.za", "sec.zadns.net", "ucthpx.uct.ac.za"}, n, n, e, e, e, 0x0, t},
	{"lp.school.za", &z[4827], x, s{"lava.obsidian.co.za", "mopani.school.za", "ns0.serendipity.org.za", "ochre.school.za"}, n, n, e, e, e, 0x0, t},
	{"mpm.school.za", &z[4827], x, s{"lava.obsidian.co.za", "mopani.school.za", "ns0.serendipity.org.za", "ochre.school.za"}, n, n, e, e, e, 0x0, t},
	{"ncape.school.za", &z[4827], x, s{"mopani.school.za", "ns0.serendipity.org.za", "ochre.school.za", "ucthpx.uct.ac.za"}, n, n, e, e, e, 0x0, t},
	{"nw.school.za", &z[4827], x, s{"lava.obsidian.co.za", "mopani.school.za", "ns0.serendipity.org.za", "ochre.school.za"}, n, n, e, e, e, 0x0, t},
	{"wcape.school.za", &z[4827], x, s{"mopani.school.za", "ns0.serendipity.org.za", "ochre.school.za", "ucthpx.uct.ac.za"}, n, n, e, e, e, 0x0, t},
}

// ZoneMap maps domain names to Zones.
var ZoneMap = map[string]*Zone{
	"aaa":                                &z[0],
	"aarp":                               &z[1],
	"abarth":                             &z[2],
	"abb":                                &z[3],
	"abbott":                             &z[4],
	"abbvie":                             &z[5],
	"abc":                                &z[6],
	"able":                               &z[7],
	"abogado":                            &z[8],
	"abudhabi":                           &z[9],
	"ac":                                 &z[10],
	"academy":                            &z[11],
	"accenture":                          &z[12],
	"accountant":                         &z[13],
	"accountants":                        &z[14],
	"acer":                               &z[15],
	"aco":                                &z[16],
	"active":                             &z[17],
	"actor":                              &z[18],
	"ad":                                 &z[19],
	"adac":                               &z[20],
	"ads":                                &z[21],
	"adult":                              &z[22],
	"ae":                                 &z[23],
	"aeg":                                &z[24],
	"aero":                               &z[25],
	"aetna":                              &z[26],
	"af":                                 &z[27],
	"afamilycompany":                     &z[28],
	"afl":                                &z[29],
	"africa":                             &z[30],
	"africamagic":                        &z[31],
	"ag":                                 &z[32],
	"agakhan":                            &z[33],
	"agency":                             &z[34],
	"ai":                                 &z[35],
	"aig":                                &z[36],
	"aigo":                               &z[37],
	"airbus":                             &z[38],
	"airforce":                           &z[39],
	"airtel":                             &z[40],
	"akdn":                               &z[41],
	"al":                                 &z[42],
	"alcon":                              &z[43],
	"alfaromeo":                          &z[44],
	"alibaba":                            &z[45],
	"alipay":                             &z[46],
	"allfinanz":                          &z[47],
	"allfinanzberater":                   &z[48],
	"allfinanzberatung":                  &z[49],
	"allstate":                           &z[50],
	"ally":                               &z[51],
	"alsace":                             &z[52],
	"alstom":                             &z[53],
	"am":                                 &z[54],
	"amazon":                             &z[55],
	"americanexpress":                    &z[56],
	"americanfamily":                     &z[57],
	"amex":                               &z[58],
	"amfam":                              &z[59],
	"amica":                              &z[60],
	"amp":                                &z[61],
	"amsterdam":                          &z[62],
	"an":                                 &z[63],
	"analytics":                          &z[64],
	"android":                            &z[65],
	"anquan":                             &z[66],
	"ansons":                             &z[67],
	"anthem":                             &z[68],
	"antivirus":                          &z[69],
	"anz":                                &z[70],
	"ao":                                 &z[71],
	"aol":                                &z[72],
	"apartments":                         &z[73],
	"app":                                &z[74],
	"apple":                              &z[75],
	"aq":                                 &z[76],
	"aquarelle":                          &z[77],
	"aquitaine":                          &z[78],
	"ar":                                 &z[79],
	"arab":                               &z[80],
	"aramco":                             &z[81],
	"archi":                              &z[82],
	"architect":                          &z[83],
	"army":                               &z[84],
	"arpa":                               &z[85],
	"art":                                &z[86],
	"arte":                               &z[87],
	"as":                                 &z[88],
	"asda":                               &z[89],
	"asia":                               &z[90],
	"associates":                         &z[91],
	"astrium":                            &z[92],
	"at":                                 &z[93],
	"athleta":                            &z[94],
	"attorney":                           &z[95],
	"au":                                 &z[96],
	"auction":                            &z[97],
	"audi":                               &z[98],
	"audible":                            &z[99],
	"audio":                              &z[100],
	"auspost":                            &z[101],
	"author":                             &z[102],
	"auto":                               &z[103],
	"autoinsurance":                      &z[104],
	"autos":                              &z[105],
	"avery":                              &z[106],
	"avianca":                            &z[107],
	"aw":                                 &z[108],
	"aws":                                &z[109],
	"ax":                                 &z[110],
	"axa":                                &z[111],
	"axis":                               &z[112],
	"az":                                 &z[113],
	"azure":                              &z[114],
	"ba":                                 &z[115],
	"baby":                               &z[116],
	"baidu":                              &z[117],
	"banamex":                            &z[118],
	"bananarepublic":                     &z[119],
	"band":                               &z[120],
	"bank":                               &z[121],
	"banque":                             &z[122],
	"bar":                                &z[123],
	"barcelona":                          &z[124],
	"barclaycard":                        &z[125],
	"barclays":                           &z[126],
	"barefoot":                           &z[127],
	"bargains":                           &z[128],
	"baseball":                           &z[129],
	"basketball":                         &z[130],
	"bauhaus":                            &z[131],
	"bayern":                             &z[132],
	"bb":                                 &z[133],
	"bbb":                                &z[134],
	"bbc":                                &z[135],
	"bbt":                                &z[136],
	"bbva":                               &z[137],
	"bcg":                                &z[138],
	"bcn":                                &z[139],
	"bd":                                 &z[140],
	"be":                                 &z[141],
	"beats":                              &z[142],
	"beauty":                             &z[143],
	"beer":                               &z[144],
	"beknown":                            &z[145],
	"bentley":                            &z[146],
	"berlin":                             &z[147],
	"best":                               &z[148],
	"bestbuy":                            &z[149],
	"bet":                                &z[150],
	"bf":                                 &z[151],
	"bg":                                 &z[152],
	"bh":                                 &z[153],
	"bharti":                             &z[154],
	"bi":                                 &z[155],
	"bible":                              &z[156],
	"bid":                                &z[157],
	"bike":                               &z[158],
	"bing":                               &z[159],
	"bingo":                              &z[160],
	"bio":                                &z[161],
	"biz":                                &z[162],
	"bj":                                 &z[163],
	"black":                              &z[164],
	"blackfriday":                        &z[165],
	"blanco":                             &z[166],
	"blockbuster":                        &z[167],
	"blog":                               &z[168],
	"bloomberg":                          &z[169],
	"bloomingdales":                      &z[170],
	"blue":                               &z[171],
	"bm":                                 &z[172],
	"bms":                                &z[173],
	"bmw":                                &z[174],
	"bn":                                 &z[175],
	"bnl":                                &z[176],
	"bnpparibas":                         &z[177],
	"bo":                                 &z[178],
	"boats":                              &z[179],
	"boehringer":                         &z[180],
	"bofa":                               &z[181],
	"bom":                                &z[182],
	"bond":                               &z[183],
	"boo":                                &z[184],
	"book":                               &z[185],
	"booking":                            &z[186],
	"boots":                              &z[187],
	"bosch":                              &z[188],
	"bostik":                             &z[189],
	"boston":                             &z[190],
	"bot":                                &z[191],
	"boutique":                           &z[192],
	"box":                                &z[193],
	"br":                                 &z[194],
	"bradesco":                           &z[195],
	"bridgestone":                        &z[196],
	"broadway":                           &z[197],
	"broker":                             &z[198],
	"brother":                            &z[199],
	"brussels":                           &z[200],
	"bs":                                 &z[201],
	"bt":                                 &z[202],
	"budapest":                           &z[203],
	"bugatti":                            &z[204],
	"buick":                              &z[205],
	"build":                              &z[206],
	"builders":                           &z[207],
	"business":                           &z[208],
	"buy":                                &z[209],
	"buzz":                               &z[210],
	"bv":                                 &z[211],
	"bw":                                 &z[212],
	"bway":                               &z[213],
	"by":                                 &z[214],
	"bz":                                 &z[215],
	"bzh":                                &z[216],
	"ca":                                 &z[217],
	"cab":                                &z[218],
	"cadillac":                           &z[219],
	"cafe":                               &z[220],
	"cal":                                &z[221],
	"call":                               &z[222],
	"calvinklein":                        &z[223],
	"cam":                                &z[224],
	"camera":                             &z[225],
	"camp":                               &z[226],
	"canalplus":                          &z[227],
	"cancerresearch":                     &z[228],
	"canon":                              &z[229],
	"capetown":                           &z[230],
	"capital":                            &z[231],
	"capitalone":                         &z[232],
	"car":                                &z[233],
	"caravan":                            &z[234],
	"cards":                              &z[235],
	"care":                               &z[236],
	"career":                             &z[237],
	"careers":                            &z[238],
	"carinsurance":                       &z[239],
	"cars":                               &z[240],
	"cartier":                            &z[241],
	"casa":                               &z[242],
	"case":                               &z[243],
	"caseih":                             &z[244],
	"cash":                               &z[245],
	"cashbackbonus":                      &z[246],
	"casino":                             &z[247],
	"cat":                                &z[248],
	"catalonia":                          &z[249],
	"catering":                           &z[250],
	"catholic":                           &z[251],
	"cba":                                &z[252],
	"cbn":                                &z[253],
	"cbre":                               &z[254],
	"cbs":                                &z[255],
	"cc":                                 &z[256],
	"cd":                                 &z[257],
	"ceb":                                &z[258],
	"center":                             &z[259],
	"ceo":                                &z[260],
	"cern":                               &z[261],
	"cf":                                 &z[262],
	"cfa":                                &z[263],
	"cfd":                                &z[264],
	"cg":                                 &z[265],
	"ch":                                 &z[266],
	"chanel":                             &z[267],
	"changiairport":                      &z[268],
	"channel":                            &z[269],
	"charity":                            &z[270],
	"chartis":                            &z[271],
	"chase":                              &z[272],
	"chat":                               &z[273],
	"cheap":                              &z[274],
	"chesapeake":                         &z[275],
	"chevrolet":                          &z[276],
	"chevy":                              &z[277],
	"chintai":                            &z[278],
	"chk":                                &z[279],
	"chloe":                              &z[280],
	"christmas":                          &z[281],
	"chrome":                             &z[282],
	"chrysler":                           &z[283],
	"church":                             &z[284],
	"ci":                                 &z[285],
	"cimb":                               &z[286],
	"cipriani":                           &z[287],
	"circle":                             &z[288],
	"cisco":                              &z[289],
	"citadel":                            &z[290],
	"citi":                               &z[291],
	"citic":                              &z[292],
	"city":                               &z[293],
	"cityeats":                           &z[294],
	"ck":                                 &z[295],
	"cl":                                 &z[296],
	"claims":                             &z[297],
	"cleaning":                           &z[298],
	"click":                              &z[299],
	"clinic":                             &z[300],
	"clinique":                           &z[301],
	"clothing":                           &z[302],
	"cloud":                              &z[303],
	"club":                               &z[304],
	"clubmed":                            &z[305],
	"cm":                                 &z[306],
	"cn":                                 &z[307],
	"co":                                 &z[308],
	"coach":                              &z[309],
	"codes":                              &z[310],
	"coffee":                             &z[311],
	"college":                            &z[312],
	"cologne":                            &z[313],
	"com":                                &z[314],
	"comcast":                            &z[315],
	"commbank":                           &z[316],
	"community":                          &z[317],
	"company":                            &z[318],
	"compare":                            &z[319],
	"computer":                           &z[320],
	"comsec":                             &z[321],
	"condos":                             &z[322],
	"connectors":                         &z[323],
	"construction":                       &z[324],
	"consulting":                         &z[325],
	"contact":                            &z[326],
	"contractors":                        &z[327],
	"cooking":                            &z[328],
	"cookingchannel":                     &z[329],
	"cool":                               &z[330],
	"coop":                               &z[331],
	"corp":                               &z[332],
	"corsica":                            &z[333],
	"country":                            &z[334],
	"coupon":                             &z[335],
	"coupons":                            &z[336],
	"courses":                            &z[337],
	"cpa":                                &z[338],
	"cr":                                 &z[339],
	"credit":                             &z[340],
	"creditcard":                         &z[341],
	"creditunion":                        &z[342],
	"cricket":                            &z[343],
	"crown":                              &z[344],
	"crs":                                &z[345],
	"cruise":                             &z[346],
	"cruises":                            &z[347],
	"csc":                                &z[348],
	"cu":                                 &z[349],
	"cuisinella":                         &z[350],
	"cv":                                 &z[351],
	"cw":                                 &z[352],
	"cx":                                 &z[353],
	"cy":                                 &z[354],
	"cymru":                              &z[355],
	"cyou":                               &z[356],
	"cz":                                 &z[357],
	"dabur":                              &z[358],
	"dad":                                &z[359],
	"dance":                              &z[360],
	"data":                               &z[361],
	"date":                               &z[362],
	"dating":                             &z[363],
	"datsun":                             &z[364],
	"day":                                &z[365],
	"dclk":                               &z[366],
	"dds":                                &z[367],
	"de":                                 &z[368],
	"deal":                               &z[369],
	"dealer":                             &z[370],
	"deals":                              &z[371],
	"degree":                             &z[372],
	"delivery":                           &z[373],
	"dell":                               &z[374],
	"delmonte":                           &z[375],
	"deloitte":                           &z[376],
	"delta":                              &z[377],
	"democrat":                           &z[378],
	"dental":                             &z[379],
	"dentist":                            &z[380],
	"desi":                               &z[381],
	"design":                             &z[382],
	"deutschepost":                       &z[383],
	"dev":                                &z[384],
	"dhl":                                &z[385],
	"diamonds":                           &z[386],
	"diet":                               &z[387],
	"digikey":                            &z[388],
	"digital":                            &z[389],
	"direct":                             &z[390],
	"directory":                          &z[391],
	"discount":                           &z[392],
	"discover":                           &z[393],
	"dish":                               &z[394],
	"diy":                                &z[395],
	"dj":                                 &z[396],
	"dk":                                 &z[397],
	"dm":                                 &z[398],
	"dnb":                                &z[399],
	"dnp":                                &z[400],
	"do":                                 &z[401],
	"docomo":                             &z[402],
	"docs":                               &z[403],
	"doctor":                             &z[404],
	"dodge":                              &z[405],
	"dog":                                &z[406],
	"doha":                               &z[407],
	"domains":                            &z[408],
	"doosan":                             &z[409],
	"dot":                                &z[410],
	"dotafrica":                          &z[411],
	"download":                           &z[412],
	"drive":                              &z[413],
	"dstv":                               &z[414],
	"dtv":                                &z[415],
	"dubai":                              &z[416],
	"duck":                               &z[417],
	"dunlop":                             &z[418],
	"duns":                               &z[419],
	"dupont":                             &z[420],
	"durban":                             &z[421],
	"dvag":                               &z[422],
	"dvr":                                &z[423],
	"dwg":                                &z[424],
	"dz":                                 &z[425],
	"earth":                              &z[426],
	"eat":                                &z[427],
	"ec":                                 &z[428],
	"eco":                                &z[429],
	"ecom":                               &z[430],
	"edeka":                              &z[431],
	"edu":                                &z[432],
	"education":                          &z[433],
	"ee":                                 &z[434],
	"eg":                                 &z[435],
	"email":                              &z[436],
	"emerck":                             &z[437],
	"emerson":                            &z[438],
	"energy":                             &z[439],
	"engineer":                           &z[440],
	"engineering":                        &z[441],
	"enterprises":                        &z[442],
	"epost":                              &z[443],
	"epson":                              &z[444],
	"equipment":                          &z[445],
	"er":                                 &z[446],
	"ericsson":                           &z[447],
	"erni":                               &z[448],
	"es":                                 &z[449],
	"esq":                                &z[450],
	"estate":                             &z[451],
	"esurance":                           &z[452],
	"et":                                 &z[453],
	"etisalat":                           &z[454],
	"eu":                                 &z[455],
	"eurovision":                         &z[456],
	"eus":                                &z[457],
	"events":                             &z[458],
	"everbank":                           &z[459],
	"exchange":                           &z[460],
	"expert":                             &z[461],
	"exposed":                            &z[462],
	"express":                            &z[463],
	"extraspace":                         &z[464],
	"fage":                               &z[465],
	"fail":                               &z[466],
	"fairwinds":                          &z[467],
	"faith":                              &z[468],
	"family":                             &z[469],
	"fan":                                &z[470],
	"fans":                               &z[471],
	"farm":                               &z[472],
	"farmers":                            &z[473],
	"fashion":                            &z[474],
	"fast":                               &z[475],
	"fedex":                              &z[476],
	"feedback":                           &z[477],
	"ferrari":                            &z[478],
	"ferrero":                            &z[479],
	"fi":                                 &z[480],
	"fiat":                               &z[481],
	"fidelity":                           &z[482],
	"fido":                               &z[483],
	"film":                               &z[484],
	"final":                              &z[485],
	"finance":                            &z[486],
	"financial":                          &z[487],
	"financialaid":                       &z[488],
	"finish":                             &z[489],
	"fire":                               &z[490],
	"firestone":                          &z[491],
	"firmdale":                           &z[492],
	"fish":                               &z[493],
	"fishing":                            &z[494],
	"fit":                                &z[495],
	"fitness":                            &z[496],
	"fj":                                 &z[497],
	"fk":                                 &z[498],
	"flickr":                             &z[499],
	"flights":                            &z[500],
	"flir":                               &z[501],
	"florist":                            &z[502],
	"flowers":                            &z[503],
	"fls":                                &z[504],
	"flsmidth":                           &z[505],
	"fly":                                &z[506],
	"fm":                                 &z[507],
	"fo":                                 &z[508],
	"foo":                                &z[509],
	"food":                               &z[510],
	"foodnetwork":                        &z[511],
	"football":                           &z[512],
	"ford":                               &z[513],
	"forex":                              &z[514],
	"forsale":                            &z[515],
	"forum":                              &z[516],
	"foundation":                         &z[517],
	"fox":                                &z[518],
	"fr":                                 &z[519],
	"free":                               &z[520],
	"fresenius":                          &z[521],
	"frl":                                &z[522],
	"frogans":                            &z[523],
	"frontdoor":                          &z[524],
	"frontier":                           &z[525],
	"ftr":                                &z[526],
	"fujitsu":                            &z[527],
	"fujixerox":                          &z[528],
	"fun":                                &z[529],
	"fund":                               &z[530],
	"furniture":                          &z[531],
	"futbol":                             &z[532],
	"fyi":                                &z[533],
	"ga":                                 &z[534],
	"gal":                                &z[535],
	"gallery":                            &z[536],
	"gallo":                              &z[537],
	"gallup":                             &z[538],
	"game":                               &z[539],
	"games":                              &z[540],
	"gap":                                &z[541],
	"garden":                             &z[542],
	"garnier":                            &z[543],
	"gay":                                &z[544],
	"gb":                                 &z[545],
	"gbiz":                               &z[546],
	"gcc":                                &z[547],
	"gd":                                 &z[548],
	"gdn":                                &z[549],
	"ge":                                 &z[550],
	"gea":                                &z[551],
	"gecompany":                          &z[552],
	"ged":                                &z[553],
	"gent":                               &z[554],
	"genting":                            &z[555],
	"george":                             &z[556],
	"gf":                                 &z[557],
	"gg":                                 &z[558],
	"ggee":                               &z[559],
	"gh":                                 &z[560],
	"gi":                                 &z[561],
	"gift":                               &z[562],
	"gifts":                              &z[563],
	"gives":                              &z[564],
	"giving":                             &z[565],
	"gl":                                 &z[566],
	"glade":                              &z[567],
	"glass":                              &z[568],
	"gle":                                &z[569],
	"global":                             &z[570],
	"globalx":                            &z[571],
	"globo":                              &z[572],
	"gm":                                 &z[573],
	"gmail":                              &z[574],
	"gmbh":                               &z[575],
	"gmc":                                &z[576],
	"gmo":                                &z[577],
	"gmx":                                &z[578],
	"gn":                                 &z[579],
	"godaddy":                            &z[580],
	"gold":                               &z[581],
	"goldpoint":                          &z[582],
	"golf":                               &z[583],
	"goo":                                &z[584],
	"goodhands":                          &z[585],
	"goodyear":                           &z[586],
	"goog":                               &z[587],
	"google":                             &z[588],
	"gop":                                &z[589],
	"got":                                &z[590],
	"gotv":                               &z[591],
	"gov":                                &z[592],
	"gp":                                 &z[593],
	"gq":                                 &z[594],
	"gr":                                 &z[595],
	"grainger":                           &z[596],
	"graphics":                           &z[597],
	"gratis":                             &z[598],
	"gree":                               &z[599],
	"green":                              &z[600],
	"gripe":                              &z[601],
	"grocery":                            &z[602],
	"group":                              &z[603],
	"gs":                                 &z[604],
	"gt":                                 &z[605],
	"gu":                                 &z[606],
	"guardian":                           &z[607],
	"guardianlife":                       &z[608],
	"guardianmedia":                      &z[609],
	"gucci":                              &z[610],
	"guge":                               &z[611],
	"guide":                              &z[612],
	"guitars":                            &z[613],
	"guru":                               &z[614],
	"gw":                                 &z[615],
	"gy":                                 &z[616],
	"hair":                               &z[617],
	"halal":                              &z[618],
	"hamburg":                            &z[619],
	"hangout":                            &z[620],
	"haus":                               &z[621],
	"hbo":                                &z[622],
	"hdfc":                               &z[623],
	"hdfcbank":                           &z[624],
	"health":                             &z[625],
	"healthcare":                         &z[626],
	"heart":                              &z[627],
	"heinz":                              &z[628],
	"help":                               &z[629],
	"helsinki":                           &z[630],
	"here":                               &z[631],
	"hermes":                             &z[632],
	"hgtv":                               &z[633],
	"hilton":                             &z[634],
	"hiphop":                             &z[635],
	"hisamitsu":                          &z[636],
	"hitachi":                            &z[637],
	"hiv":                                &z[638],
	"hk":                                 &z[639],
	"hkt":                                &z[640],
	"hm":                                 &z[641],
	"hn":                                 &z[642],
	"hockey":                             &z[643],
	"holdings":                           &z[644],
	"holiday":                            &z[645],
	"home":                               &z[646],
	"homedepot":                          &z[647],
	"homegoods":                          &z[648],
	"homes":                              &z[649],
	"homesense":                          &z[650],
	"honda":                              &z[651],
	"honeywell":                          &z[652],
	"horse":                              &z[653],
	"hospital":                           &z[654],
	"host":                               &z[655],
	"hosting":                            &z[656],
	"hot":                                &z[657],
	"hoteis":                             &z[658],
	"hotel":                              &z[659],
	"hoteles":                            &z[660],
	"hotels":                             &z[661],
	"hotmail":                            &z[662],
	"house":                              &z[663],
	"how":                                &z[664],
	"hr":                                 &z[665],
	"hsbc":                               &z[666],
	"ht":                                 &z[667],
	"htc":                                &z[668],
	"hu":                                 &z[669],
	"hughes":                             &z[670],
	"hyatt":                              &z[671],
	"hyundai":                            &z[672],
	"ibm":                                &z[673],
	"icbc":                               &z[674],
	"ice":                                &z[675],
	"icu":                                &z[676],
	"id":                                 &z[677],
	"idn":                                &z[678],
	"ie":                                 &z[679],
	"ieee":                               &z[680],
	"ifm":                                &z[681],
	"iinet":                              &z[682],
	"ikano":                              &z[683],
	"il":                                 &z[684],
	"im":                                 &z[685],
	"imamat":                             &z[686],
	"imdb":                               &z[687],
	"immo":                               &z[688],
	"immobilien":                         &z[689],
	"in":                                 &z[690],
	"inc":                                &z[691],
	"indians":                            &z[692],
	"industries":                         &z[693],
	"infiniti":                           &z[694],
	"info":                               &z[695],
	"infosys":                            &z[696],
	"infy":                               &z[697],
	"ing":                                &z[698],
	"ink":                                &z[699],
	"institute":                          &z[700],
	"insurance":                          &z[701],
	"insure":                             &z[702],
	"int":                                &z[703],
	"intel":                              &z[704],
	"international":                      &z[705],
	"intuit":                             &z[706],
	"investments":                        &z[707],
	"io":                                 &z[708],
	"ipiranga":                           &z[709],
	"iq":                                 &z[710],
	"ir":                                 &z[711],
	"ira":                                &z[712],
	"irish":                              &z[713],
	"is":                                 &z[714],
	"iselect":                            &z[715],
	"islam":                              &z[716],
	"ismaili":                            &z[717],
	"ist":                                &z[718],
	"istanbul":                           &z[719],
	"it":                                 &z[720],
	"itau":                               &z[721],
	"itv":                                &z[722],
	"iveco":                              &z[723],
	"iwc":                                &z[724],
	"jaguar":                             &z[725],
	"java":                               &z[726],
	"jcb":                                &z[727],
	"jcp":                                &z[728],
	"je":                                 &z[729],
	"jeep":                               &z[730],
	"jetzt":                              &z[731],
	"jewelry":                            &z[732],
	"jio":                                &z[733],
	"jlc":                                &z[734],
	"jll":                                &z[735],
	"jm":                                 &z[736],
	"jmp":                                &z[737],
	"jnj":                                &z[738],
	"jo":                                 &z[739],
	"jobs":                               &z[740],
	"joburg":                             &z[741],
	"jot":                                &z[742],
	"joy":                                &z[743],
	"jp":                                 &z[744],
	"jpmorgan":                           &z[745],
	"jpmorganchase":                      &z[746],
	"jprs":                               &z[747],
	"juegos":                             &z[748],
	"juniper":                            &z[749],
	"justforu":                           &z[750],
	"kaufen":                             &z[751],
	"kddi":                               &z[752],
	"ke":                                 &z[753],
	"kerastase":                          &z[754],
	"kerryhotels":                        &z[755],
	"kerrylogisitics":                    &z[756],
	"kerrylogistics":                     &z[757],
	"kerryproperties":                    &z[758],
	"ketchup":                            &z[759],
	"kfh":                                &z[760],
	"kg":                                 &z[761],
	"kh":                                 &z[762],
	"ki":                                 &z[763],
	"kia":                                &z[764],
	"kid":                                &z[765],
	"kids":                               &z[766],
	"kiehls":                             &z[767],
	"kim":                                &z[768],
	"kinder":                             &z[769],
	"kindle":                             &z[770],
	"kitchen":                            &z[771],
	"kiwi":                               &z[772],
	"km":                                 &z[773],
	"kn":                                 &z[774],
	"koeln":                              &z[775],
	"komatsu":                            &z[776],
	"konami":                             &z[777],
	"kone":                               &z[778],
	"kosher":                             &z[779],
	"kp":                                 &z[780],
	"kpmg":                               &z[781],
	"kpn":                                &z[782],
	"kr":                                 &z[783],
	"krd":                                &z[784],
	"kred":                               &z[785],
	"kuokgroup":                          &z[786],
	"kw":                                 &z[787],
	"ky":                                 &z[788],
	"kyknet":                             &z[789],
	"kyoto":                              &z[790],
	"kz":                                 &z[791],
	"la":                                 &z[792],
	"lacaixa":                            &z[793],
	"ladbrokes":                          &z[794],
	"lamborghini":                        &z[795],
	"lamer":                              &z[796],
	"lancaster":                          &z[797],
	"lancia":                             &z[798],
	"lancome":                            &z[799],
	"land":                               &z[800],
	"landrover":                          &z[801],
	"lanxess":                            &z[802],
	"lasalle":                            &z[803],
	"lat":                                &z[804],
	"latino":                             &z[805],
	"latrobe":                            &z[806],
	"law":                                &z[807],
	"lawyer":                             &z[808],
	"lb":                                 &z[809],
	"lc":                                 &z[810],
	"lds":                                &z[811],
	"lease":                              &z[812],
	"leclerc":                            &z[813],
	"lefrak":                             &z[814],
	"legal":                              &z[815],
	"lego":                               &z[816],
	"lexus":                              &z[817],
	"lgbt":                               &z[818],
	"li":                                 &z[819],
	"liaison":                            &z[820],
	"lidl":                               &z[821],
	"life":                               &z[822],
	"lifeinsurance":                      &z[823],
	"lifestyle":                          &z[824],
	"lighting":                           &z[825],
	"like":                               &z[826],
	"lilly":                              &z[827],
	"limited":                            &z[828],
	"limo":                               &z[829],
	"lincoln":                            &z[830],
	"linde":                              &z[831],
	"link":                               &z[832],
	"lipsy":                              &z[833],
	"live":                               &z[834],
	"livestrong":                         &z[835],
	"living":                             &z[836],
	"lixil":                              &z[837],
	"lk":                                 &z[838],
	"llc":                                &z[839],
	"llp":                                &z[840],
	"loan":                               &z[841],
	"loans":                              &z[842],
	"locker":                             &z[843],
	"locus":                              &z[844],
	"loft":                               &z[845],
	"lol":                                &z[846],
	"london":                             &z[847],
	"loreal":                             &z[848],
	"lotte":                              &z[849],
	"lotto":                              &z[850],
	"love":                               &z[851],
	"lpl":                                &z[852],
	"lplfinancial":                       &z[853],
	"lr":                                 &z[854],
	"ls":                                 &z[855],
	"lt":                                 &z[856],
	"ltd":                                &z[857],
	"ltda":                               &z[858],
	"lu":                                 &z[859],
	"lundbeck":                           &z[860],
	"lupin":                              &z[861],
	"luxe":                               &z[862],
	"luxury":                             &z[863],
	"lv":                                 &z[864],
	"ly":                                 &z[865],
	"ma":                                 &z[866],
	"macys":                              &z[867],
	"madrid":                             &z[868],
	"maif":                               &z[869],
	"mail":                               &z[870],
	"maison":                             &z[871],
	"makeup":                             &z[872],
	"man":                                &z[873],
	"management":                         &z[874],
	"mango":                              &z[875],
	"map":                                &z[876],
	"market":                             &z[877],
	"marketing":                          &z[878],
	"markets":                            &z[879],
	"marriott":                           &z[880],
	"marshalls":                          &z[881],
	"maserati":                           &z[882],
	"matrix":                             &z[883],
	"mattel":                             &z[884],
	"maybelline":                         &z[885],
	"mba":                                &z[886],
	"mc":                                 &z[887],
	"mcd":                                &z[888],
	"mcdonalds":                          &z[889],
	"mckinsey":                           &z[890],
	"md":                                 &z[891],
	"me":                                 &z[892],
	"med":                                &z[893],
	"media":                              &z[894],
	"medical":                            &z[895],
	"meet":                               &z[896],
	"melbourne":                          &z[897],
	"meme":                               &z[898],
	"memorial":                           &z[899],
	"men":                                &z[900],
	"menu":                               &z[901],
	"meo":                                &z[902],
	"merck":                              &z[903],
	"merckmsd":                           &z[904],
	"metlife":                            &z[905],
	"mf":                                 &z[906],
	"mg":                                 &z[907],
	"mh":                                 &z[908],
	"miami":                              &z[909],
	"microsoft":                          &z[910],
	"mih":                                &z[911],
	"mii":                                &z[912],
	"mil":                                &z[913],
	"mini":                               &z[914],
	"mint":                               &z[915],
	"mit":                                &z[916],
	"mitek":                              &z[917],
	"mitsubishi":                         &z[918],
	"mk":                                 &z[919],
	"ml":                                 &z[920],
	"mlb":                                &z[921],
	"mls":                                &z[922],
	"mm":                                 &z[923],
	"mma":                                &z[924],
	"mn":                                 &z[925],
	"mnet":                               &z[926],
	"mo":                                 &z[927],
	"mobi":                               &z[928],
	"mobile":                             &z[929],
	"mobily":                             &z[930],
	"moda":                               &z[931],
	"moe":                                &z[932],
	"moi":                                &z[933],
	"mom":                                &z[934],
	"monash":                             &z[935],
	"money":                              &z[936],
	"monster":                            &z[937],
	"montblanc":                          &z[938],
	"mopar":                              &z[939],
	"mormon":                             &z[940],
	"mortgage":                           &z[941],
	"moscow":                             &z[942],
	"moto":                               &z[943],
	"motorcycles":                        &z[944],
	"mov":                                &z[945],
	"movie":                              &z[946],
	"movistar":                           &z[947],
	"mozaic":                             &z[948],
	"mp":                                 &z[949],
	"mq":                                 &z[950],
	"mr":                                 &z[951],
	"mrmuscle":                           &z[952],
	"mrporter":                           &z[953],
	"ms":                                 &z[954],
	"msd":                                &z[955],
	"mt":                                 &z[956],
	"mtn":                                &z[957],
	"mtpc":                               &z[958],
	"mtr":                                &z[959],
	"mu":                                 &z[960],
	"multichoice":                        &z[961],
	"museum":                             &z[962],
	"music":                              &z[963],
	"mutual":                             &z[964],
	"mutualfunds":                        &z[965],
	"mutuelle":                           &z[966],
	"mv":                                 &z[967],
	"mw":                                 &z[968],
	"mx":                                 &z[969],
	"my":                                 &z[970],
	"mz":                                 &z[971],
	"mzansimagic":                        &z[972],
	"na":                                 &z[973],
	"nab":                                &z[974],
	"nadex":                              &z[975],
	"nagoya":                             &z[976],
	"name":                               &z[977],
	"naspers":                            &z[978],
	"nationwide":                         &z[979],
	"natura":                             &z[980],
	"navy":                               &z[981],
	"nba":                                &z[982],
	"nc":                                 &z[983],
	"ne":                                 &z[984],
	"nec":                                &z[985],
	"net":                                &z[986],
	"netaporter":                         &z[987],
	"netbank":                            &z[988],
	"netflix":                            &z[989],
	"network":                            &z[990],
	"neustar":                            &z[991],
	"new":                                &z[992],
	"newholland":                         &z[993],
	"news":                               &z[994],
	"next":                               &z[995],
	"nextdirect":                         &z[996],
	"nexus":                              &z[997],
	"nf":                                 &z[998],
	"nfl":                                &z[999],
	"ng":                                 &z[1000],
	"ngo":                                &z[1001],
	"nhk":                                &z[1002],
	"ni":                                 &z[1003],
	"nico":                               &z[1004],
	"nike":                               &z[1005],
	"nikon":                              &z[1006],
	"ninja":                              &z[1007],
	"nissan":                             &z[1008],
	"nissay":                             &z[1009],
	"nl":                                 &z[1010],
	"no":                                 &z[1011],
	"nokia":                              &z[1012],
	"northlandinsurance":                 &z[1013],
	"northwesternmutual":                 &z[1014],
	"norton":                             &z[1015],
	"now":                                &z[1016],
	"nowruz":                             &z[1017],
	"nowtv":                              &z[1018],
	"np":                                 &z[1019],
	"nr":                                 &z[1020],
	"nra":                                &z[1021],
	"nrw":                                &z[1022],
	"ntt":                                &z[1023],
	"nu":                                 &z[1024],
	"nyc":                                &z[1025],
	"nz":                                 &z[1026],
	"obi":                                &z[1027],
	"observer":                           &z[1028],
	"off":                                &z[1029],
	"office":                             &z[1030],
	"okinawa":                            &z[1031],
	"olayan":                             &z[1032],
	"olayangroup":                        &z[1033],
	"oldnavy":                            &z[1034],
	"ollo":                               &z[1035],
	"olympus":                            &z[1036],
	"om":                                 &z[1037],
	"omega":                              &z[1038],
	"one":                                &z[1039],
	"ong":                                &z[1040],
	"onl":                                &z[1041],
	"online":                             &z[1042],
	"onyourside":                         &z[1043],
	"ooo":                                &z[1044],
	"open":                               &z[1045],
	"oracle":                             &z[1046],
	"orange":                             &z[1047],
	"org":                                &z[1048],
	"organic":                            &z[1049],
	"orientexpress":                      &z[1050],
	"origin":                             &z[1051],
	"origins":                            &z[1052],
	"osaka":                              &z[1053],
	"otsuka":                             &z[1054],
	"ott":                                &z[1055],
	"overheidnl":                         &z[1056],
	"ovh":                                &z[1057],
	"pa":                                 &z[1058],
	"page":                               &z[1059],
	"pamperedchef":                       &z[1060],
	"panasonic":                          &z[1061],
	"panerai":                            &z[1062],
	"paris":                              &z[1063],
	"pars":                               &z[1064],
	"partners":                           &z[1065],
	"parts":                              &z[1066],
	"party":                              &z[1067],
	"passagens":                          &z[1068],
	"patagonia":                          &z[1069],
	"patch":                              &z[1070],
	"pay":                                &z[1071],
	"payu":                               &z[1072],
	"pccw":                               &z[1073],
	"pe":                                 &z[1074],
	"persiangulf":                        &z[1075],
	"pet":                                &z[1076],
	"pets":                               &z[1077],
	"pf":                                 &z[1078],
	"pfizer":                             &z[1079],
	"pg":                                 &z[1080],
	"ph":                                 &z[1081],
	"pharmacy":                           &z[1082],
	"phd":                                &z[1083],
	"philips":                            &z[1084],
	"phone":                              &z[1085],
	"photo":                              &z[1086],
	"photography":                        &z[1087],
	"photos":                             &z[1088],
	"physio":                             &z[1089],
	"piaget":                             &z[1090],
	"pics":                               &z[1091],
	"pictet":                             &z[1092],
	"pictures":                           &z[1093],
	"pid":                                &z[1094],
	"pin":                                &z[1095],
	"ping":                               &z[1096],
	"pink":                               &z[1097],
	"pioneer":                            &z[1098],
	"piperlime":                          &z[1099],
	"pitney":                             &z[1100],
	"pizza":                              &z[1101],
	"pk":                                 &z[1102],
	"pl":                                 &z[1103],
	"place":                              &z[1104],
	"play":                               &z[1105],
	"playstation":                        &z[1106],
	"plumbing":                           &z[1107],
	"plus":                               &z[1108],
	"pm":                                 &z[1109],
	"pn":                                 &z[1110],
	"pnc":                                &z[1111],
	"pohl":                               &z[1112],
	"poker":                              &z[1113],
	"politie":                            &z[1114],
	"polo":                               &z[1115],
	"porn":                               &z[1116],
	"post":                               &z[1117],
	"pr":                                 &z[1118],
	"pramerica":                          &z[1119],
	"praxi":                              &z[1120],
	"press":                              &z[1121],
	"prime":                              &z[1122],
	"pro":                                &z[1123],
	"prod":                               &z[1124],
	"productions":                        &z[1125],
	"prof":                               &z[1126],
	"progressive":                        &z[1127],
	"promo":                              &z[1128],
	"properties":                         &z[1129],
	"property":                           &z[1130],
	"protection":                         &z[1131],
	"pru":                                &z[1132],
	"prudential":                         &z[1133],
	"ps":                                 &z[1134],
	"pt":                                 &z[1135],
	"pub":                                &z[1136],
	"pw":                                 &z[1137],
	"pwc":                                &z[1138],
	"py":                                 &z[1139],
	"qa":                                 &z[1140],
	"qpon":                               &z[1141],
	"qtel":                               &z[1142],
	"quebec":                             &z[1143],
	"quest":                              &z[1144],
	"qvc":                                &z[1145],
	"racing":                             &z[1146],
	"radio":                              &z[1147],
	"raid":                               &z[1148],
	"ram":                                &z[1149],
	"re":                                 &z[1150],
	"read":                               &z[1151],
	"realestate":                         &z[1152],
	"realtor":                            &z[1153],
	"realty":                             &z[1154],
	"recipes":                            &z[1155],
	"red":                                &z[1156],
	"redken":                             &z[1157],
	"redstone":                           &z[1158],
	"redumbrella":                        &z[1159],
	"rehab":                              &z[1160],
	"reise":                              &z[1161],
	"reisen":                             &z[1162],
	"reit":                               &z[1163],
	"reliance":                           &z[1164],
	"ren":                                &z[1165],
	"rent":                               &z[1166],
	"rentals":                            &z[1167],
	"repair":                             &z[1168],
	"report":                             &z[1169],
	"republican":                         &z[1170],
	"rest":                               &z[1171],
	"restaurant":                         &z[1172],
	"retirement":                         &z[1173],
	"review":                             &z[1174],
	"reviews":                            &z[1175],
	"rexroth":                            &z[1176],
	"rich":                               &z[1177],
	"richardli":                          &z[1178],
	"ricoh":                              &z[1179],
	"rightathome":                        &z[1180],
	"ril":                                &z[1181],
	"rio":                                &z[1182],
	"rip":                                &z[1183],
	"rmit":                               &z[1184],
	"ro":                                 &z[1185],
	"rocher":                             &z[1186],
	"rocks":                              &z[1187],
	"rockwool":                           &z[1188],
	"rodeo":                              &z[1189],
	"rogers":                             &z[1190],
	"roma":                               &z[1191],
	"room":                               &z[1192],
	"root":                               &z[1193],
	"rs":                                 &z[1194],
	"rsvp":                               &z[1195],
	"ru":                                 &z[1196],
	"rugby":                              &z[1197],
	"ruhr":                               &z[1198],
	"run":                                &z[1199],
	"rw":                                 &z[1200],
	"rwe":                                &z[1201],
	"ryukyu":                             &z[1202],
	"sa":                                 &z[1203],
	"saarland":                           &z[1204],
	"safe":                               &z[1205],
	"safety":                             &z[1206],
	"safeway":                            &z[1207],
	"sakura":                             &z[1208],
	"sale":                               &z[1209],
	"salon":                              &z[1210],
	"samsclub":                           &z[1211],
	"samsung":                            &z[1212],
	"sandvik":                            &z[1213],
	"sandvikcoromant":                    &z[1214],
	"sanofi":                             &z[1215],
	"sap":                                &z[1216],
	"sapo":                               &z[1217],
	"sapphire":                           &z[1218],
	"sarl":                               &z[1219],
	"sas":                                &z[1220],
	"save":                               &z[1221],
	"saxo":                               &z[1222],
	"sb":                                 &z[1223],
	"sbi":                                &z[1224],
	"sbs":                                &z[1225],
	"sc":                                 &z[1226],
	"sca":                                &z[1227],
	"scb":                                &z[1228],
	"schaeffler":                         &z[1229],
	"schmidt":                            &z[1230],
	"scholarships":                       &z[1231],
	"school":                             &z[1232],
	"schule":                             &z[1233],
	"schwarz":                            &z[1234],
	"schwarzgroup":                       &z[1235],
	"science":                            &z[1236],
	"scjohnson":                          &z[1237],
	"scor":                               &z[1238],
	"scot":                               &z[1239],
	"sd":                                 &z[1240],
	"se":                                 &z[1241],
	"search":                             &z[1242],
	"seat":                               &z[1243],
	"secure":                             &z[1244],
	"security":                           &z[1245],
	"seek":                               &z[1246],
	"select":                             &z[1247],
	"sener":                              &z[1248],
	"services":                           &z[1249],
	"ses":                                &z[1250],
	"seven":                              &z[1251],
	"sew":                                &z[1252],
	"sex":                                &z[1253],
	"sexy":                               &z[1254],
	"sfr":                                &z[1255],
	"sg":                                 &z[1256],
	"sh":                                 &z[1257],
	"shangrila":                          &z[1258],
	"sharp":                              &z[1259],
	"shaw":                               &z[1260],
	"shell":                              &z[1261],
	"shia":                               &z[1262],
	"shiksha":                            &z[1263],
	"shoes":                              &z[1264],
	"shop":                               &z[1265],
	"shopping":                           &z[1266],
	"shopyourway":                        &z[1267],
	"shouji":                             &z[1268],
	"show":                               &z[1269],
	"showtime":                           &z[1270],
	"shriram":                            &z[1271],
	"si":                                 &z[1272],
	"silk":                               &z[1273],
	"sina":                               &z[1274],
	"singles":                            &z[1275],
	"site":                               &z[1276],
	"sj":                                 &z[1277],
	"sk":                                 &z[1278],
	"ski":                                &z[1279],
	"skin":                               &z[1280],
	"skolkovo":                           &z[1281],
	"sky":                                &z[1282],
	"skydrive":                           &z[1283],
	"skype":                              &z[1284],
	"sl":                                 &z[1285],
	"sling":                              &z[1286],
	"sm":                                 &z[1287],
	"smart":                              &z[1288],
	"smile":                              &z[1289],
	"sn":                                 &z[1290],
	"sncf":                               &z[1291],
	"so":                                 &z[1292],
	"soccer":                             &z[1293],
	"social":                             &z[1294],
	"softbank":                           &z[1295],
	"software":                           &z[1296],
	"sohu":                               &z[1297],
	"solar":                              &z[1298],
	"solutions":                          &z[1299],
	"song":                               &z[1300],
	"sony":                               &z[1301],
	"soy":                                &z[1302],
	"spa":                                &z[1303],
	"space":                              &z[1304],
	"spiegel":                            &z[1305],
	"sport":                              &z[1306],
	"sports":                             &z[1307],
	"spot":                               &z[1308],
	"spreadbetting":                      &z[1309],
	"sr":                                 &z[1310],
	"srl":                                &z[1311],
	"srt":                                &z[1312],
	"ss":                                 &z[1313],
	"st":                                 &z[1314],
	"stada":                              &z[1315],
	"staples":                            &z[1316],
	"star":                               &z[1317],
	"starhub":                            &z[1318],
	"statebank":                          &z[1319],
	"statefarm":                          &z[1320],
	"statoil":                            &z[1321],
	"stc":                                &z[1322],
	"stcgroup":                           &z[1323],
	"stockholm":                          &z[1324],
	"storage":                            &z[1325],
	"store":                              &z[1326],
	"stream":                             &z[1327],
	"stroke":                             &z[1328],
	"studio":                             &z[1329],
	"study":                              &z[1330],
	"style":                              &z[1331],
	"su":                                 &z[1332],
	"sucks":                              &z[1333],
	"supersport":                         &z[1334],
	"supplies":                           &z[1335],
	"supply":                             &z[1336],
	"support":                            &z[1337],
	"surf":                               &z[1338],
	"surgery":                            &z[1339],
	"suzuki":                             &z[1340],
	"sv":                                 &z[1341],
	"svr":                                &z[1342],
	"swatch":                             &z[1343],
	"swiftcover":                         &z[1344],
	"swiss":                              &z[1345],
	"sx":                                 &z[1346],
	"sy":                                 &z[1347],
	"sydney":                             &z[1348],
	"symantec":                           &z[1349],
	"systems":                            &z[1350],
	"sz":                                 &z[1351],
	"tab":                                &z[1352],
	"taipei":                             &z[1353],
	"talk":                               &z[1354],
	"taobao":                             &z[1355],
	"target":                             &z[1356],
	"tata":                               &z[1357],
	"tatamotors":                         &z[1358],
	"tatar":                              &z[1359],
	"tattoo":                             &z[1360],
	"tax":                                &z[1361],
	"taxi":                               &z[1362],
	"tc":                                 &z[1363],
	"tci":                                &z[1364],
	"td":                                 &z[1365],
	"tdk":                                &z[1366],
	"team":                               &z[1367],
	"tech":                               &z[1368],
	"technology":                         &z[1369],
	"tel":                                &z[1370],
	"telecity":                           &z[1371],
	"telefonica":                         &z[1372],
	"temasek":                            &z[1373],
	"tennis":                             &z[1374],
	"terra":                              &z[1375],
	"teva":                               &z[1376],
	"tf":                                 &z[1377],
	"tg":                                 &z[1378],
	"th":                                 &z[1379],
	"thai":                               &z[1380],
	"thd":                                &z[1381],
	"theater":                            &z[1382],
	"theatre":                            &z[1383],
	"theguardian":                        &z[1384],
	"thehartford":                        &z[1385],
	"tiaa":                               &z[1386],
	"tickets":                            &z[1387],
	"tienda":                             &z[1388],
	"tiffany":                            &z[1389],
	"tiffay":                             &z[1390],
	"tiia":                               &z[1391],
	"tips":                               &z[1392],
	"tires":                              &z[1393],
	"tirol":                              &z[1394],
	"tj":                                 &z[1395],
	"tjmaxx":                             &z[1396],
	"tjx":                                &z[1397],
	"tk":                                 &z[1398],
	"tkmaxx":                             &z[1399],
	"tl":                                 &z[1400],
	"tm":                                 &z[1401],
	"tmall":                              &z[1402],
	"tn":                                 &z[1403],
	"to":                                 &z[1404],
	"today":                              &z[1405],
	"tokyo":                              &z[1406],
	"tools":                              &z[1407],
	"top":                                &z[1408],
	"toray":                              &z[1409],
	"toshiba":                            &z[1410],
	"total":                              &z[1411],
	"tour":                               &z[1412],
	"tours":                              &z[1413],
	"town":                               &z[1414],
	"toyota":                             &z[1415],
	"toys":                               &z[1416],
	"tp":                                 &z[1417],
	"tr":                                 &z[1418],
	"trade":                              &z[1419],
	"tradershotels":                      &z[1420],
	"trading":                            &z[1421],
	"training":                           &z[1422],
	"transformers":                       &z[1423],
	"translations":                       &z[1424],
	"transunion":                         &z[1425],
	"travel":                             &z[1426],
	"travelchannel":                      &z[1427],
	"travelers":                          &z[1428],
	"travelersinsurance":                 &z[1429],
	"travelguard":                        &z[1430],
	"trust":                              &z[1431],
	"trv":                                &z[1432],
	"tt":                                 &z[1433],
	"tube":                               &z[1434],
	"tui":                                &z[1435],
	"tunes":                              &z[1436],
	"tushu":                              &z[1437],
	"tv":                                 &z[1438],
	"tvs":                                &z[1439],
	"tw":                                 &z[1440],
	"tz":                                 &z[1441],
	"ua":                                 &z[1442],
	"ubank":                              &z[1443],
	"ubs":                                &z[1444],
	"uconnect":                           &z[1445],
	"ug":                                 &z[1446],
	"uk":                                 &z[1447],
	"ultrabook":                          &z[1448],
	"um":                                 &z[1449],
	"ummah":                              &z[1450],
	"unicom":                             &z[1451],
	"unicorn":                            &z[1452],
	"university":                         &z[1453],
	"uno":                                &z[1454],
	"uol":                                &z[1455],
	"ups":                                &z[1456],
	"us":                                 &z[1457],
	"uy":                                 &z[1458],
	"uz":                                 &z[1459],
	"va":                                 &z[1460],
	"vacations":                          &z[1461],
	"vana":                               &z[1462],
	"vanguard":                           &z[1463],
	"vanish":                             &z[1464],
	"vc":                                 &z[1465],
	"ve":                                 &z[1466],
	"vegas":                              &z[1467],
	"ventures":                           &z[1468],
	"verisign":                           &z[1469],
	"xn--vermgensberater-ctb":            &z[1470], // vermögensberater
	"xn--vermgensberatung-pwb":           &z[1471], // vermögensberatung
	"versicherung":                       &z[1472],
	"vet":                                &z[1473],
	"vg":                                 &z[1474],
	"vi":                                 &z[1475],
	"viajes":                             &z[1476],
	"video":                              &z[1477],
	"vig":                                &z[1478],
	"viking":                             &z[1479],
	"villas":                             &z[1480],
	"vin":                                &z[1481],
	"vip":                                &z[1482],
	"virgin":                             &z[1483],
	"visa":                               &z[1484],
	"vision":                             &z[1485],
	"vista":                              &z[1486],
	"vistaprint":                         &z[1487],
	"viva":                               &z[1488],
	"vivo":                               &z[1489],
	"vlaanderen":                         &z[1490],
	"vn":                                 &z[1491],
	"vodka":                              &z[1492],
	"volkswagen":                         &z[1493],
	"volvo":                              &z[1494],
	"vons":                               &z[1495],
	"vote":                               &z[1496],
	"voting":                             &z[1497],
	"voto":                               &z[1498],
	"voyage":                             &z[1499],
	"vu":                                 &z[1500],
	"vuelos":                             &z[1501],
	"wales":                              &z[1502],
	"walmart":                            &z[1503],
	"walter":                             &z[1504],
	"wang":                               &z[1505],
	"wanggou":                            &z[1506],
	"warman":                             &z[1507],
	"watch":                              &z[1508],
	"watches":                            &z[1509],
	"weather":                            &z[1510],
	"weatherchannel":                     &z[1511],
	"web":                                &z[1512],
	"webcam":                             &z[1513],
	"weber":                              &z[1514],
	"webjet":                             &z[1515],
	"webs":                               &z[1516],
	"website":                            &z[1517],
	"wed":                                &z[1518],
	"wedding":                            &z[1519],
	"weibo":                              &z[1520],
	"weir":                               &z[1521],
	"wf":                                 &z[1522],
	"whoswho":                            &z[1523],
	"wien":                               &z[1524],
	"wiki":                               &z[1525],
	"williamhill":                        &z[1526],
	"wilmar":                             &z[1527],
	"win":                                &z[1528],
	"windows":                            &z[1529],
	"wine":                               &z[1530],
	"winners":                            &z[1531],
	"wme":                                &z[1532],
	"wolterskluwer":                      &z[1533],
	"woodside":                           &z[1534],
	"work":                               &z[1535],
	"works":                              &z[1536],
	"world":                              &z[1537],
	"wow":                                &z[1538],
	"ws":                                 &z[1539],
	"wtc":                                &z[1540],
	"wtf":                                &z[1541],
	"xbox":                               &z[1542],
	"xerox":                              &z[1543],
	"xfinity":                            &z[1544],
	"xihuan":                             &z[1545],
	"xin":                                &z[1546],
	"xperia":                             &z[1547],
	"xxx":                                &z[1548],
	"xyz":                                &z[1549],
	"yachts":                             &z[1550],
	"yahoo":                              &z[1551],
	"yamaxun":                            &z[1552],
	"yandex":                             &z[1553],
	"ye":                                 &z[1554],
	"yellowpages":                        &z[1555],
	"yodobashi":                          &z[1556],
	"yoga":                               &z[1557],
	"yokohama":                           &z[1558],
	"you":                                &z[1559],
	"youtube":                            &z[1560],
	"yt":                                 &z[1561],
	"yu":                                 &z[1562],
	"yun":                                &z[1563],
	"za":                                 &z[1564],
	"zappos":                             &z[1565],
	"zara":                               &z[1566],
	"zero":                               &z[1567],
	"zip":                                &z[1568],
	"zippo":                              &z[1569],
	"zm":                                 &z[1570],
	"zone":                               &z[1571],
	"zuerich":                            &z[1572],
	"zulu":                               &z[1573],
	"zw":                                 &z[1574],
	"xn--jxalpdlp":                       &z[1575], // δοκιμή
	"xn--qxam":                           &z[1576], // ελ
	"xn--qxa6a":                          &z[1577], // ευ
	"xn--90ae":                           &z[1578], // бг
	"xn--90ais":                          &z[1579], // бел
	"xn--d1acj3b":                        &z[1580], // дети
	"xn--e1a4c":                          &z[1581], // ею
	"xn--80akhbyknj4f":                   &z[1582], // испытание
	"xn--80aqecdr1a":                     &z[1583], // католик
	"xn--j1aef":                          &z[1584], // ком
	"xn--d1alf":                          &z[1585], // мкд
	"xn--l1acc":                          &z[1586], // мон
	"xn--80adxhks":                       &z[1587], // москва
	"xn--80asehdb":                       &z[1588], // онлайн
	"xn--c1avg":                          &z[1589], // орг
	"xn--p1acf":                          &z[1590], // рус
	"xn--p1ai":                           &z[1591], // рф
	"xn--80aswg":                         &z[1592], // сайт
	"xn--90a3ac":                         &z[1593], // срб
	"xn--j1amh":                          &z[1594], // укр
	"xn--80ao21a":                        &z[1595], // қаз
	"xn--y9a3aq":                         &z[1596], // հայ
	"xn--deba0ad":                        &z[1597], // טעסט
	"xn--9dbq2a":                         &z[1598], // קום
	"xn--hgbk6aj7f53bba":                 &z[1599], // آزمایشی
	"xn--kgbechtv":                       &z[1600], // إختبار
	"xn--mgbca7dzdo":                     &z[1601], // ابوظبي
	"xn--mgbaakc7dvf":                    &z[1602], // اتصالات
	"xn--mgba3a3ejt":                     &z[1603], // ارامكو
	"xn--mgbayh7gpa":                     &z[1604], // الاردن
	"xn--mgbcpq6gpa1a":                   &z[1605], // البحرين
	"xn--lgbbat1ad8j":                    &z[1606], // الجزائر
	"xn--mgberp4a5d4ar":                  &z[1607], // السعودية
	"xn--mgba7c0bbn0a":                   &z[1608], // العليان
	"xn--mgbc0a9azcg":                    &z[1609], // المغرب
	"xn--mgbaam7a8h":                     &z[1610], // امارات
	"xn--mgba3a4f16a":                    &z[1611], // ایران
	"xn--mgbbh1a":                        &z[1612], // بارت
	"xn--mgbab2bd":                       &z[1613], // بازار
	"xn--ngbe9e0a":                       &z[1614], // بيتك
	"xn--mgbbh1a71e":                     &z[1615], // بھارت
	"xn--pgbs0dh":                        &z[1616], // تونس
	"xn--mgbpl2fh":                       &z[1617], // سودان
	"xn--ogbpf8fl":                       &z[1618], // سورية
	"xn--ngbc5azd":                       &z[1619], // شبكة
	"xn--mgbtx2b":                        &z[1620], // عراق
	"xn--ngbrx":                          &z[1621], // عرب
	"xn--mgb9awbf":                       &z[1622], // عمان
	"xn--ygbi2ammx":                      &z[1623], // فلسطين
	"xn--wgbl6a":                         &z[1624], // قطر
	"xn--mgbi4ecexp":                     &z[1625], // كاثوليك
	"xn--fhbei":                          &z[1626], // كوم
	"xn--pgb3ceoj":                       &z[1627], // كيوتل
	"xn--wgbh1c":                         &z[1628], // مصر
	"xn--mgbx4cd0ab":                     &z[1629], // مليسيا
	"xn--mgbb9fbpob":                     &z[1630], // موبايلي
	"xn--mgbah1a3hjkrd":                  &z[1631], // موريتانيا
	"xn--mgbv6cfpo":                      &z[1632], // موزايك
	"xn--4gbrim":                         &z[1633], // موقع
	"xn--mgbt3dhd":                       &z[1634], // همراه
	"xn--mgbai9azgqp6j":                  &z[1635], // پاکستان
	"xn--mgbgu82a":                       &z[1636], // ڀارت
	"xn--11b4c3d":                        &z[1637], // कॉम
	"xn--c2br7g":                         &z[1638], // नेट
	"xn--11b5bs3a9aj6g":                  &z[1639], // परीक्षा
	"xn--h2brj9c":                        &z[1640], // भारत
	"xn--h2breg3eve":                     &z[1641], // भारतम्
	"xn--h2brj9c8c":                      &z[1642], // भारोत
	"xn--i1b6b1a6a2e":                    &z[1643], // संगठन
	"xn--54b7fta0cc":                     &z[1644], // বাংলা
	"xn--45brj9c":                        &z[1645], // ভারত
	"xn--45br5cyl":                       &z[1646], // ভাৰত
	"xn--s9brj9c":                        &z[1647], // ਭਾਰਤ
	"xn--gecrj9c":                        &z[1648], // ભારત
	"xn--3hcrj9c":                        &z[1649], // ଭାରତ
	"xn--xkc2dl3a5ee0h":                  &z[1650], // இந்தியா
	"xn--xkc2al3hye2a":                   &z[1651], // இலங்கை
	"xn--clchc0ea0b2g2a9gcd":             &z[1652], // சிங்கப்பூர்
	"xn--hlcj6aya9esc7a":                 &z[1653], // பரிட்சை
	"xn--fpcrj9c3d":                      &z[1654], // భారత్
	"xn--2scrj9c":                        &z[1655], // ಭಾರತ
	"xn--rvc1e0am3e":                     &z[1656], // ഭാരതം
	"xn--fzc2c9e2c":                      &z[1657], // ලංකා
	"xn--42c2d9a":                        &z[1658], // คอม
	"xn--o3cw4h":                         &z[1659], // ไทย
	"xn--q7ce6a":                         &z[1660], // ລາວ
	"xn--node":                           &z[1661], // გე
	"xn--q9jyb4c":                        &z[1662], // みんな
	"xn--cckwcxetd":                      &z[1663], // アマゾン
	"xn--gckr3f0f":                       &z[1664], // クラウド
	"xn--qcka1pmc":                       &z[1665], // グーグル
	"xn--tckwe":                          &z[1666], // コム
	"xn--cck2b3b":                        &z[1667], // ストア
	"xn--1ck2e1b":                        &z[1668], // セール
	"xn--zckzah":                         &z[1669], // テスト
	"xn--bck1b9a5dre4c":                  &z[1670], // ファッション
	"xn--eckvdtc9d":                      &z[1671], // ポイント
	"xn--4gq48lf9j":                      &z[1672], // 一号店
	"xn--rhqv96g":                        &z[1673], // 世界
	"xn--fiq64b":                         &z[1674], // 中信
	"xn--fiqs8s":                         &z[1675], // 中国
	"xn--fiqz9s":                         &z[1676], // 中國
	"xn--fiq228c5hs":                     &z[1677], // 中文网
	"xn--jlq480n2rg":                     &z[1678], // 亚马逊
	"xn--vhquv":                          &z[1679], // 企业
	"xn--1qqw23a":                        &z[1680], // 佛山
	"xn--vuq861b":                        &z[1681], // 信息
	"xn--nyqy26a":                        &z[1682], // 健康
	"xn--45q11c":                         &z[1683], // 八卦
	"xn--55qx5d":                         &z[1684], // 公司
	"xn--55qw42g":                        &z[1685], // 公益
	"xn--kprw13d":                        &z[1686], // 台湾
	"xn--kpry57d":                        &z[1687], // 台灣
	"xn--czru2d":                         &z[1688], // 商城
	"xn--czrs0t":                         &z[1689], // 商店
	"xn--czr694b":                        &z[1690], // 商标
	"xn--w4rs40l":                        &z[1691], // 嘉里
	"xn--w4r85el8fhu5dnra":               &z[1692], // 嘉里大酒店
	"xn--3ds443g":                        &z[1693], // 在线
	"xn--3oq18vl8pn36a":                  &z[1694], // 大众汽车
	"xn--pssy2u":                         &z[1695], // 大拿
	"xn--tiq49xqyj":                      &z[1696], // 天主教
	"xn--fjq720a":                        &z[1697], // 娱乐
	"xn--fct429k":                        &z[1698], // 家電
	"xn--estv75g":                        &z[1699], // 工行
	"xn--xhq521b":                        &z[1700], // 广东
	"xn--6rtwn":                          &z[1701], // 广州
	"xn--9krt00a":                        &z[1702], // 微博
	"xn--30rr7y":                         &z[1703], // 慈善
	"xn--6qq986b3xl":                     &z[1704], // 我爱你
	"xn--kput3i":                         &z[1705], // 手机
	"xn--kpu716f":                        &z[1706], // 手表
	"xn--otu796d":                        &z[1707], // 招聘
	"xn--zfr164b":                        &z[1708], // 政务
	"xn--mxtq1m":                         &z[1709], // 政府
	"xn--yfro4i67o":                      &z[1710], // 新加坡
	"xn--efvy88h":                        &z[1711], // 新闻
	"xn--9et52u":                         &z[1712], // 时尚
	"xn--kcrx7bb75ajk3b":                 &z[1713], // 普利司通
	"xn--rovu88b":                        &z[1714], // 書籍
	"xn--nqv7f":                          &z[1715], // 机构
	"xn--tqq33ed31aqia":                  &z[1716], // 机构体制
	"xn--dkwm73cwpn":                     &z[1717], // 欧莱雅
	"xn--0zwm56d":                        &z[1718], // 测试
	"xn--b4w605ferd":                     &z[1719], // 淡马锡
	"xn--fes124c":                        &z[1720], // 深圳
	"xn--g6w251d":                        &z[1721], // 測試
	"xn--unup4y":                         &z[1722], // 游戏
	"xn--mix891f":                        &z[1723], // 澳門
	"xn--3pxu8k":                         &z[1724], // 点看
	"xn--pbt977c":                        &z[1725], // 珠宝
	"xn--hxt035cmppuel":                  &z[1726], // 盛貿飯店
	"xn--6frz82g":                        &z[1727], // 移动
	"xn--nqv7fs00ema":                    &z[1728], // 组织机构
	"xn--ses554g":                        &z[1729], // 网址
	"xn--hxt814e":                        &z[1730], // 网店
	"xn--5tzm5g":                         &z[1731], // 网站
	"xn--io0a7i":                         &z[1732], // 网络
	"xn--8y0a063a":                       &z[1733], // 联通
	"xn--jlq61u9w7b":                     &z[1734], // 诺基亚
	"xn--flw351e":                        &z[1735], // 谷歌
	"xn--g2xx48c":                        &z[1736], // 购物
	"xn--55qx5d8y0buji4b870u":            &z[1737], // 通用电气公司
	"xn--gk3at1e":                        &z[1738], // 通販
	"xn--3bst00m":                        &z[1739], // 集团
	"xn--fzys8d69uvgm":                   &z[1740], // 電訊盈科
	"xn--kcrx77d1x4a":                    &z[1741], // 飞利浦
	"xn--jvr189m":                        &z[1742], // 食品
	"xn--imr513n":                        &z[1743], // 餐厅
	"xn--5su34j936bgsg":                  &z[1744], // 香格里拉
	"xn--j6w193g":                        &z[1745], // 香港
	"xn--j6w470d71issc":                  &z[1746], // 香港電訊
	"xn--c1yn36f":                        &z[1747], // 點看
	"xn--t60b56a":                        &z[1748], // 닷넷
	"xn--mk1bu44c":                       &z[1749], // 닷컴
	"xn--cg4bki":                         &z[1750], // 삼성
	"xn--9t4b11yi5a":                     &z[1751], // 테스트
	"xn--3e0b707e":                       &z[1752], // 한국
	"com.ac":                             &z[1753],
	"gov.ac":                             &z[1754],
	"mil.ac":                             &z[1755],
	"net.ac":                             &z[1756],
	"org.ac":                             &z[1757],
	"nom.ad":                             &z[1758],
	"ac.ae":                              &z[1759],
	"co.ae":                              &z[1760],
	"gov.ae":                             &z[1761],
	"mil.ae":                             &z[1762],
	"name.ae":                            &z[1763],
	"net.ae":                             &z[1764],
	"org.ae":                             &z[1765],
	"pro.ae":                             &z[1766],
	"sch.ae":                             &z[1767],
	"airport.aero":                       &z[1768],
	"cargo.aero":                         &z[1769],
	"charter.aero":                       &z[1770],
	"bank.af":                            &z[1771],
	"com.af":                             &z[1772],
	"edu.af":                             &z[1773],
	"gov.af":                             &z[1774],
	"hotel.af":                           &z[1775],
	"law.af":                             &z[1776],
	"music.af":                           &z[1777],
	"net.af":                             &z[1778],
	"org.af":                             &z[1779],
	"tv.af":                              &z[1780],
	"co.ag":                              &z[1781],
	"com.ag":                             &z[1782],
	"net.ag":                             &z[1783],
	"nom.ag":                             &z[1784],
	"ok.ag":                              &z[1785],
	"org.ag":                             &z[1786],
	"com.ai":                             &z[1787],
	"net.ai":                             &z[1788],
	"off.ai":                             &z[1789],
	"org.ai":                             &z[1790],
	"com.al":                             &z[1791],
	"edu.al":                             &z[1792],
	"gov.al":                             &z[1793],
	"inima.al":                           &z[1794],
	"net.al":                             &z[1795],
	"org.al":                             &z[1796],
	"soros.al":                           &z[1797],
	"tirana.al":                          &z[1798],
	"uniti.al":                           &z[1799],
	"upt.al":                             &z[1800],
	"co.am":                              &z[1801],
	"com.am":                             &z[1802],
	"net.am":                             &z[1803],
	"north.am":                           &z[1804],
	"org.am":                             &z[1805],
	"radio.am":                           &z[1806],
	"south.am":                           &z[1807],
	"com.an":                             &z[1808],
	"edu.an":                             &z[1809],
	"net.an":                             &z[1810],
	"org.an":                             &z[1811],
	"co.ao":                              &z[1812],
	"ed.ao":                              &z[1813],
	"gv.ao":                              &z[1814],
	"it.ao":                              &z[1815],
	"og.ao":                              &z[1816],
	"pb.ao":                              &z[1817],
	"com.aq":                             &z[1818],
	"com.ar":                             &z[1819],
	"edu.ar":                             &z[1820],
	"gob.ar":                             &z[1821],
	"gov.ar":                             &z[1822],
	"int.ar":                             &z[1823],
	"mil.ar":                             &z[1824],
	"net.ar":                             &z[1825],
	"org.ar":                             &z[1826],
	"tur.ar":                             &z[1827],
	"e164.arpa":                          &z[1828],
	"in-addr.arpa":                       &z[1829],
	"ip6.arpa":                           &z[1830],
	"iris.arpa":                          &z[1831],
	"uri.arpa":                           &z[1832],
	"urn.arpa":                           &z[1833],
	"ac.at":                              &z[1834],
	"co.at":                              &z[1835],
	"gv.at":                              &z[1836],
	"or.at":                              &z[1837],
	"priv.at":                            &z[1838],
	"act.au":                             &z[1839],
	"asn.au":                             &z[1840],
	"com.au":                             &z[1841],
	"conf.au":                            &z[1842],
	"csiro.au":                           &z[1843],
	"edu.au":                             &z[1844],
	"gov.au":                             &z[1845],
	"id.au":                              &z[1846],
	"info.au":                            &z[1847],
	"net.au":                             &z[1848],
	"nsw.au":                             &z[1849],
	"nt.au":                              &z[1850],
	"org.au":                             &z[1851],
	"oz.au":                              &z[1852],
	"qld.au":                             &z[1853],
	"sa.au":                              &z[1854],
	"tas.au":                             &z[1855],
	"telememo.au":                        &z[1856],
	"vic.au":                             &z[1857],
	"wa.au":                              &z[1858],
	"com.aw":                             &z[1859],
	"bilesuvar.az":                       &z[1860],
	"biz.az":                             &z[1861],
	"co.az":                              &z[1862],
	"com.az":                             &z[1863],
	"edu.az":                             &z[1864],
	"ganja.az":                           &z[1865],
	"gov.az":                             &z[1866],
	"imishli.az":                         &z[1867],
	"info.az":                            &z[1868],
	"int.az":                             &z[1869],
	"mil.az":                             &z[1870],
	"name.az":                            &z[1871],
	"net.az":                             &z[1872],
	"org.az":                             &z[1873],
	"pp.az":                              &z[1874],
	"pro.az":                             &z[1875],
	"samux.az":                           &z[1876],
	"shamaxi.az":                         &z[1877],
	"shusha.az":                          &z[1878],
	"sumgait.az":                         &z[1879],
	"zaqatala.az":                        &z[1880],
	"co.ba":                              &z[1881],
	"com.ba":                             &z[1882],
	"edu.ba":                             &z[1883],
	"gov.ba":                             &z[1884],
	"mil.ba":                             &z[1885],
	"net.ba":                             &z[1886],
	"org.ba":                             &z[1887],
	"rs.ba":                              &z[1888],
	"unbi.ba":                            &z[1889],
	"unmo.ba":                            &z[1890],
	"unsa.ba":                            &z[1891],
	"untz.ba":                            &z[1892],
	"unze.ba":                            &z[1893],
	"biz.bb":                             &z[1894],
	"co.bb":                              &z[1895],
	"com.bb":                             &z[1896],
	"gov.bb":                             &z[1897],
	"info.bb":                            &z[1898],
	"net.bb":                             &z[1899],
	"org.bb":                             &z[1900],
	"store.bb":                           &z[1901],
	"tv.bb":                              &z[1902],
	"ac.bd":                              &z[1903],
	"com.bd":                             &z[1904],
	"edu.bd":                             &z[1905],
	"gov.bd":                             &z[1906],
	"mil.bd":                             &z[1907],
	"net.bd":                             &z[1908],
	"org.bd":                             &z[1909],
	"gov.bf":                             &z[1910],
	"0.bg":                               &z[1911],
	"1.bg":                               &z[1912],
	"2.bg":                               &z[1913],
	"3.bg":                               &z[1914],
	"4.bg":                               &z[1915],
	"5.bg":                               &z[1916],
	"6.bg":                               &z[1917],
	"7.bg":                               &z[1918],
	"8.bg":                               &z[1919],
	"9.bg":                               &z[1920],
	"a.bg":                               &z[1921],
	"b.bg":                               &z[1922],
	"c.bg":                               &z[1923],
	"d.bg":                               &z[1924],
	"e.bg":                               &z[1925],
	"f.bg":                               &z[1926],
	"g.bg":                               &z[1927],
	"h.bg":                               &z[1928],
	"i.bg":                               &z[1929],
	"j.bg":                               &z[1930],
	"k.bg":                               &z[1931],
	"l.bg":                               &z[1932],
	"m.bg":                               &z[1933],
	"n.bg":                               &z[1934],
	"o.bg":                               &z[1935],
	"p.bg":                               &z[1936],
	"q.bg":                               &z[1937],
	"r.bg":                               &z[1938],
	"s.bg":                               &z[1939],
	"t.bg":                               &z[1940],
	"u.bg":                               &z[1941],
	"v.bg":                               &z[1942],
	"w.bg":                               &z[1943],
	"x.bg":                               &z[1944],
	"y.bg":                               &z[1945],
	"z.bg":                               &z[1946],
	"biz.bh":                             &z[1947],
	"cc.bh":                              &z[1948],
	"com.bh":                             &z[1949],
	"edu.bh":                             &z[1950],
	"gov.bh":                             &z[1951],
	"info.bh":                            &z[1952],
	"net.bh":                             &z[1953],
	"org.bh":                             &z[1954],
	"co.bi":                              &z[1955],
	"com.bi":                             &z[1956],
	"edu.bi":                             &z[1957],
	"gov.bi":                             &z[1958],
	"info.bi":                            &z[1959],
	"mo.bi":                              &z[1960],
	"net.bi":                             &z[1961],
	"or.bi":                              &z[1962],
	"org.bi":                             &z[1963],
	"ote.bi":                             &z[1964],
	"1x.biz":                             &z[1965],
	"auz.biz":                            &z[1966],
	"asso.bj":                            &z[1967],
	"barreau.bj":                         &z[1968],
	"com.bj":                             &z[1969],
	"edu.bj":                             &z[1970],
	"gouv.bj":                            &z[1971],
	"gov.bj":                             &z[1972],
	"mil.bj":                             &z[1973],
	"art.blog":                           &z[1974],
	"business.blog":                      &z[1975],
	"car.blog":                           &z[1976],
	"code.blog":                          &z[1977],
	"family.blog":                        &z[1978],
	"fashion.blog":                       &z[1979],
	"finance.blog":                       &z[1980],
	"fitness.blog":                       &z[1981],
	"food.blog":                          &z[1982],
	"game.blog":                          &z[1983],
	"health.blog":                        &z[1984],
	"home.blog":                          &z[1985],
	"law.blog":                           &z[1986],
	"movie.blog":                         &z[1987],
	"music.blog":                         &z[1988],
	"news.blog":                          &z[1989],
	"photo.blog":                         &z[1990],
	"poetry.blog":                        &z[1991],
	"politics.blog":                      &z[1992],
	"school.blog":                        &z[1993],
	"science.blog":                       &z[1994],
	"sport.blog":                         &z[1995],
	"tech.blog":                          &z[1996],
	"travel.blog":                        &z[1997],
	"video.blog":                         &z[1998],
	"water.blog":                         &z[1999],
	"com.bm":                             &z[2000],
	"edu.bm":                             &z[2001],
	"gov.bm":                             &z[2002],
	"net.bm":                             &z[2003],
	"org.bm":                             &z[2004],
	"com.bn":                             &z[2005],
	"edu.bn":                             &z[2006],
	"gov.bn":                             &z[2007],
	"net.bn":                             &z[2008],
	"org.bn":                             &z[2009],
	"com.bo":                             &z[2010],
	"edu.bo":                             &z[2011],
	"gob.bo":                             &z[2012],
	"gov.bo":                             &z[2013],
	"int.bo":                             &z[2014],
	"mil.bo":                             &z[2015],
	"net.bo":                             &z[2016],
	"org.bo":                             &z[2017],
	"tv.bo":                              &z[2018],
	"abc.br":                             &z[2019],
	"adm.br":                             &z[2020],
	"adv.br":                             &z[2021],
	"agr.br":                             &z[2022],
	"am.br":                              &z[2023],
	"aparecida.br":                       &z[2024],
	"arq.br":                             &z[2025],
	"art.br":                             &z[2026],
	"ato.br":                             &z[2027],
	"b.br":                               &z[2028],
	"belem.br":                           &z[2029],
	"bhz.br":                             &z[2030],
	"bio.br":                             &z[2031],
	"blog.br":                            &z[2032],
	"bmd.br":                             &z[2033],
	"boavista.br":                        &z[2034],
	"bsb.br":                             &z[2035],
	"campinas.br":                        &z[2036],
	"caxias.br":                          &z[2037],
	"cim.br":                             &z[2038],
	"cng.br":                             &z[2039],
	"cnt.br":                             &z[2040],
	"com.br":                             &z[2041],
	"coop.br":                            &z[2042],
	"curitiba.br":                        &z[2043],
	"ecn.br":                             &z[2044],
	"eco.br":                             &z[2045],
	"edu.br":                             &z[2046],
	"emp.br":                             &z[2047],
	"eng.br":                             &z[2048],
	"esp.br":                             &z[2049],
	"etc.br":                             &z[2050],
	"eti.br":                             &z[2051],
	"far.br":                             &z[2052],
	"flog.br":                            &z[2053],
	"floripa.br":                         &z[2054],
	"fm.br":                              &z[2055],
	"fnd.br":                             &z[2056],
	"fortal.br":                          &z[2057],
	"fot.br":                             &z[2058],
	"foz.br":                             &z[2059],
	"fst.br":                             &z[2060],
	"g12.br":                             &z[2061],
	"ggf.br":                             &z[2062],
	"gov.br":                             &z[2063],
	"gru.br":                             &z[2064],
	"imb.br":                             &z[2065],
	"ind.br":                             &z[2066],
	"inf.br":                             &z[2067],
	"jampa.br":                           &z[2068],
	"jor.br":                             &z[2069],
	"jus.br":                             &z[2070],
	"lel.br":                             &z[2071],
	"macapa.br":                          &z[2072],
	"maceio.br":                          &z[2073],
	"manaus.br":                          &z[2074],
	"mat.br":                             &z[2075],
	"med.br":                             &z[2076],
	"mil.br":                             &z[2077],
	"mus.br":                             &z[2078],
	"natal.br":                           &z[2079],
	"net.br":                             &z[2080],
	"nom.br":                             &z[2081],
	"not.br":                             &z[2082],
	"ntr.br":                             &z[2083],
	"odo.br":                             &z[2084],
	"org.br":                             &z[2085],
	"palmas.br":                          &z[2086],
	"poa.br":                             &z[2087],
	"ppg.br":                             &z[2088],
	"pro.br":                             &z[2089],
	"psc.br":                             &z[2090],
	"psi.br":                             &z[2091],
	"qsl.br":                             &z[2092],
	"radio.br":                           &z[2093],
	"rec.br":                             &z[2094],
	"recife.br":                          &z[2095],
	"rep.br":                             &z[2096],
	"rio.br":                             &z[2097],
	"salvador.br":                        &z[2098],
	"sec3.br":                            &z[2099],
	"sjc.br":                             &z[2100],
	"slg.br":                             &z[2101],
	"srv.br":                             &z[2102],
	"taxi.br":                            &z[2103],
	"teo.br":                             &z[2104],
	"tmp.br":                             &z[2105],
	"trd.br":                             &z[2106],
	"tur.br":                             &z[2107],
	"tv.br":                              &z[2108],
	"vet.br":                             &z[2109],
	"vix.br":                             &z[2110],
	"vlog.br":                            &z[2111],
	"wiki.br":                            &z[2112],
	"zlg.br":                             &z[2113],
	"com.bs":                             &z[2114],
	"edu.bs":                             &z[2115],
	"gov.bs":                             &z[2116],
	"net.bs":                             &z[2117],
	"org.bs":                             &z[2118],
	"we.bs":                              &z[2119],
	"com.bt":                             &z[2120],
	"edu.bt":                             &z[2121],
	"gov.bt":                             &z[2122],
	"net.bt":                             &z[2123],
	"org.bt":                             &z[2124],
	"ac.bw":                              &z[2125],
	"co.bw":                              &z[2126],
	"net.bw":                             &z[2127],
	"org.bw":                             &z[2128],
	"com.by":                             &z[2129],
	"gov.by":                             &z[2130],
	"mil.by":                             &z[2131],
	"minsk.by":                           &z[2132],
	"net.by":                             &z[2133],
	"co.bz":                              &z[2134],
	"com.bz":                             &z[2135],
	"edu.bz":                             &z[2136],
	"gov.bz":                             &z[2137],
	"net.bz":                             &z[2138],
	"org.bz":                             &z[2139],
	"za.bz":                              &z[2140],
	"ab.ca":                              &z[2141],
	"bc.ca":                              &z[2142],
	"co.ca":                              &z[2143],
	"gc.ca":                              &z[2144],
	"mb.ca":                              &z[2145],
	"nb.ca":                              &z[2146],
	"nf.ca":                              &z[2147],
	"nl.ca":                              &z[2148],
	"ns.ca":                              &z[2149],
	"nt.ca":                              &z[2150],
	"nu.ca":                              &z[2151],
	"on.ca":                              &z[2152],
	"pe.ca":                              &z[2153],
	"qc.ca":                              &z[2154],
	"sk.ca":                              &z[2155],
	"yk.ca":                              &z[2156],
	"com.cc":                             &z[2157],
	"edu.cc":                             &z[2158],
	"net.cc":                             &z[2159],
	"org.cc":                             &z[2160],
	"ac.cd":                              &z[2161],
	"com.cd":                             &z[2162],
	"edu.cd":                             &z[2163],
	"gouv.cd":                            &z[2164],
	"net.cd":                             &z[2165],
	"org.cd":                             &z[2166],
	"ac.ci":                              &z[2167],
	"aeroport.ci":                        &z[2168],
	"asso.ci":                            &z[2169],
	"assoc.ci":                           &z[2170],
	"co.ci":                              &z[2171],
	"com.ci":                             &z[2172],
	"ed.ci":                              &z[2173],
	"edu.ci":                             &z[2174],
	"go.ci":                              &z[2175],
	"gov.ci":                             &z[2176],
	"in.ci":                              &z[2177],
	"int.ci":                             &z[2178],
	"net.ci":                             &z[2179],
	"nom.ci":                             &z[2180],
	"or.ci":                              &z[2181],
	"org.ci":                             &z[2182],
	"presse.ci":                          &z[2183],
	"biz.ck":                             &z[2184],
	"co.ck":                              &z[2185],
	"edu.ck":                             &z[2186],
	"gen.ck":                             &z[2187],
	"gov.ck":                             &z[2188],
	"info.ck":                            &z[2189],
	"net.ck":                             &z[2190],
	"org.ck":                             &z[2191],
	"co.cm":                              &z[2192],
	"com.cm":                             &z[2193],
	"edu.cm":                             &z[2194],
	"net.cm":                             &z[2195],
	"ac.cn":                              &z[2196],
	"ah.cn":                              &z[2197],
	"bj.cn":                              &z[2198],
	"com.cn":                             &z[2199],
	"cq.cn":                              &z[2200],
	"edu.cn":                             &z[2201],
	"fj.cn":                              &z[2202],
	"gd.cn":                              &z[2203],
	"gov.cn":                             &z[2204],
	"gs.cn":                              &z[2205],
	"gx.cn":                              &z[2206],
	"gz.cn":                              &z[2207],
	"ha.cn":                              &z[2208],
	"hb.cn":                              &z[2209],
	"he.cn":                              &z[2210],
	"hi.cn":                              &z[2211],
	"hk.cn":                              &z[2212],
	"hl.cn":                              &z[2213],
	"hn.cn":                              &z[2214],
	"jl.cn":                              &z[2215],
	"js.cn":                              &z[2216],
	"jx.cn":                              &z[2217],
	"keyword.cn":                         &z[2218],
	"ln.cn":                              &z[2219],
	"mil.cn":                             &z[2220],
	"mo.cn":                              &z[2221],
	"net.cn":                             &z[2222],
	"nm.cn":                              &z[2223],
	"nx.cn":                              &z[2224],
	"org.cn":                             &z[2225],
	"qh.cn":                              &z[2226],
	"sc.cn":                              &z[2227],
	"sd.cn":                              &z[2228],
	"sh.cn":                              &z[2229],
	"sn.cn":                              &z[2230],
	"sx.cn":                              &z[2231],
	"tj.cn":                              &z[2232],
	"tw.cn":                              &z[2233],
	"xj.cn":                              &z[2234],
	"xz.cn":                              &z[2235],
	"yn.cn":                              &z[2236],
	"zj.cn":                              &z[2237],
	"com.co":                             &z[2238],
	"edu.co":                             &z[2239],
	"gov.co":                             &z[2240],
	"mil.co":                             &z[2241],
	"net.co":                             &z[2242],
	"nom.co":                             &z[2243],
	"org.co":                             &z[2244],
	"4u.com":                             &z[2245],
	"ae.com":                             &z[2246],
	"africa.com":                         &z[2247],
	"ar.com":                             &z[2248],
	"asia.com":                           &z[2249],
	"au.com":                             &z[2250],
	"br.com":                             &z[2251],
	"cn.com":                             &z[2252],
	"co.com":                             &z[2253],
	"de.com":                             &z[2254],
	"eu.com":                             &z[2255],
	"gb.com":                             &z[2256],
	"gr.com":                             &z[2257],
	"hk.com":                             &z[2258],
	"hu.com":                             &z[2259],
	"jpn.com":                            &z[2260],
	"kr.com":                             &z[2261],
	"mex.com":                            &z[2262],
	"no.com":                             &z[2263],
	"nv.com":                             &z[2264],
	"pty-ltd.com":                        &z[2265],
	"qb.com":                             &z[2266],
	"qc.com":                             &z[2267],
	"ru.com":                             &z[2268],
	"sa.com":                             &z[2269],
	"se.com":                             &z[2270],
	"uk.com":                             &z[2271],
	"us.com":                             &z[2272],
	"uy.com":                             &z[2273],
	"za.com":                             &z[2274],
	"de.cool":                            &z[2275],
	"ac.cr":                              &z[2276],
	"co.cr":                              &z[2277],
	"ed.cr":                              &z[2278],
	"eu.cr":                              &z[2279],
	"fi.cr":                              &z[2280],
	"go.cr":                              &z[2281],
	"or.cr":                              &z[2282],
	"sa.cr":                              &z[2283],
	"co.cu":                              &z[2284],
	"com.cu":                             &z[2285],
	"cuba.cu":                            &z[2286],
	"cyt.cu":                             &z[2287],
	"edu.cu":                             &z[2288],
	"get.cu":                             &z[2289],
	"gov.cu":                             &z[2290],
	"inf.cu":                             &z[2291],
	"net.cu":                             &z[2292],
	"org.cu":                             &z[2293],
	"tur.cu":                             &z[2294],
	"com.cv":                             &z[2295],
	"edu.cv":                             &z[2296],
	"gov.cv":                             &z[2297],
	"int.cv":                             &z[2298],
	"net.cv":                             &z[2299],
	"nome.cv":                            &z[2300],
	"org.cv":                             &z[2301],
	"publ.cv":                            &z[2302],
	"com.cw":                             &z[2303],
	"net.cw":                             &z[2304],
	"com.cx":                             &z[2305],
	"edu.cx":                             &z[2306],
	"gov.cx":                             &z[2307],
	"net.cx":                             &z[2308],
	"org.cx":                             &z[2309],
	"ac.cy":                              &z[2310],
	"biz.cy":                             &z[2311],
	"com.cy":                             &z[2312],
	"ekloges.cy":                         &z[2313],
	"gov.cy":                             &z[2314],
	"ltd.cy":                             &z[2315],
	"name.cy":                            &z[2316],
	"net.cy":                             &z[2317],
	"org.cy":                             &z[2318],
	"parliament.cy":                      &z[2319],
	"press.cy":                           &z[2320],
	"pro.cy":                             &z[2321],
	"tm.cy":                              &z[2322],
	"co.cz":                              &z[2323],
	"1x.de":                              &z[2324],
	"co.de":                              &z[2325],
	"com.de":                             &z[2326],
	"biz.dk":                             &z[2327],
	"co.dk":                              &z[2328],
	"co.dm":                              &z[2329],
	"com.dm":                             &z[2330],
	"edu.dm":                             &z[2331],
	"gov.dm":                             &z[2332],
	"net.dm":                             &z[2333],
	"org.dm":                             &z[2334],
	"art.do":                             &z[2335],
	"com.do":                             &z[2336],
	"edu.do":                             &z[2337],
	"gob.do":                             &z[2338],
	"gov.do":                             &z[2339],
	"mil.do":                             &z[2340],
	"net.do":                             &z[2341],
	"org.do":                             &z[2342],
	"sid.do":                             &z[2343],
	"sld.do":                             &z[2344],
	"web.do":                             &z[2345],
	"art.dz":                             &z[2346],
	"asso.dz":                            &z[2347],
	"com.dz":                             &z[2348],
	"edu.dz":                             &z[2349],
	"gov.dz":                             &z[2350],
	"net.dz":                             &z[2351],
	"org.dz":                             &z[2352],
	"pol.dz":                             &z[2353],
	"com.ec":                             &z[2354],
	"edu.ec":                             &z[2355],
	"fin.ec":                             &z[2356],
	"gob.ec":                             &z[2357],
	"gov.ec":                             &z[2358],
	"info.ec":                            &z[2359],
	"med.ec":                             &z[2360],
	"mil.ec":                             &z[2361],
	"net.ec":                             &z[2362],
	"org.ec":                             &z[2363],
	"pro.ec":                             &z[2364],
	"co.ee":                              &z[2365],
	"com.ee":                             &z[2366],
	"edu.ee":                             &z[2367],
	"fie.ee":                             &z[2368],
	"gov.ee":                             &z[2369],
	"hiiumaa.ee":                         &z[2370],
	"kul.ee":                             &z[2371],
	"med.ee":                             &z[2372],
	"org.ee":                             &z[2373],
	"parnu.ee":                           &z[2374],
	"parnumaa.ee":                        &z[2375],
	"polvamaa.ee":                        &z[2376],
	"pri.ee":                             &z[2377],
	"tartu.ee":                           &z[2378],
	"com.eg":                             &z[2379],
	"edu.eg":                             &z[2380],
	"eun.eg":                             &z[2381],
	"gov.eg":                             &z[2382],
	"info.eg":                            &z[2383],
	"mil.eg":                             &z[2384],
	"name.eg":                            &z[2385],
	"net.eg":                             &z[2386],
	"org.eg":                             &z[2387],
	"sci.eg":                             &z[2388],
	"sport.eg":                           &z[2389],
	"tv.eg":                              &z[2390],
	"com.er":                             &z[2391],
	"edu.er":                             &z[2392],
	"gov.er":                             &z[2393],
	"ind.er":                             &z[2394],
	"mil.er":                             &z[2395],
	"net.er":                             &z[2396],
	"org.er":                             &z[2397],
	"com.es":                             &z[2398],
	"edu.es":                             &z[2399],
	"gob.es":                             &z[2400],
	"nom.es":                             &z[2401],
	"org.es":                             &z[2402],
	"biz.et":                             &z[2403],
	"com.et":                             &z[2404],
	"edu.et":                             &z[2405],
	"gov.et":                             &z[2406],
	"info.et":                            &z[2407],
	"name.et":                            &z[2408],
	"net.et":                             &z[2409],
	"org.et":                             &z[2410],
	"24.eu":                              &z[2411],
	"ecb.eu":                             &z[2412],
	"europa.eu":                          &z[2413],
	"ac.fj":                              &z[2414],
	"biz.fj":                             &z[2415],
	"com.fj":                             &z[2416],
	"gov.fj":                             &z[2417],
	"info.fj":                            &z[2418],
	"mil.fj":                             &z[2419],
	"name.fj":                            &z[2420],
	"net.fj":                             &z[2421],
	"org.fj":                             &z[2422],
	"pro.fj":                             &z[2423],
	"school.fj":                          &z[2424],
	"ac.fk":                              &z[2425],
	"co.fk":                              &z[2426],
	"gov.fk":                             &z[2427],
	"net.fk":                             &z[2428],
	"nom.fk":                             &z[2429],
	"org.fk":                             &z[2430],
	"0.fm":                               &z[2431],
	"2.fm":                               &z[2432],
	"4.fm":                               &z[2433],
	"6.fm":                               &z[2434],
	"8.fm":                               &z[2435],
	"radio.fm":                           &z[2436],
	"aero.fo":                            &z[2437],
	"biz.fo":                             &z[2438],
	"co.fo":                              &z[2439],
	"com.fo":                             &z[2440],
	"coop.fo":                            &z[2441],
	"edu.fo":                             &z[2442],
	"flp.fo":                             &z[2443],
	"ftp.fo":                             &z[2444],
	"gov.fo":                             &z[2445],
	"info.fo":                            &z[2446],
	"int.fo":                             &z[2447],
	"internet.fo":                        &z[2448],
	"irc.fo":                             &z[2449],
	"mail.fo":                            &z[2450],
	"mil.fo":                             &z[2451],
	"museum.fo":                          &z[2452],
	"name.fo":                            &z[2453],
	"org.fo":                             &z[2454],
	"telenet.fo":                         &z[2455],
	"telnet.fo":                          &z[2456],
	"web.fo":                             &z[2457],
	"www.fo":                             &z[2458],
	"aeroport.fr":                        &z[2459],
	"asso.fr":                            &z[2460],
	"avocat.fr":                          &z[2461],
	"chambagri.fr":                       &z[2462],
	"chirurgiens-dentistes.fr":           &z[2463],
	"com.fr":                             &z[2464],
	"experts-comptables.fr":              &z[2465],
	"geometre-expert.fr":                 &z[2466],
	"gouv.fr":                            &z[2467],
	"medecin.fr":                         &z[2468],
	"nom.fr":                             &z[2469],
	"notaires.fr":                        &z[2470],
	"pharmacien.fr":                      &z[2471],
	"port.fr":                            &z[2472],
	"prd.fr":                             &z[2473],
	"presse.fr":                          &z[2474],
	"tm.fr":                              &z[2475],
	"veterinaire.fr":                     &z[2476],
	"ac.ga":                              &z[2477],
	"aeroport.ga":                        &z[2478],
	"asso.ga":                            &z[2479],
	"co.ga":                              &z[2480],
	"com.ga":                             &z[2481],
	"ed.ga":                              &z[2482],
	"edu.ga":                             &z[2483],
	"go.ga":                              &z[2484],
	"int.ga":                             &z[2485],
	"net.ga":                             &z[2486],
	"or.ga":                              &z[2487],
	"org.ga":                             &z[2488],
	"presse.ga":                          &z[2489],
	"hmg.gb":                             &z[2490],
	"com.gd":                             &z[2491],
	"edu.gd":                             &z[2492],
	"gov.gd":                             &z[2493],
	"mlt.gd":                             &z[2494],
	"net.gd":                             &z[2495],
	"org.gd":                             &z[2496],
	"sci.gd":                             &z[2497],
	"com.ge":                             &z[2498],
	"edu.ge":                             &z[2499],
	"gov.ge":                             &z[2500],
	"mil.ge":                             &z[2501],
	"net.ge":                             &z[2502],
	"org.ge":                             &z[2503],
	"pvt.ge":                             &z[2504],
	"school.ge":                          &z[2505],
	"24.gg":                              &z[2506],
	"ac.gg":                              &z[2507],
	"co.gg":                              &z[2508],
	"eu.gg":                              &z[2509],
	"gov.gg":                             &z[2510],
	"net.gg":                             &z[2511],
	"org.gg":                             &z[2512],
	"sch.gg":                             &z[2513],
	"tr.gg":                              &z[2514],
	"tv.gg":                              &z[2515],
	"web.gg":                             &z[2516],
	"com.gh":                             &z[2517],
	"edu.gh":                             &z[2518],
	"gov.gh":                             &z[2519],
	"mil.gh":                             &z[2520],
	"net.gh":                             &z[2521],
	"org.gh":                             &z[2522],
	"com.gi":                             &z[2523],
	"edu.gi":                             &z[2524],
	"gov.gi":                             &z[2525],
	"ltd.gi":                             &z[2526],
	"mod.gi":                             &z[2527],
	"org.gi":                             &z[2528],
	"co.gl":                              &z[2529],
	"com.gl":                             &z[2530],
	"edu.gl":                             &z[2531],
	"net.gl":                             &z[2532],
	"org.gl":                             &z[2533],
	"ac.gn":                              &z[2534],
	"co.gn":                              &z[2535],
	"com.gn":                             &z[2536],
	"gov.gn":                             &z[2537],
	"net.gn":                             &z[2538],
	"org.gn":                             &z[2539],
	"24.gp":                              &z[2540],
	"asia.gp":                            &z[2541],
	"asso.gp":                            &z[2542],
	"co.gp":                              &z[2543],
	"com.gp":                             &z[2544],
	"edu.gp":                             &z[2545],
	"eu.gp":                              &z[2546],
	"mobi.gp":                            &z[2547],
	"net.gp":                             &z[2548],
	"online.gp":                          &z[2549],
	"org.gp":                             &z[2550],
	"com.gr":                             &z[2551],
	"edu.gr":                             &z[2552],
	"gov.gr":                             &z[2553],
	"net.gr":                             &z[2554],
	"org.gr":                             &z[2555],
	"com.gt":                             &z[2556],
	"edu.gt":                             &z[2557],
	"gob.gt":                             &z[2558],
	"ind.gt":                             &z[2559],
	"mil.gt":                             &z[2560],
	"net.gt":                             &z[2561],
	"org.gt":                             &z[2562],
	"com.gu":                             &z[2563],
	"edu.gu":                             &z[2564],
	"gov.gu":                             &z[2565],
	"guam.gu":                            &z[2566],
	"net.gu":                             &z[2567],
	"org.gu":                             &z[2568],
	"web.gu":                             &z[2569],
	"co.gy":                              &z[2570],
	"com.gy":                             &z[2571],
	"net.gy":                             &z[2572],
	"org.gy":                             &z[2573],
	"com.hk":                             &z[2574],
	"edu.hk":                             &z[2575],
	"gov.hk":                             &z[2576],
	"idv.hk":                             &z[2577],
	"inc.hk":                             &z[2578],
	"ltd.hk":                             &z[2579],
	"net.hk":                             &z[2580],
	"org.hk":                             &z[2581],
	"xn--55qx5d.hk":                      &z[2582], // 公司.hk
	"com.hn":                             &z[2583],
	"edu.hn":                             &z[2584],
	"gob.hn":                             &z[2585],
	"mil.hn":                             &z[2586],
	"net.hn":                             &z[2587],
	"org.hn":                             &z[2588],
	"com.hr":                             &z[2589],
	"from.hr":                            &z[2590],
	"iz.hr":                              &z[2591],
	"name.hr":                            &z[2592],
	"adult.ht":                           &z[2593],
	"art.ht":                             &z[2594],
	"asso.ht":                            &z[2595],
	"com.ht":                             &z[2596],
	"coop.ht":                            &z[2597],
	"edu.ht":                             &z[2598],
	"firm.ht":                            &z[2599],
	"gouv.ht":                            &z[2600],
	"info.ht":                            &z[2601],
	"med.ht":                             &z[2602],
	"net.ht":                             &z[2603],
	"org.ht":                             &z[2604],
	"perso.ht":                           &z[2605],
	"pol.ht":                             &z[2606],
	"pro.ht":                             &z[2607],
	"rel.ht":                             &z[2608],
	"shop.ht":                            &z[2609],
	"2000.hu":                            &z[2610],
	"ac.hu":                              &z[2611],
	"agrar.hu":                           &z[2612],
	"bolt.hu":                            &z[2613],
	"casino.hu":                          &z[2614],
	"city.hu":                            &z[2615],
	"co.hu":                              &z[2616],
	"edu.hu":                             &z[2617],
	"erotica.hu":                         &z[2618],
	"erotika.hu":                         &z[2619],
	"film.hu":                            &z[2620],
	"forum.hu":                           &z[2621],
	"games.hu":                           &z[2622],
	"gov.hu":                             &z[2623],
	"hotel.hu":                           &z[2624],
	"info.hu":                            &z[2625],
	"ingatlan.hu":                        &z[2626],
	"jogasz.hu":                          &z[2627],
	"konyvelo.hu":                        &z[2628],
	"lakas.hu":                           &z[2629],
	"media.hu":                           &z[2630],
	"news.hu":                            &z[2631],
	"org.hu":                             &z[2632],
	"priv.hu":                            &z[2633],
	"reklam.hu":                          &z[2634],
	"sex.hu":                             &z[2635],
	"shop.hu":                            &z[2636],
	"sport.hu":                           &z[2637],
	"suli.hu":                            &z[2638],
	"szex.hu":                            &z[2639],
	"tm.hu":                              &z[2640],
	"tozsde.hu":                          &z[2641],
	"utazas.hu":                          &z[2642],
	"video.hu":                           &z[2643],
	"ac.id":                              &z[2644],
	"biz.id":                             &z[2645],
	"co.id":                              &z[2646],
	"desa.id":                            &z[2647],
	"go.id":                              &z[2648],
	"mi.id":                              &z[2649],
	"mil.id":                             &z[2650],
	"my.id":                              &z[2651],
	"net.id":                             &z[2652],
	"or.id":                              &z[2653],
	"sch.id":                             &z[2654],
	"web.id":                             &z[2655],
	"com.ie":                             &z[2656],
	"gov.ie":                             &z[2657],
	"net.ie":                             &z[2658],
	"nli.ie":                             &z[2659],
	"org.ie":                             &z[2660],
	"ac.il":                              &z[2661],
	"co.il":                              &z[2662],
	"gov.il":                             &z[2663],
	"idf.il":                             &z[2664],
	"k12.il":                             &z[2665],
	"muni.il":                            &z[2666],
	"net.il":                             &z[2667],
	"org.il":                             &z[2668],
	"ac.im":                              &z[2669],
	"co.im":                              &z[2670],
	"com.im":                             &z[2671],
	"gov.im":                             &z[2672],
	"net.im":                             &z[2673],
	"org.im":                             &z[2674],
	"ac.in":                              &z[2675],
	"co.in":                              &z[2676],
	"edu.in":                             &z[2677],
	"ernet.in":                           &z[2678],
	"firm.in":                            &z[2679],
	"gen.in":                             &z[2680],
	"gov.in":                             &z[2681],
	"ind.in":                             &z[2682],
	"mil.in":                             &z[2683],
	"net.in":                             &z[2684],
	"org.in":                             &z[2685],
	"res.in":                             &z[2686],
	"auz.info":                           &z[2687],
	"eu.int":                             &z[2688],
	"com.io":                             &z[2689],
	"org.io":                             &z[2690],
	"biz.iq":                             &z[2691],
	"com.iq":                             &z[2692],
	"edu.iq":                             &z[2693],
	"gov.iq":                             &z[2694],
	"info.iq":                            &z[2695],
	"mil.iq":                             &z[2696],
	"name.iq":                            &z[2697],
	"net.iq":                             &z[2698],
	"org.iq":                             &z[2699],
	"tv.iq":                              &z[2700],
	"ac.ir":                              &z[2701],
	"co.ir":                              &z[2702],
	"gov.ir":                             &z[2703],
	"id.ir":                              &z[2704],
	"net.ir":                             &z[2705],
	"org.ir":                             &z[2706],
	"sch.ir":                             &z[2707],
	"abr.it":                             &z[2708],
	"abruzzo.it":                         &z[2709],
	"ag.it":                              &z[2710],
	"agrigento.it":                       &z[2711],
	"al.it":                              &z[2712],
	"alessandria.it":                     &z[2713],
	"alto-adige.it":                      &z[2714],
	"altoadige.it":                       &z[2715],
	"an.it":                              &z[2716],
	"ancona.it":                          &z[2717],
	"andria-barletta-trani.it":           &z[2718],
	"andria-trani-barletta.it":           &z[2719],
	"andriabarlettatrani.it":             &z[2720],
	"andriatranibarletta.it":             &z[2721],
	"ao.it":                              &z[2722],
	"aosta.it":                           &z[2723],
	"aoste.it":                           &z[2724],
	"ap.it":                              &z[2725],
	"aq.it":                              &z[2726],
	"aquila.it":                          &z[2727],
	"ar.it":                              &z[2728],
	"arezzo.it":                          &z[2729],
	"ascoli-piceno.it":                   &z[2730],
	"ascolipiceno.it":                    &z[2731],
	"asti.it":                            &z[2732],
	"at.it":                              &z[2733],
	"av.it":                              &z[2734],
	"avellino.it":                        &z[2735],
	"ba.it":                              &z[2736],
	"balsan.it":                          &z[2737],
	"bari.it":                            &z[2738],
	"barletta-trani-andria.it":           &z[2739],
	"barlettatraniandria.it":             &z[2740],
	"bas.it":                             &z[2741],
	"basilicata.it":                      &z[2742],
	"belluno.it":                         &z[2743],
	"benevento.it":                       &z[2744],
	"bergamo.it":                         &z[2745],
	"bg.it":                              &z[2746],
	"bi.it":                              &z[2747],
	"biella.it":                          &z[2748],
	"bl.it":                              &z[2749],
	"bn.it":                              &z[2750],
	"bo.it":                              &z[2751],
	"bologna.it":                         &z[2752],
	"bolzano.it":                         &z[2753],
	"bozen.it":                           &z[2754],
	"br.it":                              &z[2755],
	"brescia.it":                         &z[2756],
	"brindisi.it":                        &z[2757],
	"bs.it":                              &z[2758],
	"bt.it":                              &z[2759],
	"bz.it":                              &z[2760],
	"ca.it":                              &z[2761],
	"cagliari.it":                        &z[2762],
	"cal.it":                             &z[2763],
	"calabria.it":                        &z[2764],
	"caltanissetta.it":                   &z[2765],
	"cam.it":                             &z[2766],
	"campania.it":                        &z[2767],
	"campidano-medio.it":                 &z[2768],
	"campidanomedio.it":                  &z[2769],
	"campobasso.it":                      &z[2770],
	"carbonia-iglesias.it":               &z[2771],
	"carboniaiglesias.it":                &z[2772],
	"carrara-massa.it":                   &z[2773],
	"carraramassa.it":                    &z[2774],
	"caserta.it":                         &z[2775],
	"catania.it":                         &z[2776],
	"catanzaro.it":                       &z[2777],
	"cb.it":                              &z[2778],
	"ce.it":                              &z[2779],
	"cesena-forli.it":                    &z[2780],
	"cesenaforli.it":                     &z[2781],
	"ch.it":                              &z[2782],
	"chieti.it":                          &z[2783],
	"ci.it":                              &z[2784],
	"cl.it":                              &z[2785],
	"cn.it":                              &z[2786],
	"co.it":                              &z[2787],
	"como.it":                            &z[2788],
	"cosenza.it":                         &z[2789],
	"cr.it":                              &z[2790],
	"cremona.it":                         &z[2791],
	"crotone.it":                         &z[2792],
	"cs.it":                              &z[2793],
	"ct.it":                              &z[2794],
	"cuneo.it":                           &z[2795],
	"cz.it":                              &z[2796],
	"dell-ogliastra.it":                  &z[2797],
	"dellogliastra.it":                   &z[2798],
	"edu.it":                             &z[2799],
	"emilia-romagna.it":                  &z[2800],
	"emiliaromagna.it":                   &z[2801],
	"emr.it":                             &z[2802],
	"en.it":                              &z[2803],
	"enna.it":                            &z[2804],
	"fc.it":                              &z[2805],
	"fe.it":                              &z[2806],
	"fermo.it":                           &z[2807],
	"ferrara.it":                         &z[2808],
	"fg.it":                              &z[2809],
	"fi.it":                              &z[2810],
	"firenze.it":                         &z[2811],
	"florence.it":                        &z[2812],
	"fm.it":                              &z[2813],
	"foggia.it":                          &z[2814],
	"forli-cesena.it":                    &z[2815],
	"forlicesena.it":                     &z[2816],
	"fr.it":                              &z[2817],
	"friuli-v-giulia.it":                 &z[2818],
	"friuli-ve-giulia.it":                &z[2819],
	"friuli-vegiulia.it":                 &z[2820],
	"friuli-venezia-giulia.it":           &z[2821],
	"friuli-veneziagiulia.it":            &z[2822],
	"friuli-vgiulia.it":                  &z[2823],
	"friuliv-giulia.it":                  &z[2824],
	"friulive-giulia.it":                 &z[2825],
	"friulivegiulia.it":                  &z[2826],
	"friulivenezia-giulia.it":            &z[2827],
	"friuliveneziagiulia.it":             &z[2828],
	"friulivgiulia.it":                   &z[2829],
	"frosinone.it":                       &z[2830],
	"fvg.it":                             &z[2831],
	"ge.it":                              &z[2832],
	"genoa.it":                           &z[2833],
	"genova.it":                          &z[2834],
	"go.it":                              &z[2835],
	"gorizia.it":                         &z[2836],
	"gov.it":                             &z[2837],
	"gr.it":                              &z[2838],
	"grosseto.it":                        &z[2839],
	"iglesias-carbonia.it":               &z[2840],
	"iglesiascarbonia.it":                &z[2841],
	"im.it":                              &z[2842],
	"imperia.it":                         &z[2843],
	"is.it":                              &z[2844],
	"isernia.it":                         &z[2845],
	"kr.it":                              &z[2846],
	"la-spezia.it":                       &z[2847],
	"laquila.it":                         &z[2848],
	"laspezia.it":                        &z[2849],
	"latina.it":                          &z[2850],
	"laz.it":                             &z[2851],
	"lazio.it":                           &z[2852],
	"lc.it":                              &z[2853],
	"le.it":                              &z[2854],
	"lecce.it":                           &z[2855],
	"lecco.it":                           &z[2856],
	"li.it":                              &z[2857],
	"lig.it":                             &z[2858],
	"liguria.it":                         &z[2859],
	"livorno.it":                         &z[2860],
	"lo.it":                              &z[2861],
	"lodi.it":                            &z[2862],
	"lom.it":                             &z[2863],
	"lombardia.it":                       &z[2864],
	"lombardy.it":                        &z[2865],
	"lt.it":                              &z[2866],
	"lu.it":                              &z[2867],
	"lucania.it":                         &z[2868],
	"lucca.it":                           &z[2869],
	"macerata.it":                        &z[2870],
	"mantova.it":                         &z[2871],
	"mar.it":                             &z[2872],
	"marche.it":                          &z[2873],
	"massa-carrara.it":                   &z[2874],
	"massacarrara.it":                    &z[2875],
	"matera.it":                          &z[2876],
	"mb.it":                              &z[2877],
	"mc.it":                              &z[2878],
	"me.it":                              &z[2879],
	"medio-campidano.it":                 &z[2880],
	"mediocampidano.it":                  &z[2881],
	"messina.it":                         &z[2882],
	"mi.it":                              &z[2883],
	"milan.it":                           &z[2884],
	"milano.it":                          &z[2885],
	"mn.it":                              &z[2886],
	"mo.it":                              &z[2887],
	"modena.it":                          &z[2888],
	"mol.it":                             &z[2889],
	"molise.it":                          &z[2890],
	"monza.it":                           &z[2891],
	"monza-brianza.it":                   &z[2892],
	"monza-e-della-brianza.it":           &z[2893],
	"monzabrianza.it":                    &z[2894],
	"monzaebrianza.it":                   &z[2895],
	"monzaedellabrianza.it":              &z[2896],
	"ms.it":                              &z[2897],
	"mt.it":                              &z[2898],
	"na.it":                              &z[2899],
	"naples.it":                          &z[2900],
	"napoli.it":                          &z[2901],
	"no.it":                              &z[2902],
	"novara.it":                          &z[2903],
	"nu.it":                              &z[2904],
	"nuoro.it":                           &z[2905],
	"og.it":                              &z[2906],
	"ogliastra.it":                       &z[2907],
	"olbia-tempio.it":                    &z[2908],
	"olbiatempio.it":                     &z[2909],
	"or.it":                              &z[2910],
	"oristano.it":                        &z[2911],
	"ot.it":                              &z[2912],
	"pa.it":                              &z[2913],
	"padova.it":                          &z[2914],
	"padua.it":                           &z[2915],
	"palermo.it":                         &z[2916],
	"parma.it":                           &z[2917],
	"pavia.it":                           &z[2918],
	"pc.it":                              &z[2919],
	"pd.it":                              &z[2920],
	"pe.it":                              &z[2921],
	"perugia.it":                         &z[2922],
	"pesaro-urbino.it":                   &z[2923],
	"pesarourbino.it":                    &z[2924],
	"pescara.it":                         &z[2925],
	"pg.it":                              &z[2926],
	"pi.it":                              &z[2927],
	"piacenza.it":                        &z[2928],
	"piedmont.it":                        &z[2929],
	"piemonte.it":                        &z[2930],
	"pisa.it":                            &z[2931],
	"pistoia.it":                         &z[2932],
	"pmn.it":                             &z[2933],
	"pn.it":                              &z[2934],
	"po.it":                              &z[2935],
	"pordenone.it":                       &z[2936],
	"potenza.it":                         &z[2937],
	"pr.it":                              &z[2938],
	"prato.it":                           &z[2939],
	"pt.it":                              &z[2940],
	"pu.it":                              &z[2941],
	"pug.it":                             &z[2942],
	"puglia.it":                          &z[2943],
	"pv.it":                              &z[2944],
	"pz.it":                              &z[2945],
	"ra.it":                              &z[2946],
	"ragusa.it":                          &z[2947],
	"ravenna.it":                         &z[2948],
	"rc.it":                              &z[2949],
	"re.it":                              &z[2950],
	"reggio-calabria.it":                 &z[2951],
	"reggio-emilia.it":                   &z[2952],
	"reggiocalabria.it":                  &z[2953],
	"reggioemilia.it":                    &z[2954],
	"rg.it":                              &z[2955],
	"ri.it":                              &z[2956],
	"rieti.it":                           &z[2957],
	"rimini.it":                          &z[2958],
	"rm.it":                              &z[2959],
	"rn.it":                              &z[2960],
	"ro.it":                              &z[2961],
	"roma.it":                            &z[2962],
	"rome.it":                            &z[2963],
	"rovigo.it":                          &z[2964],
	"sa.it":                              &z[2965],
	"salerno.it":                         &z[2966],
	"sar.it":                             &z[2967],
	"sardegna.it":                        &z[2968],
	"sardinia.it":                        &z[2969],
	"sassari.it":                         &z[2970],
	"savona.it":                          &z[2971],
	"si.it":                              &z[2972],
	"sic.it":                             &z[2973],
	"sicilia.it":                         &z[2974],
	"sicily.it":                          &z[2975],
	"siena.it":                           &z[2976],
	"siracusa.it":                        &z[2977],
	"so.it":                              &z[2978],
	"sondrio.it":                         &z[2979],
	"sp.it":                              &z[2980],
	"sr.it":                              &z[2981],
	"ss.it":                              &z[2982],
	"suedtirol.it":                       &z[2983],
	"sv.it":                              &z[2984],
	"ta.it":                              &z[2985],
	"taa.it":                             &z[2986],
	"taranto.it":                         &z[2987],
	"te.it":                              &z[2988],
	"tempio-olbia.it":                    &z[2989],
	"tempioolbia.it":                     &z[2990],
	"teramo.it":                          &z[2991],
	"terni.it":                           &z[2992],
	"tn.it":                              &z[2993],
	"to.it":                              &z[2994],
	"torino.it":                          &z[2995],
	"tos.it":                             &z[2996],
	"toscana.it":                         &z[2997],
	"tp.it":                              &z[2998],
	"tr.it":                              &z[2999],
	"trani-andria-barletta.it":           &z[3000],
	"trani-barletta-andria.it":           &z[3001],
	"traniandriabarletta.it":             &z[3002],
	"tranibarlettaandria.it":             &z[3003],
	"trapani.it":                         &z[3004],
	"trentino.it":                        &z[3005],
	"trentino-a-adige.it":                &z[3006],
	"trentino-aadige.it":                 &z[3007],
	"trentino-alto-adige.it":             &z[3008],
	"trentino-altoadige.it":              &z[3009],
	"trentino-s-tirol.it":                &z[3010],
	"trentino-stirol.it":                 &z[3011],
	"trentino-sud-tirol.it":              &z[3012],
	"trentino-sudtirol.it":               &z[3013],
	"trentino-sued-tirol.it":             &z[3014],
	"trentino-suedtirol.it":              &z[3015],
	"trentinoa-adige.it":                 &z[3016],
	"trentinoaadige.it":                  &z[3017],
	"trentinoalto-adige.it":              &z[3018],
	"trentinoaltoadige.it":               &z[3019],
	"trentinos-tirol.it":                 &z[3020],
	"trentinosud-tirol.it":               &z[3021],
	"trentinosudtirol.it":                &z[3022],
	"trentinosued-tirol.it":              &z[3023],
	"trentinosuedtirol.it":               &z[3024],
	"trento.it":                          &z[3025],
	"treviso.it":                         &z[3026],
	"trieste.it":                         &z[3027],
	"ts.it":                              &z[3028],
	"turin.it":                           &z[3029],
	"tuscany.it":                         &z[3030],
	"tv.it":                              &z[3031],
	"ud.it":                              &z[3032],
	"udine.it":                           &z[3033],
	"umb.it":                             &z[3034],
	"umbria.it":                          &z[3035],
	"urbino-pesaro.it":                   &z[3036],
	"urbinopesaro.it":                    &z[3037],
	"va.it":                              &z[3038],
	"val-d-aosta.it":                     &z[3039],
	"val-daosta.it":                      &z[3040],
	"vald-aosta.it":                      &z[3041],
	"valdaosta.it":                       &z[3042],
	"valle-d-aosta.it":                   &z[3043],
	"valle-daosta.it":                    &z[3044],
	"valled-aosta.it":                    &z[3045],
	"valledaosta.it":                     &z[3046],
	"vao.it":                             &z[3047],
	"varese.it":                          &z[3048],
	"vb.it":                              &z[3049],
	"vc.it":                              &z[3050],
	"vda.it":                             &z[3051],
	"ve.it":                              &z[3052],
	"ven.it":                             &z[3053],
	"veneto.it":                          &z[3054],
	"venezia.it":                         &z[3055],
	"venice.it":                          &z[3056],
	"verbania.it":                        &z[3057],
	"vercelli.it":                        &z[3058],
	"verona.it":                          &z[3059],
	"vi.it":                              &z[3060],
	"vibo-valentia.it":                   &z[3061],
	"vibovalentia.it":                    &z[3062],
	"vicenza.it":                         &z[3063],
	"viterbo.it":                         &z[3064],
	"vr.it":                              &z[3065],
	"vs.it":                              &z[3066],
	"vt.it":                              &z[3067],
	"vv.it":                              &z[3068],
	"24.je":                              &z[3069],
	"co.je":                              &z[3070],
	"gov.je":                             &z[3071],
	"net.je":                             &z[3072],
	"org.je":                             &z[3073],
	"sch.je":                             &z[3074],
	"com.jm":                             &z[3075],
	"edu.jm":                             &z[3076],
	"gov.jm":                             &z[3077],
	"mil.jm":                             &z[3078],
	"net.jm":                             &z[3079],
	"org.jm":                             &z[3080],
	"com.jo":                             &z[3081],
	"edu.jo":                             &z[3082],
	"gov.jo":                             &z[3083],
	"mil.jo":                             &z[3084],
	"name.jo":                            &z[3085],
	"net.jo":                             &z[3086],
	"org.jo":                             &z[3087],
	"sch.jo":                             &z[3088],
	"ac.jp":                              &z[3089],
	"ad.jp":                              &z[3090],
	"aichi.jp":                           &z[3091],
	"akita.jp":                           &z[3092],
	"aomori.jp":                          &z[3093],
	"chiba.jp":                           &z[3094],
	"co.jp":                              &z[3095],
	"ed.jp":                              &z[3096],
	"ehime.jp":                           &z[3097],
	"fukui.jp":                           &z[3098],
	"fukuoka.jp":                         &z[3099],
	"fukushima.jp":                       &z[3100],
	"gifu.jp":                            &z[3101],
	"go.jp":                              &z[3102],
	"gr.jp":                              &z[3103],
	"gunma.jp":                           &z[3104],
	"hiroshima.jp":                       &z[3105],
	"hokkaido.jp":                        &z[3106],
	"hyogo.jp":                           &z[3107],
	"ibaraki.jp":                         &z[3108],
	"ishikawa.jp":                        &z[3109],
	"iwate.jp":                           &z[3110],
	"kagawa.jp":                          &z[3111],
	"kagoshima.jp":                       &z[3112],
	"kanagawa.jp":                        &z[3113],
	"kochi.jp":                           &z[3114],
	"kumamoto.jp":                        &z[3115],
	"kyoto.jp":                           &z[3116],
	"lg.jp":                              &z[3117],
	"mie.jp":                             &z[3118],
	"miyagi.jp":                          &z[3119],
	"miyazaki.jp":                        &z[3120],
	"nagano.jp":                          &z[3121],
	"nagasaki.jp":                        &z[3122],
	"nara.jp":                            &z[3123],
	"ne.jp":                              &z[3124],
	"niigata.jp":                         &z[3125],
	"oita.jp":                            &z[3126],
	"okayama.jp":                         &z[3127],
	"okinawa.jp":                         &z[3128],
	"or.jp":                              &z[3129],
	"osaka.jp":                           &z[3130],
	"saga.jp":                            &z[3131],
	"saitama.jp":                         &z[3132],
	"shiga.jp":                           &z[3133],
	"shimane.jp":                         &z[3134],
	"shizuoka.jp":                        &z[3135],
	"tochigi.jp":                         &z[3136],
	"tokushima.jp":                       &z[3137],
	"tokyo.jp":                           &z[3138],
	"tottori.jp":                         &z[3139],
	"toyama.jp":                          &z[3140],
	"wakayama.jp":                        &z[3141],
	"yamagata.jp":                        &z[3142],
	"yamaguchi.jp":                       &z[3143],
	"yamanashi.jp":                       &z[3144],
	"xn--ehqz56n.jp":                     &z[3145], // 三重.jp
	"xn--1lqs03n.jp":                     &z[3146], // 京都.jp
	"xn--qqqt11m.jp":                     &z[3147], // 佐賀.jp
	"xn--f6qx53a.jp":                     &z[3148], // 兵庫.jp
	"xn--djrs72d6uy.jp":                  &z[3149], // 北海道.jp
	"xn--mkru45i.jp":                     &z[3150], // 千葉.jp
	"xn--0trq7p7nn.jp":                   &z[3151], // 和歌山.jp
	"xn--5js045d.jp":                     &z[3152], // 埼玉.jp
	"xn--kbrq7o.jp":                      &z[3153], // 大分.jp
	"xn--pssu33l.jp":                     &z[3154], // 大阪.jp
	"xn--ntsq17g.jp":                     &z[3155], // 奈良.jp
	"xn--uisz3g.jp":                      &z[3156], // 宮城.jp
	"xn--6btw5a.jp":                      &z[3157], // 宮崎.jp
	"xn--1ctwo.jp":                       &z[3158], // 富山.jp
	"xn--6orx2r.jp":                      &z[3159], // 山口.jp
	"xn--rht61e.jp":                      &z[3160], // 山形.jp
	"xn--rht27z.jp":                      &z[3161], // 山梨.jp
	"xn--nit225k.jp":                     &z[3162], // 岐阜.jp
	"xn--rht3d.jp":                       &z[3163], // 岡山.jp
	"xn--djty4k.jp":                      &z[3164], // 岩手.jp
	"xn--klty5x.jp":                      &z[3165], // 島根.jp
	"xn--kltx9a.jp":                      &z[3166], // 広島.jp
	"xn--kltp7d.jp":                      &z[3167], // 徳島.jp
	"xn--c3s14m.jp":                      &z[3168], // 愛媛.jp
	"xn--vgu402c.jp":                     &z[3169], // 愛知.jp
	"xn--efvn9s.jp":                      &z[3170], // 新潟.jp
	"xn--1lqs71d.jp":                     &z[3171], // 東京.jp
	"xn--4pvxs.jp":                       &z[3172], // 栃木.jp
	"xn--uuwu58a.jp":                     &z[3173], // 沖縄.jp
	"xn--zbx025d.jp":                     &z[3174], // 滋賀.jp
	"xn--8pvr4u.jp":                      &z[3175], // 熊本.jp
	"xn--5rtp49c.jp":                     &z[3176], // 石川.jp
	"xn--ntso0iqx3a.jp":                  &z[3177], // 神奈川.jp
	"xn--elqq16h.jp":                     &z[3178], // 福井.jp
	"xn--4it168d.jp":                     &z[3179], // 福岡.jp
	"xn--klt787d.jp":                     &z[3180], // 福島.jp
	"xn--rny31h.jp":                      &z[3181], // 秋田.jp
	"xn--7t0a264c.jp":                    &z[3182], // 群馬.jp
	"xn--uist22h.jp":                     &z[3183], // 茨城.jp
	"xn--8ltr62k.jp":                     &z[3184], // 長崎.jp
	"xn--2m4a15e.jp":                     &z[3185], // 長野.jp
	"xn--32vp30h.jp":                     &z[3186], // 青森.jp
	"xn--4it797k.jp":                     &z[3187], // 静岡.jp
	"xn--5rtq34k.jp":                     &z[3188], // 香川.jp
	"xn--k7yn95e.jp":                     &z[3189], // 高知.jp
	"xn--tor131o.jp":                     &z[3190], // 鳥取.jp
	"xn--d5qv7z876c.jp":                  &z[3191], // 鹿児島.jp
	"ac.ke":                              &z[3192],
	"co.ke":                              &z[3193],
	"go.ke":                              &z[3194],
	"info.ke":                            &z[3195],
	"me.ke":                              &z[3196],
	"mobi.ke":                            &z[3197],
	"ne.ke":                              &z[3198],
	"or.ke":                              &z[3199],
	"sc.ke":                              &z[3200],
	"com.kg":                             &z[3201],
	"edu.kg":                             &z[3202],
	"gov.kg":                             &z[3203],
	"mil.kg":                             &z[3204],
	"net.kg":                             &z[3205],
	"org.kg":                             &z[3206],
	"com.kh":                             &z[3207],
	"edu.kh":                             &z[3208],
	"gov.kh":                             &z[3209],
	"mil.kh":                             &z[3210],
	"net.kh":                             &z[3211],
	"org.kh":                             &z[3212],
	"per.kh":                             &z[3213],
	"biz.ki":                             &z[3214],
	"com.ki":                             &z[3215],
	"edu.ki":                             &z[3216],
	"eu.ki":                              &z[3217],
	"gov.ki":                             &z[3218],
	"info.ki":                            &z[3219],
	"mob.ki":                             &z[3220],
	"mobi.ki":                            &z[3221],
	"net.ki":                             &z[3222],
	"org.ki":                             &z[3223],
	"phone.ki":                           &z[3224],
	"tel.ki":                             &z[3225],
	"asso.km":                            &z[3226],
	"com.km":                             &z[3227],
	"coop.km":                            &z[3228],
	"edu.km":                             &z[3229],
	"gouv.km":                            &z[3230],
	"medecin.km":                         &z[3231],
	"mil.km":                             &z[3232],
	"nom.km":                             &z[3233],
	"notaires.km":                        &z[3234],
	"org.km":                             &z[3235],
	"pharmaciens.km":                     &z[3236],
	"presse.km":                          &z[3237],
	"tm.km":                              &z[3238],
	"veterinaire.km":                     &z[3239],
	"co.kn":                              &z[3240],
	"com.kn":                             &z[3241],
	"edu.kn":                             &z[3242],
	"gov.kn":                             &z[3243],
	"net.kn":                             &z[3244],
	"org.kn":                             &z[3245],
	"com.kp":                             &z[3246],
	"net.kp":                             &z[3247],
	"org.kp":                             &z[3248],
	"rep.kp":                             &z[3249],
	"ac.kr":                              &z[3250],
	"busan.kr":                           &z[3251],
	"chungbuk.kr":                        &z[3252],
	"chungnam.kr":                        &z[3253],
	"co.kr":                              &z[3254],
	"daegu.kr":                           &z[3255],
	"daejeon.kr":                         &z[3256],
	"es.kr":                              &z[3257],
	"gangwon.kr":                         &z[3258],
	"go.kr":                              &z[3259],
	"gwangju.kr":                         &z[3260],
	"gyeongbuk.kr":                       &z[3261],
	"gyeonggi.kr":                        &z[3262],
	"gyeongnam.kr":                       &z[3263],
	"hs.kr":                              &z[3264],
	"incheon.kr":                         &z[3265],
	"jeju.kr":                            &z[3266],
	"jeonbuk.kr":                         &z[3267],
	"jeonnam.kr":                         &z[3268],
	"kg.kr":                              &z[3269],
	"mil.kr":                             &z[3270],
	"ms.kr":                              &z[3271],
	"ne.kr":                              &z[3272],
	"or.kr":                              &z[3273],
	"pe.kr":                              &z[3274],
	"re.kr":                              &z[3275],
	"sc.kr":                              &z[3276],
	"seoul.kr":                           &z[3277],
	"ulsan.kr":                           &z[3278],
	"com.kw":                             &z[3279],
	"edu.kw":                             &z[3280],
	"gov.kw":                             &z[3281],
	"net.kw":                             &z[3282],
	"org.kw":                             &z[3283],
	"com.ky":                             &z[3284],
	"edu.ky":                             &z[3285],
	"gov.ky":                             &z[3286],
	"net.ky":                             &z[3287],
	"org.ky":                             &z[3288],
	"com.kz":                             &z[3289],
	"edu.kz":                             &z[3290],
	"gov.kz":                             &z[3291],
	"mil.kz":                             &z[3292],
	"net.kz":                             &z[3293],
	"org.kz":                             &z[3294],
	"com.lb":                             &z[3295],
	"edu.lb":                             &z[3296],
	"gov.lb":                             &z[3297],
	"net.lb":                             &z[3298],
	"org.lb":                             &z[3299],
	"24.lc":                              &z[3300],
	"co.lc":                              &z[3301],
	"com.lc":                             &z[3302],
	"edu.lc":                             &z[3303],
	"gov.lc":                             &z[3304],
	"l.lc":                               &z[3305],
	"net.lc":                             &z[3306],
	"org.lc":                             &z[3307],
	"p.lc":                               &z[3308],
	"assn.lk":                            &z[3309],
	"com.lk":                             &z[3310],
	"edu.lk":                             &z[3311],
	"gov.lk":                             &z[3312],
	"grp.lk":                             &z[3313],
	"hotel.lk":                           &z[3314],
	"int.lk":                             &z[3315],
	"ltd.lk":                             &z[3316],
	"net.lk":                             &z[3317],
	"ngo.lk":                             &z[3318],
	"org.lk":                             &z[3319],
	"sch.lk":                             &z[3320],
	"soc.lk":                             &z[3321],
	"web.lk":                             &z[3322],
	"com.lr":                             &z[3323],
	"edu.lr":                             &z[3324],
	"gov.lr":                             &z[3325],
	"net.lr":                             &z[3326],
	"org.lr":                             &z[3327],
	"vcom.lr":                            &z[3328],
	"ac.ls":                              &z[3329],
	"co.ls":                              &z[3330],
	"gov.ls":                             &z[3331],
	"net.ls":                             &z[3332],
	"org.ls":                             &z[3333],
	"parliament.ls":                      &z[3334],
	"gov.lt":                             &z[3335],
	"asn.lv":                             &z[3336],
	"com.lv":                             &z[3337],
	"conf.lv":                            &z[3338],
	"edu.lv":                             &z[3339],
	"gov.lv":                             &z[3340],
	"id.lv":                              &z[3341],
	"mil.lv":                             &z[3342],
	"net.lv":                             &z[3343],
	"org.lv":                             &z[3344],
	"com.ly":                             &z[3345],
	"edu.ly":                             &z[3346],
	"gov.ly":                             &z[3347],
	"id.ly":                              &z[3348],
	"med.ly":                             &z[3349],
	"net.ly":                             &z[3350],
	"org.ly":                             &z[3351],
	"plc.ly":                             &z[3352],
	"sch.ly":                             &z[3353],
	"ac.ma":                              &z[3354],
	"co.ma":                              &z[3355],
	"gov.ma":                             &z[3356],
	"net.ma":                             &z[3357],
	"org.ma":                             &z[3358],
	"press.ma":                           &z[3359],
	"asso.mc":                            &z[3360],
	"tm.mc":                              &z[3361],
	"ac.me":                              &z[3362],
	"co.me":                              &z[3363],
	"edu.me":                             &z[3364],
	"gov.me":                             &z[3365],
	"its.me":                             &z[3366],
	"net.me":                             &z[3367],
	"org.me":                             &z[3368],
	"priv.me":                            &z[3369],
	"co.mg":                              &z[3370],
	"com.mg":                             &z[3371],
	"edu.mg":                             &z[3372],
	"gov.mg":                             &z[3373],
	"in.mg":                              &z[3374],
	"mil.mg":                             &z[3375],
	"net.mg":                             &z[3376],
	"nom.mg":                             &z[3377],
	"org.mg":                             &z[3378],
	"prd.mg":                             &z[3379],
	"tm.mg":                              &z[3380],
	"com.mk":                             &z[3381],
	"edu.mk":                             &z[3382],
	"gov.mk":                             &z[3383],
	"inf.mk":                             &z[3384],
	"name.mk":                            &z[3385],
	"net.mk":                             &z[3386],
	"org.mk":                             &z[3387],
	"pro.mk":                             &z[3388],
	"com.ml":                             &z[3389],
	"edu.ml":                             &z[3390],
	"gov.ml":                             &z[3391],
	"net.ml":                             &z[3392],
	"org.ml":                             &z[3393],
	"presse.ml":                          &z[3394],
	"biz.mm":                             &z[3395],
	"com.mm":                             &z[3396],
	"edu.mm":                             &z[3397],
	"gov.mm":                             &z[3398],
	"mil.mm":                             &z[3399],
	"net.mm":                             &z[3400],
	"org.mm":                             &z[3401],
	"per.mm":                             &z[3402],
	"edu.mn":                             &z[3403],
	"gov.mn":                             &z[3404],
	"org.mn":                             &z[3405],
	"co.mo":                              &z[3406],
	"com.mo":                             &z[3407],
	"edu.mo":                             &z[3408],
	"gov.mo":                             &z[3409],
	"net.mo":                             &z[3410],
	"org.mo":                             &z[3411],
	"co.mp":                              &z[3412],
	"com.mp":                             &z[3413],
	"gov.mp":                             &z[3414],
	"org.mp":                             &z[3415],
	"edu.mr":                             &z[3416],
	"gov.mr":                             &z[3417],
	"org.mr":                             &z[3418],
	"perso.mr":                           &z[3419],
	"co.ms":                              &z[3420],
	"com.ms":                             &z[3421],
	"net.ms":                             &z[3422],
	"org.ms":                             &z[3423],
	"com.mt":                             &z[3424],
	"edu.mt":                             &z[3425],
	"gov.mt":                             &z[3426],
	"net.mt":                             &z[3427],
	"org.mt":                             &z[3428],
	"24.mu":                              &z[3429],
	"ac.mu":                              &z[3430],
	"co.mu":                              &z[3431],
	"com.mu":                             &z[3432],
	"gov.mu":                             &z[3433],
	"net.mu":                             &z[3434],
	"nom.mu":                             &z[3435],
	"or.mu":                              &z[3436],
	"org.mu":                             &z[3437],
	"aero.mv":                            &z[3438],
	"biz.mv":                             &z[3439],
	"com.mv":                             &z[3440],
	"coop.mv":                            &z[3441],
	"edu.mv":                             &z[3442],
	"gov.mv":                             &z[3443],
	"info.mv":                            &z[3444],
	"int.mv":                             &z[3445],
	"mil.mv":                             &z[3446],
	"museum.mv":                          &z[3447],
	"name.mv":                            &z[3448],
	"net.mv":                             &z[3449],
	"org.mv":                             &z[3450],
	"pro.mv":                             &z[3451],
	"ac.mw":                              &z[3452],
	"co.mw":                              &z[3453],
	"com.mw":                             &z[3454],
	"coop.mw":                            &z[3455],
	"edu.mw":                             &z[3456],
	"gov.mw":                             &z[3457],
	"int.mw":                             &z[3458],
	"museum.mw":                          &z[3459],
	"net.mw":                             &z[3460],
	"org.mw":                             &z[3461],
	"com.mx":                             &z[3462],
	"edu.mx":                             &z[3463],
	"gob.mx":                             &z[3464],
	"net.mx":                             &z[3465],
	"org.mx":                             &z[3466],
	"com.my":                             &z[3467],
	"edi.my":                             &z[3468],
	"edu.my":                             &z[3469],
	"gov.my":                             &z[3470],
	"mil.my":                             &z[3471],
	"name.my":                            &z[3472],
	"net.my":                             &z[3473],
	"org.my":                             &z[3474],
	"ac.mz":                              &z[3475],
	"adv.mz":                             &z[3476],
	"co.mz":                              &z[3477],
	"edu.mz":                             &z[3478],
	"gov.mz":                             &z[3479],
	"net.mz":                             &z[3480],
	"org.mz":                             &z[3481],
	"alt.na":                             &z[3482],
	"cc.na":                              &z[3483],
	"co.na":                              &z[3484],
	"com.na":                             &z[3485],
	"dr.na":                              &z[3486],
	"edu.na":                             &z[3487],
	"in.na":                              &z[3488],
	"info.na":                            &z[3489],
	"mobi.na":                            &z[3490],
	"name.na":                            &z[3491],
	"net.na":                             &z[3492],
	"of.na":                              &z[3493],
	"or.na":                              &z[3494],
	"org.na":                             &z[3495],
	"pro.na":                             &z[3496],
	"school.na":                          &z[3497],
	"tv.na":                              &z[3498],
	"ws.na":                              &z[3499],
	"kyrylkov.name":                      &z[3500],
	"puig.name":                          &z[3501],
	"santos.name":                        &z[3502],
	"asso.nc":                            &z[3503],
	"com.nc":                             &z[3504],
	"nom.nc":                             &z[3505],
	"com.ne":                             &z[3506],
	"info.ne":                            &z[3507],
	"int.ne":                             &z[3508],
	"org.ne":                             &z[3509],
	"perso.ne":                           &z[3510],
	"1x.net":                             &z[3511],
	"auz.net":                            &z[3512],
	"gb.net":                             &z[3513],
	"hu.net":                             &z[3514],
	"in.net":                             &z[3515],
	"jp.net":                             &z[3516],
	"ru.net":                             &z[3517],
	"se.net":                             &z[3518],
	"uk.net":                             &z[3519],
	"za.net":                             &z[3520],
	"arts.nf":                            &z[3521],
	"com.nf":                             &z[3522],
	"firm.nf":                            &z[3523],
	"info.nf":                            &z[3524],
	"net.nf":                             &z[3525],
	"org.nf":                             &z[3526],
	"other.nf":                           &z[3527],
	"per.nf":                             &z[3528],
	"rec.nf":                             &z[3529],
	"store.nf":                           &z[3530],
	"us.nf":                              &z[3531],
	"web.nf":                             &z[3532],
	"com.ng":                             &z[3533],
	"edu.ng":                             &z[3534],
	"gov.ng":                             &z[3535],
	"i.ng":                               &z[3536],
	"mil.ng":                             &z[3537],
	"mobi.ng":                            &z[3538],
	"name.ng":                            &z[3539],
	"net.ng":                             &z[3540],
	"org.ng":                             &z[3541],
	"sch.ng":                             &z[3542],
	"ac.ni":                              &z[3543],
	"biz.ni":                             &z[3544],
	"co.ni":                              &z[3545],
	"com.ni":                             &z[3546],
	"edu.ni":                             &z[3547],
	"gob.ni":                             &z[3548],
	"gov.ni":                             &z[3549],
	"in.ni":                              &z[3550],
	"info.ni":                            &z[3551],
	"int.ni":                             &z[3552],
	"mil.ni":                             &z[3553],
	"net.ni":                             &z[3554],
	"nom.ni":                             &z[3555],
	"org.ni":                             &z[3556],
	"web.ni":                             &z[3557],
	"24.nl":                              &z[3558],
	"co.nl":                              &z[3559],
	"com.nl":                             &z[3560],
	"net.nl":                             &z[3561],
	"nom.nl":                             &z[3562],
	"punt.nl":                            &z[3563],
	"co.no":                              &z[3564],
	"fhs.no":                             &z[3565],
	"folkebibl.no":                       &z[3566],
	"fylkesbibl.no":                      &z[3567],
	"gs.no":                              &z[3568],
	"idrett.no":                          &z[3569],
	"museum.no":                          &z[3570],
	"priv.no":                            &z[3571],
	"uenorge.no":                         &z[3572],
	"vgs.no":                             &z[3573],
	"academy.np":                         &z[3574],
	"accountants.np":                     &z[3575],
	"actor.np":                           &z[3576],
	"aero.np":                            &z[3577],
	"agency.np":                          &z[3578],
	"asia.np":                            &z[3579],
	"associates.np":                      &z[3580],
	"audio.np":                           &z[3581],
	"bar.np":                             &z[3582],
	"bargains.np":                        &z[3583],
	"beer.np":                            &z[3584],
	"bid.np":                             &z[3585],
	"bike.np":                            &z[3586],
	"bio.np":                             &z[3587],
	"biz.np":                             &z[3588],
	"black.np":                           &z[3589],
	"blue.np":                            &z[3590],
	"boutique.np":                        &z[3591],
	"build.np":                           &z[3592],
	"builders.np":                        &z[3593],
	"buzz.np":                            &z[3594],
	"cab.np":                             &z[3595],
	"camera.np":                          &z[3596],
	"camp.np":                            &z[3597],
	"capital.np":                         &z[3598],
	"cards.np":                           &z[3599],
	"care.np":                            &z[3600],
	"careers.np":                         &z[3601],
	"cash.np":                            &z[3602],
	"catering.np":                        &z[3603],
	"center.np":                          &z[3604],
	"ceo.np":                             &z[3605],
	"christmas.np":                       &z[3606],
	"clinic.np":                          &z[3607],
	"clothing.np":                        &z[3608],
	"club.np":                            &z[3609],
	"codes.np":                           &z[3610],
	"coffee.np":                          &z[3611],
	"college.np":                         &z[3612],
	"com.np":                             &z[3613],
	"community.np":                       &z[3614],
	"company.np":                         &z[3615],
	"computer.np":                        &z[3616],
	"cool.np":                            &z[3617],
	"coop.np":                            &z[3618],
	"country.np":                         &z[3619],
	"credit.np":                          &z[3620],
	"creditcard.np":                      &z[3621],
	"dental.np":                          &z[3622],
	"diamonds.np":                        &z[3623],
	"edu.np":                             &z[3624],
	"email.np":                           &z[3625],
	"engineering.np":                     &z[3626],
	"estate.np":                          &z[3627],
	"events.np":                          &z[3628],
	"expert.np":                          &z[3629],
	"finance.np":                         &z[3630],
	"financial.np":                       &z[3631],
	"fish.np":                            &z[3632],
	"fishing.np":                         &z[3633],
	"fitness.np":                         &z[3634],
	"flights.np":                         &z[3635],
	"florist.np":                         &z[3636],
	"fund.np":                            &z[3637],
	"furniture.np":                       &z[3638],
	"futbol.np":                          &z[3639],
	"gallery.np":                         &z[3640],
	"gov.np":                             &z[3641],
	"guitars.np":                         &z[3642],
	"guru.np":                            &z[3643],
	"hiphop.np":                          &z[3644],
	"hiv.np":                             &z[3645],
	"house.np":                           &z[3646],
	"industries.np":                      &z[3647],
	"info.np":                            &z[3648],
	"ink.np":                             &z[3649],
	"jobs.np":                            &z[3650],
	"limited.np":                         &z[3651],
	"link.np":                            &z[3652],
	"management.np":                      &z[3653],
	"marketing.np":                       &z[3654],
	"media.np":                           &z[3655],
	"menu.np":                            &z[3656],
	"mil.np":                             &z[3657],
	"mobi.np":                            &z[3658],
	"museum.np":                          &z[3659],
	"name.np":                            &z[3660],
	"net.np":                             &z[3661],
	"ninja.np":                           &z[3662],
	"onl.np":                             &z[3663],
	"org.np":                             &z[3664],
	"partners.np":                        &z[3665],
	"parts.np":                           &z[3666],
	"photo.np":                           &z[3667],
	"photos.np":                          &z[3668],
	"pics.np":                            &z[3669],
	"pink.np":                            &z[3670],
	"pro.np":                             &z[3671],
	"productions.np":                     &z[3672],
	"products.np":                        &z[3673],
	"properties.np":                      &z[3674],
	"pub.np":                             &z[3675],
	"red.np":                             &z[3676],
	"rentals.np":                         &z[3677],
	"repair.np":                          &z[3678],
	"rest.np":                            &z[3679],
	"rocks.np":                           &z[3680],
	"services.np":                        &z[3681],
	"shiksha.np":                         &z[3682],
	"shoes.np":                           &z[3683],
	"social.np":                          &z[3684],
	"solar.np":                           &z[3685],
	"solutions.np":                       &z[3686],
	"space.np":                           &z[3687],
	"supplies.np":                        &z[3688],
	"supply.np":                          &z[3689],
	"support.np":                         &z[3690],
	"surf.np":                            &z[3691],
	"surgery.np":                         &z[3692],
	"systems.np":                         &z[3693],
	"tattoo.np":                          &z[3694],
	"tax.np":                             &z[3695],
	"technology.np":                      &z[3696],
	"tel.np":                             &z[3697],
	"tips.np":                            &z[3698],
	"today.np":                           &z[3699],
	"tools.np":                           &z[3700],
	"town.np":                            &z[3701],
	"trade.np":                           &z[3702],
	"training.np":                        &z[3703],
	"travel.np":                          &z[3704],
	"university.np":                      &z[3705],
	"vacations.np":                       &z[3706],
	"ventures.np":                        &z[3707],
	"villas.np":                          &z[3708],
	"vision.np":                          &z[3709],
	"vodka.np":                           &z[3710],
	"voting.np":                          &z[3711],
	"voyage.np":                          &z[3712],
	"watch.np":                           &z[3713],
	"webcam.np":                          &z[3714],
	"wiki.np":                            &z[3715],
	"works.np":                           &z[3716],
	"wtf.np":                             &z[3717],
	"xyz.np":                             &z[3718],
	"zone.np":                            &z[3719],
	"biz.nr":                             &z[3720],
	"com.nr":                             &z[3721],
	"edu.nr":                             &z[3722],
	"gov.nr":                             &z[3723],
	"info.nr":                            &z[3724],
	"net.nr":                             &z[3725],
	"org.nr":                             &z[3726],
	"co.nu":                              &z[3727],
	"com.nu":                             &z[3728],
	"eu.nu":                              &z[3729],
	"ie.nu":                              &z[3730],
	"info.nu":                            &z[3731],
	"ac.nz":                              &z[3732],
	"co.nz":                              &z[3733],
	"cri.nz":                             &z[3734],
	"geek.nz":                            &z[3735],
	"gen.nz":                             &z[3736],
	"govt.nz":                            &z[3737],
	"health.nz":                          &z[3738],
	"iwi.nz":                             &z[3739],
	"kiwi.nz":                            &z[3740],
	"maori.nz":                           &z[3741],
	"mil.nz":                             &z[3742],
	"net.nz":                             &z[3743],
	"org.nz":                             &z[3744],
	"parliament.nz":                      &z[3745],
	"school.nz":                          &z[3746],
	"ac.om":                              &z[3747],
	"biz.om":                             &z[3748],
	"co.om":                              &z[3749],
	"com.om":                             &z[3750],
	"edu.om":                             &z[3751],
	"gov.om":                             &z[3752],
	"med.om":                             &z[3753],
	"mil.om":                             &z[3754],
	"museum.om":                          &z[3755],
	"net.om":                             &z[3756],
	"org.om":                             &z[3757],
	"pro.om":                             &z[3758],
	"sch.om":                             &z[3759],
	"ae.org":                             &z[3760],
	"eu.org":                             &z[3761],
	"hk.org":                             &z[3762],
	"js.org":                             &z[3763],
	"us.org":                             &z[3764],
	"za.org":                             &z[3765],
	"abo.pa":                             &z[3766],
	"ac.pa":                              &z[3767],
	"com.pa":                             &z[3768],
	"edu.pa":                             &z[3769],
	"gob.pa":                             &z[3770],
	"ing.pa":                             &z[3771],
	"med.pa":                             &z[3772],
	"net.pa":                             &z[3773],
	"nom.pa":                             &z[3774],
	"org.pa":                             &z[3775],
	"sld.pa":                             &z[3776],
	"com.pe":                             &z[3777],
	"edu.pe":                             &z[3778],
	"gob.pe":                             &z[3779],
	"gov.pe":                             &z[3780],
	"mil.pe":                             &z[3781],
	"net.pe":                             &z[3782],
	"nom.pe":                             &z[3783],
	"org.pe":                             &z[3784],
	"sld.pe":                             &z[3785],
	"asso.pf":                            &z[3786],
	"com.pf":                             &z[3787],
	"edu.pf":                             &z[3788],
	"gov.pf":                             &z[3789],
	"org.pf":                             &z[3790],
	"ac.pg":                              &z[3791],
	"com.pg":                             &z[3792],
	"gov.pg":                             &z[3793],
	"mil.pg":                             &z[3794],
	"net.pg":                             &z[3795],
	"org.pg":                             &z[3796],
	"com.ph":                             &z[3797],
	"edi.ph":                             &z[3798],
	"edu.ph":                             &z[3799],
	"gov.ph":                             &z[3800],
	"i.ph":                               &z[3801],
	"mil.ph":                             &z[3802],
	"net.ph":                             &z[3803],
	"ngo.ph":                             &z[3804],
	"org.ph":                             &z[3805],
	"biz.pk":                             &z[3806],
	"com.pk":                             &z[3807],
	"edu.pk":                             &z[3808],
	"fam.pk":                             &z[3809],
	"gkp.pk":                             &z[3810],
	"gob.pk":                             &z[3811],
	"gog.pk":                             &z[3812],
	"gok.pk":                             &z[3813],
	"gon.pk":                             &z[3814],
	"gop.pk":                             &z[3815],
	"gos.pk":                             &z[3816],
	"gov.pk":                             &z[3817],
	"net.pk":                             &z[3818],
	"org.pk":                             &z[3819],
	"web.pk":                             &z[3820],
	"agro.pl":                            &z[3821],
	"aid.pl":                             &z[3822],
	"art.pl":                             &z[3823],
	"atm.pl":                             &z[3824],
	"augustow.pl":                        &z[3825],
	"auto.pl":                            &z[3826],
	"babia-gora.pl":                      &z[3827],
	"bedzin.pl":                          &z[3828],
	"beskidy.pl":                         &z[3829],
	"bialowieza.pl":                      &z[3830],
	"bialystok.pl":                       &z[3831],
	"bielawa.pl":                         &z[3832],
	"bieszczady.pl":                      &z[3833],
	"biz.pl":                             &z[3834],
	"boleslawiec.pl":                     &z[3835],
	"bydgoszcz.pl":                       &z[3836],
	"bytom.pl":                           &z[3837],
	"ciesyn.pl":                          &z[3838],
	"cieszyn.pl":                         &z[3839],
	"co.pl":                              &z[3840],
	"com.pl":                             &z[3841],
	"czeladz.pl":                         &z[3842],
	"czest.pl":                           &z[3843],
	"dlugoleka.pl":                       &z[3844],
	"edu.pl":                             &z[3845],
	"elblag.pl":                          &z[3846],
	"elk.pl":                             &z[3847],
	"gda.pl":                             &z[3848],
	"gdansk.pl":                          &z[3849],
	"glogow.pl":                          &z[3850],
	"gmina.pl":                           &z[3851],
	"gniezno.pl":                         &z[3852],
	"gniezon.pl":                         &z[3853],
	"gorlice.pl":                         &z[3854],
	"gov.pl":                             &z[3855],
	"grajewo.pl":                         &z[3856],
	"gsm.pl":                             &z[3857],
	"ilawa.pl":                           &z[3858],
	"info.pl":                            &z[3859],
	"jaworzno.pl":                        &z[3860],
	"jaworzono.pl":                       &z[3861],
	"jelenia-gora.pl":                    &z[3862],
	"jgora.pl":                           &z[3863],
	"kalisz.pl":                          &z[3864],
	"karpacz.pl":                         &z[3865],
	"kartuzy.pl":                         &z[3866],
	"kaszuby.pl":                         &z[3867],
	"katowice.pl":                        &z[3868],
	"kazimierz-dolny.pl":                 &z[3869],
	"kepno.pl":                           &z[3870],
	"ketrzyn.pl":                         &z[3871],
	"klodzko.pl":                         &z[3872],
	"kobierzyce.pl":                      &z[3873],
	"kolobrzeg.pl":                       &z[3874],
	"konin.pl":                           &z[3875],
	"konskowola.pl":                      &z[3876],
	"krakow.pl":                          &z[3877],
	"ksazuby.pl":                         &z[3878],
	"kutno.pl":                           &z[3879],
	"lapy.pl":                            &z[3880],
	"lebork.pl":                          &z[3881],
	"legnica.pl":                         &z[3882],
	"lezajsk.pl":                         &z[3883],
	"limanowa.pl":                        &z[3884],
	"lodz.pl":                            &z[3885],
	"lomza.pl":                           &z[3886],
	"lowicz.pl":                          &z[3887],
	"lubin.pl":                           &z[3888],
	"lublin.pl":                          &z[3889],
	"lukow.pl":                           &z[3890],
	"mail.pl":                            &z[3891],
	"malbork.pl":                         &z[3892],
	"malopolska.pl":                      &z[3893],
	"mazowsze.pl":                        &z[3894],
	"mazury.pl":                          &z[3895],
	"media.pl":                           &z[3896],
	"miasta.pl":                          &z[3897],
	"mielec.pl":                          &z[3898],
	"mielno.pl":                          &z[3899],
	"mil.pl":                             &z[3900],
	"mragowo.pl":                         &z[3901],
	"naklo.pl":                           &z[3902],
	"net.pl":                             &z[3903],
	"ngo.pl":                             &z[3904],
	"nieruchomosci.pl":                   &z[3905],
	"nom.pl":                             &z[3906],
	"nowaruda.pl":                        &z[3907],
	"nysa.pl":                            &z[3908],
	"olawa.pl":                           &z[3909],
	"olecko.pl":                          &z[3910],
	"olkusz.pl":                          &z[3911],
	"olsztyn.pl":                         &z[3912],
	"opoczno.pl":                         &z[3913],
	"opole.pl":                           &z[3914],
	"org.pl":                             &z[3915],
	"ostroda.pl":                         &z[3916],
	"ostroleka.pl":                       &z[3917],
	"ostrowiec.pl":                       &z[3918],
	"ostrowwlkp.pl":                      &z[3919],
	"pc.pl":                              &z[3920],
	"pila.pl":                            &z[3921],
	"pisz.pl":                            &z[3922],
	"podhale.pl":                         &z[3923],
	"podlasie.pl":                        &z[3924],
	"polkowice.pl":                       &z[3925],
	"pomorskie.pl":                       &z[3926],
	"pomorze.pl":                         &z[3927],
	"powiat.pl":                          &z[3928],
	"poznan.pl":                          &z[3929],
	"priv.pl":                            &z[3930],
	"prochowice.pl":                      &z[3931],
	"pruszkow.pl":                        &z[3932],
	"przeworsk.pl":                       &z[3933],
	"pulawy.pl":                          &z[3934],
	"radom.pl":                           &z[3935],
	"rawa-maz.pl":                        &z[3936],
	"realestate.pl":                      &z[3937],
	"rel.pl":                             &z[3938],
	"rybnik.pl":                          &z[3939],
	"rzeszow.pl":                         &z[3940],
	"sanok.pl":                           &z[3941],
	"sejny.pl":                           &z[3942],
	"sex.pl":                             &z[3943],
	"shop.pl":                            &z[3944],
	"sklep.pl":                           &z[3945],
	"skoczow.pl":                         &z[3946],
	"slask.pl":                           &z[3947],
	"slupsk.pl":                          &z[3948],
	"sos.pl":                             &z[3949],
	"sosnowiec.pl":                       &z[3950],
	"stalowa-wola.pl":                    &z[3951],
	"starachowice.pl":                    &z[3952],
	"stargard.pl":                        &z[3953],
	"suwalki.pl":                         &z[3954],
	"swidnica.pl":                        &z[3955],
	"swiebodzin.pl":                      &z[3956],
	"swinoujscie.pl":                     &z[3957],
	"szczecin.pl":                        &z[3958],
	"szczytno.pl":                        &z[3959],
	"szkola.pl":                          &z[3960],
	"targi.pl":                           &z[3961],
	"tarnobrzeg.pl":                      &z[3962],
	"tgory.pl":                           &z[3963],
	"tm.pl":                              &z[3964],
	"torun.pl":                           &z[3965],
	"tourism.pl":                         &z[3966],
	"travel.pl":                          &z[3967],
	"turek.pl":                           &z[3968],
	"turystyka.pl":                       &z[3969],
	"tychy.pl":                           &z[3970],
	"ustka.pl":                           &z[3971],
	"walbrzych.pl":                       &z[3972],
	"warmia.pl":                          &z[3973],
	"warszawa.pl":                        &z[3974],
	"waw.pl":                             &z[3975],
	"wegrow.pl":                          &z[3976],
	"wielun.pl":                          &z[3977],
	"wlocl.pl":                           &z[3978],
	"wloclawek.pl":                       &z[3979],
	"wodzislaw.pl":                       &z[3980],
	"wolomin.pl":                         &z[3981],
	"wroc.pl":                            &z[3982],
	"wroclaw.pl":                         &z[3983],
	"zachpomor.pl":                       &z[3984],
	"zagan.pl":                           &z[3985],
	"zarow.pl":                           &z[3986],
	"zgora.pl":                           &z[3987],
	"zgorzelec.pl":                       &z[3988],
	"at.pn":                              &z[3989],
	"au.pn":                              &z[3990],
	"ca.pn":                              &z[3991],
	"ch.pn":                              &z[3992],
	"cn.pn":                              &z[3993],
	"co.pn":                              &z[3994],
	"de.pn":                              &z[3995],
	"edu.pn":                             &z[3996],
	"es.pn":                              &z[3997],
	"eu.pn":                              &z[3998],
	"fr.pn":                              &z[3999],
	"gov.pn":                             &z[4000],
	"in.pn":                              &z[4001],
	"it.pn":                              &z[4002],
	"jp.pn":                              &z[4003],
	"net.pn":                             &z[4004],
	"org.pn":                             &z[4005],
	"uk.pn":                              &z[4006],
	"us.pn":                              &z[4007],
	"ac.pr":                              &z[4008],
	"ag.pr":                              &z[4009],
	"ai.pr":                              &z[4010],
	"alumni.pr":                          &z[4011],
	"at.pr":                              &z[4012],
	"au.pr":                              &z[4013],
	"aw.pr":                              &z[4014],
	"bb.pr":                              &z[4015],
	"biz.pr":                             &z[4016],
	"bm.pr":                              &z[4017],
	"br.pr":                              &z[4018],
	"bs.pr":                              &z[4019],
	"ch.pr":                              &z[4020],
	"cl.pr":                              &z[4021],
	"cn.pr":                              &z[4022],
	"com.pr":                             &z[4023],
	"de.pr":                              &z[4024],
	"dm.pr":                              &z[4025],
	"do.pr":                              &z[4026],
	"edu.pr":                             &z[4027],
	"en.pr":                              &z[4028],
	"es.pr":                              &z[4029],
	"est.pr":                             &z[4030],
	"eu.pr":                              &z[4031],
	"exalumnos.pr":                       &z[4032],
	"fr.pr":                              &z[4033],
	"gd.pr":                              &z[4034],
	"gov.pr":                             &z[4035],
	"gp.pr":                              &z[4036],
	"ht.pr":                              &z[4037],
	"info.pr":                            &z[4038],
	"isla.pr":                            &z[4039],
	"it.pr":                              &z[4040],
	"jm.pr":                              &z[4041],
	"jp.pr":                              &z[4042],
	"ky.pr":                              &z[4043],
	"lc.pr":                              &z[4044],
	"ms.pr":                              &z[4045],
	"mx.pr":                              &z[4046],
	"name.pr":                            &z[4047],
	"net.pr":                             &z[4048],
	"nl.pr":                              &z[4049],
	"nom.pr":                             &z[4050],
	"org.pr":                             &z[4051],
	"pro.pr":                             &z[4052],
	"prof.pr":                            &z[4053],
	"tc.pr":                              &z[4054],
	"tt.pr":                              &z[4055],
	"uk.pr":                              &z[4056],
	"us.pr":                              &z[4057],
	"vg.pr":                              &z[4058],
	"vi.pr":                              &z[4059],
	"aaa.pro":                            &z[4060],
	"aca.pro":                            &z[4061],
	"acct.pro":                           &z[4062],
	"arc.pro":                            &z[4063],
	"avocat.pro":                         &z[4064],
	"bar.pro":                            &z[4065],
	"bus.pro":                            &z[4066],
	"cfp.pro":                            &z[4067],
	"chi.pro":                            &z[4068],
	"chiro.pro":                          &z[4069],
	"cpa.pro":                            &z[4070],
	"dds.pro":                            &z[4071],
	"den.pro":                            &z[4072],
	"dent.pro":                           &z[4073],
	"ed.pro":                             &z[4074],
	"eng.pro":                            &z[4075],
	"jur.pro":                            &z[4076],
	"law.pro":                            &z[4077],
	"med.pro":                            &z[4078],
	"min.pro":                            &z[4079],
	"nitr.pro":                           &z[4080],
	"nur.pro":                            &z[4081],
	"nurse.pro":                          &z[4082],
	"opt.pro":                            &z[4083],
	"pa.pro":                             &z[4084],
	"pha.pro":                            &z[4085],
	"pharma.pro":                         &z[4086],
	"pod.pro":                            &z[4087],
	"pr.pro":                             &z[4088],
	"prof.pro":                           &z[4089],
	"prx.pro":                            &z[4090],
	"pt.pro":                             &z[4091],
	"recht.pro":                          &z[4092],
	"rel.pro":                            &z[4093],
	"teach.pro":                          &z[4094],
	"vet.pro":                            &z[4095],
	"com.ps":                             &z[4096],
	"edu.ps":                             &z[4097],
	"gov.ps":                             &z[4098],
	"mobi.ps":                            &z[4099],
	"mun.ps":                             &z[4100],
	"net.ps":                             &z[4101],
	"org.ps":                             &z[4102],
	"plo.ps":                             &z[4103],
	"sch.ps":                             &z[4104],
	"co.pt":                              &z[4105],
	"com.pt":                             &z[4106],
	"edu.pt":                             &z[4107],
	"gov.pt":                             &z[4108],
	"int.pt":                             &z[4109],
	"net.pt":                             &z[4110],
	"nome.pt":                            &z[4111],
	"org.pt":                             &z[4112],
	"publ.pt":                            &z[4113],
	"belau.pw":                           &z[4114],
	"co.pw":                              &z[4115],
	"com.pw":                             &z[4116],
	"ed.pw":                              &z[4117],
	"edu.pw":                             &z[4118],
	"go.pw":                              &z[4119],
	"gov.pw":                             &z[4120],
	"ne.pw":                              &z[4121],
	"net.pw":                             &z[4122],
	"or.pw":                              &z[4123],
	"org.pw":                             &z[4124],
	"com.py":                             &z[4125],
	"coop.py":                            &z[4126],
	"edu.py":                             &z[4127],
	"gov.py":                             &z[4128],
	"mil.py":                             &z[4129],
	"net.py":                             &z[4130],
	"org.py":                             &z[4131],
	"una.py":                             &z[4132],
	"com.qa":                             &z[4133],
	"edu.qa":                             &z[4134],
	"gov.qa":                             &z[4135],
	"mil.qa":                             &z[4136],
	"name.qa":                            &z[4137],
	"net.qa":                             &z[4138],
	"org.qa":                             &z[4139],
	"sch.qa":                             &z[4140],
	"asso.re":                            &z[4141],
	"com.re":                             &z[4142],
	"nom.re":                             &z[4143],
	"arts.ro":                            &z[4144],
	"co.ro":                              &z[4145],
	"com.ro":                             &z[4146],
	"firm.ro":                            &z[4147],
	"info.ro":                            &z[4148],
	"ne.ro":                              &z[4149],
	"nom.ro":                             &z[4150],
	"nt.ro":                              &z[4151],
	"or.ro":                              &z[4152],
	"org.ro":                             &z[4153],
	"rec.ro":                             &z[4154],
	"ro.ro":                              &z[4155],
	"sa.ro":                              &z[4156],
	"srl.ro":                             &z[4157],
	"store.ro":                           &z[4158],
	"tm.ro":                              &z[4159],
	"www.ro":                             &z[4160],
	"ac.rs":                              &z[4161],
	"co.rs":                              &z[4162],
	"edu.rs":                             &z[4163],
	"gov.rs":                             &z[4164],
	"in.rs":                              &z[4165],
	"org.rs":                             &z[4166],
	"ac.ru":                              &z[4167],
	"adygeya.ru":                         &z[4168],
	"bashkiria.ru":                       &z[4169],
	"bir.ru":                             &z[4170],
	"cbg.ru":                             &z[4171],
	"com.ru":                             &z[4172],
	"dagestan.ru":                        &z[4173],
	"edu.ru":                             &z[4174],
	"gov.ru":                             &z[4175],
	"grozny.ru":                          &z[4176],
	"int.ru":                             &z[4177],
	"kalmykia.ru":                        &z[4178],
	"kustanai.ru":                        &z[4179],
	"marine.ru":                          &z[4180],
	"mil.ru":                             &z[4181],
	"mordovia.ru":                        &z[4182],
	"msk.ru":                             &z[4183],
	"mytis.ru":                           &z[4184],
	"nalchik.ru":                         &z[4185],
	"net.ru":                             &z[4186],
	"nov.ru":                             &z[4187],
	"org.ru":                             &z[4188],
	"pp.ru":                              &z[4189],
	"pyatigorsk.ru":                      &z[4190],
	"relarn.ru":                          &z[4191],
	"spb.ru":                             &z[4192],
	"vladikavkaz.ru":                     &z[4193],
	"vladimir.ru":                        &z[4194],
	"ac.rw":                              &z[4195],
	"co.rw":                              &z[4196],
	"com.rw":                             &z[4197],
	"edu.rw":                             &z[4198],
	"gouv.rw":                            &z[4199],
	"gov.rw":                             &z[4200],
	"int.rw":                             &z[4201],
	"mil.rw":                             &z[4202],
	"net.rw":                             &z[4203],
	"org.rw":                             &z[4204],
	"com.sa":                             &z[4205],
	"edu.sa":                             &z[4206],
	"gov.sa":                             &z[4207],
	"med.sa":                             &z[4208],
	"net.sa":                             &z[4209],
	"org.sa":                             &z[4210],
	"pub.sa":                             &z[4211],
	"sch.sa":                             &z[4212],
	"com.sb":                             &z[4213],
	"edu.sb":                             &z[4214],
	"gov.sb":                             &z[4215],
	"net.sb":                             &z[4216],
	"org.sb":                             &z[4217],
	"com.sc":                             &z[4218],
	"edu.sc":                             &z[4219],
	"gov.sc":                             &z[4220],
	"net.sc":                             &z[4221],
	"org.sc":                             &z[4222],
	"com.sd":                             &z[4223],
	"edu.sd":                             &z[4224],
	"gov.sd":                             &z[4225],
	"info.sd":                            &z[4226],
	"med.sd":                             &z[4227],
	"net.sd":                             &z[4228],
	"org.sd":                             &z[4229],
	"tv.sd":                              &z[4230],
	"a.se":                               &z[4231],
	"ac.se":                              &z[4232],
	"b.se":                               &z[4233],
	"bd.se":                              &z[4234],
	"c.se":                               &z[4235],
	"com.se":                             &z[4236],
	"d.se":                               &z[4237],
	"e.se":                               &z[4238],
	"f.se":                               &z[4239],
	"g.se":                               &z[4240],
	"h.se":                               &z[4241],
	"i.se":                               &z[4242],
	"k.se":                               &z[4243],
	"l.se":                               &z[4244],
	"m.se":                               &z[4245],
	"mil.se":                             &z[4246],
	"n.se":                               &z[4247],
	"o.se":                               &z[4248],
	"org.se":                             &z[4249],
	"p.se":                               &z[4250],
	"parti.se":                           &z[4251],
	"pp.se":                              &z[4252],
	"press.se":                           &z[4253],
	"r.se":                               &z[4254],
	"s.se":                               &z[4255],
	"t.se":                               &z[4256],
	"tm.se":                              &z[4257],
	"u.se":                               &z[4258],
	"w.se":                               &z[4259],
	"x.se":                               &z[4260],
	"y.se":                               &z[4261],
	"z.se":                               &z[4262],
	"com.sg":                             &z[4263],
	"edu.sg":                             &z[4264],
	"gov.sg":                             &z[4265],
	"net.sg":                             &z[4266],
	"org.sg":                             &z[4267],
	"per.sg":                             &z[4268],
	"co.sh":                              &z[4269],
	"com.sh":                             &z[4270],
	"edu.sh":                             &z[4271],
	"gov.sh":                             &z[4272],
	"net.sh":                             &z[4273],
	"nom.sh":                             &z[4274],
	"org.sh":                             &z[4275],
	"ae.si":                              &z[4276],
	"at.si":                              &z[4277],
	"cn.si":                              &z[4278],
	"co.si":                              &z[4279],
	"de.si":                              &z[4280],
	"uk.si":                              &z[4281],
	"us.si":                              &z[4282],
	"com.sl":                             &z[4283],
	"edu.sl":                             &z[4284],
	"gov.sl":                             &z[4285],
	"net.sl":                             &z[4286],
	"org.sl":                             &z[4287],
	"art.sn":                             &z[4288],
	"com.sn":                             &z[4289],
	"edu.sn":                             &z[4290],
	"gouv.sn":                            &z[4291],
	"org.sn":                             &z[4292],
	"perso.sn":                           &z[4293],
	"univ.sn":                            &z[4294],
	"com.so":                             &z[4295],
	"edu.so":                             &z[4296],
	"net.so":                             &z[4297],
	"org.so":                             &z[4298],
	"uber.space":                         &z[4299],
	"biz.ss":                             &z[4300],
	"com.ss":                             &z[4301],
	"edu.ss":                             &z[4302],
	"me.ss":                              &z[4303],
	"net.ss":                             &z[4304],
	"org.ss":                             &z[4305],
	"sch.ss":                             &z[4306],
	"co.st":                              &z[4307],
	"com.st":                             &z[4308],
	"consulado.st":                       &z[4309],
	"edu.st":                             &z[4310],
	"embaixada.st":                       &z[4311],
	"embaizada.st":                       &z[4312],
	"gov.st":                             &z[4313],
	"mil.st":                             &z[4314],
	"net.st":                             &z[4315],
	"org.st":                             &z[4316],
	"principe.st":                        &z[4317],
	"saotome.st":                         &z[4318],
	"store.st":                           &z[4319],
	"abkhazia.su":                        &z[4320],
	"adygeya.su":                         &z[4321],
	"aktyubinsk.su":                      &z[4322],
	"arkhangelsk.su":                     &z[4323],
	"armenia.su":                         &z[4324],
	"ashgabad.su":                        &z[4325],
	"azerbaijan.su":                      &z[4326],
	"balashov.su":                        &z[4327],
	"bashkiria.su":                       &z[4328],
	"bryansk.su":                         &z[4329],
	"bukhara.su":                         &z[4330],
	"chimkent.su":                        &z[4331],
	"dagestan.su":                        &z[4332],
	"east-kazakhstan.su":                 &z[4333],
	"exnet.su":                           &z[4334],
	"georgia.su":                         &z[4335],
	"grozny.su":                          &z[4336],
	"ivanovo.su":                         &z[4337],
	"jambyl.su":                          &z[4338],
	"kalmykia.su":                        &z[4339],
	"kaluga.su":                          &z[4340],
	"karacol.su":                         &z[4341],
	"karaganda.su":                       &z[4342],
	"karelia.su":                         &z[4343],
	"khakassia.su":                       &z[4344],
	"krasnodar.su":                       &z[4345],
	"kurgan.su":                          &z[4346],
	"kustanai.su":                        &z[4347],
	"lenug.su":                           &z[4348],
	"mangyshlak.su":                      &z[4349],
	"mordovia.su":                        &z[4350],
	"msk.su":                             &z[4351],
	"murmansk.su":                        &z[4352],
	"nalchik.su":                         &z[4353],
	"navoi.su":                           &z[4354],
	"north-kazakhstan.su":                &z[4355],
	"nov.su":                             &z[4356],
	"obninsk.su":                         &z[4357],
	"penza.su":                           &z[4358],
	"pokrovsk.su":                        &z[4359],
	"sochi.su":                           &z[4360],
	"spb.su":                             &z[4361],
	"tashkent.su":                        &z[4362],
	"termez.su":                          &z[4363],
	"togliatti.su":                       &z[4364],
	"troitsk.su":                         &z[4365],
	"tselinograd.su":                     &z[4366],
	"tula.su":                            &z[4367],
	"tuva.su":                            &z[4368],
	"vladikavkaz.su":                     &z[4369],
	"vladimir.su":                        &z[4370],
	"vologda.su":                         &z[4371],
	"com.sv":                             &z[4372],
	"edu.sv":                             &z[4373],
	"gob.sv":                             &z[4374],
	"org.sv":                             &z[4375],
	"red.sv":                             &z[4376],
	"com.sy":                             &z[4377],
	"edu.sy":                             &z[4378],
	"gov.sy":                             &z[4379],
	"mil.sy":                             &z[4380],
	"net.sy":                             &z[4381],
	"org.sy":                             &z[4382],
	"ac.sz":                              &z[4383],
	"co.sz":                              &z[4384],
	"org.sz":                             &z[4385],
	"at.tc":                              &z[4386],
	"au.tc":                              &z[4387],
	"be.tc":                              &z[4388],
	"bg.tc":                              &z[4389],
	"biz.tc":                             &z[4390],
	"br.tc":                              &z[4391],
	"ch.tc":                              &z[4392],
	"com.tc":                             &z[4393],
	"cz.tc":                              &z[4394],
	"de.tc":                              &z[4395],
	"dk.tc":                              &z[4396],
	"edu.tc":                             &z[4397],
	"es.tc":                              &z[4398],
	"eu.tc":                              &z[4399],
	"hk.tc":                              &z[4400],
	"hu.tc":                              &z[4401],
	"ie.tc":                              &z[4402],
	"int.tc":                             &z[4403],
	"it.tc":                              &z[4404],
	"kr.tc":                              &z[4405],
	"mx.tc":                              &z[4406],
	"net.tc":                             &z[4407],
	"no.tc":                              &z[4408],
	"org.tc":                             &z[4409],
	"ph.tc":                              &z[4410],
	"pl.tc":                              &z[4411],
	"pro.tc":                             &z[4412],
	"ru.tc":                              &z[4413],
	"se.tc":                              &z[4414],
	"shop.tc":                            &z[4415],
	"th.tc":                              &z[4416],
	"ua.tc":                              &z[4417],
	"uk.tc":                              &z[4418],
	"us.tc":                              &z[4419],
	"com.td":                             &z[4420],
	"net.td":                             &z[4421],
	"org.td":                             &z[4422],
	"tourism.td":                         &z[4423],
	"at.tf":                              &z[4424],
	"bg.tf":                              &z[4425],
	"ca.tf":                              &z[4426],
	"ch.tf":                              &z[4427],
	"cz.tf":                              &z[4428],
	"de.tf":                              &z[4429],
	"edu.tf":                             &z[4430],
	"eu.tf":                              &z[4431],
	"int.tf":                             &z[4432],
	"net.tf":                             &z[4433],
	"pl.tf":                              &z[4434],
	"ru.tf":                              &z[4435],
	"sg.tf":                              &z[4436],
	"us.tf":                              &z[4437],
	"ac.th":                              &z[4438],
	"co.th":                              &z[4439],
	"go.th":                              &z[4440],
	"in.th":                              &z[4441],
	"mi.th":                              &z[4442],
	"net.th":                             &z[4443],
	"or.th":                              &z[4444],
	"ac.tj":                              &z[4445],
	"aero.tj":                            &z[4446],
	"biz.tj":                             &z[4447],
	"co.tj":                              &z[4448],
	"com.tj":                             &z[4449],
	"coop.tj":                            &z[4450],
	"dyn.tj":                             &z[4451],
	"edu.tj":                             &z[4452],
	"go.tj":                              &z[4453],
	"gov.tj":                             &z[4454],
	"info.tj":                            &z[4455],
	"int.tj":                             &z[4456],
	"mil.tj":                             &z[4457],
	"museum.tj":                          &z[4458],
	"my.tj":                              &z[4459],
	"name.tj":                            &z[4460],
	"net.tj":                             &z[4461],
	"org.tj":                             &z[4462],
	"per.tj":                             &z[4463],
	"pro.tj":                             &z[4464],
	"web.tj":                             &z[4465],
	"24.tl":                              &z[4466],
	"com.tl":                             &z[4467],
	"gov.tl":                             &z[4468],
	"in.tl":                              &z[4469],
	"na.tl":                              &z[4470],
	"net.tl":                             &z[4471],
	"org.tl":                             &z[4472],
	"co.tm":                              &z[4473],
	"com.tm":                             &z[4474],
	"edu.tm":                             &z[4475],
	"gov.tm":                             &z[4476],
	"mil.tm":                             &z[4477],
	"net.tm":                             &z[4478],
	"nom.tm":                             &z[4479],
	"org.tm":                             &z[4480],
	"agrinet.tn":                         &z[4481],
	"com.tn":                             &z[4482],
	"defense.tn":                         &z[4483],
	"edunet.tn":                          &z[4484],
	"ens.tn":                             &z[4485],
	"fin.tn":                             &z[4486],
	"gov.tn":                             &z[4487],
	"ind.tn":                             &z[4488],
	"info.tn":                            &z[4489],
	"intl.tn":                            &z[4490],
	"mincom.tn":                          &z[4491],
	"nat.tn":                             &z[4492],
	"net.tn":                             &z[4493],
	"org.tn":                             &z[4494],
	"perso.tn":                           &z[4495],
	"rnrt.tn":                            &z[4496],
	"rns.tn":                             &z[4497],
	"rnu.tn":                             &z[4498],
	"tourism.tn":                         &z[4499],
	"com.tp":                             &z[4500],
	"or.tp":                              &z[4501],
	"org.tp":                             &z[4502],
	"av.tr":                              &z[4503],
	"bbs.tr":                             &z[4504],
	"bel.tr":                             &z[4505],
	"biz.tr":                             &z[4506],
	"com.tr":                             &z[4507],
	"dr.tr":                              &z[4508],
	"edu.tr":                             &z[4509],
	"gen.tr":                             &z[4510],
	"gov.tr":                             &z[4511],
	"info.tr":                            &z[4512],
	"k12.tr":                             &z[4513],
	"mil.tr":                             &z[4514],
	"name.tr":                            &z[4515],
	"nc.tr":                              &z[4516],
	"net.tr":                             &z[4517],
	"org.tr":                             &z[4518],
	"pol.tr":                             &z[4519],
	"tel.tr":                             &z[4520],
	"tsk.tr":                             &z[4521],
	"tv.tr":                              &z[4522],
	"web.tr":                             &z[4523],
	"aero.tt":                            &z[4524],
	"at.tt":                              &z[4525],
	"au.tt":                              &z[4526],
	"be.tt":                              &z[4527],
	"biz.tt":                             &z[4528],
	"ca.tt":                              &z[4529],
	"cat.tt":                             &z[4530],
	"ch.tt":                              &z[4531],
	"co.tt":                              &z[4532],
	"com.tt":                             &z[4533],
	"coop.tt":                            &z[4534],
	"de.tt":                              &z[4535],
	"edu.tt":                             &z[4536],
	"es.tt":                              &z[4537],
	"eu.tt":                              &z[4538],
	"fr.tt":                              &z[4539],
	"gov.tt":                             &z[4540],
	"info.tt":                            &z[4541],
	"int.tt":                             &z[4542],
	"it.tt":                              &z[4543],
	"jobs.tt":                            &z[4544],
	"mobi.tt":                            &z[4545],
	"museum.tt":                          &z[4546],
	"name.tt":                            &z[4547],
	"net.tt":                             &z[4548],
	"nl.tt":                              &z[4549],
	"org.tt":                             &z[4550],
	"pro.tt":                             &z[4551],
	"tel.tt":                             &z[4552],
	"travel.tt":                          &z[4553],
	"uk.tt":                              &z[4554],
	"us.tt":                              &z[4555],
	"club.tw":                            &z[4556],
	"com.tw":                             &z[4557],
	"ebiz.tw":                            &z[4558],
	"edu.tw":                             &z[4559],
	"game.tw":                            &z[4560],
	"gov.tw":                             &z[4561],
	"idv.tw":                             &z[4562],
	"mil.tw":                             &z[4563],
	"net.tw":                             &z[4564],
	"org.tw":                             &z[4565],
	"xn--czrw28b.tw":                     &z[4566], // 商業.tw
	"xn--uc0atv.tw":                      &z[4567], // 組織.tw
	"xn--zf0ao64a.tw":                    &z[4568], // 網路.tw
	"ac.tz":                              &z[4569],
	"co.tz":                              &z[4570],
	"go.tz":                              &z[4571],
	"hotel.tz":                           &z[4572],
	"info.tz":                            &z[4573],
	"me.tz":                              &z[4574],
	"mil.tz":                             &z[4575],
	"mobi.tz":                            &z[4576],
	"ne.tz":                              &z[4577],
	"or.tz":                              &z[4578],
	"sc.tz":                              &z[4579],
	"tv.tz":                              &z[4580],
	"biz.ua":                             &z[4581],
	"cherkassy.ua":                       &z[4582],
	"cherkasy.ua":                        &z[4583],
	"chernigov.ua":                       &z[4584],
	"chernivtsi.ua":                      &z[4585],
	"chernovtsy.ua":                      &z[4586],
	"ck.ua":                              &z[4587],
	"cn.ua":                              &z[4588],
	"co.ua":                              &z[4589],
	"com.ua":                             &z[4590],
	"crimea.ua":                          &z[4591],
	"cv.ua":                              &z[4592],
	"dn.ua":                              &z[4593],
	"dnepropetrovsk.ua":                  &z[4594],
	"dnipropetrovsk.ua":                  &z[4595],
	"donetsk.ua":                         &z[4596],
	"dp.ua":                              &z[4597],
	"edu.ua":                             &z[4598],
	"gov.ua":                             &z[4599],
	"if.ua":                              &z[4600],
	"in.ua":                              &z[4601],
	"ivano-frankivsk.ua":                 &z[4602],
	"kh.ua":                              &z[4603],
	"kharkiv.ua":                         &z[4604],
	"kharkov.ua":                         &z[4605],
	"kherson.ua":                         &z[4606],
	"khmelnitskiy.ua":                    &z[4607],
	"kiev.ua":                            &z[4608],
	"kirovograd.ua":                      &z[4609],
	"km.ua":                              &z[4610],
	"kr.ua":                              &z[4611],
	"ks.ua":                              &z[4612],
	"kyiv.ua":                            &z[4613],
	"lg.ua":                              &z[4614],
	"lt.ua":                              &z[4615],
	"lugansk.ua":                         &z[4616],
	"lutsk.ua":                           &z[4617],
	"lviv.ua":                            &z[4618],
	"mk.ua":                              &z[4619],
	"net.ua":                             &z[4620],
	"nikolaev.ua":                        &z[4621],
	"od.ua":                              &z[4622],
	"odesa.ua":                           &z[4623],
	"odessa.ua":                          &z[4624],
	"org.ua":                             &z[4625],
	"pl.ua":                              &z[4626],
	"poltava.ua":                         &z[4627],
	"pp.ua":                              &z[4628],
	"rivne.ua":                           &z[4629],
	"rovno.ua":                           &z[4630],
	"rv.ua":                              &z[4631],
	"sebastopol.ua":                      &z[4632],
	"sm.ua":                              &z[4633],
	"sumy.ua":                            &z[4634],
	"te.ua":                              &z[4635],
	"ternopil.ua":                        &z[4636],
	"uz.ua":                              &z[4637],
	"uzhgorod.ua":                        &z[4638],
	"vinnica.ua":                         &z[4639],
	"vn.ua":                              &z[4640],
	"volyn.ua":                           &z[4641],
	"yalta.ua":                           &z[4642],
	"zaporizhzhe.ua":                     &z[4643],
	"zhitomir.ua":                        &z[4644],
	"zp.ua":                              &z[4645],
	"zt.ua":                              &z[4646],
	"ac.ug":                              &z[4647],
	"co.ug":                              &z[4648],
	"com.ug":                             &z[4649],
	"go.ug":                              &z[4650],
	"mil.ug":                             &z[4651],
	"ne.ug":                              &z[4652],
	"or.ug":                              &z[4653],
	"org.ug":                             &z[4654],
	"sc.ug":                              &z[4655],
	"ac.uk":                              &z[4656],
	"co.uk":                              &z[4657],
	"gov.uk":                             &z[4658],
	"ltd.uk":                             &z[4659],
	"me.uk":                              &z[4660],
	"mod.uk":                             &z[4661],
	"net.uk":                             &z[4662],
	"org.uk":                             &z[4663],
	"plc.uk":                             &z[4664],
	"sch.uk":                             &z[4665],
	"ak.us":                              &z[4666],
	"al.us":                              &z[4667],
	"ar.us":                              &z[4668],
	"as.us":                              &z[4669],
	"az.us":                              &z[4670],
	"ca.us":                              &z[4671],
	"co.us":                              &z[4672],
	"ct.us":                              &z[4673],
	"dc.us":                              &z[4674],
	"de.us":                              &z[4675],
	"dni.us":                             &z[4676],
	"fed.us":                             &z[4677],
	"fl.us":                              &z[4678],
	"ga.us":                              &z[4679],
	"gu.us":                              &z[4680],
	"hi.us":                              &z[4681],
	"ia.us":                              &z[4682],
	"id.us":                              &z[4683],
	"il.us":                              &z[4684],
	"in.us":                              &z[4685],
	"isa.us":                             &z[4686],
	"kids.us":                            &z[4687],
	"ks.us":                              &z[4688],
	"ky.us":                              &z[4689],
	"la.us":                              &z[4690],
	"ma.us":                              &z[4691],
	"md.us":                              &z[4692],
	"me.us":                              &z[4693],
	"mi.us":                              &z[4694],
	"mn.us":                              &z[4695],
	"mo.us":                              &z[4696],
	"ms.us":                              &z[4697],
	"mt.us":                              &z[4698],
	"nc.us":                              &z[4699],
	"nd.us":                              &z[4700],
	"ne.us":                              &z[4701],
	"nh.us":                              &z[4702],
	"nj.us":                              &z[4703],
	"nm.us":                              &z[4704],
	"nsn.us":                             &z[4705],
	"nv.us":                              &z[4706],
	"ny.us":                              &z[4707],
	"oh.us":                              &z[4708],
	"ok.us":                              &z[4709],
	"or.us":                              &z[4710],
	"pa.us":                              &z[4711],
	"pr.us":                              &z[4712],
	"ri.us":                              &z[4713],
	"sc.us":                              &z[4714],
	"sd.us":                              &z[4715],
	"tn.us":                              &z[4716],
	"tx.us":                              &z[4717],
	"ut.us":                              &z[4718],
	"va.us":                              &z[4719],
	"vi.us":                              &z[4720],
	"vt.us":                              &z[4721],
	"wa.us":                              &z[4722],
	"wi.us":                              &z[4723],
	"wv.us":                              &z[4724],
	"wy.us":                              &z[4725],
	"com.uy":                             &z[4726],
	"edu.uy":                             &z[4727],
	"gub.uy":                             &z[4728],
	"mil.uy":                             &z[4729],
	"net.uy":                             &z[4730],
	"org.uy":                             &z[4731],
	"ac.uz":                              &z[4732],
	"aero.uz":                            &z[4733],
	"biz.uz":                             &z[4734],
	"co.uz":                              &z[4735],
	"com.uz":                             &z[4736],
	"coop.uz":                            &z[4737],
	"edu.uz":                             &z[4738],
	"info.uz":                            &z[4739],
	"int.uz":                             &z[4740],
	"museum.uz":                          &z[4741],
	"name.uz":                            &z[4742],
	"net.uz":                             &z[4743],
	"org.uz":                             &z[4744],
	"pro.uz":                             &z[4745],
	"com.vc":                             &z[4746],
	"net.vc":                             &z[4747],
	"org.vc":                             &z[4748],
	"co.ve":                              &z[4749],
	"com.ve":                             &z[4750],
	"edu.ve":                             &z[4751],
	"gob.ve":                             &z[4752],
	"info.ve":                            &z[4753],
	"int.ve":                             &z[4754],
	"mil.ve":                             &z[4755],
	"net.ve":                             &z[4756],
	"org.ve":                             &z[4757],
	"tec.ve":                             &z[4758],
	"web.ve":                             &z[4759],
	"pro.vg":                             &z[4760],
	"biz.vi":                             &z[4761],
	"co.vi":                              &z[4762],
	"com.vi":                             &z[4763],
	"k12.vi":                             &z[4764],
	"net.vi":                             &z[4765],
	"org.vi":                             &z[4766],
	"ac.vn":                              &z[4767],
	"biz.vn":                             &z[4768],
	"com.vn":                             &z[4769],
	"edu.vn":                             &z[4770],
	"gov.vn":                             &z[4771],
	"health.vn":                          &z[4772],
	"info.vn":                            &z[4773],
	"int.vn":                             &z[4774],
	"name.vn":                            &z[4775],
	"net.vn":                             &z[4776],
	"org.vn":                             &z[4777],
	"pro.vn":                             &z[4778],
	"co.vu":                              &z[4779],
	"com.vu":                             &z[4780],
	"name.vu":                            &z[4781],
	"net.vu":                             &z[4782],
	"org.vu":                             &z[4783],
	"com.ws":                             &z[4784],
	"edu.ws":                             &z[4785],
	"gov.ws":                             &z[4786],
	"net.ws":                             &z[4787],
	"org.ws":                             &z[4788],
	"co.ye":                              &z[4789],
	"com.ye":                             &z[4790],
	"gov.ye":                             &z[4791],
	"ltd.ye":                             &z[4792],
	"me.ye":                              &z[4793],
	"net.ye":                             &z[4794],
	"org.ye":                             &z[4795],
	"plc.ye":                             &z[4796],
	"ac.yu":                              &z[4797],
	"cg.yu":                              &z[4798],
	"co.yu":                              &z[4799],
	"edu.yu":                             &z[4800],
	"gov.yu":                             &z[4801],
	"org.yu":                             &z[4802],
	"ac.za":                              &z[4803],
	"agric.za":                           &z[4804],
	"alt.za":                             &z[4805],
	"bourse.za":                          &z[4806],
	"city.za":                            &z[4807],
	"co.za":                              &z[4808],
	"cybernet.za":                        &z[4809],
	"db.za":                              &z[4810],
	"edu.za":                             &z[4811],
	"gov.za":                             &z[4812],
	"grondar.za":                         &z[4813],
	"iaccess.za":                         &z[4814],
	"imt.za":                             &z[4815],
	"inca.za":                            &z[4816],
	"landesign.za":                       &z[4817],
	"law.za":                             &z[4818],
	"mil.za":                             &z[4819],
	"net.za":                             &z[4820],
	"ngo.za":                             &z[4821],
	"nis.za":                             &z[4822],
	"nom.za":                             &z[4823],
	"olivetti.za":                        &z[4824],
	"org.za":                             &z[4825],
	"pix.za":                             &z[4826],
	"school.za":                          &z[4827],
	"tm.za":                              &z[4828],
	"web.za":                             &z[4829],
	"ac.zm":                              &z[4830],
	"co.zm":                              &z[4831],
	"com.zm":                             &z[4832],
	"edu.zm":                             &z[4833],
	"gov.zm":                             &z[4834],
	"net.zm":                             &z[4835],
	"org.zm":                             &z[4836],
	"sch.zm":                             &z[4837],
	"ac.zw":                              &z[4838],
	"co.zw":                              &z[4839],
	"com.zw":                             &z[4840],
	"org.zw":                             &z[4841],
	"001.xn--p1acf":                      &z[4842], // 001.рус
	"002.xn--p1acf":                      &z[4843], // 002.рус
	"003.xn--p1acf":                      &z[4844], // 003.рус
	"004.xn--p1acf":                      &z[4845], // 004.рус
	"005.xn--p1acf":                      &z[4846], // 005.рус
	"006.xn--p1acf":                      &z[4847], // 006.рус
	"007.xn--p1acf":                      &z[4848], // 007.рус
	"008.xn--p1acf":                      &z[4849], // 008.рус
	"009.xn--p1acf":                      &z[4850], // 009.рус
	"010.xn--p1acf":                      &z[4851], // 010.рус
	"011.xn--p1acf":                      &z[4852], // 011.рус
	"012.xn--p1acf":                      &z[4853], // 012.рус
	"013.xn--p1acf":                      &z[4854], // 013.рус
	"014.xn--p1acf":                      &z[4855], // 014.рус
	"015.xn--p1acf":                      &z[4856], // 015.рус
	"016.xn--p1acf":                      &z[4857], // 016.рус
	"017.xn--p1acf":                      &z[4858], // 017.рус
	"018.xn--p1acf":                      &z[4859], // 018.рус
	"019.xn--p1acf":                      &z[4860], // 019.рус
	"021.xn--p1acf":                      &z[4861], // 021.рус
	"022.xn--p1acf":                      &z[4862], // 022.рус
	"023.xn--p1acf":                      &z[4863], // 023.рус
	"024.xn--p1acf":                      &z[4864], // 024.рус
	"025.xn--p1acf":                      &z[4865], // 025.рус
	"026.xn--p1acf":                      &z[4866], // 026.рус
	"027.xn--p1acf":                      &z[4867], // 027.рус
	"028.xn--p1acf":                      &z[4868], // 028.рус
	"029.xn--p1acf":                      &z[4869], // 029.рус
	"030.xn--p1acf":                      &z[4870], // 030.рус
	"031.xn--p1acf":                      &z[4871], // 031.рус
	"032.xn--p1acf":                      &z[4872], // 032.рус
	"033.xn--p1acf":                      &z[4873], // 033.рус
	"034.xn--p1acf":                      &z[4874], // 034.рус
	"035.xn--p1acf":                      &z[4875], // 035.рус
	"036.xn--p1acf":                      &z[4876], // 036.рус
	"037.xn--p1acf":                      &z[4877], // 037.рус
	"038.xn--p1acf":                      &z[4878], // 038.рус
	"039.xn--p1acf":                      &z[4879], // 039.рус
	"040.xn--p1acf":                      &z[4880], // 040.рус
	"041.xn--p1acf":                      &z[4881], // 041.рус
	"042.xn--p1acf":                      &z[4882], // 042.рус
	"043.xn--p1acf":                      &z[4883], // 043.рус
	"044.xn--p1acf":                      &z[4884], // 044.рус
	"045.xn--p1acf":                      &z[4885], // 045.рус
	"046.xn--p1acf":                      &z[4886], // 046.рус
	"047.xn--p1acf":                      &z[4887], // 047.рус
	"048.xn--p1acf":                      &z[4888], // 048.рус
	"049.xn--p1acf":                      &z[4889], // 049.рус
	"050.xn--p1acf":                      &z[4890], // 050.рус
	"051.xn--p1acf":                      &z[4891], // 051.рус
	"052.xn--p1acf":                      &z[4892], // 052.рус
	"053.xn--p1acf":                      &z[4893], // 053.рус
	"054.xn--p1acf":                      &z[4894], // 054.рус
	"055.xn--p1acf":                      &z[4895], // 055.рус
	"056.xn--p1acf":                      &z[4896], // 056.рус
	"057.xn--p1acf":                      &z[4897], // 057.рус
	"058.xn--p1acf":                      &z[4898], // 058.рус
	"059.xn--p1acf":                      &z[4899], // 059.рус
	"060.xn--p1acf":                      &z[4900], // 060.рус
	"061.xn--p1acf":                      &z[4901], // 061.рус
	"062.xn--p1acf":                      &z[4902], // 062.рус
	"063.xn--p1acf":                      &z[4903], // 063.рус
	"064.xn--p1acf":                      &z[4904], // 064.рус
	"065.xn--p1acf":                      &z[4905], // 065.рус
	"066.xn--p1acf":                      &z[4906], // 066.рус
	"067.xn--p1acf":                      &z[4907], // 067.рус
	"068.xn--p1acf":                      &z[4908], // 068.рус
	"069.xn--p1acf":                      &z[4909], // 069.рус
	"070.xn--p1acf":                      &z[4910], // 070.рус
	"071.xn--p1acf":                      &z[4911], // 071.рус
	"072.xn--p1acf":                      &z[4912], // 072.рус
	"073.xn--p1acf":                      &z[4913], // 073.рус
	"074.xn--p1acf":                      &z[4914], // 074.рус
	"075.xn--p1acf":                      &z[4915], // 075.рус
	"076.xn--p1acf":                      &z[4916], // 076.рус
	"077.xn--p1acf":                      &z[4917], // 077.рус
	"078.xn--p1acf":                      &z[4918], // 078.рус
	"079.xn--p1acf":                      &z[4919], // 079.рус
	"083.xn--p1acf":                      &z[4920], // 083.рус
	"086.xn--p1acf":                      &z[4921], // 086.рус
	"087.xn--p1acf":                      &z[4922], // 087.рус
	"089.xn--p1acf":                      &z[4923], // 089.рус
	"094.xn--p1acf":                      &z[4924], // 094.рус
	"095.xn--p1acf":                      &z[4925], // 095.рус
	"xn--80aaac0ct.xn--p1acf":            &z[4926], // абакан.рус
	"xn--80ae0bp.xn--p1acf":              &z[4927], // авто.рус
	"xn--80awd.xn--p1acf":                &z[4928], // алм.рус
	"xn--80aa1ag9a.xn--p1acf":            &z[4929], // алтай.рус
	"xn--80aam8ar9di.xn--p1acf":          &z[4930], // анадырь.рус
	"xn--80aaa5csg.xn--p1acf":            &z[4931], // астана.рус
	"xn--80aaa6cmfh0a9d.xn--p1acf":       &z[4932], // астрахань.рус
	"xn--80ag7c.xn--p1acf":               &z[4933], // ахг.рус
	"xn--80ab2azb.xn--p1acf":             &z[4934], // баку.рус
	"xn--80aab6birx.xn--p1acf":           &z[4935], // барнаул.рус
	"xn--90ais.xn--p1acf":                &z[4936], // бел.рус
	"xn--90aedc4atap.xn--p1acf":          &z[4937], // белгород.рус
	"xn--90amc.xn--p1acf":                &z[4938], // биз.рус
	"xn--80abamkjb7bdt.xn--p1acf":        &z[4939], // биробиджан.рус
	"xn--90aiiib5f.xn--p1acf":            &z[4940], // бишкек.рус
	"xn--80abedla9acxg1b7f.xn--p1acf":    &z[4941], // благовещенск.рус
	"xn--90aayernio.xn--p1acf":           &z[4942], // бобруйск.рус
	"xn--90ai6aff.xn--p1acf":             &z[4943], // брест.рус
	"xn--90asilg6f.xn--p1acf":            &z[4944], // брянск.рус
	"xn--90aoxid7ec.xn--p1acf":           &z[4945], // бурятия.рус
	"xn--b1aadecsaihi0amca3a.xn--p1acf":  &z[4946], // великийновгород.рус
	"xn--b1amjiu8dp.xn--p1acf":           &z[4947], // вильнюс.рус
	"xn--90abjlm5be.xn--p1acf":           &z[4948], // витебск.рус
	"xn--80adbhunc2aa3al.xn--p1acf":      &z[4949], // владивосток.рус
	"xn--80aaafckyesce.xn--p1acf":        &z[4950], // владикавказ.рус
	"xn--80adhqaok7a.xn--p1acf":          &z[4951], // владимир.рус
	"xn--80add5ao.xn--p1acf":             &z[4952], // волга.рус
	"xn--80addag2buct.xn--p1acf":         &z[4953], // волгоград.рус
	"xn--80adde7arb.xn--p1acf":           &z[4954], // вологда.рус
	"xn--b1agd0aean.xn--p1acf":           &z[4955], // воронеж.рус
	"xn--c1aescj1g.xn--p1acf":            &z[4956], // гомель.рус
	"xn--c1ac1acci.xn--p1acf":            &z[4957], // гродно.рус
	"xn--c1aigpdl4f.xn--p1acf":           &z[4958], // грозный.рус
	"xn--e1aky.xn--p1acf":                &z[4959], // ект.рус
	"xn--80adia6bo.xn--p1acf":            &z[4960], // ереван.рус
	"xn--80adbv1agb.xn--p1acf":           &z[4961], // иваново.рус
	"xn--b1afchn5b.xn--p1acf":            &z[4962], // ижевск.рус
	"xn--h1aeawgfg.xn--p1acf":            &z[4963], // иркутск.рус
	"xn--80aauks4g.xn--p1acf":            &z[4964], // казань.рус
	"xn--80aaifraljtb8a.xn--p1acf":       &z[4965], // калининград.рус
	"xn--80aai0ag2c.xn--p1acf":           &z[4966], // калуга.рус
	"xn--b1afaslnbn.xn--p1acf":           &z[4967], // кемерово.рус
	"xn--b1afih.xn--p1acf":               &z[4968], // киев.рус
	"xn--b1alfrj.xn--p1acf":              &z[4969], // киров.рус
	"xn--b1afiaiu9e.xn--p1acf":           &z[4970], // кишинев.рус
	"xn--j1aef.xn--p1acf":                &z[4971], // ком.рус
	"xn--h1adgh.xn--p1acf":               &z[4972], // коми.рус
	"xn--80atghalgi.xn--p1acf":           &z[4973], // кострома.рус
	"xn--80aalwqglfe.xn--p1acf":          &z[4974], // краснодар.рус
	"xn--80atblfjdfd2l.xn--p1acf":        &z[4975], // красноярск.рус
	"xn--j1ael8b.xn--p1acf":              &z[4976], // крым.рус
	"xn--80afuomr.xn--p1acf":             &z[4977], // курган.рус
	"xn--j1aarei.xn--p1acf":              &z[4978], // курск.рус
	"xn--g1afe6db.xn--p1acf":             &z[4979], // кызыл.рус
	"xn--e1afhbv7b.xn--p1acf":            &z[4980], // липецк.рус
	"xn--80aaakg8bm.xn--p1acf":           &z[4981], // магадан.рус
	"xn--80aai8a2a.xn--p1acf":            &z[4982], // магас.рус
	"xn--80asdfng.xn--p1acf":             &z[4983], // майкоп.рус
	"xn--80aqdibz7g.xn--p1acf":           &z[4984], // марийэл.рус
	"xn--80aqjbv3f.xn--p1acf":            &z[4985], // мариэл.рус
	"xn--80aaaa2chc7eta.xn--p1acf":       &z[4986], // махачкала.рус
	"xn--d1abu.xn--p1acf":                &z[4987], // мед.рус
	"xn--h1aeefu.xn--p1acf":              &z[4988], // минск.рус
	"xn--h1ahn.xn--p1acf":                &z[4989], // мир.рус
	"xn--b1abpmcm0l.xn--p1acf":           &z[4990], // могилёв.рус
	"xn--j1adp.xn--p1acf":                &z[4991], // мск.рус
	"xn--80aueagpkl.xn--p1acf":           &z[4992], // мурманск.рус
	"xn--80aqgci6d8a.xn--p1acf":          &z[4993], // нальчик.рус
	"xn----7sbb1ccbue7h4a.xn--p1acf":     &z[4994], // нарьян-мар.рус
	"xn--b1avn.xn--p1acf":                &z[4995], // нвс.рус
	"xn--m1aa.xn--p1acf":                 &z[4996], // нн.рус
	"xn--90absbknhbvge.xn--p1acf":        &z[4997], // новосибирск.рус
	"xn--j1adfn.xn--p1acf":               &z[4998], // омск.рус
	"xn--c1avg.xn--p1acf":                &z[4999], // орг.рус
	"xn--90aee6admdx.xn--p1acf":          &z[5000], // оренбург.рус
	"xn--k1afg2e.xn--p1acf":              &z[5001], // орёл.рус
	"xn--80ajgxi.xn--p1acf":              &z[5002], // пенза.рус
	"xn--e1aohf5d.xn--p1acf":             &z[5003], // пермь.рус
	"xn--80aegbkvxddlre.xn--p1acf":       &z[5004], // петрозаводск.рус
	"xn--b1apmck.xn--p1acf":              &z[5005], // псков.рус
	"xn--c1ajhpcjhd0j.xn--p1acf":         &z[5006], // пятигорск.рус
	"xn--80afo5a.xn--p1acf":              &z[5007], // рига.рус
	"xn-----7kcgn5cdbagnnnx.xn--p1acf":   &z[5008], // ростов-на-дону.рус
	"xn--b1a1ade.xn--p1acf":              &z[5009], // рств.рус
	"xn--80antj7do.xn--p1acf":            &z[5010], // рязань.рус
	"xn--80aamc3a6ac9a.xn--p1acf":        &z[5011], // салехард.рус
	"xn--80aaa0cvac.xn--p1acf":           &z[5012], // самара.рус
	"xn--80aa4alnee.xn--p1acf":           &z[5013], // саранск.рус
	"xn--80aag1ciek.xn--p1acf":           &z[5014], // саратов.рус
	"xn--80adi0aoagldk8i.xn--p1acf":      &z[5015], // севастополь.рус
	"xn--90anb6ab4e.xn--p1acf":           &z[5016], // сибирь.рус
	"xn--e1afkclaggf6a2g.xn--p1acf":      &z[5017], // симферополь.рус
	"xn--e1akbdhdtf.xn--p1acf":           &z[5018], // смоленск.рус
	"xn--h1aliz.xn--p1acf":               &z[5019], // сочи.рус
	"xn--90a1af.xn--p1acf":               &z[5020], // спб.рус
	"xn--80ae1alafffj1i.xn--p1acf":       &z[5021], // ставрополь.рус
	"xn--80aqialz.xn--p1acf":             &z[5022], // таллин.рус
	"xn--80acd2blu.xn--p1acf":            &z[5023], // тамбов.рус
	"xn--80akonve2b.xn--p1acf":           &z[5024], // ташкент.рус
	"xn--b1ag7af7c.xn--p1acf":            &z[5025], // тверь.рус
	"xn--j1adfnc.xn--p1acf":              &z[5026], // томск.рус
	"xn--80avue.xn--p1acf":               &z[5027], // тула.рус
	"xn--p1add.xn--p1acf":                &z[5028], // тур.рус
	"xn--e1aner7ci.xn--p1acf":            &z[5029], // тюмень.рус
	"xn--b1aqbiftj7e1a.xn--p1acf":        &z[5030], // ульяновск.рус
	"xn--80a1bd.xn--p1acf":               &z[5031], // уфа.рус
	"xn--80aacf4bwnk3a.xn--p1acf":        &z[5032], // хабаровск.рус
	"xn--80ablvtof7b4b.xn--p1acf":        &z[5033], // чебоксары.рус
	"xn--90ahkico2a6b9d.xn--p1acf":       &z[5034], // челябинск.рус
	"xn--e1aaob1aia6b.xn--p1acf":         &z[5035], // черкесск.рус
	"xn--80ap4as.xn--p1acf":              &z[5036], // чита.рус
	"xn--80apizf6d.xn--p1acf":            &z[5037], // элиста.рус
	"xn--80af3b0c.xn--p1acf":             &z[5038], // югра.рус
	"xn--41a.xn--p1acf":                  &z[5039], // я.рус
	"xn--j1aaude4e.xn--p1acf":            &z[5040], // якутск.рус
	"xn--80aezclli6gta.xn--p1acf":        &z[5041], // ярославль.рус
	"xn--j1aef.xn--p1ai":                 &z[5042], // ком.рф
	"xn--e1apq.xn--p1ai":                 &z[5043], // нет.рф
	"xn--c1avg.xn--p1ai":                 &z[5044], // орг.рф
	"xn--o-btb9b.xn--90a3ac":             &z[5045], // oбр.срб
	"xn--o-htb.xn--90a3ac":               &z[5046], // oд.срб
	"xn--80au.xn--90a3ac":                &z[5047], // ак.срб
	"xn--o1ac.xn--90a3ac":                &z[5048], // пр.срб
	"xn--o1ach.xn--90a3ac":               &z[5049], // упр.срб
	"xn--fhbed7t1n.xn--mgbbh1a71e":       &z[5050], // كمپنی.بھارت
	"xn--i1b1b4ch5i.xn--h2brj9c":         &z[5051], // कंपनी.भारत
	"xn--p5b2bfp1g0b0b.xn--45brj9c":      &z[5052], // কম্পেনি.ভারত
	"xn--p5b2bfp5fh3fra.xn--45brj9c":     &z[5053], // কোম্পানি.ভারত
	"xn--d9b2bf3g1k.xn--s9brj9c":         &z[5054], // ਕੰਪਨੀ.ਭਾਰਤ
	"xn--hdc1b4ch5i.xn--gecrj9c":         &z[5055], // કંપની.ભારત
	"xn--vlccpku2dp3h.xn--xkc2dl3a5ee0h": &z[5056], // நிறுவனம்.இந்தியா
	"xn--12co0c3b4eva.xn--o3cw4h":        &z[5057], // ธุรกิจ.ไทย
	"xn--gmqw5a.xn--j6w193g":             &z[5058], // 個人.香港
	"xn--55qx5d.xn--j6w193g":             &z[5059], // 公司.香港
	"xn--mxtq1m.xn--j6w193g":             &z[5060], // 政府.香港
	"xn--wcvs22d.xn--j6w193g":            &z[5061], // 教育.香港
	"xn--uc0atv.xn--j6w193g":             &z[5062], // 組織.香港
	"xn--od0alg.xn--j6w193g":             &z[5063], // 網絡.香港
	"lda.co.ao":                          &z[5064],
	"sa.co.ao":                           &z[5065],
	"esc.edu.ar":                         &z[5066],
	"act.edu.au":                         &z[5067],
	"nsw.edu.au":                         &z[5068],
	"nt.edu.au":                          &z[5069],
	"qld.edu.au":                         &z[5070],
	"sa.edu.au":                          &z[5071],
	"tas.edu.au":                         &z[5072],
	"vic.edu.au":                         &z[5073],
	"wa.edu.au":                          &z[5074],
	"fed.rep.br":                         &z[5075],
	"wireless.keyword.cn":                &z[5076],
	"ltd.co.im":                          &z[5077],
	"plc.co.im":                          &z[5078],
	"lg.gov.ng":                          &z[5079],
	"co.net.nz":                          &z[5080],
	"al.eu.org":                          &z[5081],
	"asso.eu.org":                        &z[5082],
	"at.eu.org":                          &z[5083],
	"au.eu.org":                          &z[5084],
	"be.eu.org":                          &z[5085],
	"bg.eu.org":                          &z[5086],
	"ca.eu.org":                          &z[5087],
	"cd.eu.org":                          &z[5088],
	"ch.eu.org":                          &z[5089],
	"cn.eu.org":                          &z[5090],
	"cy.eu.org":                          &z[5091],
	"cz.eu.org":                          &z[5092],
	"de.eu.org":                          &z[5093],
	"dk.eu.org":                          &z[5094],
	"edu.eu.org":                         &z[5095],
	"ee.eu.org":                          &z[5096],
	"es.eu.org":                          &z[5097],
	"fi.eu.org":                          &z[5098],
	"fr.eu.org":                          &z[5099],
	"gr.eu.org":                          &z[5100],
	"hr.eu.org":                          &z[5101],
	"hu.eu.org":                          &z[5102],
	"ie.eu.org":                          &z[5103],
	"il.eu.org":                          &z[5104],
	"in.eu.org":                          &z[5105],
	"int.eu.org":                         &z[5106],
	"is.eu.org":                          &z[5107],
	"it.eu.org":                          &z[5108],
	"jp.eu.org":                          &z[5109],
	"kr.eu.org":                          &z[5110],
	"lt.eu.org":                          &z[5111],
	"lu.eu.org":                          &z[5112],
	"lv.eu.org":                          &z[5113],
	"me.eu.org":                          &z[5114],
	"mk.eu.org":                          &z[5115],
	"mt.eu.org":                          &z[5116],
	"my.eu.org":                          &z[5117],
	"net.eu.org":                         &z[5118],
	"ng.eu.org":                          &z[5119],
	"nl.eu.org":                          &z[5120],
	"no.eu.org":                          &z[5121],
	"nz.eu.org":                          &z[5122],
	"pl.eu.org":                          &z[5123],
	"pt.eu.org":                          &z[5124],
	"ro.eu.org":                          &z[5125],
	"ru.eu.org":                          &z[5126],
	"se.eu.org":                          &z[5127],
	"si.eu.org":                          &z[5128],
	"sk.eu.org":                          &z[5129],
	"tr.eu.org":                          &z[5130],
	"uk.eu.org":                          &z[5131],
	"us.eu.org":                          &z[5132],
	"co.at.pn":                           &z[5133],
	"com.au.pn":                          &z[5134],
	"co.uk.pn":                           &z[5135],
	"co.at.tc":                           &z[5136],
	"com.au.tc":                          &z[5137],
	"co.uk.tc":                           &z[5138],
	"me.uk.tc":                           &z[5139],
	"org.uk.tc":                          &z[5140],
	"co.at.tt":                           &z[5141],
	"com.au.tt":                          &z[5142],
	"co.uk.tt":                           &z[5143],
	"me.uk.tt":                           &z[5144],
	"org.uk.tt":                          &z[5145],
	"barking-dagenham.sch.uk":            &z[5146],
	"barnet.sch.uk":                      &z[5147],
	"barnsley.sch.uk":                    &z[5148],
	"bathnes.sch.uk":                     &z[5149],
	"beds.sch.uk":                        &z[5150],
	"bexley.sch.uk":                      &z[5151],
	"bham.sch.uk":                        &z[5152],
	"blackburn.sch.uk":                   &z[5153],
	"blackpool.sch.uk":                   &z[5154],
	"bolton.sch.uk":                      &z[5155],
	"bournemouth.sch.uk":                 &z[5156],
	"bracknell-forest.sch.uk":            &z[5157],
	"bradford.sch.uk":                    &z[5158],
	"brent.sch.uk":                       &z[5159],
	"doncaster.sch.uk":                   &z[5160],
	"bg.ac.yu":                           &z[5161],
	"ecape.school.za":                    &z[5162],
	"fs.school.za":                       &z[5163],
	"gp.school.za":                       &z[5164],
	"kzn.school.za":                      &z[5165],
	"lp.school.za":                       &z[5166],
	"mpm.school.za":                      &z[5167],
	"ncape.school.za":                    &z[5168],
	"nw.school.za":                       &z[5169],
	"wcape.school.za":                    &z[5170],
}
